/*
 * Copyright (C) 2003  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#define COMPAT_INTERNAL_ACCESS
#include "include.h"
#include "compat.h"

#ifndef HAVE_STRSTR
# ifdef HAVE_MEMCMP
extern char * strstr(const char * s1, const char * s2)
{
	int l1, l2;

	l2 = strlen(s2);
	if (!l2)
		return (char *) s1;
	l1 = strlen(s1);
	while (l1 >= l2) {
		l1--;
		if (!memcmp(s1,s2,l2))
			return (char *) s1;
		s1++;
	}
	return NULL;
}
# else
#  error "This program requires either strstr()"
# endif
#endif


#ifndef HAVE_STRDUP
extern char * strdup(char const * str)
{
    char * out;

    if (!str)
        return NULL;
    if (!(out = malloc(strlen(str)+1)))
        return NULL;
    strcpy(out,str);
    return out;
}
#endif

#ifndef HAVE_GETTIMEOFDAY
# ifdef WIN32
#  include <windef.h>
#  include <windows.h>
#  include <winreg.h>
#  include <winbase.h>
#  include <winsock2.h>
#  define _W32_FT_OFFSET (116444736000000000LL)


struct timeval * aa = NULL;

__inline int gettimeofday(struct timeval * tv, struct timezone * tz /* IGNORED */)
{
    FILETIME        ft;
    LARGE_INTEGER   li;
    __int64         t;
    static int      tzflag;

    if (tv)
    {
        GetSystemTimeAsFileTime(&ft);
        li.LowPart  = ft.dwLowDateTime;
        li.HighPart = ft.dwHighDateTime;
        t  = li.QuadPart;       /* In 100-nanosecond intervals */
        t -= _W32_FT_OFFSET;     /* Offset to the Epoch time */
        t /= 10;                /* In microseconds */
        tv->tv_sec  = (long)(t / 1000000);
        tv->tv_usec = (long)(t % 1000000);
    }

    return 0;
}
# else
#  error Nincs gettimeofday() function...
# endif
#endif
