/*
 * Copyright (C) 2003  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#include "typedef.h"
#ifndef INCLUDED_CONF_TYPES
#define INCLUDED_CONF_TYPES

typedef enum
{
    conftype_none = 0,
    conftype_def = 1,
    conftype_global = 2,
    conftype_user = 3,
    conftype_curr = 4,
    conftype_commandline = 5
} t_conftype;

typedef enum
{
    confset_none = 0x00,
    confset_conf = 0x01,
    confset_kar = 0x02,
    confset_commandline = 0x04
} t_confset;

#ifdef CONF_INTERNAL_ACCESS

typedef struct conf_int
{
    char * name;
    int enabled;
} t_conf_int;

typedef struct conf_str
{
    char * name;
    char * value;
    t_confset confset;
} t_conf_str;

typedef struct aconf_line
{
    int def;
    int curr;
    int read;
    int commandline;
} t_aconf_line;

typedef struct aconf
{
    t_aconf_line reformat_ktjelentes;
    t_aconf_line winul_nextul;
    t_aconf_line kiemeles_mozgas;
    t_aconf_line kiemeles_karakterszam;
    t_aconf_line tudatkutatas_karszam;
    t_aconf_line kiemeles_szornyszam;
    t_aconf_line hyperlink_szorny;
    t_aconf_line kiemeles_epulet;
    t_aconf_line hyperlink_epulet;
    t_aconf_line hyperlink_targy;
    t_aconf_line hyperlink_spell;
    t_aconf_line kiszamolas_epulet_koordinata;
    t_aconf_line notes_labikoordinata;
    t_aconf_line kiemeles_szakicsillag;
    t_aconf_line kiemeles_szornykompi;
    t_aconf_line kiemeles_trezsor;
    t_aconf_line kiemeles_zarknod;
    t_aconf_line kiemeles_buvoles;
    t_aconf_line kiemeles_ef;
    t_aconf_line kiemeles_szornyehes;
    t_aconf_line kiemeles_varazslatlopas;
    t_aconf_line kiemeles_targypusztulas;
    t_aconf_line kiemeles_szopoko;
    t_aconf_line kiemeles_jellemvaltozas;
    t_aconf_line kiemeles_nincskompi;
    t_aconf_line kiemeles_onanalizis;
    t_aconf_line megfejtes_phua;
    t_aconf_line megfejtes_tim;
    t_aconf_line csata_stat_kiiras;
    t_aconf_line csata_sebzes;
    t_aconf_line csata_vampirizacio;
    t_aconf_line csata_nekrocsok;
    t_aconf_line csata_trafo;
    t_aconf_line csata_kontaktus;
    t_aconf_line csata_oregedes;
    t_aconf_line csata_papirang;
    t_aconf_line csata_morgan;
    t_aconf_line csata_kreitonfozet;
    t_aconf_line csata_ep_osszesen;
    t_aconf_line korvege_sebzes_stat;
    t_aconf_line korvege_sebzodes_stat;
    t_aconf_line korvege_csata_gyogyulas_stat;
    t_aconf_line korvege_csata_vp_stat;
    t_aconf_line korvege_csata_pp_stat;
    t_aconf_line korvege_csata_tu_stat;
    t_aconf_line korvege_csata_tvp_stat;
    t_aconf_line korvege_csata_oregedes_stat;
    t_aconf_line korvege_csata_papirang_stat;
    t_aconf_line korvege_eroforras_ep_stat;
    t_aconf_line korvege_eroforras_vp_stat;
    t_aconf_line korvege_eroforras_pp_stat;
    t_aconf_line korvege_eroforras_tu_stat;
    t_aconf_line korvege_eroforras_tvp_stat;
    t_aconf_line korvege_eroforras_ladiko_stat;
    t_aconf_line korvege_permanens_max_stat;
    t_aconf_line korvege_permanens_instabil_stat;
    t_aconf_line korvege_permanens_tulajdonsag_stat;
    t_aconf_line korvege_permanens_jellem_stat;
    t_aconf_line korvege_permanens_oregedes_stat;
    t_aconf_line korvege_permanens_papirang_stat;
    t_aconf_line korvege_spell_hasznalat_kiiras;
    t_aconf_line korvege_kalandozocsata_kiiras;
    t_aconf_line korvege_mezo_kiiras;
    t_aconf_line korvege_psziernyo_kiiras;
    t_aconf_line korvege_figyelmeztetes_kiiras;
    t_aconf_line notes_figyelmeztetes;
    t_aconf_line karlap_ismeretek_kiiras;
    t_aconf_line karlap_tno_osszeg_kiiras;
    t_aconf_line karlap_bonuszok_kiiras;
    t_aconf_line karlap_spell_erosseg_kiiras;
    t_aconf_line karlap_spell_oszto_kiiras;
    t_aconf_line karlap_vpregen_kiiras;
    t_aconf_line karlap_targy_bonusz_kiiras;
    t_aconf_line karlap_targy_kepesseg_kiiras;
    t_aconf_line karlap_targy_spell_kiiras;
    t_aconf_line karlap_spell_sebzes_kiiras;
    t_aconf_line spell_sebzes_spellero_bonusz;
    t_aconf_line spell_sebzes_magia_bonusz;
    t_aconf_line spell_sebzes_bonusz_csak_meglevo;
    t_aconf_line karlap_fegyver_sebzes_kiiras;
    t_aconf_line karlap_targy_tipusonkent_pancel;
    t_aconf_line karlap_targy_tipusonkent_ekszer;
    t_aconf_line karlap_targy_tipusonkent_kulcsok;
    t_aconf_line karlap_targy_tipusonkent_zarknod;
    t_aconf_line karlap_targy_tipusonkent_cirkusz;
    t_aconf_line karlap_targy_tipusonkent_ejfatty;
    t_aconf_line karlap_targy_tipusonkent_moa;
    t_aconf_line karlap_targy_tipusonkent_ryuku;
    t_aconf_line karlap_targy_ertek_kiiras;
    t_aconf_line karlap_targy_suly_kiiras;
    t_aconf_line karlap_targy_valtozas_kiiras;
    t_aconf_line karlap_kihivas_torony_kiiras;
    t_aconf_line karlap_kihivas_torony_reszletes;
    t_aconf_line fullstats_kiiras_stat;
    t_aconf_line fullstats_kiiras_varazslat;
    t_aconf_line notes_phua_jlk;
    t_aconf_line notes_tim_jlk;
    t_aconf_line targy_figyelt;
    t_aconf_line spell_figyelt;
    t_aconf_line szorny_oles;
} t_aconf;

typedef struct bconf_line
{
    char * def;
    char * global;
    char * user;
    char * commandline;
    char * curr;
    int read;
} t_bconf_line;

typedef struct bconf
{
    t_bconf_line conffile;
    t_bconf_line confdir;
    t_bconf_line karconfdir;
    t_bconf_line txtdir;
    t_bconf_line outdir;
    t_bconf_line indir;
    t_bconf_line winul40dir;
    t_bconf_line notesdir;
    t_bconf_line cachedir;
    t_bconf_line file_karakter;
    t_bconf_line file_monster;
    t_bconf_line file_targy;
    t_bconf_line file_varazslat;
    t_bconf_line file_phua;
    t_bconf_line file_titkosiras;
    t_bconf_line webhyper;
    t_bconf_line color_trezsor;
    t_bconf_line color_koordinata;
    t_bconf_line color_onanalizis;
    t_bconf_line color_webhyperlink;
    t_bconf_line color_figyelt_keves;
    t_bconf_line color_figyelt_sok;
} t_bconf;
#endif /*  CONF_INTERNAL_ACCESS */
#endif

#ifndef JUST_NEED_TYPES
#ifndef INCLUDED_CONF_PROTOS
extern int clearconf(void);
extern char * bconf_get_value(char * name, t_conftype type);
extern char * bconf_get_value_pri(char * name);
extern char * bconf_set_value(char * name, t_conftype type, char * value);
extern char * bconf_get_outdir(void);
extern char * bconf_get_indir(void);
extern char * bconf_get_notesdir(void);
extern char * bconf_get_winul40dir(void);
extern char * bconf_get_webhyper(void);
extern char * bconf_get_cachedir(void);
extern int aconf_get_webhyper_offline(void);
extern char * bconf_get_color_figyelt_keves(void);
extern char * bconf_get_color_figyelt_sok(void);
extern int conf_set_hard_default(void);
extern int conf_load_str(char * filename, char * direktive, char * value);
extern int conf_load_value(char * filename, char * l1, char * p1, t_confset confset, t_karakter * karakter);
extern int conf_set_default(void);
extern int conf_load_default(void);
extern int conf_load_karakter(t_karakter * karakter);
extern int init_conf (void);
extern int conf_unload (void);
#define INCLUDED_CONF_PROTOS
#endif
#endif
