/*
 * Copyright (C) 2003-2005  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */

#include "setup.h"

/* Hardcoded definiciok */
#define CONF_FILE "reformat.cfg"
#define USERCONF_DIR ".reformat"
#define KARCONF_DIR "cfg"
#define TXT_DIR "txt"
#define CACHE_DIR "cache"

#define REFORMAT_HYPERLINK "http://reformat.vizipok.hu/"
#define WEBHYPER_HYPERLINK "http://hyper.pbm.hu/webhyper/"
#define TAPFAKTOR_GRAFIKON_HYPERLINK "http://chaarlee.hu/kompania/grafikon.php?mit=tapfaktor&savg=1"

#define KARAKTER_TXT "karakter.txt"
#define MONSTER_TXT "monster.txt"
#define TARGY_TXT "targy.txt"
#define VARAZSLAT_TXT "varazslat.txt"
#define PHUA_TXT "phua.txt"
#define TIM_TXT "titkosiras.txt"

#define COLOR_TREZSOR "#400080"
#define COLOR_KOORDINATA "#BF6000"
#define COLOR_ONANALIZIS "#004080"
#define COLOR_WEBHYPERLINK "#494925"
#define COLOR_FIGYELT_KEVES "red"
#define COLOR_FIGYELT_SOK "blue"

//#define DEBUG
//#define DEBUG_STR
//#define USE_CHECK_ALLOC

/*   STOP STOP STOP STOP STOP STOP STOP STOP STOP STOP STOP STOP STOP STOP  */
/*   STOP STOP STOP STOP STOP STOP STOP STOP STOP STOP STOP STOP STOP STOP  */
/*   STOP STOP STOP STOP STOP STOP STOP STOP STOP STOP STOP STOP STOP STOP  */

#define VS "0.5.0p4"
#define VST "2003-2004"

#define LINE_MAXLEN 1024
#define NAME_LEN 50

#define PSZI_VALTOZAS_TIME 1079737200
#define SPELLERO_VALTOZAS_TIME 1103194800
#define CSUPASZIZOM_VALTOZAS_TIME 1107730800

#ifdef DEBUG
# ifdef USE_CHECK_ALLOC
#  define VERSION "ReFormat "VS" Debugger+Alloc"
# else
#  define VERSION "ReFormat "VS" Debugger"
# endif
#else
#ifdef USE_CHECK_ALLOC
#  define VERSION "ReFormat "VS" ALLOC"
# else
#  define VERSION "ReFormat "VS
# endif
#endif

#ifdef DEBUG
# define DEBUGFILE "reformat.log.debug"
#endif

#ifndef DEBUG
#undef DEBUG_STR
#endif

#ifdef USE_CHECK_ALLOC
# define ALLOCFILE "reformat.log.alloc"
#endif

#define TIME_FORMAT "%b %d %H:%M:%S"
#define TIME_MAXLEN 32


#ifndef MAX
#define MAX(a, b)       ((a) > (b) ? (a) : (b))
#endif
#ifndef MIN
#define MIN(a, b)       ((a) < (b) ? (a) : (b))
#endif

/* ------------------------- END CONFIGURATION SECTION -------------------- */

#ifndef HAVE_VPRINTF
#error Nincs vprintf() function...
#endif

#ifndef HAVE_ATOI
#error Nincs atoi() function...
#endif

#ifndef HAVE_MALLOC
#error Nincs malloc() function...
#endif

#ifndef HAVE_FREE
#error Nincs free() function...
#endif

#ifndef HAVE_MEMSET
#error Nincs memset() function...
#endif

#ifndef HAVE_GETENV
#error Nincs getenv() function...
#endif

#ifndef HAVE_TIME
#error Nincs time() function...
#endif

#ifndef HAVE_FOPEN
#error Nincs fopen() function...
#endif

#ifndef HAVE_FCLOSE
#error Nincs fclose() function...
#endif

#ifndef HAVE_FFLUSH
#error Nincs fflush() function...
#endif

#ifndef HAVE_FPRINTF
#error Nincs fprintf() function...
#endif

#ifndef HAVE_FREAD
#error Nincs fread() function...
#endif

#ifndef HAVE_FWRITE
#error Nincs fwrite() function...
#endif

#ifndef HAVE_MKDIR
#error Nincs mkdir() function...
#endif

#ifndef HAVE_STAT
#error Nincs stat() function...
#endif

#ifndef HAVE_CHMOD
#error Nincs chmod() function...
#endif

#ifndef HAVE_SPRINTF
#error Nincs sprintf() function...
#endif

#ifndef HAVE_STRCMP
#error Nincs strcmp() function...
#endif

#ifndef HAVE_STRNCMP
#error Nincs strncmp() function...
#endif

#ifndef HAVE_STRCPY
#error Nincs strcpy() function...
#endif

#ifndef HAVE_STRERROR
#error Nincs strerror() function...
#endif

#ifndef HAVE_STRLEN
#error Nincs strlen() function...
#endif

#ifndef HAVE_STDARG_H
#error Nincs stdarg.h header...
#endif

#ifndef HAVE_STDIO_H
#error Nincs stdio.h header...
#endif

#ifdef WIN32
# if !defined(HAVE_WINBASE_H) || !defined(HAVE_WINDEF_H) || !defined(HAVE_WINDOWS_H) || !defined(HAVE_WINREG_H)
#  error Nincsenek windows headerek...
# endif
#endif
