/*
 * Copyright (C) 2003,2004,2005  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#define F_CSATA_INTERNAL_ACCESS
#include "include.h"
#ifndef JUST_NEED_TYPES
# define JUST_NEED_TYPES
# include "fordulo.h"
# include "format.h"
# undef JUST_NEED_TYPES
#else
# include "fordulo.h"
# include "format.h"
#endif
#include "f_csata.h"
#include "f_fordulo.h"
#include "sorszam.h"
#include "output.h"
#include "cache.h"

static t_spec_csata spec_csata[] =
{
 {"aurja <SPAN CLASS=\"sebez\">", NULL, "aurja <SPAN CLASS=\"szenved\">", "", spec_aurakorrekcio, NULL},	//  0
 {NULL, "p-t sebzdsz te is.", "<SPAN CLASS=\"szenved\">", "</SPAN>", spec_sebzodik, NULL},			//  1
 {NULL, "p-t sebzett rajtad.", "<SPAN CLASS=\"szenved\">", "</SPAN>", spec_sebzodik, NULL},			//  2
 {NULL, "p-t sebzett ellenfeleden.", "<SPAN CLASS=\"sebez\">", "</SPAN>", spec_sebez, NULL},			//  3
 {NULL, "letpontot gygyultl.", "<SPAN CLASS=\"plusminus\">", "</SPAN>", spec_gyogyul, NULL},			//  4
 {NULL, "p-t gygyultl,", "<SPAN CLASS=\"plusminus\">", "</SPAN>", spec_gyogyul, NULL},			//  5
 {NULL, "P.)", "<SPAN CLASS=\"plusminus\">", "</SPAN>", spec_gyogyul, NULL},					//  6
 {"Darabokra robban egy birtokodban lev", NULL, "<b>", "</b>", spec_targypusztul, NULL},			//  7
 {"Darabokra trt a birtokodban lev", NULL, "<b>", "</b>", spec_targypusztul, NULL},				//  8
 {"apr pukkans ksretben eltnik szeretett trgyad", NULL, "<b>", "</b>", spec_targypusztul, NULL},		//  9
 {"sztfolyt drga kincsed", NULL, "<b>", "</b>", spec_targypusztul, NULL},					// 10
 {"dezintegrldik kedvenc trgyad", NULL, "<b>", "</b>", spec_targypusztul, NULL},				// 11
 {"Megsemmislt a nlad lev", NULL, "<b>", "</b>", spec_targypusztul, NULL},					// 12
 {"Egy hatalmas, kusza csom ktdtt", NULL, "<b>", "</b>", spec_targypusztul, NULL},				// 13
 {"tnyjtod a birtokodban lev", NULL, "<b>", "</b>", spec_targypusztul, NULL},				// 14
 {"engedelmesen tnyjtod a nlad lev", NULL, "<b>", "</b>", spec_targypusztul, NULL},				// 15
 {"Elfehredsz: a birtokodban lev", NULL, "<b>", "</b>", spec_targypusztul, NULL},				// 16
 {"Vgleg elfelejtetted", "nev varzslatodat.", "<b>", "</b>", spec_varazslatlop, NULL},			// 17
 {"regedtl", "vet.", "<b>", "</b>", spec_oregedes, NULL},							// 18
 {"Isteni hited kicsit megrendlt!", NULL, "<b>", "</b>", spec_papirang, NULL},					// 19
 {"Papi rangod egy leheletnyit visszaesett.", NULL, "<b>", "</b>", spec_papirang, NULL},			// 20
 {"Papi rangodon csekly repeds keletkezett!", NULL, "<b>", "</b>", spec_papirang, NULL},			// 21
 {"Papi rangod egy IMdkozsnyit cskkent.", NULL, "<b>", "</b>", spec_papirang, NULL},				// 22
 {"Ajjaj, az sszes vized gzz vlt!", NULL, "<b>", "</b>", spec_csak_kiemel, NULL},				// 23
 {"Hirtelen iszonyatosan hes leszel!", NULL, "<b>", "</b>", spec_csak_kiemel, NULL},				// 24
 {"Borzalmasan szomjazni kezdesz.", NULL, "<b>", "</b>", spec_csak_kiemel, NULL},				// 25
 {"a nlad lev", "sszeragadt", "<b>", "</b>", spec_targypusztul, NULL},					// 26
 {"(nanalzis:", ".)", "<SPAN class=\"onanalizis\">", "</SPAN>", spec_csak_kiemel, "kiemeles_onanalizis"},	// 27
 {"Ellenfeled -", "szerencst kap", "<b>", "</b>", spec_csak_kiemel, NULL},					// 28
 {"s igen, sikerlt neki! Egy", NULL, "<b>", "</b>", spec_targypusztul, NULL},					// 29
 {NULL, NULL, NULL, NULL, 0, NULL}										// 
};

char * spec_csata_next(char * start, char * end, char ** eleje, char ** vege, int * vi)
{
    char * p1;
    char * p2;
    char * p3;
    char * buf;
    char * buf_vege;
    char tmp;
    int i;
    int ok;
    char * ee1;
    char * vv1;
    char * ee2;
    char * vv2;

    if (!start || !end)
    {
	return NULL;
    }
    buf = start;
    if (end && (end > start))
    {
	buf_vege =  end;
    }
    else
    {
	buf_vege =  buf + strlen(buf);
    }    
    tmp = *buf_vege;
    *buf_vege = '\0';

    for (i = 0, ok = 0, p1 = NULL, p3 = buf_vege; (i < (sizeof(spec_csata) / sizeof(t_spec_csata))) && (spec_csata[i].eleje || spec_csata[i].vege); i++)
    {
	ee1 = NULL;
	vv1 = NULL;
	ee2 = NULL;
	vv2 = NULL;
	p1 = NULL;
	p2 = NULL;
		
	if (spec_csata[i].eleje)
	{
	    p1 = strstr3_(buf, spec_csata[i].eleje, p3, &ee1, &vv1);
	}
	if (spec_csata[i].vege)
	{
	    p2 = strstr3_(buf, spec_csata[i].vege, p3, &ee2, &vv2);
	}
	
	if (spec_csata[i].eleje && spec_csata[i].vege)
	{
	    if (p1 && p2 && (p1 < p2) && (p2 < p3))
	    {
		ok = 1;
		p3 = p2;
		*vi = i;
		*eleje = (spec_csata[i].type&spec_csak_kozti ? vv1 : ee1);
		*vege = (spec_csata[i].type&spec_csak_kozti ? ee2 : vv2);
	    }
	}
	else if (spec_csata[i].vege)
	{
	    if (p2 && (p2 < p3))
	    {
		ok = 1;
		p3 = p2;
		*vi = i;
		*eleje = ee2;
		*vege = vv2;
	    }
	}
	else if (spec_csata[i].eleje)
	{
	    if (p1 && (p1 < p3))
	    {
		ok = 1;
		p3 = p1;
		*vi = i;
		*eleje = ee1;
		*vege = vv1;
	    }
	}
    }
    *buf_vege = tmp;

    if (ok)
    {
	return p3;
    }
    else
    {
	return NULL;
    }
}

char * reformat_csata_kiiras_kiemeles(t_fordulo * fordulo, char * start, char * end, t_csata * pcsata)
{
    char * l1;
    char * l2;
    char * l3;
    char * l4;
    int ok;
    char * eleje;
    char * vege;
    int vi;
    int n;
    int m;
    int sebzesertek;
    int z;
    int faname;
    
    l3 = start;
    ok = 0;

    for (l2 = l3 ; (l2 = spec_csata_next(l2, end, &eleje, &vege, &vi)) && (l2 < end); )
    {
	sebzesertek = 0;
	faname = 0;
	
	// csataban varazslatlopas
	if (!get_cache_mode() && (spec_csata[vi].type&spec_varazslatlop) && (aconf_get_curr("kiemeles_varazslatlopas") == 1))
	{
	    l1 = eleje;
	    faname = figyelmeztetes_store(fordulo, l1, l2, 1);
	    output(fordulo, "%.*s<a name=\"figyelmeztetes%d\">%s%.*s%s</a>", l1 - l3, l3, faname, spec_csata[vi].kiemel_s, l2 - l1, l1, spec_csata[vi].kiemel_e);
	    l3 = l2;
#ifdef DEBUG
	    debug(fordulo, "reformat_csata_kiiras_kiemeles: varazslatlopas i=%d, \"%.*s\"\n", vi, l2 - l1, l1);
#endif
	}

	// csataban targypusztulas
	else if (!get_cache_mode() && (spec_csata[vi].type&spec_targypusztul) && (aconf_get_curr("kiemeles_targypusztulas") == 1))
	{
	    char * felkialtojel;
	    
	    if (strstr_(spec_csata[vi].eleje, "sikerlt neki!", NULL))
	    {
		eleje = strstr2(eleje, "!");
		eleje = skip_nonspace(eleje);
	    }
	    l1 = eleje;
	    felkialtojel = strstr2(l2, "!");
	    for(l4 = l2 ; (l4 = strstr2(l4, ".")) && (l4 < end); )
	    {
		if (felkialtojel && (l4 > felkialtojel))
		{
		    l4 = felkialtojel;
		    ok = 1;
		    break;
		}
		l4 = skip_space(l4);
		if (isupper2(*l4) || (*l4 == '<') || (*l4 == '(') || (*l4 == '{'))
		{
		    ok = 1;
		    break;
		}
	    }
	    if (ok)
	    {
		if (!strstr_(l2, "deus ex machina", l4))
		{
		    faname = figyelmeztetes_store(fordulo, l1, l4, 1);
		}
		output(fordulo, "%.*s<a name=\"figyelmeztetes%d\">%s%.*s%s</a>", l1 - l3, l3, faname, spec_csata[vi].kiemel_s, l4 - l1, l1, spec_csata[vi].kiemel_e);
		l3 = l4;
#ifdef DEBUG
		debug(fordulo, "reformat_csata_kiiras_kiemeles: targypusztulas i=%d, \"%.*s\"\n", vi, l4 - l1, l1);
#endif
	    }
	}

	// Aurakorrekcio
	else if (spec_csata[vi].type&spec_aurakorrekcio)
	{
	    if ((l1 = strstr_(vege, "sebzst okoz.</SPAN>", vege + 30)) && (l1 - vege < 10))
	    {
		if (!get_cache_mode())
		{
		    output(fordulo, "%.*s%s", eleje - l3, l3, spec_csata[vi].kiemel_s);
		    l3 = vege;
		}
		l1 = skip_space(vege);
		if (isdigit2(*l1))
		{
		    sebzesertek = atoi(l1);
		    pcsata->sebzes_egyeb -= sebzesertek;
		    pcsata->sebzodes_egyeb += sebzesertek;
		}
#ifdef DEBUG
		l1 = skip_nonspace(l1);
		debug(fordulo, "reformat_csata_kiiras_kiemeles: aurakorrekcio i=%d, \"%.*s\"\n", vi, l1 - eleje, eleje);
#endif
	    }
	}
	
	// Nem kiemelt sebzes/sebzodes kiemelese
	else if (((spec_csata[vi].type&spec_gyogyul) || (spec_csata[vi].type&spec_sebzodik) || (spec_csata[vi].type&spec_sebez)) && ((aconf_get_curr("csata_sebzes") == 1) || (aconf_get_curr("korvege_sebzodes_stat") == 1)))
	{
	    if (spec_csata[vi].eleje)
	    {
		l1 = skip_space(eleje);
	    }
	    else
	    {
	    	l1 = eleje - 1;
		for( ; (l1 > l3) && ((*l1 == ' ') || (*l1 == '\t') || (*l1 == '\r') || (*l1 == '\n')); l1--);
		for( ; (l1 > l3) && (isdigit2(*(l1-1))); l1--);
	    }
	    l4 = NULL;
	    z = 0;
	    if (*(vege-1) == ')')
	    {
	        for(l4 = l1 ; (l4 >= l3) && (*(l4-1) != '('); l4--);
	        z = 1;
	    }
	    if (isdigit2(*l1))
	    {
		sebzesertek = atoi(l1);
		if (spec_csata[vi].type & spec_sebez)
		{
		    pcsata->sebzes_egyeb += sebzesertek;
		}
		else if (spec_csata[vi].type & spec_sebzodik)
		{
		    pcsata->sebzodes_egyeb += sebzesertek;
		}
		else if (spec_csata[vi].type & spec_gyogyul)
		{
		    pcsata->ep_n += sebzesertek;
		}
	    }
	    if (!get_cache_mode())
	    {
		if (l4)
		{
		    output(fordulo, "%.*s%s%s%.*s%d %.*s%s%s", l4 - l3 - z, l3, (z?"(":""), spec_csata[vi].kiemel_s, l1 - l4, l4, sebzesertek, vege - eleje - z, eleje, spec_csata[vi].kiemel_e, (z?")":""));
		}
		else
		{
		    output(fordulo, "%.*s%s%d %.*s%s", l1 - l3, l3, spec_csata[vi].kiemel_s, sebzesertek, vege - eleje, eleje, spec_csata[vi].kiemel_e);
		}
		l3 = l2;
	    }
#ifdef DEBUG
	    debug(fordulo, "reformat_csata_kiiras_kiemeles:  nem kiemelt sebzes/sebzodes i=%d, \"%.*s\"\n", vi, l2 - (l4?l4:l1), (l4?l4:l1));
#endif
	}
	
	// Papi hit vesztes csataban
	else if ((spec_csata[vi].type&spec_papirang) && ((aconf_get_curr("csata_papirang") == 1) || (aconf_get_curr("korvege_csata_papirang_stat") == 1)))
	{
	    if (!get_cache_mode())
	    {
		l1 = eleje;
		output(fordulo, "%.*s%s%.*s%s", l1 - l3, l3, spec_csata[vi].kiemel_s, l2 - l1, l1, spec_csata[vi].kiemel_e);
		l3 = l2;
	    }
	    pcsata->papirang_csata += 1;
#ifdef DEBUG
	    debug(fordulo, "reformat_csata_kiiras_kiemeles: papi hit vesztes i=%d, \"%.*s\"\n", vi, l2 - l1, l1);
#endif
	}
	// Oregedes
	else if ((spec_csata[vi].type&spec_oregedes) && ((aconf_get_curr("csata_oregedes") == 1) || (aconf_get_curr("korvege_csata_oregedes_stat") == 1)))
	{
	    l1 = eleje;
	    if (l2 - l1 < 25)
	    {
		if (!get_cache_mode())
		{
		    faname = 0;
		    l4 = strstr_(start, spec_csata[vi].eleje, l2);
		    if ((l1 != l4 ) || !(strstr_(start, "ongliant tombols", l1) || strstr_(start, "frgls", l1)))
		    {
			faname = figyelmeztetes_store(fordulo, l1, l2, 1);
		    }
		    output(fordulo, "%.*s<a name=\"figyelmeztetes%d\">%s%.*s%s</a>", l1 - l3, l3, faname, spec_csata[vi].kiemel_s, l2 - l1, l1, spec_csata[vi].kiemel_e);
		    l3 = l2;
		}
#ifdef DEBUG
		debug(fordulo, "reformat_csata_kiiras_kiemeles: oregedes i=%d, \"%.*s\"\n", vi, l2 - l1, l1);
#endif
		for ( ; !isdigit2(*l1) && (l1 < l2); l1++);
		if (isdigit2(*l1))
		{
		    pcsata->oregedes_csata += atoi(l1);
		}
	    }
	}
	else if (!get_cache_mode() && (spec_csata[vi].type&spec_csak_kiemel))
	{
	    if (spec_csata[vi].aconf && ((aconf_get_curr(spec_csata[vi].aconf) != 1)))
	    {
		continue;
	    }
	    l1 = eleje;
	    output(fordulo, "%.*s%s%.*s%s", l1 - l3, l3, spec_csata[vi].kiemel_s, l2 - l1, l1, spec_csata[vi].kiemel_e);
	    l3 = l2;
#ifdef DEBUG
	    debug(fordulo, "reformat_csata_kiiras_kiemeles: csak_kiemel: \"%.*s\"\n", l2 - l1, l1);
#endif
	}
	else
	{
#ifdef DEBUG
	    debug(fordulo, "reformat_csata_kiiras_kiemeles: le nem kezelt, de megtalalt kiemeles i=%d, \"%.*s\"\n", vi, l2 - eleje, eleje);
#endif
	}
    }
    return l3;
}

extern int csata_osszesiteshez_hozzad(t_fordulo * fordulo)
{
    long * o1;
    long * o2;
    t_csata * osszesen;
    t_csata * pcsata;
    
    osszesen = &fordulo->osszesen;
    pcsata = &fordulo->csata;
    
    osszesen->sebzes_utes += fordulo->csata.sebzes_utes;
    osszesen->sebzes_utes_beforr += fordulo->csata.sebzes_utes_beforr;
    osszesen->sebzes_egyeb += fordulo->csata.sebzes_egyeb;
    osszesen->sebzodes_utes += fordulo->csata.sebzodes_utes;
    osszesen->sebzodes_egyeb += fordulo->csata.sebzodes_egyeb;
    
    for (o1 = &pcsata->vampiri, o2 = &osszesen->vampiri; o2 <= &osszesen->egyeb_n; o1++, o2++)
    {
	*o2 += *o1;
    }
}
	
extern int csata_osszesites_kiir(t_fordulo * fordulo, t_csata * pcsata, int osszesites)
{
    int szumma;
    int sp;
    
    // Csata vegere a kulonfele dolgok kiirasa
    if (aconf_get_curr("csata_stat_kiiras") == 1)
    {
	output(fordulo," <b>");
	if (aconf_get_curr("csata_sebzes") == 1)
	{
    	    if (!osszesites && (pcsata->sebzes_utes + pcsata->sebzodes_utes) && (pcsata->sebzes_egyeb + pcsata->sebzodes_egyeb))
	    {
		szumma = 1;
	    }
	    else
	    {
		szumma = 0;
	    }
	    sp = 0;
	    output(fordulo,"[");
	    if (szumma)
	    {
		output(fordulo,"<SPAN CLASS=\"sebez\">%ld</SPAN>/<SPAN CLASS=\"szenved\">%ld</SPAN> <i>(", pcsata->sebzes_utes + pcsata->sebzes_egyeb, pcsata->sebzodes_utes + pcsata->sebzodes_egyeb);
	    }
	    if (pcsata->sebzes_utes || pcsata->sebzodes_utes)
	    {
	        output(fordulo,"ts: <SPAN CLASS=\"sebez\">%ld</SPAN>/<SPAN CLASS=\"szenved\">%ld</SPAN>", pcsata->sebzes_utes, pcsata->sebzodes_utes);
		sp++;
	    }
	    if (pcsata->sebzes_egyeb || pcsata->sebzodes_egyeb)
	    {
	        output(fordulo,"%sSpec: <SPAN CLASS=\"sebez\">%ld</SPAN>/<SPAN CLASS=\"szenved\">%ld</SPAN>", (sp++?" ":""), pcsata->sebzes_egyeb, pcsata->sebzodes_egyeb);
	    }
	    if (!(pcsata->sebzes_utes || pcsata->sebzodes_utes || pcsata->sebzes_egyeb || pcsata->sebzodes_egyeb))
	    {
	        output(fordulo,"Harc: <SPAN CLASS=\"sebez\">0</SPAN>/<SPAN CLASS=\"szenved\">0</SPAN>");
	    }
	    output(fordulo,"%s] ", (szumma?")</i>":""));
	}
	
	if (osszesites)
	{
	    output(fordulo,"<br>");
	}
	
	if (aconf_get_curr("csata_vampirizacio") == 1)
	{
	    if (pcsata->vampiri)
	    {
	        output(fordulo,"Vmpirizci: (<SPAN CLASS=\"plusminuz\">%+ld p</SPAN>) ", pcsata->vampiri);
	    }
	}

//	if (!osszesites)
	{
	    if (aconf_get_curr("csata_nekrocsok") == 1)
	    {
		if (pcsata->nekrocsok)
		{
		    output(fordulo,"Nekrocsk: (<SPAN CLASS=\"plusminuz\">%+ld p</SPAN>) ", pcsata->nekrocsok);
		}
	    }

	    if (aconf_get_curr("csata_kreitonfozet") == 1)
	    {
		if (pcsata->kreitonfozet)
		{
		    output(fordulo,"Kreiton fzet: (<SPAN CLASS=\"plusminuz\">%+ld p</SPAN>) ", pcsata->kreitonfozet);
		}
	    }

	    if (aconf_get_curr("csata_trafo") == 1)
	    {
		if (pcsata->trafo_ep)
		{
		    output(fordulo,"Traf: (<SPAN CLASS=\"plusminuz\">%+ld p</SPAN>) ", pcsata->trafo_ep);
		}
	    }

	    if (aconf_get_curr("csata_morgan") == 1)
	    {
		if (pcsata->morgan_csata)
		{
		    output(fordulo,"Morgan: (<SPAN CLASS=\"plusminuz\">%+ld p</SPAN>) ", pcsata->morgan_csata);
		}
	    }

	    if (aconf_get_curr("csata_ep_osszesen") == 1)
	    {
		long ossz = 0;
		
		ossz =  pcsata->vampiri + pcsata->nekrocsok + pcsata->kreitonfozet + pcsata->trafo_ep + pcsata->morgan_csata - pcsata->sebzodes_utes - pcsata->sebzodes_egyeb;
		if (ossz)
		{
		    output(fordulo,"<i>sszesen: <SPAN CLASS=\"plusminuz\">%+ld p.</SPAN></i> ", ossz);
		}
	    }

	    if (aconf_get_curr("csata_trafo") == 1)
	    {
		if (pcsata->trafo_vp)
		{
		    output(fordulo,"Traf: (<SPAN CLASS=\"plusminuz\">%+ld vp</SPAN>) ", pcsata->trafo_vp);
		}
	    }

	    if (aconf_get_curr("csata_kontaktus") == 1)
	    {
		if (pcsata->kontakt_vp)
		{
		    output(fordulo,"Kontaktus: (<SPAN CLASS=\"plusminuz\">%+ld vp</SPAN>) ", pcsata->kontakt_vp);
		}

		if (pcsata->kontakt_pp)
		{
		    output(fordulo,"Kontaktus: (<SPAN CLASS=\"plusminuz\">%+ld pp</SPAN>) ", pcsata->kontakt_pp);
		}
	    }

	    if (aconf_get_curr("csata_oregedes") == 1)
	    {
		if (pcsata->oregedes_csata)
		{
		    output(fordulo,"regeds: (<SPAN CLASS=\"plusminuz\">%+ld v</SPAN>) ", pcsata->oregedes_csata);
		}
	    }

	    if (aconf_get_curr("csata_papirang") == 1)
	    {
		if (pcsata->papirang_csata)
		{
		    output(fordulo,"Papier: (<SPAN CLASS=\"plusminuz\">%+ld hitpont</SPAN>) ", 0 - pcsata->papirang_csata);
		}
	    }

	}
	output(fordulo, "</b>");
    }
}

extern void reformat_csata(t_fordulo * fordulo, t_csata * pcsata)
{
    char * p1;
    char * p2;
    char * p3;
    char * p4;
    char * pelozo;
    char * pbeforr;
    char * t1;
    char * t2;
    char * t3;
    char * t4;
    t_csata * osszesen;
    int max;
    unsigned long int n;
    
    osszesen = &fordulo->osszesen;
    
#ifdef DEBUG
	debug(fordulo, "reformat_csata: 1 %p\n", pcsata);
#endif
	// KVGEO
	if ((get_cache_mode() || (aconf_get_curr("korvege_csata_tvp_stat") == 1)) && (p1 = strstr(pcsata->eleje,"KVGEO")))
	{
	    for ( p3 = p1; !isdigit2(p3[0]) && (p3 >= pcsata->eleje); p3--);
	    for ( ; isdigit2(p3[0]) && (p3 >= pcsata->eleje); p3--);
	    p3++;
	    if (isdigit2(p3[0]) && (p3 >= pcsata->eleje) && (p3 < p1))
	    {
#ifdef DEBUG
		debug(fordulo, "reformat_csata: KVGEO: %d tvp, %.60s\n", atoi(p3), p1 - 40);
#endif
		pcsata->tvp_n += atoi(p3);
	    }
	}
	// csatan beluli tvp koltes (pl dem)
	if ((get_cache_mode() || (aconf_get_curr("korvege_eroforras_tvp_stat") == 1)) && (p1 = strstr_(pcsata->eleje,"pontot hasznltl fel, van mg", pcsata->vege)))
	{
	    for (p2 = pcsata->eleje; (p1 = strstr2(p2, "[")) && (p2 = strstr(p1, "]")) && (p2 < pcsata->vege); )
	    {
		if ((p3 = strstr2_(p1,"pontot hasznltl fel, van mg", p2)) && (p3 < p2))
		{
		    if (!fordulo->p || !((fordulo->p[0] == 't') && (fordulo->p[1] == 'p') && (fordulo->p[2] == 's')))
		    {
			if (isdigit2(*p1) || ((*p1 == '-') && isdigit2(*(p1+1))))
			{
			    fordulo->osszesen.tvp_koltes += atoi(p1);
			    p4 = p3;
			    if (fordulo->osszesen.tvp_kapas <= 0)
			    {
				for( ; !isdigit2(*p3) && (p3 < p2); p3++);
				if (isdigit2(*p3))
				{
				    fordulo->osszesen.tvp_kapas += fordulo->osszesen.tvp_koltes + atoi(p3) - fordulo->osszesen.tvp_p + fordulo->osszesen.tvp_n;
				}
			    }
			    if ((p2 == strstr(p1, "VP-t.]")) && (p3 = strstr2(p3, "Kapsz")) && (p3 < p2))
			    {
				p3 = skip_space(p3);
				if (isdigit2(*p3))
				{
		    		    fordulo->osszesen.vp_fno += atoi(p3);
#ifdef DEBUG
				    debug(fordulo, "reformat_csata: FNO vpregen: x=%d\n", atoi(p3));
#endif
				}
			    }
			}
		    }
		}
	    }
	}
	// Az okozott sebzesek osszeszamolasa
	if (get_cache_mode() || (aconf_get_curr("csata_sebzes") == 1) || (aconf_get_curr("korvege_sebzodes_stat") == 1))
	{
	    for (p1 = pcsata->eleje; (p2 = strstr2(p1, "CLASS=\"sebez\">")) && (p1 = strstr2(p2,"</SPAN>")) && (p2 < pcsata->vege); p1 = strstr2(p2,"</SPAN>"))
	    {
#ifdef DEBUG
		debug(fordulo, "reformat_csata: sebzes: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
		// utessel (x tamadassal y eletpontot...)
		if (p1 == strstr2(p2,"sebezve.</SPAN>"))
		{
		    for (p3 = p2; isdigit2(p3[0]) && (p3 <= p1); p3++);
		    for ( ; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
			pbeforr = skip_nonspace(p1);
			pbeforr = skip_space(pbeforr);
			if (pbeforr == strstr_(p2, "A seb azonnal beforr!", pcsata->vege))
			{
			    pcsata->sebzes_utes += 1;
			    pcsata->sebzes_utes_beforr += atoi(p3);
			}
			else
			{
			    pcsata->sebzes_utes += atoi(p3);
			}
		    }
		}
		// Liderc
		else if (p1 == strstr2(p2,"okozott.</SPAN>"))
		{
		    for (p3 = p2; isdigit2(p3[0]) && (p3 <= p1); p3++);
		    for ( ; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
			pcsata->sebzes_egyeb += atoi(p3);
		    }
		}
		// _NEM_ utessel (x eletpontot...)
		else if (p1 == strstr2(p2,"</SPAN>"))
		{
		    if (isdigit2(p2[0]))
		    {
			pcsata->sebzes_egyeb += atoi(p2);
			// Nekrocsok gyogyitasa
			if (strstr2(p1,"gygyultl.") == strstr2(p1,"."))
			{
			    char * nekro;
			    int inekro;
			
			    for (inekro = 5, nekro = p1; inekro && !isdigit2(nekro[0]); inekro--, nekro++);
			    if (isdigit2(nekro[0]))
			    {
				if (aconf_get_curr("csata_nekrocsok") == 1)
				{
				    pcsata->nekrocsok += atoi(nekro);
				}
				else
				{
				    pcsata->ep_p += atoi(nekro);
				}
			    }
		        }
		    }
		}
	    }
	}
	
	// Az elszenvedett sebzodes
	if (get_cache_mode() || (aconf_get_curr("csata_sebzes") == 1) || (aconf_get_curr("korvege_sebzodes_stat") == 1))
	{
	    for (p1 = pcsata->eleje, pelozo = p1; (p2 = strstr2(p1, "CLASS=\"szenved\">")) && (p1 = strstr2(p2,"</SPAN>")) && (p2 < pcsata->vege); pelozo = p1, p1 = strstr2(p2,"</SPAN>"))
	    {
#ifdef DEBUG
		debug(fordulo, "reformat_csata: sebzodes: p1=%p p2=%p utes=%p %.*s\n", p1, p2, (p1 == strstr2(p2,"vesztesz.</SPAN>")), p1-p2, p2);
#endif
		// utessel (x tamadassal y eletpontot...)
		if (p1 == strstr2(p2,"vesztesz.</SPAN>"))
		{
		    for (p3 = p2; isdigit2(p3[0]) && (p3 <= p1); p3++);
		    for ( ; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
			pcsata->sebzodes_utes += atoi(p3);
		    }
		}
		// _NEM_ utessel (x eletpontot...)
		else if (p1 == strstr2(p2,"</SPAN>"))
		{
		    if (*p2 == '-')
		    {
			p2++;
		    }
		    if (isdigit2(p2[0]))
		    {
			pcsata->sebzodes_egyeb += atoi(p2);
		    }
		}
	    }
	}
	
	// Kapott pluszok csatan belul
	for (p1 = pcsata->eleje, pelozo = p1; (p2 = strstr2(p1, "CLASS=\"plusminus\">+")) && (p1 = strstr2(p2,"</SPAN>")) && (p2 < pcsata->vege); pelozo = p1, p1 = strstr2(p2,"</SPAN>"))
	{
	    max = 0;
	    // Max kapasa?
	    p3 = strstr2(p2,"max.");
	    if (p3 <= p1 && p3 >= p2)
	    {
		max = 1;
	    }
	    if ((get_cache_mode() || (aconf_get_curr("korvege_permanens_max_stat") == 1)) && max)
	    {
		// max ep kapas
		if ((p1 == strstr2(p2,"leter.</SPAN>")) || (p1 == strstr2(p2,"leter</SPAN>")))
		{
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_csata: max p kapas: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			osszesen->ep_max_p += atoi(p3);
			continue;
		    }
		}
		if ((p1 == strstr2(p2,"varzspont.</SPAN>")) || (p1 == strstr2(p2,"varzspont</SPAN>")))
		{
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_csata: max vp kapas: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			osszesen->vp_max_p += atoi(p3);
			continue;
		    }
		}
		if ((p1 == strstr2_(p2,"pszi pont.</SPAN>", p1+1)) || (p1 == strstr2_(p2,"pszi pont</SPAN>", p1+1)))
		{
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_csata: max vp kapas: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			osszesen->vp_max_p += atoi(p3);
			continue;
		    }
		}
#ifdef DEBUG
		debug(fordulo, "reformat_csata: ?_plusz: max=%d %.*s\n", max, p1-p2, p2);
#endif
	    }
	    if (max)
	    {
		continue;
	    }
	    if (get_cache_mode() || (aconf_get_curr("csata_vampirizacio") == 1) || (aconf_get_curr("csata_kreitonfozet") == 1))
	    {
		// Vampirizacio
		if (p1 == strstr2(p2,"leter</SPAN>"))
		{
		    char * kfozet;
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
			if ((aconf_get_curr("csata_kreitonfozet") == 1) && (kfozet = strstr_(p2 - 80, "kreiton fzet", p2)) && (kfozet < p2))
			{
#ifdef DEBUG
			    debug(fordulo, "reformat_csata: kreiton fozet: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			    pcsata->kreitonfozet += atoi(p3);
			}
			else if ((aconf_get_curr("csata_vampirizacio") == 1))
			{
#ifdef DEBUG
			    debug(fordulo, "reformat_csata: vampiri: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			    pcsata->vampiri += atoi(p3);
			}
			continue;
		    }
		}
	    }
	    if (get_cache_mode() || (aconf_get_curr("csata_trafo") == 1))
	    {
		// EP-re trafo
		if (p1 == strstr2(p2,"letpont.</SPAN>"))
		{
#ifdef DEBUG
		    debug(fordulo, "reformat_csata: trafo epre: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
			pcsata->trafo_ep += atoi(p3);
			continue;
		    }
		}
		// VP-re trafo
		if (p1 == strstr2(p2,"varzspont.</SPAN>"))
		{
		    p3 = NULL;
//		    if (!(p3 = strstr2_(p2-120, "direkt kontakt", p2)) || (p3 && (p3 > p1)))
		    if ((p3 = strstr2_(p2-50, "Transzformlsz!", p2)) && (p3 < p2))
		    {
			for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
			if (isdigit2(p3[0]) && (p3 < p1))
			{
#ifdef DEBUG
			    debug(fordulo, "reformat_csata: trafo vpre: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			    pcsata->trafo_vp += atoi(p3);
			    continue;
			}
		    }
		}
	    }
	    if (get_cache_mode() || (aconf_get_curr("korvege_csata_gyogyulas_stat") == 1))
	    {
		// Morgan szilank
		if (p1 == strstr2(p2,"letpont</SPAN>"))
		{

		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
			char * v1;
			if (v1 = strstr2(pelozo,"Feltmadsz!"))
			{
			    if ((v1 > pelozo) && (v1 < p2))
			    {
#ifdef DEBUG
				debug(fordulo, "reformat_csata: feltamadas: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
				osszesen->feltamadas += atoi(p3);
				continue;
			    }
			}

#ifdef DEBUG
			debug(fordulo, "reformat_csata: Morgan: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			if (aconf_get_curr("csata_morgan") == 1)
			{
			    pcsata->morgan_csata += atoi(p3);
			}
			else
			{
			    osszesen->morgan_stat += atoi(p3);
			}
			continue;
		    }
		}
		// Torpregeneracio
		else if (p1 == strstr2(p2,"leter.</SPAN>"))
		{
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
			char * v1;
			if (v1 = strstr2(pelozo,"Trpregenerlsz!"))
			{
			    if ((v1 > pelozo) && (v1 < p2))
			    {
#ifdef DEBUG
				debug(fordulo, "reformat_csata: torpregen: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
				pcsata->torpregen += atoi(p3);
				continue;
			    }
			}
#ifdef DEBUG
			debug(fordulo, "reformat_csata: egyeb EP_plusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			pcsata->ep_p += atoi(p3);
			continue;
		    }
		}
		// egyeb EP_plusz csata kozben
		else if ((p1 == strstr2(p2,"leter</SPAN>")) || (p1 == strstr2(p2,"leter.</SPAN>")) || (p1 == strstr2(p2,"letpont</SPAN>")) || (p1 == strstr2(p2,"letpont.</SPAN>")))
		{
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_csata: egyeb EP_plusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			pcsata->ep_p += atoi(p3);
			continue;
		    }
		}
	    }
	    
	    if (get_cache_mode() || (aconf_get_curr("csata_kontaktus") == 1))
	    {
		// direkt kontaktus II.
		if ((p1 == strstr2(p2,"varzspont.</SPAN>")) && (p3 = strstr2_(p2-120 ,"direkt kontakt", p2)))
		{
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_csata: direkt kontaktus vpre: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			pcsata->kontakt_vp += atoi(p3);
			continue;
		    }
		}
		// direkt kontaktus I.
		if ((p1 == strstr2_(p2,"pszi pont.</SPAN>", p1+3)) && (p3 = strstr2_(p2-120 ,"direkt kontakt", p2)))
		{
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_csata: direkt kontaktus pszire: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			pcsata->kontakt_pp += atoi(p3);
			continue;
		    }
		}
	    }
	    if (get_cache_mode() || (aconf_get_curr("korvege_csata_vp_stat") == 1))
	    {
		// egyeb VP_plusz csata kozben (Manaelemental, varazstoltodes, stb)
		if ((p1 == strstr2(p2,"varzspont</SPAN>")) || (p1 == strstr2(p2,"varzspont.</SPAN>")) || (p1 == strstr2(p2,"vp</SPAN>")))
		{
		    char * pvarazsko = NULL;
		    char * pvarazsko2 = NULL;
		    if ((pvarazsko = strstr2_(p2-100, "sszetrsz", p2)) && (pvarazsko < p2))
		    {
			for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
			if (isdigit2(p3[0]) && (p3 < p1))
			{
			    if ((pvarazsko2 = strstr(pvarazsko, "manakristly")) && (pvarazsko2 < p1))
			    {
#ifdef DEBUG
				debug(fordulo, "reformat_csata: manakristaly tores a csataveg elott: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
				osszesen->vp_manakristaly += atoi(p3);
				continue;
			    }
			    if ((pvarazsko2 = strstr(pvarazsko, "varzsk")) && (pvarazsko2 < p1))
			    {
#ifdef DEBUG
				debug(fordulo, "reformat_csata: varazsko tores a csataveg elott: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
				osszesen->vp_varazsko += atoi(p3);
				continue;
			    }
			    continue;
			}
		    }
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_csata: egyeb VP_plusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			pcsata->vp_p += atoi(p3);
			continue;
		    }
		}
	    }

	    if (get_cache_mode() || (aconf_get_curr("korvege_csata_pp_stat") == 1))
	    {
		if ((p1 == strstr2(p2,"pszi pont.</SPAN>")) || (p1 == strstr2(p2,"pszi pont</SPAN>")))
		{
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_csata: pszi plusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			pcsata->pszi_p += atoi(p3);
			continue;
		    }
		}
	    }
	    
	    // Jellem
	    if (get_cache_mode() || (aconf_get_curr("korvege_permanens_jellem_stat") == 1))
	    {
		// Josag
		if (p1 == strstr2(p2,"jsg.</SPAN>"))
		{
#ifdef DEBUG
		    debug(fordulo, "reformat_csata: jellem josag: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
			pcsata->jellem_csata_p += atoi(p3);
			continue;
		    }
		}
		// Gonoszsag
		else if (p1 == strstr2(p2,"gonoszsg.</SPAN>"))
		{
#ifdef DEBUG
		    debug(fordulo, "reformat_csata: jellem gonoszsag: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
			pcsata->jellem_csata_n += atoi(p3);
			continue;
		    }
		}
	    }

#ifdef DEBUG
	    debug(fordulo, "reformat_csata: ?_plusz: max=%d %.*s\n", max, p1-p2, p2);
#endif
	}

	// Kulon for-on!
	// Kobor (foldelem urai kepesseg)
	if (get_cache_mode() || (aconf_get_curr("korvege_csata_gyogyulas_stat") == 1))
	{
	    for (p1 = pcsata->eleje; (p2 = strstr2_(p1, "brd vdelmez", pcsata->vege - 1)) && (p1 = strstr2(p2,")")) && (p2 < pcsata->vege); p1 = strstr2(p2,")"))
	    {
#ifdef DEBUG
		debug(fordulo, "reformat_csata: kobor: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
		if (p1 == strstr2(p2,"P.)"))
		{
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
			pcsata->kobor += atoi(p3);
		    }
		}
	    }
	    // Kobor (vampir kepesseg)
	    for (p1 = pcsata->eleje; (p2 = strstr2_(p1, "seb gygyul", pcsata->vege - 1)) && (p1 = strstr2(p2,")")) && (p2 < pcsata->vege); p1 = strstr2(p2,")"))
	    {
#ifdef DEBUG
		debug(fordulo, "reformat_csata: vampir KT: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
		if (p1 == strstr2(p2,"P.)"))
		{
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
			pcsata->vampirkt += atoi(p3);
		    }
		}
	    }
	}
	
	// Kapott minuszok csata kozben
	for (p1 = pcsata->eleje; (p4 = p1) && (p2 = strstr2(p1, "CLASS=\"plusminus\">-")) && (p1 = strstr2(p2,"</SPAN>")) && (p2 < pcsata->vege); p1 = strstr2(p2,"</SPAN>"))
	{
	    max = 0;
	    // Max kapasa?
	    p3 = strstr2(p2,"max.");
	    if ((p3 <= p1) && (p3 >= p2))
	    {
		max = 1;
	    }
	    if ((get_cache_mode() || (aconf_get_curr("korvege_permanens_max_stat") == 1)) && max)
	    {
		// Max EP szivo monsta
		if (p1 == strstr2(p2,"leter.</SPAN>"))
		{
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_csata: max EP_minusz: p1=%p p2=%p p3=%p %.60s\n", p1, p2, strstr2(p2,"leter."), p2);
#endif
			osszesen->ep_max_n += atoi(p3);
			continue;
		    }
		}
		else if (p1 == strstr2(p2,"varzspont.</SPAN>"))
		{
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_csata: max VP_minusz: p1=%p p2=%p p3=%p %.60s\n", p1, p2, strstr2(p2,"varzspont."), p2);
#endif
			osszesen->vp_max_n += atoi(p3);
			continue;
		    }
		}
		else if (p1 == strstr2_(p2,"pszi pont.</SPAN>", p1 + 1))
		{
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    for ( ; isdigit2(p3[0]) && p3 >= p2; p3--);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_csata: max Pszi_minusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			pcsata->pszi_max_n += atoi(p3);
			continue;
		    }
		}
		// ml'othag szurcsolo
		else if (p1 == strstr2(p2,"TP.</SPAN>"))
		{
		    int ml_mep = 0;
		    int ml_tvp = 0;
		    int ml_tp = 0;
#ifdef DEBUG
		    debug(fordulo, "reformat_csata: ml'othag_minusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
			ml_mep = atoi(p3);
		    }
		    for ( ; isdigit2(p3[0]) && (p3 <= p1); p3++);
		    for ( ; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
			ml_tvp = atoi(p3);
		    }
		    for ( ; isdigit2(p3[0]) && (p3 <= p1); p3++);
		    for ( ; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
			ml_tp = atoi(p3);
		    }
		    if (ml_mep && ml_tvp && ml_tp)
		    {
			pcsata->ep_max_n += ml_mep;
			pcsata->tvp_n += ml_tvp;
			pcsata->tp_n += ml_tp;				
		    }
		}
#ifdef DEBUG
		debug(fordulo, "reformat_csata: ?_minusz: max=%d %.*s\n", max, p1-p2, p2);
#endif
	    }
	    if (max)
	    {
		continue;
	    }
	    // VP_minusz csata kozben (utesevel vpszivo monsta)
	    if ((get_cache_mode() || (aconf_get_curr("korvege_csata_vp_stat") == 1)) && (p1 == strstr2(p2,"varzspont.</SPAN>")))
	    {
		for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		if (isdigit2(p3[0]) && (p3 < p1))
		{
#ifdef DEBUG
		    debug(fordulo, "reformat_csata: VP_minusz: p1=%p p2=%p p3=%p %.60s\n", p1, p2, strstr2(p2,"varzspont."), p2);
#endif
		    pcsata->vp_n += atoi(p3);
		    continue;
		}
	    }
	    // Pszi_minusz csata kozben (utesevel pszi pontot szivo monsta)
	    else if ((get_cache_mode() || (aconf_get_curr("korvege_csata_pp_stat") == 1)) && (p1 == strstr2_(p2,"pszi pont.</SPAN>", p1 + 1)))
	    {
		for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		if (isdigit2(p3[0]) && (p3 < p1))
		{
#ifdef DEBUG
		    debug(fordulo, "reformat_csata: Pszi_minusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
		    pcsata->pszi_n += atoi(p3);
		    continue;
		}
	    }
	    // TU_minusz csata kozben (utesevel TU-t szivo monsta)
	    else if ((get_cache_mode() || (aconf_get_curr("korvege_csata_tu_stat") == 1)) && (p1 == strstr2(p2,"TU.</SPAN>")))
	    {
#ifdef DEBUG
		debug(fordulo, "reformat_csata: TU_minusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
		for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		if (isdigit2(p3[0]) && (p3 < p1))
		{
		    char * pp;
		    
		    if ((pp = strstr2_(p3, "pszi pont,", p1)) && (pp < p1))
		    {
			pcsata->pszi_n += atoi(p3);
			for (p3 = pp; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    }
		    if (isdigit2(p3[0]))
		    {
			pcsata->tu_n += atoi(p3);
			continue;
		    }
		}
	    }
	    // TVP_minusz csata kozben (utesevel TVP-t szivo monsta)
	    else if ((get_cache_mode() || (aconf_get_curr("korvege_csata_tvp_stat") == 1)) && (p1 == strstr2(p2,"TVP</SPAN>")))
	    {
#ifdef DEBUG
		debug(fordulo, "reformat_csata: TVP_minusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
		for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		if (isdigit2(p3[0]) && (p3 < p1))
		{
		    pcsata->tvp_n += atoi(p3);
		    continue;
		}
	    }
	    // Instabil szingularitas
	    else if ((get_cache_mode() || (aconf_get_curr("korvege_permanens_instabil_stat") == 1)) && (p1 == strstr2(p2,"msodikra</SPAN>")))
	    {
#ifdef DEBUG
		debug(fordulo, "reformat_csata: instabil: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif		
		for (p3 = p2; (p3[0] != ',') && (p3 >= p4); p3--);
		p3 = skip_nonspace(p3);
		p3 = skip_space(p3);
		if (strncmp(p3, "er", 3) == 0)
		{
		    osszesen->ero -= 2;
		}
		else if (strncmp(p3, "IQ", 2) == 0)
		{
		    osszesen->iq -= 2;
		}
		else if (strncmp(p3, "gyessg", 8) == 0)
		{
		    osszesen->ugyesseg -= 2;
		}
		else if (strncmp(p3, "egszsg", 8) == 0)
		{
		    osszesen->egeszseg -= 2;
		}
		else if (strncmp(p3, "szerencse", 9) == 0)
		{
		    osszesen->szerencse -= 2;
		}
		else
		{
#ifdef DEBUG
		debug(fordulo, "reformat_csata: instabil error: %.60s\n", p3);
#endif		    
		}
		p3 = skip_nonspace(p3);
		p3 = skip_space(p3);
		p3 = skip_nonspace(p3);
		p3 = skip_space(p3);
		if (strncmp(p3, "er", 3) == 0)
		{
		    osszesen->ero += 2;
		}
		else if (strncmp(p3, "IQ", 2) == 0)
		{
		    osszesen->iq += 2;
		}
		else if (strncmp(p3, "gyessg", 8) == 0)
		{
		    osszesen->ugyesseg += 2;
		}
		else if (strncmp(p3, "egszsg", 8) == 0)
		{
		    osszesen->egeszseg += 2;
		}
		else if (strncmp(p3, "szerencse", 9) == 0)
		{
		    osszesen->szerencse += 2;
		}
		else
		{
#ifdef DEBUG
		debug(fordulo, "reformat_csata: instabil error: %.60s\n", p3);
#endif		    
		}
		continue;
	    }
	    // Agyroppantas
	    else if ((get_cache_mode() || (aconf_get_curr("korvege_permanens_tulajdonsag_stat") == 1)) && (p1 == strstr2(p2,"ah!</SPAN>")))
	    {
		int valtozas;
#ifdef DEBUG
		debug(fordulo, "reformat_csata: agyropi: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif		
		for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		if (isdigit2(p3[0]) && (p3 < p1))
		{
		    valtozas = atoi(p3);
		}
		p3 = skip_nonspace(p3);
		p3 = skip_space(p3);
		if (strncmp(p3, "er", 3) == 0)
		{
		    osszesen->ero -= valtozas;
		}
		else if (strncmp(p3, "IQ", 2) == 0)
		{
		    osszesen->iq -= valtozas;
		}
		else if (strncmp(p3, "gyessg", 8) == 0)
		{
		    osszesen->ugyesseg -= valtozas;
		}
		else if (strncmp(p3, "egszsg", 8) == 0)
		{
		    osszesen->egeszseg -= valtozas;
		}
		else if (strncmp(p3, "szerencse", 9) == 0)
		{
		    osszesen->szerencse -= valtozas;
		}
		else
		{
#ifdef DEBUG
		    debug(fordulo, "reformat_csata: agyropi error: %.60s\n", p3);
#endif		    
		}
		continue;
	    }
	    // szintszivas
	    else if ((p1 == strstr2(p2,"kpessgpont.</SPAN>")) && (p3 = strstr2(p2, "szint:")) && (p3 < p1))
	    {
	        char * szl;
	        int szi;
		
		szl = strstr2(p3, "TP,");
		for  ( ; szl && (szl = strstr2(szl, "-")) && isdigit2(*szl); szl++)
		{
		    szi = atoi(szl);
		    szl = skip_nonspace(szl);
		    szl = skip_space(szl);
		    if (strncmp(szl, "max/akt.", strlen("max/akt.")) == 0)
		    {
			szl = skip_nonspace(szl);
			szl = skip_space(szl);
			if (strncmp(szl, "leter,", strlen("leter,")) == 0)
			{
			    pcsata->ep_max_n += szi;
			}
			else if (strncmp(szl, "varzspont,", strlen("varzspont,")) == 0)
			{
			    pcsata->vp_max_n += szi;
			}
		    }
		}
	    }

#ifdef DEBUG
	    debug(fordulo, "reformat_csata: ?_minusz: max=%d %.*s\n", max, p1-p2, p2);
#endif
	}

    p3 = pcsata->eleje;
    t1 = NULL;
    t2 = NULL;
    t3 = pcsata->vege_eleje;
    
    if (!get_cache_mode())
    {
	
#ifdef DEBUG
	debug(fordulo, "reformat_csata: kiiras\n");
#endif

	// Csata kiirasa
#ifdef DEBUG
	debug(fordulo, "csata_kiir 1: neve: %.*s | block: %.20s | eleje: %.20s | vege_eleje: %.20s | vege: %.20s\n",pcsata->nevvege - pcsata->neveleje,pcsata->neveleje,pcsata->block,pcsata->eleje,pcsata->vege_eleje,pcsata->vege);
#endif
#ifdef DEBUG
	output(fordulo,"---> csata start (%d)<---\r\n",pcsata->vege - pcsata->eleje);
#endif

	// Kiszedett komponens megkeresese
	if (aconf_get_curr("kiemeles_szornykompi") == 1)
	{
	    if ((t1 = strstr2(pcsata->eleje, "zereztl")) && (t2 = strstr(t1,".")) && (t2 < pcsata->vege_eleje))
	    {
		for (t3 = t1; (t2 = strstr(t3+1,".")) && (t2 < pcsata->vege_eleje); t3 = t2)
		{
		    t4 = skip_space(t2+1);
#ifdef DEBUG
		    debug(fordulo, "reformat_csata: szornykompi vege: t4=\"%.30s\"\n", t4);
#endif
		    if ((t4 != (t2+1)) && (isupper2(*t4) || (*t4 == '<') || (*t4 == '(')))
		    {
			break;
		    }
		}
		if (!t2 || (t2 > pcsata->vege_eleje))
		{
		    t2 = t3;
		}
		t3 = t2;
	    }
	    else
	    {
		t1 = NULL;
		t2 = NULL;
	    }
	}
    }
    
    // Csata kiiras
    if (p2 = trezsor_next(p3, t3, 1))
    {
	p3 = reformat_csata_kiiras_kiemeles(fordulo, p3, p2, pcsata);
    }
    else
    {
	p3 = reformat_csata_kiiras_kiemeles(fordulo, p3, t3, pcsata);
    }
	
    if (!get_cache_mode())
    {
	// Szornynel levo trezsor
	if (aconf_get_curr("kiemeles_trezsor") == 1)
	{
	    for (p1 = p3; ((p2 = trezsor_next(p1, t3, 1)) && (p2 < t3)); p1 = t2)
	    {
		p3 = trezsor(fordulo, p2, p3, t3);
	    }
	}
	// Kiszedett komponens kiirasa
	if ((aconf_get_curr("kiemeles_szornykompi") == 1) && t1 && t2)
	{
#ifdef DEBUG
	    output(fordulo,"%.*s---> szereztel start <---<SPAN CLASS=\"trezsor\">%.*s</SPAN>---> szereztel end <---\r\n", t1 - p3, p3, t2 - t1, t1);
#else
	    output(fordulo,"%.*s<SPAN CLASS=\"trezsor\">%.*s</SPAN>", t1 - p3, p3, t2 - t1, t1);
#endif
	    p3 = t2;
	}
	
	output(fordulo,"%.*s", pcsata->vege_eleje - p3, p3);
	p3 = pcsata->vege_eleje;
	if ((p1 = strstr_(pcsata->vege_eleje, "Ez idzett szrny volt, TP sajnos nem jr rte", pcsata->vege)) && (p2 = strstr(p1, ".")) && (p2 < pcsata->vege))
	{
	    output(fordulo,"%.*s<SPAN CLASS=\"tp\">Ez idzett szrny volt, TP sajnos nem jr rte</SPAN>", p1 - p3, p3);
	    p3 = p2;
	}
	n = pcsata->vege - p3;
	output(fordulo,"%.*s", n, p3);
	
#ifdef DEBUG
	output(fordulo,"\n---> csata end <---\r\n");
#endif
    
	// Csata vegere a kulonfele dolgok kiirasa
	csata_osszesites_kiir(fordulo, pcsata, 0);
    } // end of get_cache_mode()
    
	// Osszesiteshez a csata hozzaadasa
#ifdef DEBUG
	debug(fordulo, "reformat_csata: osszesiteshez adasa\n");
#endif
	csata_osszesiteshez_hozzad(fordulo);
    
    // csata nevhez adasa (sarkanybarlang, viharoriasbarlang eredeti Kft-s forduloja bugos, nem irja jol a nevet)
    // phua kup is...
//    if (!fordulo->p || ((strncmp(fordulo->p, "be 620", 6) != 0) && (strncmp(fordulo->p, "be 612", 6) != 0) && (strncmp(fordulo->p, "tim", 3) != 0) && (strncmp(fordulo->p, "jlk", 3) != 0)))
    if (!fordulo->p || ((strncmp(fordulo->p, "be 620", 6) != 0) && (strncmp(fordulo->p, "be 612", 6) != 0)))
    {
	if (fordulo->mezo_utolso && fordulo->mezo_utolso->enemy_utolso && !fordulo->mezo_utolso->enemy_utolso->csata)
	{
	    t_csata * ucsata;
	    
	    if (ucsata = malloc(sizeof(t_csata)))
	    {
	        memcpy(ucsata, &fordulo->csata, sizeof(t_csata));
	        fordulo->mezo_utolso->enemy_utolso->csata = ucsata;
	    }
	    
	    //szornymegoles cache
	    if (!fordulo->cache)
	    {
	        fordulo->cache = cache_create(fordulo);
	    }
	    cache_add_monster_megoles(fordulo->cache, fordulo->mezo_utolso->enemy_utolso->ssz, (pcsata->csataveg_i < CSATAVEG_SIKER_MAX ? cache_monster_megoli_flag_megoli : cache_monster_megoli_flag_nemoli));
	}
    }
}
