/*
 * Copyright (C) 2003  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#define F_CSATAN_KIVUL_INTERNAL_ACCESS
#include "include.h"
#ifndef JUST_NEED_TYPES
# define JUST_NEED_TYPES
# include "fordulo.h"
# include "karakter.h"
# include "format.h"
# undef JUST_NEED_TYPES
#else
# include "fordulo.h"
# include "karakter.h"
# include "format.h"
#endif
#include "f_csatan_kivul.h"
#include "f_fordulo.h"
#include "f_mezo.h"
#include "sorszam.h"
#include "phua.h"
#include "tit.h"
#include "output.h"
#include "notes.h"
#include "globals.h"
#include "psziernyo.h"

static char ** block_taborozas_utani = NULL;
static int loptak = 0;

static t_varos varosok[] = 
{
    {"szaktz", 311, 11},
    {"Srknyverem", 309, 64},
    {"Lvafoly", 312, 117},
    {"Zangroz", 184, 31},
    {"Alanor", 186, 60},
    {"Roxat", 187, 116},
    {NULL, 0, 0}
};

static t_spec_event spec_event[] =
{
    {"sszeszalad vagy egy tucat", "kirlyi palotar" , ", hogy meglltsanak", "kirlyi palotar", NULL, event_type_spec_monsta|event_type_csak_kozti, event_subtype_none, NULL},
    {"izz szem", "Thargodan kufr", "lp el", "Thargodan kufr", NULL, event_type_spec_monsta|event_type_csak_kozti, event_subtype_none, NULL},
    {"megsemmistselek! - kiltod. A", "kufr", "meglepetten felhorkan", "Thargodan kufr", NULL, event_type_spec_monsta|event_type_csak_kozti, event_subtype_none, NULL},
    {"elpuszttsalak! - kiltod. A", "kufr", "meglepetten felhorkan", "Thargodan kufr", NULL, event_type_spec_monsta|event_type_csak_kozti, event_subtype_none, NULL},
    {"csatzni kell: egy", "massza", "nz veled", "massza", NULL, event_type_spec_monsta|event_type_csak_kozti, event_subtype_none, NULL},
    {"elszr is a", "masszt", ", ami idebent", "massza", NULL, event_type_spec_monsta|event_type_csak_kozti, event_subtype_none, NULL},
    {"szrny... , egy", "massza", "jn!", "massza", NULL, event_type_spec_monsta|event_type_csak_kozti, event_subtype_none, NULL},
    {"ocsmny", "massza", "pattan eld!", "massza", NULL, event_type_spec_monsta|event_type_csak_kozti, event_subtype_none, NULL},
    {"odabent mozdul: egy", "massza", "!", "massza", NULL, event_type_spec_monsta|event_type_csak_kozti, event_subtype_none, NULL},
    {"Moa teremtmny, egy", "massza", "rohan rd", "massza", NULL, event_type_spec_monsta|event_type_csak_kozti, event_subtype_none, NULL},
    {"Hiszen ez", "Folrang", ", a legsibb", "Folrang", NULL, event_type_spec_monsta|event_type_csak_kozti, event_subtype_none, NULL},
    {"Hiszen ez", "Nateilena", ", a legsibb", "Nateilena", NULL, event_type_spec_monsta|event_type_csak_kozti, event_subtype_none, NULL},
    {"Hiszen ez", "Ylgoroth", ", a  Stt  Fld", "Ylgoroth", NULL, event_type_spec_monsta|event_type_csak_kozti, event_subtype_none, NULL},
    {"tbor fel.", "Sir Rasolphius", "int a tbbi", "Sir Rasolphius", NULL, event_type_spec_monsta|event_type_csak_kozti, event_subtype_none, NULL},
    {"Elegend gyakorlatra tettl", NULL, "fegyvermesternl.", NULL, NULL, event_type_szaki_csillag, event_subtype_none, NULL},
    {"Elegend tapasztalatra", NULL, "szakrtelmed megnvekedjen!", NULL, NULL, event_type_szaki_csillag, event_subtype_none, NULL},
    {"plusz TU-kat", NULL, "TVP-re vltod.", NULL, NULL, event_type_tutvp|event_type_csak_taborozas, event_subtype_none, NULL},
    {NULL, NULL, "ellopott tled", NULL, NULL, event_type_tolvaj|event_type_csak_taborozas, event_subtype_tolvaj_felismeres_ktkepesseg, NULL},
    {"Fura rzsed van:", NULL, "mintha valamid hinyozna...", NULL, NULL, event_type_tolvaj|event_type_csak_taborozas, event_subtype_tolvaj_default_kiiras, NULL},
    {"szopk(vek)", NULL, "kerlt(ek) hozzd.", NULL, NULL, event_type_szopoko|event_type_csak_taborozas, event_subtype_szopoko_jon, NULL},
    {"Hoh! rmmel ltod", NULL, "kevesebb szopk van nlad.", NULL, NULL, event_type_szopoko, event_subtype_szopoko_megy, NULL},
    {"Hihi! A tenyereidet drzsld", NULL, "szopkved gazdt cserlt.", NULL, NULL, event_type_szopoko, event_subtype_szopoko_megy, NULL},
    {"Igen! A drgak felfnylik", NULL, "csinlni neked valamit!", NULL, NULL, event_type_zarknod, event_subtype_none, NULL},
    {"Jellemed hamarosan", NULL, "fog vltozni.", NULL, NULL, event_type_jellemvaltozas,event_subtype_none,  NULL},
    {"Figyelem:", NULL, "EFelsed nullzdik!", NULL, NULL, event_type_ef, event_subtype_none, NULL},
    {"EF-elsed", NULL, "kezdetektl indul.", NULL, NULL, event_type_ef, event_subtype_none, NULL},
    {"Mr olyan hes volt", NULL, "!", NULL, NULL, event_type_szornyehes, event_subtype_none, NULL},
    {NULL, NULL, "Elbvlve blintasz. tadsz", NULL, NULL, event_type_buvoles, event_subtype_none, NULL},
    {"<SPAN CLASS=\"k\">", NULL, "</SPAN>", NULL, NULL, event_type_epulet|event_type_csak_kozti, event_subtype_none, NULL},
    {"<SPAN CLASS=\"szogletes\">[", NULL, "]</SPAN>", NULL, NULL, event_type_mezo, event_subtype_1, NULL},
    {"[", NULL, "]", NULL, NULL, event_type_mezo|event_type_csak_kozti, event_subtype_2, NULL},
    {"cellpadding=0 cellspacing=0 border=0><tr><td width=15 align=center><img src=", NULL, "</table>", NULL, NULL, event_type_megfejtes, event_subtype_megfejtes_tim, NULL},
    {"<I>", NULL, "</I>", NULL, NULL, event_type_megfejtes, event_subtype_megfejtes_phua, NULL},
    {"Megjtod a", NULL, "varzslatot", NULL, NULL, event_type_varazsol, event_subtype_1, NULL},
    {"(Varzsolsz:)", NULL, "varzslatot!", NULL, NULL, event_type_varazsol, event_subtype_1, NULL},
    {"knyszerport", NULL, "varzslatot!", NULL, NULL, event_type_varazsol, event_subtype_1, NULL},
    {"kreci", NULL, "varzslatot!", NULL, NULL, event_type_varazsol, event_subtype_1, NULL},
    {"(Felt. gygyts:)", NULL, "<SPAN", NULL, NULL, event_type_varazsol, event_subtype_2, NULL},
    {"elszvott tled", NULL, "napjn.", NULL, NULL, event_type_vpvalt, event_subtype_1, NULL},
    {"regenerldtl", NULL, "varzspontot.", NULL, NULL, event_type_vpvalt, event_subtype_2, NULL},
    {"<SPAN CLASS=\"szenved\">", NULL, "</SPAN>", NULL, NULL, event_type_sebzodes, event_subtype_none, NULL},
    {"ygyultl", NULL, "leterpontot.", NULL, NULL, event_type_epvalt, event_subtype_1, NULL},
    {"gygyuls maradand:", NULL, "leter.", NULL, NULL, event_type_epvalt, event_subtype_2, NULL},
    {"bizserg dudorok", NULL, "leterpontot gygytanak", NULL, NULL, event_type_epvalt, event_subtype_2, NULL},
    {"Tudati vitalizcit hajtasz vgre. Gygyultl", NULL, "letpontot!", NULL, NULL, event_type_epvalt, event_subtype_3, NULL},
    {"elrhet magassgban", NULL, "lebeg", "<SPAN CLASS=\"trezsor\">", "</SPAN>", event_type_trezsor|event_type_csak_kozti, event_subtype_1, NULL},
    {"megajndkozott, ezentl", NULL, "tudhatsz magadnak.", "<SPAN CLASS=\"trezsor\">", "</SPAN>", event_type_trezsor|event_type_csak_kozti, event_subtype_1, NULL},
    {"Kipakolod, hogy szemgyre vehesd mi az. A leltr", NULL, "tbbletet jelez.", "<SPAN CLASS=\"trezsor\">", "</SPAN>", event_type_trezsor|event_type_csak_kozti, event_subtype_1, NULL},
    {NULL, NULL, "Materializldik eltted egy vrs zyel", "<SPAN CLASS=\"trezsor\">", "</SPAN>", event_type_trezsor, event_subtype_2, NULL},
    {NULL, NULL, "vet fiatalodtl!", "<b>", "</b>", event_type_eletkorvalt, event_subtype_1, NULL},
    {"(fiatalodtl", NULL, "vet.)", "<b>", "</b>", event_type_eletkorvalt, event_subtype_2, NULL},
    {"regedtl", NULL, "vet.", "<b>", "</b>", event_type_eletkorvalt, event_subtype_3, NULL},
    {"ellltottl", NULL, "Tudatpontot.", NULL, NULL, event_type_tuvalt|event_type_csak_kozti, event_subtype_1, NULL},
    {"Olimpin kaptl", NULL, "tudatpontot", NULL, NULL, event_type_tuvalt|event_type_csak_kozti, event_subtype_1, NULL},
    {"tadott neked", "napon", "TU-t", NULL, NULL, event_type_tuvalt|event_type_csak_kozti, event_subtype_2, NULL},
    {"Visszanyertl", NULL, "tudatpontot!", NULL, NULL, event_type_tuvalt|event_type_csak_kozti, event_subtype_3, NULL},
    {"sfrnykristlyt.", NULL, "tevkenysgpontot kaptl!", "<b>", "</b>", event_type_tvpvalt|event_type_csak_kozti, event_subtype_1, NULL},
    {NULL, NULL, "(kaptl 30 TVP-t)", "<b>", "</b>", event_type_tvpvalt, event_subtype_2, NULL},
    {"(<SPAN CLASS=\"plusminus\">+", NULL, ")", NULL, NULL, event_type_X_plusz, event_subtype_none, NULL},
    {"(<SPAN CLASS=\"plusminus\">-", NULL, ")", NULL, NULL, event_type_X_minusz, event_subtype_none, NULL},
    {"Ennek eredmnyekpp, karaktered a kvetkez fejldst tapasztalja", NULL, "kpessg-pontot.", "<b>", "</b>", event_type_maxvalt|event_type_csak_kozti, event_subtype_1, NULL},
    {NULL, NULL, "Megntt eggyel a maximlis lehetsges", "<b>", "</b>", event_type_maxvalt, event_subtype_2, NULL},
    {"Sajnos nincs a birtokodban valamilyen komponens,", NULL, "varzslat elmondshoz", "<b>", "</b>", event_type_nincskompi, event_subtype_none, NULL},
    {"(nanalzis:", NULL, ".)", "<SPAN CLASS=\"onanalizis\">", "</SPAN>", event_type_csak_kiemel, event_subtype_1, NULL},
    {NULL, NULL, NULL, NULL, NULL, event_type_none, event_subtype_none, NULL}
};

static t_nevhiany nevhiany[] = 
{
    {325, "Ovgun", "Ovgun"},
    {324, "viharris smn", "viharris smn"},
    {278, "viharris", "viharris"},
    {320, "zafr drakn", "zafr drakn"},
    {321, "smaragd drakn", "smaragd drakn"},
    {322, "mrvny drakn", "mrvny drakn"},
    {326, "smaragd srkny", "smaragd srkny"},
    {327, "ben srkny", "ben srkny"},
    {328, "mrvny srkny", "mrvny srkny"},
    {329, "zafr srkny", "zafr srkny"},
    {330, "rubin srkny", "rubin srkny"},
    {0, NULL, NULL}
};

char * spec_event_next(t_fordulo * fordulo, char * start, char * end, char ** eleje, char ** vege, int * vi)
{
    char * p1;
    char * p2;
    char * p3;
    char * p4;
    char * buf;
    char * buf_vege;
    char tmp;
    int i;
    int ok;
    char * ee1;
    char * vv1;
    char * ee2;
    char * vv2;
    char * szn;
    
    if (!start || !end)
    {
	return NULL;
    }
    buf = start;
    if (end && (end > start))
    {
	buf_vege =  end;
    }
    else
    {
	buf_vege =  buf + strlen(buf);
    }    
    tmp = *buf_vege;
    *buf_vege = '\0';

    for (szn = NULL, i = 0, ok = 0, p1 = NULL, p3 = buf_vege, p4 = NULL; (i < (sizeof(spec_event) / sizeof(t_spec_event))) && (spec_event[i].eleje || spec_event[i].vege); i++)
    {
	ee1 = NULL;
	vv1 = NULL;
	ee2 = NULL;
	vv2 = NULL;
	p1 = NULL;
	p2 = NULL;
	
	if (get_cache_mode()
	    && !(spec_event[i].type&event_type_mezo) && !(spec_event[i].type&event_type_spec_monsta) 
	    && !(spec_event[i].type&event_type_varazsol) && !(spec_event[i].type&event_type_eletkorvalt) 
	    && !(spec_event[i].type&event_type_tutvp) && !(spec_event[i].type&event_type_tuvalt) 
	    && !(spec_event[i].type&event_type_tvpvalt) && !(spec_event[i].type&event_type_sebzodes)
	    && !(spec_event[i].type&event_type_X_plusz) && !(spec_event[i].type&event_type_X_minusz)
	    && !(spec_event[i].type&event_type_maxvalt)
	)
	{
	    continue;
	}
	if ((spec_event[i].type&event_type_csak_taborozas) && block_taborozas_utani && *block_taborozas_utani && (start >= *block_taborozas_utani))
	{
	    continue;
	}
	if (!spec_event[i].hol || (spec_event[i].hol >= p3))
	{
	    continue;
	}
	if (spec_event[i].type&event_type_spec_monsta)
	{
	    if (szn)
	    {
		if (strcmp(szn, spec_event[i].kiemel_s) == 0)
		{
		    continue;
		}
	    }
	}

	if (spec_event[i].eleje)
	{
	    p1 = strstr3_(buf, spec_event[i].eleje, p3, &ee1, &vv1);
	}
	else
	{
	    p1 = NULL;
	}
	if (spec_event[i].vege)
	{
	    p2 = strstr3_((p1 ? p1 : buf), spec_event[i].vege, p3, &ee2, &vv2);
	}
	else
	{
	    p2 = NULL;
	}
	
	if (spec_event[i].eleje && spec_event[i].vege)
	{
	    if (p1 && p2 && (p1 < p2) && (p2 < p3))
	    {
		if (!p4 || (p1 < p4))
		{
		    ok = 1;
		    p3 = p2;
		    p4 = p1;
		    *vi = i;
		    *eleje = (spec_event[i].type&event_type_csak_kozti ? vv1 : ee1);
		    *vege = (spec_event[i].type&event_type_csak_kozti ? ee2 : vv2);
		    if (spec_event[i].type&event_type_spec_monsta)
		    {
			if (szn)
			{
			    free(szn);
			    szn = NULL;
			}
			if (spec_event[i].kiemel_s)
			{
			    szn = strdup(spec_event[i].kiemel_s);
			}
		    }
		}
	    }
	}
	else if (spec_event[i].vege)
	{
	    if (p2 && (p2 < p3))
	    {
		ok = 1;
		p3 = p2;
		p4 = NULL;
		*vi = i;
		*eleje = ee2;
		*vege = vv2;
		if (spec_event[i].type&event_type_spec_monsta)
		{
		    if (szn)
		    {
			free(szn);
			szn = NULL;
		    }
		    if (spec_event[i].kiemel_s)
		    {
			szn = strdup(spec_event[i].kiemel_s);
		    }
		}
	    }
	}
	else if (spec_event[i].eleje)
	{
	    if (p1 && (p1 < p3))
	    {
		ok = 1;
		p3 = p1;
		p4 = NULL;
		*vi = i;
		*eleje = ee1;
		*vege = vv1;
		if (spec_event[i].type&event_type_spec_monsta)
		{
		    if (szn)
		    {
			free(szn);
			szn = NULL;
		    }
		    if (spec_event[i].kiemel_s)
		    {
			szn = strdup(spec_event[i].kiemel_s);
		    }
		}
	    }
	}
    }
    *buf_vege = tmp;

    if (szn)
    {
        free(szn);
        szn = NULL;
    }

    if (ok)
    {
	return p3;
    }
    else
    {
	return NULL;
    }
}

extern int event_init(t_fordulo * fordulo)
{
    int i;
    char * p1;
    char * p3;
    char tmp;
    char korvegechr;
    char * buf;
    
    block_taborozas_utani = NULL;
    loptak = 0;
    
    if (fordulo == NULL || !fordulo->fordulostr)
    {
	return -1;
    }

    // taborozas utani block feljegyzese
    for (block_taborozas_utani = &fordulo->taborozas + 1; (*block_taborozas_utani == NULL) && (block_taborozas_utani < &fordulo->end); block_taborozas_utani++);

    if (fordulo->korvege_tvp)
    {
	korvegechr = *fordulo->korvege_tvp;
	*fordulo->korvege_tvp = '\0';
    }
    else
    {
	korvegechr = '\0';
    }
    for (i = 0; (i < (sizeof(spec_event) / sizeof(t_spec_event))) && (spec_event[i].eleje || spec_event[i].vege); i++)
    {
	if (spec_event[i].eleje)
	{
	    buf = strdup(spec_event[i].eleje);
	}
	else if (spec_event[i].vege)
	{
	    buf = strdup(spec_event[i].vege);
	}
	if (!buf)
	{
	    continue;
	}
	p1 = skip_space(buf);
	p1 = skip_nonspace(p1);
	tmp = *p1;
	*p1 = '\0';

	p3 = strstr2(fordulo->fordulostr, buf);
	spec_event[i].hol = p3;
#ifdef DEBUG
	debug(fordulo, "event_init: spec_event [%d] buf=\"%s\" => %p (\"%.40s\")\n", i, buf, spec_event[i].hol, (spec_event[i].hol ? spec_event[i].hol  - strlen(buf) : spec_event[i].hol));
#endif
	*p1 = tmp;
	free(buf);
	buf = NULL;
    }
    if (korvegechr)
    {
	*fordulo->korvege_tvp = korvegechr;
    }
}

char * reformat_event_feldolgoz(t_fordulo * fordulo, char * start, char * end)
{
    char * l1;
    char * l2;
    char * l3;
    char * l4;
    int ok;
    char * eleje;
    char * vege;
    char * elozo;
    char * X_elozo;
    int vi;
    int faname;
    char * pn;
    int n;
    int ssz;
    char * buf;
    char * b2;
    int for1;
    int for2;
    int elojel;
    t_csata * osszesen;
    int i;
    int jellemvaltozas;
    char * ptvp;
    char * ladiko;
    
    l3 = start;
    ok = 0;
    
    if (!fordulo)
    {
	return l3;
    }
    
    osszesen = &fordulo->osszesen;
    
    for (l2 = l3, elozo = l2, X_elozo = elozo; (l2 = spec_event_next(fordulo, l2, end, &eleje, &vege, &vi)) && (l2 <= end); elozo = l2, l2 = (l3 > l2 ? l3 : l2))
    {
#ifdef DEBUG
	debug(fordulo, "reformat_event_feldolgoz: type=%d, event=\"%.*s\", l2=\"%.*s\"\n", spec_event[vi].type, vege-eleje, eleje, end - l2, l2);
#endif
	faname = 0;
	
	if (!(spec_event[vi].type&event_type_mezo) && !fordulo->mezo_utolso && (aconf_get_curr("korvege_mezo_kiiras") == 1) && (l3 == fordulo->taborozas) && (fordulo->mezo.x == 0) && (fordulo->mezo.y == 0) && (fordulo->mezo.ssz == 0))
	{
	    mezo_store(fordulo, fordulo->mezo.x, fordulo->mezo.y);
	    output(fordulo, "<a name=\"mezo%d\">", fordulo->mezo.ssz);
	}
	
	// ladikok atugrasa
	if ((spec_event[vi].type&event_type_mezo) && (ladiko = strstr(eleje, "ldikba-&gt;")) && (ladiko < vege))
	{
	    continue;
	}
	// hatizsak beleteles
	if ((spec_event[vi].type&event_type_mezo) && (ladiko = strstr_(eleje, "maximlis megengedett szm trgy van Nlad", vege)) && (ladiko < vege))
	{
	    continue;
	}
	// mezei trezsor az eventek kozott
	if (aconf_get_curr("kiemeles_trezsor") == 1)
	{
	    char * t1;
	    char * t2;
	    
	    for (t1 = l3; ((t2 = trezsor_next(t1, eleje, 2)) && (t2 < eleje)); t1 = t2)
	    {
		l3 = trezsor(fordulo, t2, l3, eleje);
	    }
	}
	
	// spec monsta kiemeles
	if ((spec_event[vi].type&event_type_spec_monsta) && (get_cache_mode() || (aconf_get_curr("kiemeles_szornyszam") == 1)))
	{
	    eleje = skip_space(eleje);
	    for ( ; isspace2(*(vege-1)) && (vege > eleje); vege--);
	    output(fordulo, "%.*s", eleje - l3, l3);
	    l3 = reformat_nev_kiemeles(fordulo, eleje, vege, 1);
	}
	// szaki csillag kiemeles
	else if (!get_cache_mode() && (spec_event[vi].type&event_type_szaki_csillag) && (aconf_get_curr("kiemeles_szakicsillag") == 1))
	{
	    int bold;
	    
	    bold = 0;
	    if (*(eleje - 1) != '>')
	    {
		bold = 1;
	    }
	    faname = figyelmeztetes_store(fordulo, eleje, vege, 0);
	    output(fordulo, "%.*s<a name=\"figyelmeztetes%d\">%s%.*s%s</a>", eleje - l3, l3, faname, (bold?"<b>":""), vege - eleje, eleje, ((bold?"</b>":"")));
	    l3 = vege;
	}
	// TVP valtozas
	else if ((spec_event[vi].type&event_type_tvpvalt) && (get_cache_mode() || (aconf_get_curr("korvege_csata_tvp_stat") == 1)))
	{
	    // tvp kapas safranykristaly
	    if (spec_event[vi].subtype == event_subtype_1)
	    {
		eleje = skip_space(eleje);
		if (isdigit2(*eleje))
		{
		    fordulo->osszesen.tvp_stat_p += atoi(eleje);
		}
		output(fordulo, "%.*s%s%.*s%s", eleje - l3, l3, spec_event[vi].kiemel_s, vege - eleje, eleje, spec_event[vi].kiemel_e);
		l3 = vege;
	    }
	    // idotorzitas
	    else if (spec_event[vi].subtype == event_subtype_2)
	    {
		fordulo->osszesen.tvp_stat_p += 30;
		if (fordulo->osszesen.tvp_kapas <= 0)
		{
		    fordulo->osszesen.tvp_kapas -= 30;
		}
		output(fordulo, "%.*s%s%.*s%s", eleje - l3, l3, spec_event[vi].kiemel_s, vege - eleje, eleje, spec_event[vi].kiemel_e);
		l3 = vege;
	    }
	}
	// TU valtozas
	else if ((spec_event[vi].type&event_type_tuvalt) && (get_cache_mode() || (aconf_get_curr("korvege_csata_tu_stat") == 1)))
	{
	    // tu kapas osvortexbol
	    if (spec_event[vi].subtype == event_subtype_3)
	    {
		char * tubug1;
		char * tubug2;
		
		if ((tubug1 = strstr_(vege, "pontot hasznltl fel, van mg", end)) && (tubug2 = strstr(vege, "(+#")) && (tubug2 < tubug1))
		{
		    continue;
		}
	    }
	    // tu kapas konverziobol, olimpian, osvortexen
	    if ((spec_event[vi].subtype == event_subtype_1) || (spec_event[vi].subtype == event_subtype_3))
	    {
		eleje = skip_space(eleje);
		if (isdigit2(*eleje))
		{
		    fordulo->osszesen.tu_stat_p += atoi(eleje);
		}
	    }
	    else if (spec_event[vi].subtype == event_subtype_2)
	    {
		for ( ; !isdigit2(*eleje) && (eleje < vege); eleje++);
		eleje = skip_nonspace(eleje);
		for ( ; !isdigit2(*eleje) && (eleje < vege); eleje++);
		if (isdigit2(*eleje))
		{
		    fordulo->osszesen.tu_stat_p += atoi(eleje);
//kiir(NULL, "|%d|", atoi(eleje));
		}
	    }
	}
	// automatikus tu -> tvp valtas ha a taborozaskor max fole regenesz
	else if ((spec_event[vi].type&event_type_tutvp) && (get_cache_mode() || (aconf_get_curr("korvege_csata_tu_stat") == 1) || (aconf_get_curr("korvege_csata_tvp_stat") == 1)))
	{
	    if (vege - eleje < 50)
	    {
		 
		for(pn = eleje; !isdigit2(*pn) && (pn < vege); pn++);
		if (isdigit2(*pn))
		{
		    n = atoi(pn);
		    fordulo->osszesen.tvp_stat_p += n;
		    fordulo->osszesen.tu_koltes += n / 5;
		    if ((fordulo->osszesen.tvp_kapas <= 0) && (!(ptvp = strstr_(start, "pontot hasznltl fel, van mg", vege)) || (ptvp > vege)))
		    {
			fordulo->osszesen.tvp_kapas -= n;
		    }
	    	    
		    l1 = eleje - 1;
		    for( ; (l1 > l3) && ((*l1 == ' ') || (*l1 == '\t') || (*l1 == '\r') || (*l1 == '\n')); l1--);
		    for( ; (l1 > l3) && (*l1 != ' '); l1--);
		    l1 = skip_space(l1);
		    
		    output(fordulo, "%.*s<b>%.*s</b>", l1 - l3, l3, vege - l1, l1);
		    l3 = vege;
		}
	    }
	}
	// tolvaj felismeres
	else if (!get_cache_mode() && (spec_event[vi].type&event_type_tolvaj) && (aconf_get_curr("kiemeles_karakterszam") == 1))
	{
	    // KT-kepesseg a felismeresre
	    if (spec_event[vi].subtype == event_subtype_tolvaj_felismeres_ktkepesseg)
	    {
	        l1 = eleje;
		for ( ; !isdigit2(*l1) && (l1 + 10 > eleje); l1--);
	        for ( ; isdigit2(*l1) && (l1 + 10 > eleje); l1--);
		l4 = vege;
		for ( ; (l4 < end) && !((*l4 == '.') && isspace2(*(l4+1))); l4++);
		if (*l1 == '(')
		{
		    for ( ; (l1 > start) && !((*l1 == '.') && isspace2(*(l1+1))); l1--);
		    l1 = skip_space(l1+1);
		    
		    if (b2 = malloc(l4 - l1 + 1))
		    {
			sprintf(b2, "%.*s", l4 - l1, l1);
			faname = figyelmeztetes_store(fordulo, b2, b2 + strlen(b2), 0);
			free(b2);
		    }
		    output(fordulo, "%.*s<a name=\"figyelmeztetes%d\"><b>%.*s</b></a>", l1 - l3, l3, faname, l4 - l1, l1);
		    l3 = l4;
		    loptak = 3;
		}
	    }
	    else if ((!loptak) && (spec_event[vi].subtype == event_subtype_tolvaj_default_kiiras))
	    {
		output(fordulo, "%.*s<b>%.*s</b>", eleje - l3, l3, vege - eleje, eleje);
		l3 = vege;
		loptak = 1;

		// Alap, nyomokbol felismeres
		if ((eleje = strstr_i(l3, "hogy a tolvaj", end)) && (l1 = strstr2(eleje, "tolvaj")) && (l4 = strstr(l1, "volt.")) && (vege = strstr2(l1, "volt.")) && (vege < end))
		{
		    eleje = skip_nonspace(eleje);
		    eleje = skip_space(eleje);
		    l1 = skip_space(l1);
		    for(l4--; (l4 > l1) && ((*l4 == ' ') || (*l4 == '\t') || (*l4 == '\r') || (*l4 == '\n')); l4--);
		    l4++;

		    output(fordulo, "%.*s<b>%.*s</b>", eleje - l3, l3, l1 - eleje, eleje);
		    l3 = l1;
		    if (buf = malloc(l4 - l1 + 1))
		    {
			sprintf(buf,"%.*s", l4 - l1, l1);
			reformat_nev_kiemeles(fordulo, buf, buf + strlen(buf), 0);
			l3 = l4;
			ssz = 0;
			n = 0;
			if (fordulo->mezo_utolso && fordulo->mezo_utolso->enemy_utolso)
			{
			    ssz = fordulo->mezo_utolso->enemy_utolso->ssz;
			    n = (fordulo->mezo_utolso->enemy_utolso->nev ? strlen(fordulo->mezo_utolso->enemy_utolso->nev) : 0);
			}
			
			if (b2 = malloc((n ? n : strlen(buf)) + (ssz ? 10 : 0) + 50 + 1))
			{
			    if (ssz)
			    {
				sprintf(b2, "Loptak tled, a tolvaj %s (#%d) volt.", (n ? fordulo->mezo_utolso->enemy_utolso->nev : buf), ssz);
			    }
			    else
			    {
				sprintf(b2, "Loptak tled, a tolvaj %s volt.", (n ? fordulo->mezo_utolso->enemy_utolso->nev : buf));
			    }
			    faname = figyelmeztetes_store(fordulo, b2, b2 + strlen(b2), 0);
			    output(fordulo, "<a name=\"figyelmeztetes%d\"></a>", faname);
			    free(b2);
			    loptak = 2;
			}
			free(buf);
		    }
		    output(fordulo, "<b>%.*s</b>", vege - l4, l4);
		    l3 = vege;
		}
		else if (b2 = malloc(75 + 1))
		{
		    sprintf(b2, "Loptak tled, a nyomokbl nem tudtad megllapitani ki volt a tolvaj.");
		    figyelmeztetes_store(fordulo, b2, b2 + strlen(b2), 0);
		    output(fordulo, "<a name=\"figyelmeztetes%d\"></a>", faname);
		    free(b2);
		}
	    }
	}
	// szopoko
	else if (!get_cache_mode() && (spec_event[vi].type&event_type_szopoko) && (aconf_get_curr("kiemeles_szopoko") == 1))
	{
	    if (spec_event[vi].subtype == event_subtype_szopoko_jon)
	    {
		faname = figyelmeztetes_store(fordulo, eleje, vege, 0);
		output(fordulo, "%.*s<a name=\"figyelmeztetes%d\"><b>%.*s</b></a>", eleje - l3, l3, faname, vege - eleje, eleje);
		l3 = vege;
	    }
	    else if (spec_event[vi].subtype == event_subtype_szopoko_megy)
	    {
		int n1= 4;
		int n2 = 1;

		if (fordulo->mezo_utolso && fordulo->mezo_utolso->enemy_utolso)
		{
		    if (fordulo->mezo_utolso->enemy_utolso->ssz)
		    {
			n1 = 6;
		    }
		    if (fordulo->mezo_utolso->enemy_utolso->nev)
		    {
			n2 = strlen(fordulo->mezo_utolso->enemy_utolso->nev);
		    }
		    if (b2 = malloc(50 + n1 + n2 + 1))
		    {
			if (fordulo->mezo_utolso->enemy_utolso->ssz == 0)
			{
			    sprintf(b2, "tugrott egy szopkved \"%s\" karakterhez.", (fordulo->mezo_utolso->enemy_utolso->nev ? fordulo->mezo_utolso->enemy_utolso->nev : "?"));
			}
			else
			{
			    sprintf(b2, "tugrott egy szopkved %s (#%d) karakterhez.", (fordulo->mezo_utolso->enemy_utolso->nev ? fordulo->mezo_utolso->enemy_utolso->nev : "?"), fordulo->mezo_utolso->enemy_utolso->ssz);
			}
			faname = figyelmeztetes_store(fordulo, b2, b2 + strlen(b2), 0);
			free(b2);
		    }
		}
		output(fordulo, "%.*s<a name=\"figyelmeztetes%d\"><b>%.*s</b></a>", eleje - l3, l3, faname, vege - eleje, eleje);
		l3 = vege;
	    }
	}
	// maxvaltozas
	else if ((spec_event[vi].type&event_type_maxvalt) && (get_cache_mode() || (aconf_get_curr("korvege_permanens_max_stat") == 1)))
	{
	    char * sz1;
	    char * sz2;
	    char * sze;
	    char * szv;
	    int szi;
	    
	    sze = NULL;
	    szv = NULL;
		
	    // szintlepes
	    if (spec_event[vi].subtype == event_subtype_1)
	    {
		for (sz2 = eleje; (sz1 = strstr2(sz2, "+")) && isdigit2(*sz1) && (sz2 = strstr2(sz1, "max.")) && (sz2 < vege); )
		{
		    if (!sze)
		    {
			sze = sz1;
		    }
		    sz2 = skip_space(sz2);
		    szi = atoi(sz1);
		    if (strncmp(sz2, "varzspont,", strlen("varzspont,")) == 0)
		    {
			fordulo->osszesen.vp_max_p += szi;
		    }
		    else if (strncmp(sz2, "leter,", strlen("leter,")) == 0)
		    {
			fordulo->osszesen.ep_max_p += szi;
		    }
		    szv = skip_nonspace(sz2);
		}
		if (sze && szv && (eleje < sze) && (sze < szv) && (szv < vege))
		{
		    output(fordulo, "%.*s%s%.*s%s", sze - l3, l3, spec_event[vi].kiemel_s, szv - sze, sze, spec_event[vi].kiemel_e);
		    l3 = szv;
		}
	    }
	    // osvortex
	    else if (spec_event[vi].subtype == event_subtype_2)
	    {
		vege = skip_space(vege);
		if (strncmp(vege, "varzspontod", strlen("varzspontod")) == 0)
		{
		    fordulo->osszesen.vp_max_p += 1;
		    vege = skip_nonspace(vege);
		}
		else if (strncmp(vege, "letpontod", strlen("letpontod")) == 0)
		{
		    fordulo->osszesen.ep_max_p += 1;
		    vege = skip_nonspace(vege);
		}
		output(fordulo, "%.*s%s%.*s%s", eleje - l3, l3, spec_event[vi].kiemel_s, vege - eleje, eleje, spec_event[vi].kiemel_e);
		l3 = vege;
	    }
	}
	// eletkorvalt
	else if ((spec_event[vi].type&event_type_eletkorvalt) && (get_cache_mode() || (aconf_get_curr("korvege_permanens_oregedes_stat") == 1)))
	{
	    char * f1 = NULL;
	    char * o1 = NULL;
	    
	    // fiatalodas spell
	    if (spec_event[vi].subtype == event_subtype_1)
	    {
		f1 = eleje - 1;
		for ( ; (f1 > l3) && isspace2(*f1) ; f1--);
		for ( ; (f1 > l3) && isdigit2(*f1) ; f1--);
		f1++;
		if (isdigit2(*f1))
		{
		    eleje = f1;
		}
	    }
	    // fitalsag ital
	    else if (spec_event[vi].subtype == event_subtype_2)
	    {
		f1 = skip_nonspace(eleje);
		f1 = skip_space(f1);
		eleje++;
		vege--;
	    }
	    // Oregedes
	    else if (spec_event[vi].subtype == event_subtype_3)
	    {
		for (o1 = eleje; !isdigit2(*o1) && (o1 < vege); o1++);
	    }
	    
	    if (f1 && isdigit2(*f1))
	    {
#ifdef DEBUG
	        debug(fordulo, "reformat_event_feldolgoz: csatan kivul fiatalodas: \"%.*s\" o1=%d\n", vege - eleje, eleje, f1);
#endif
		fordulo->osszesen.fiatalodas_stat += atoi(f1);
		output(fordulo, "%.*s%s%.*s%s", eleje - l3, l3, spec_event[vi].kiemel_s, vege - eleje, eleje, spec_event[vi].kiemel_e);
		l3 = vege;
	    }
	    if (o1 && isdigit2(*o1))
	    {
#ifdef DEBUG
	        debug(fordulo, "reformat_event_feldolgoz: csatan kivul oregedes: \"%.*s\" o1=%d\n", vege - eleje, eleje, o1);
#endif
	        fordulo->osszesen.oregedes_stat += atoi(o1);
		faname = figyelmeztetes_store(fordulo, eleje, vege, 0);
		output(fordulo, "%.*s<a name=\"figyelmeztetes%d\">%s%.*s%s</a>", eleje - l3, l3, faname, spec_event[vi].kiemel_s, vege - eleje, eleje, spec_event[vi].kiemel_e);
		l3 = vege;
	    }
	    
	}
	// nincs komponens
	else if (!get_cache_mode() && (spec_event[vi].type&event_type_nincskompi) && (aconf_get_curr("kiemeles_nincskompi") == 1))
	{
	    char * pke;
	    char * pkv;
	    char *pk1;
	    char *pk2;
	    char *pk3;
	    
	    if ((pk1 = strstr2(vege, ")")) && (pk1 != strstr2(vege, "szopk.)")) && (pk2 = strstr_(vege, "pontot hasznltl fel, van mg", end)) && (pk1 < pk2))
	    {
		vege = pk1;
		pke = eleje;
		pkv = vege;
		faname = figyelmeztetes_store(fordulo, pke, pkv, 0);
		if ((pk1 = strstr(pke, "nincs")) && (pk2 = strstr2(pk1, "birtokodban")) && (pk3 = strstr(pk2, "(")) && (pk3 < pkv))
		{
		    output(fordulo, "%.*s<a name=\"figyelmeztetes%d\">%s%.*s%s</a>%.*s%s%.*s%s", pk1 - l3, l3, faname, spec_event[vi].kiemel_s, pk2 - pk1, pk1, spec_event[vi].kiemel_e, pk3 - pk2, pk2, spec_event[vi].kiemel_s, vege - pk3, pk3, spec_event[vi].kiemel_e);
	    	    l3 = vege;
		}
		else
		{
		    output(fordulo, "%.*s<a name=\"figyelmeztetes%d\">%s%.*s%s</a>", eleje - l3, l3, faname, spec_event[vi].kiemel_s, vege - eleje, eleje, spec_event[vi].kiemel_e);
		    l3 = vege;
		}
	    }
	}
	// event_type_csak_kiemel
	else if (!get_cache_mode() && (spec_event[vi].type&event_type_csak_kiemel) && (aconf_get_curr("kiemeles_onanalizis") == 1))
	{
	    output(fordulo, "%.*s%s%.*s%s", eleje - l3, l3, spec_event[vi].kiemel_s, vege - eleje, eleje, spec_event[vi].kiemel_e);
	    l3 = vege;
	}
	// zarknod feltalals
	else if (!get_cache_mode() && (spec_event[vi].type&event_type_zarknod) && (aconf_get_curr("kiemeles_zarknod") == 1))
	{
	    output(fordulo, "%.*s<SPAN CLASS=\"trezsor\">%.*s</SPAN>", eleje - l3, l3, vege - eleje, eleje);
	    l3 = vege;
	}
	// jellemvaltozas
	else if (!get_cache_mode() && (spec_event[vi].type&event_type_jellemvaltozas) && (aconf_get_curr("kiemeles_jellemvaltozas") == 1))
	{
	    faname = figyelmeztetes_store(fordulo, eleje, vege, 0);
	    output(fordulo, "%.*s<a name=\"figyelmeztetes%d\"><b>%.*s</b></a>", l1 - l3, l3, faname, vege - eleje, eleje);
	    l3 = vege;
	}
	// EF elmulas
	else if ((!get_cache_mode() && spec_event[vi].type&event_type_ef) && (aconf_get_curr("kiemeles_ef") == 1))
	{
	    faname = figyelmeztetes_store(fordulo, eleje, vege, 0);
	    output(fordulo, "%.*s<a name=\"figyelmeztetes%d\"><b>%.*s</b></a>", eleje - l3, l3, faname, vege - eleje, eleje);
	    l3 = vege;
	}
	// szorny ehes es masikat felfal keresese
	else if (!get_cache_mode() && (spec_event[vi].type&event_type_szornyehes) && (aconf_get_curr("kiemeles_szornyehes") == 1))
	{
	    faname = figyelmeztetes_store(fordulo, eleje, vege, 0);
	    output(fordulo, "%.*s<a name=\"figyelmeztetes%d\"><b>%.*s</b></a>", eleje - l3, l3, faname, vege - eleje, eleje);
	    l3 = vege;
	}
	// trezsor
	else if ((spec_event[vi].type&event_type_trezsor) && !get_cache_mode())
	{
	    if (spec_event[vi].subtype == event_subtype_1)
	    {
		//nem csinalunk semmit
	    }
	    else if (spec_event[vi].subtype == event_subtype_2)
	    {
		eleje = skip_nonspace(eleje);
		eleje = skip_space(eleje);
		eleje = skip_nonspace(eleje);
		eleje = skip_space(eleje);
	    }
	    output(fordulo, "%.*s%s%.*s%s", eleje - l3, l3, spec_event[vi].kiemel_s, vege - eleje, eleje, spec_event[vi].kiemel_e);
	    l3 = vege;
	}
	// X_Plusz csatan kivul
	else if (spec_event[vi].type&event_type_X_plusz)
	{
	    t_spec_event_subtype event_subtype;
	    char * p1;
	    char * p2;
	    char * p3;
	    char * p4;
	    char * p5;
	    char * p6;
	    
	    p1 = vege;
	    p2 = eleje;
	    p4 = X_elozo;
	    X_elozo = vege;
	    
	    // kaja kiszurese :)
	    if (((p5 = strstr2(p2,"kaja.")) && (p5 < p1)) || ((p6 = strstr2(p2,"kaja<")) && (p6 < p1)))
	    {
#ifdef DEBUG
		debug(fordulo, "reformat_event_feldolgoz: csatan kivul kaja plusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
		continue;
	    }
	    
	    // subtype set
	    event_subtype = event_subtype_none;
	    if ((p5 = strstr(eleje, "max.")) && (p5 < vege))
	    {
		event_subtype = event_subtype_X_max;
	    }
	    
	    if (event_subtype == event_subtype_X_max)
	    {
		if (get_cache_mode() || (aconf_get_curr("korvege_permanens_max_stat") == 1))
		{
		    // max ep kapasa
		    if ((p1 == strstr2(p2,"leter</SPAN>)")) || (p1 == strstr2(p2,"leter.</SPAN>)")) || (p1 == strstr2(p2,"p</SPAN>)")) || (p1 == strstr2(p2,"p.</SPAN>)")))
		    {
			for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
			if (isdigit2(p3[0]) && (p3 < p1))
			{
#ifdef DEBUG
			    debug(fordulo, "reformat_event_feldolgoz: csatan kivul max ep plusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			    osszesen->ep_max_p += atoi(p3);
			    continue;
			}
		    }
		    // max vp kapasa
		    if ((p1 == strstr2(p2,"varzspont</SPAN>)")) || (p1 == strstr2(p2,"varzspont.</SPAN>)")))
		    {
			// Kuldetes leimadkozasa +max ep, +max vp.
			if ((p5 = strstr2(p2,"leter,")) && (p5 < p1))
			{
			    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p5); p3++);
			    if (isdigit2(p3[0]) && (p3 < p5))
			    {
#ifdef DEBUG
				debug(fordulo, "reformat_event_feldolgoz: csatan kivul max ep plusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
				osszesen->ep_max_p += atoi(p3);
			    }
			    p2 = p5;
			}
			for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
			if (isdigit2(p3[0]) && (p3 < p1))
			{
#ifdef DEBUG
			    debug(fordulo, "reformat_event_feldolgoz: csatan kivul max vp plusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			    osszesen->vp_max_p += atoi(p3);
			    continue;
			}
		    }
		    // max pszi pont kapasa
		    if ((p1 == strstr2_(p2,"pszi pont</SPAN>)", p1 + 1)) || (p1 == strstr2_(p2,"pszi pont.</SPAN>)", p1 + 1)))
		    {
			for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
			if (isdigit2(p3[0]) && (p3 < p1))
			{
#ifdef DEBUG
			    debug(fordulo, "reformat_event_feldolgoz: csatan kivul max pszi plusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			    osszesen->pszi_max_p += atoi(p3);
			    continue;
			}
		    }
		    // max tu kapasa
		    if ((p1 == strstr2(p2,"tudatpont</SPAN>)")) || (p1 == strstr2(p2,"tudatpont.</SPAN>)")) || (p1 == strstr2(p2,"TU</SPAN>)")) || (p1 == strstr2(p2,"TU.</SPAN>)")))
		    {
			for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
			if (isdigit2(p3[0]) && (p3 < p1))
			{
#ifdef DEBUG
			    debug(fordulo, "reformat_event_feldolgoz: csatan kivul max TU plusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			    osszesen->tu_max_p += atoi(p3);
			    continue;
			}
		    }
#ifdef DEBUG
		    debug(fordulo, "reformat_event_feldolgoz: csatan kivul ismeretlen max plusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
		}
		continue;
	    } // end of X_max
	    
	    // VP_plusz csatan kivul
	    if (get_cache_mode() || (aconf_get_curr("korvege_eroforras_vp_stat") == 1))
	    {
		if ((p1 == strstr2(p2,"varzspont</SPAN>)")) || (p1 == strstr2(p2,"varzspont.</SPAN>)")) || ((p1 == strstr2(p2,"VP</SPAN>)")) && (p1 != strstr2(p2,"TVP</SPAN>)"))))
		{
		    for (p5 = p2; (p5[0] != '.') && (p5 >= p4); p5--);
		    for (p5--; (p5[0] != '.') && (p5 >= p4); p5--);
		    if ((p6 = strstr(p5, "manakristly")) && (p6 < p2))
		    {
			for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
#ifdef DEBUG
			debug(fordulo, "reformat_event_feldolgoz: csatan kivul vp plusz manakristaly: p1=%p p2=%p %.60s\n", p1, p2, p5);
#endif
			osszesen->vp_manakristaly += atoi(p3);
			continue;
		    }
		    else if ((p6 = strstr(p5, "varzsk")) && (p6 < p2))
		    {
			for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
			i = atoi(p3);
			if (i == 100)
			{
#ifdef DEBUG
			    debug(fordulo, "reformat_event_feldolgoz: csatan kivul vp plusz varazsko: p1=%p p2=%p %.60s\n", p1, p2, p5);
#endif
			    osszesen->vp_varazsko += i;
			    continue;
			}
		    }
		    // idocsere
		    if ((p1 == strstr2(p2,"VP</SPAN>)")) && (p5 = strstr2(p2, "TVP,")) && p5 && (p5 < p1))
		    {
			for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
			if (isdigit2(p3[0]) && (p3 < p1))
			{
#ifdef DEBUG
			    debug(fordulo, "reformat_event_feldolgoz: csatan kivul tvp plusz (idocsere): p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			    osszesen->tvp_stat_p += atoi(p3);
			    if ((osszesen->tvp_kapas <= 0) && (!(ptvp = strstr_(start, "pontot hasznltl fel, van mg", p1)) || (ptvp > p1)))
			    {
				osszesen->tvp_kapas -= atoi(p3);
			    }
			}
			for (p3 = p5; !isdigit2(p3[0]) && (p3 <= p1); p3++);
			if (isdigit2(p3[0]) && (p3 < p1))
			{
#ifdef DEBUG
			    debug(fordulo, "reformat_event_feldolgoz: csatan kivul vp minusz (idocsere): p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			    osszesen->vp_stat_n += atoi(p3);
			}
			continue;
		    }
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_event_feldolgoz: csatan kivul vp plusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			osszesen->vp_stat_p += atoi(p3);
			continue;
		    }
		}
	    }
	    // Morgan szilank csatan kivul
	    if ((get_cache_mode() || (aconf_get_curr("korvege_eroforras_ep_stat") == 1) || (aconf_get_curr("csata_morgan") == 1)) && (p1 == strstr2(p2,"letpont</SPAN>)")))
	    {
		char * v1;
		char * v2;
		int morgancsata = 0;
		
		morgancsata = 0;
		for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		if (isdigit2(p3[0]) && p3 < p1)
		{
		    if (v1 = strstr2(p4,"Feltmadsz!"))
		    {
			if ((v1 > p4) && (v1 < p2))
			{
#ifdef DEBUG
			    debug(fordulo, "reformat_event_feldolgoz: feltamadas: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			    osszesen->feltamadas += atoi(p3);
			    continue;
			}
		    }
		    if (v1 = strstr2(p4,"hallkapu"))
		    {
			if ((v1 > p4) && (v1 < p2))
			{
#ifdef DEBUG
			    debug(fordulo, "reformat_event_feldolgoz: hallkapu: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			    osszesen->feltamadas += atoi(p3);
			    continue;
			}
		    }
		    if (aconf_get_curr("csata_morgan") == 1)
		    {
			if ((v1 = strstr2(p4,"vmpirizci")) && (v2 = strstr2(p4, "Megjtod")))
			{
			    if ((v1 > p4) && (v1 < p2) && (v2 > p4) && (v2 < v1))
			    {
				morgancsata = 1;
//				cache_add_spell_count(fordulo, fordulo->cache, 1);
			    }
			}
			else if ((v1 = strstr2(p4,"ldoms")) && (v2 = strstr2(p4, "Megjtod")))
			{
			    if ((v1 > p4) && (v1 < p2) && (v2 > p4) && (v2 < v1))
			    {
				morgancsata = 1;
//				cache_add_spell_count(fordulo, fordulo->cache, 6);
			    }
			}
			if (morgancsata)
			{
#ifdef DEBUG
			    debug(fordulo, "reformat_event_feldolgoz: csatan kivul de csatahoz tartozo Morgan: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			    osszesen->morgan_csata += atoi(p3);
			    continue;
			}
			else if (aconf_get_curr("korvege_eroforras_ep_stat") == 1)
			{
#ifdef DEBUG
			    debug(fordulo, "reformat_event_feldolgoz: csatan kivuli Morgan: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			    osszesen->morgan_stat += atoi(p3);
			    continue;
			}
		    }
		    else if (aconf_get_curr("korvege_eroforras_ep_stat") == 1)
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_event_feldolgoz: csatan kivuli vagy beluli Morgan: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			osszesen->morgan_stat += atoi(p3);
			continue;
		    }
		}
	    }
	    // Ezustmagus kurt
	    if ((get_cache_mode() || (aconf_get_curr("korvege_eroforras_ep_stat") == 1) || (aconf_get_curr("korvege_eroforras_vp_stat") == 1)) && (p1 == strstr2(p2,"letpont.</SPAN>)")))
	    {
		p3 = strstr2(p2,",");
		if ((p3 == strstr2(p2,"varzspont,")) && (p3 < p1))
		{
#ifdef DEBUG
		    debug(fordulo, "reformat_event_feldolgoz: csatan kivul Ezusmagus kurt: p1=%p p2=%p p3=%p %.60s\n", p1, p2, p3, p2);
#endif
		    for ( ; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if ((aconf_get_curr("korvege_eroforras_ep_stat") == 1) && isdigit2(p3[0]) && (p3 < p1))
		    {
			osszesen->kurt_stat_ep += atoi(p3);
		    }
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if ((aconf_get_curr("korvege_eroforras_vp_stat") == 1) && isdigit2(p3[0]) && (p3 < p1))
		    {
			osszesen->kurt_stat_vp += atoi(p3);
		    }
		    continue;
		}
	    }
	    // EP_plusz csatan kivul
	    if (get_cache_mode() || (aconf_get_curr("korvege_eroforras_ep_stat") == 1))
	    {
		if ((p1 == strstr2(p2,"leter</SPAN>)")) || (p1 == strstr2(p2,"leter.</SPAN>)")) || (p1 == strstr2(p2,"p</SPAN>)")) || (p1 == strstr2(p2,"p.</SPAN>)")))
		{
		    char * v1;

		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
			if (v1 = strstr2_(p4,"deus ex machina",p2))
			{
			    if ((v1 > p4) && (v1 < p2))
			    {
#ifdef DEBUG
				debug(fordulo, "reformat_event_feldolgoz: dem: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
				osszesen->dem += atoi(p3);
				continue;
			    }
			}
		    
#ifdef DEBUG
			debug(fordulo, "reformat_event_feldolgoz: csatan kivul ep plusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			osszesen->ep_stat_p += atoi(p3);
			continue;
		    }
		}
	    }
	    // Csupasz izom
	    if (!get_cache_mode() && (aconf_get_curr("karlap_bonuszok_kiiras") == 1) && (p1 == strstr2(p2," er</SPAN>)")))
	    {
		for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		if (isdigit2(p3[0]) && (p3 < p1))
		{
#ifdef DEBUG
		    debug(fordulo, "reformat_event_feldolgoz: csatan kivul csupaszizom: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
		    fordulo->karakter->csupaszizom = atoi(p3);
		    continue;
		}
	    }
	    // Oriasero
	    if (!get_cache_mode() && (aconf_get_curr("karlap_bonuszok_kiiras") == 1) && (p1 == strstr2(p2,"tmadsonknt.</SPAN>)")))
	    {
		for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		if (isdigit2(p3[0]) && (p3 < p1))
		{
#ifdef DEBUG
		    debug(fordulo, "reformat_event_feldolgoz: csatan kivul oriasero: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
		    fordulo->karakter->oriasero = atoi(p3);
		    continue;
		}
	    }
	    // hadiszerencse
	    if (!get_cache_mode() && (aconf_get_curr("karlap_bonuszok_kiiras") == 1) && (p1 == strstr2(p2,"szerencse.</SPAN>)")) && (p3 = strstr2(p1,"varzspont.]</SPAN>")) && (p3 == strstr2(p1, "</SPAN>")))
	    {
		for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		if (isdigit2(p3[0]) && (p3 < p1))
		{
#ifdef DEBUG
		    debug(fordulo, "reformat_event_feldolgoz: csatan kivul hadiszerencse: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
		    fordulo->karakter->hadiszerencse = atoi(p3);
		    continue;
		}
	    }
	    // hatalomvarazs
	    if (!get_cache_mode() && (aconf_get_curr("karlap_bonuszok_kiiras") == 1) && (p1 == strstr2(p2,"tulajdonsgodra.</SPAN>)")) && (p3 = strstr2(p1,"varzspont.]</SPAN>")) && (p3 == strstr2(p1, "</SPAN>")))
	    {
		for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		if (isdigit2(p3[0]) && (p3 < p1))
		{
#ifdef DEBUG
		    debug(fordulo, "reformat_event_feldolgoz: csatan kivul hatalomvarazs: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
		    fordulo->karakter->hatalomvarazs = atoi(p3);
		    continue;
		}
	    }
	    // TU_plusz csatan kivul
	    if ((get_cache_mode() || (aconf_get_curr("korvege_eroforras_tu_stat") == 1)) && ((p1 == strstr2(p2,"tudatpont</SPAN>)")) || (p1 == strstr2(p2,"tudatpont.</SPAN>)")) || (p1 == strstr2(p2,"TU</SPAN>)")) || (p1 == strstr2(p2,"TU.</SPAN>)"))))
	    {
		for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		if (isdigit2(p3[0]) && (p3 < p1))
		{
#ifdef DEBUG
		    debug(fordulo, "reformat_event_feldolgoz: csatan kivul TU plusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
		    osszesen->tu_stat_p += atoi(p3);
//kiir(NULL, "|%d|", atoi(p3));
		    continue;
		}
	    }
	    // TVP_plusz csatan kivul
	    if ((get_cache_mode() || (aconf_get_curr("korvege_eroforras_tvp_stat") == 1)) && ((p1 == strstr2(p2,"TVP</SPAN>)")) || (p1 == strstr2(p2,"TVP.</SPAN>)"))))
	    {
		char * pfno;
		
		for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		if (isdigit2(p3[0]) && (p3 < p1))
		{
		    for (pfno = p3; isdigit2(pfno[0]) && (pfno <= p1); pfno++);
		    pfno = skip_space(pfno);
		    if ((pfno[0] == 'T') && (pfno[1] == 'V') && (pfno[2] == 'P') && (pfno <= p1))
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_event_feldolgoz: csatan kivul TVP_plusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			osszesen->tvp_stat_p += atoi(p3);
			if ((osszesen->tvp_kapas <= 0) && (!(ptvp = strstr(start, "pontot hasznltl fel, van mg")) || (ptvp > p1)))
			{
			    osszesen->tvp_kapas -= atoi(p3);
			}
			if ((pfno = strstr_(p2-100, "Bugyorba irnytod", p1)) && (p1 == strstr2(pfno,"TVP</SPAN>)")))
			{
			    osszesen->tu_koltes += atoi(p3) / 5;
			}
			continue;
		    }
		}
	    }
	    jellemvaltozas = 0;
	    // Jellem_plusz csatan kivul
	    if (get_cache_mode() || (aconf_get_curr("korvege_permanens_jellem_stat") == 1))
	    {
		// Jellemvaltozas
		if ((p1 == strstr2(p2,"vagy.</SPAN>)")))
		{
		    if (p3 = strstr(p2,"Jellemed megvltozott"))
		    {
			if ((p5 = strstr(p2, "jsg")) && (p5 < p3))
			{
			    jellemvaltozas = 1;
			}
			else if ((p5 = strstr(p2, "gonoszsg")) && (p5 < p3))
			{
			    jellemvaltozas = 2;
			}
			figyelmeztetes_store(fordulo, p3, p1 - 8, 0);
		    }
		}
		// Josag
		if ((jellemvaltozas == 1) || (p1 == strstr2(p2,"jsg</SPAN>)")) || (p1 == strstr2(p2,"jsg.</SPAN>)")))
		{
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_event_feldolgoz: csatan kivul jellem josag _plusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			osszesen->jellem_stat_p += atoi(p3);
			continue;
		    }
		}
		// Gonoszsag
		if ((jellemvaltozas == 2) || (p1 == strstr2(p2,"gonoszsg</SPAN>)")) || (p1 == strstr2(p2,"gonoszsg.</SPAN>)")))
		{
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_event_feldolgoz: csatan kivul jellem gonoszsag plusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			osszesen->jellem_stat_n += atoi(p3);
			continue;
		    }
		}
	    }
	    // Pszi_plusz csatan kivul
	    if (get_cache_mode() || (aconf_get_curr("korvege_eroforras_pp_stat") == 1))
	    {
		if ((p1 == strstr2_(p2,"pszi pont</SPAN>)", p1 + 1)) || (p1 == strstr2_(p2,"pszi pont.</SPAN>)", p1 + 1)))
		{
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_event_feldolgoz: csatan kivul pszi plusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			osszesen->pszi_stat_p += atoi(p3);
			continue;
		    }
		}
	    }
	    // Papi hit kapas (aldozati oltar)
	    if (get_cache_mode() || (aconf_get_curr("korvege_permanens_papirang_stat") == 1))
	    {
		if ((p1 == strstr2_(p2,"papi hit</SPAN>)", p1 + 1)) || (p1 == strstr2_(p2,"papi hit.</SPAN>)", p1 + 1)))
		{
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_event_feldolgoz: csatan kivul papi rang plusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			osszesen->papirang_stat_p += atoi(p3);
			continue;
		    }
		}
	    }
#ifdef DEBUG
	    debug(fordulo, "reformat_event_feldolgoz: csatan kivul ?_plusz: %.*s\n", p1-p2, p2);
#endif
	}
	// X_Minusz csatan kivul
	else if (spec_event[vi].type&event_type_X_minusz)
	{
	    t_spec_event_subtype event_subtype;
	    char * p1;
	    char * p2;
	    char * p3;
	    char * p4;
	    char * p5;
	    char * p6;
	    
	    p1 = vege;
	    p2 = eleje;
	    p4 = X_elozo;
	    X_elozo = vege;
	    
	    // kaja kiszurese :)
	    if (((p5 = strstr2(p2,"kaja.")) && (p5 < p1)) || ((p6 = strstr2(p2,"kaja<")) && (p6 < p1)))
	    {
#ifdef DEBUG
		debug(fordulo, "reformat_event_feldolgoz: csatan kivul kaja plusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
		continue;
	    }
	    
	    // subtype set
	    event_subtype = event_subtype_none;
	    if ((p5 = strstr(eleje, "max.")) && (p5 < vege))
	    {
		event_subtype = event_subtype_X_max;
	    }
	    
	    if (event_subtype == event_subtype_X_max)
	    {
		if (get_cache_mode() || (aconf_get_curr("korvege_permanens_max_stat") == 1))
		{
		    // maxep bukas
		    if ((p1 == strstr2(p2,"leter</SPAN>)")) || (p1 == strstr2(p2,"leter.</SPAN>)")))
		    {
			if (p3 = strstr_(p4, "Elmlt a csillezslyalevl hatsa", p2))
			{
			    continue;
			}
			for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
			if (isdigit2(p3[0]) && (p3 < p1))
			{
#ifdef DEBUG
			    debug(fordulo, "reformat_event_feldolgoz: csatan kivul max ep minusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			    osszesen->ep_max_n += atoi(p3);
			    continue;
			}
		    }
		    // maxvp bukas
		    if ((p1 == strstr2(p2,"varzspont</SPAN>)")) || (p1 == strstr2(p2,"varzspont.</SPAN>)")))
		    {
			for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
			if (isdigit2(p3[0]) && (p3 < p1))
			{
#ifdef DEBUG
			    debug(fordulo, "reformat_event_feldolgoz: csatan kivul max vp minusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			    osszesen->vp_max_n += atoi(p3);
			    continue;
			}
		    }
		    // maxtu bukas
		    if ((p1 == strstr2(p2,"tudatpont</SPAN>)")) || (p1 == strstr2(p2,"tudatpont.</SPAN>)")) || (p1 == strstr2(p2,"TU</SPAN>)")) || (p1 == strstr2(p2,"TU.</SPAN>)")))
		    {
			for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
			if (isdigit2(p3[0]) && (p3 < p1))
			{
#ifdef DEBUG
			    debug(fordulo, "reformat_event_feldolgoz: csatan kivul max TU minusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			    osszesen->tu_max_n += atoi(p3);
			    continue;
			}
		    }
		    // max pszi bukas
		    if ((p1 == strstr2_(p2,"pszi pont</SPAN>)", p1 + 1)) || (p1 == strstr2_(p2,"pszi pont.</SPAN>)", p1 + 1)) || (p1 == strstr2_(p2,"max. pszi</SPAN>)", p1 + 1)))
		    {
			for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
			if (isdigit2(p3[0]) && (p3 < p1))
			{
#ifdef DEBUG
			    debug(fordulo, "reformat_event_feldolgoz: csatan kivul max pszi minusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			    osszesen->pszi_max_n += atoi(p3);
			    continue;
			}
		    }
#ifdef DEBUG
		    debug(fordulo, "reformat_event_feldolgoz: csatan kivul ismeretlen max minusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
		}
		continue;
	    } // end of X_max
	    // VP_minusz csatan kivul, vagy maxvp bukas
	    if (get_cache_mode() || (aconf_get_curr("korvege_eroforras_vp_stat") == 1))
	    {
		if ((p1 == strstr2(p2,"varzspont</SPAN>)")) || (p1 == strstr2(p2,"varzspont.</SPAN>)")))
		{
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_event_feldolgoz: csatan kivul vp minusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			osszesen->vp_stat_n += atoi(p3);
			continue;
		    }
		}
	    }
	    // EP_minusz csatan kivul
	    if (get_cache_mode() || (aconf_get_curr("korvege_eroforras_ep_stat") == 1))
	    {
		if ((p1 == strstr2(p2,"leter</SPAN>)")) || (p1 == strstr2(p2,"leter.</SPAN>)")))
		{
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_event_feldolgoz: csatan kivul ep minusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			osszesen->ep_stat_n += atoi(p3);
			continue;
		    }
		}
	    }
	    // TU_minusz csatan kivul
	    if (get_cache_mode() || (aconf_get_curr("korvege_eroforras_tu_stat") == 1))
	    {
		if ((p1 == strstr2(p2,"tudatpont</SPAN>)")) || (p1 == strstr2(p2,"tudatpont.</SPAN>)")) || (p1 == strstr2(p2,"TU</SPAN>)")) || (p1 == strstr2(p2,"TU.</SPAN>)")))
		{
		    // EK 40
		    if ((p4 = strstr2(p2 - 55,"Ellltottl")) && (p3 = strstr(p4,"TVP")) && (p3 < p2))
		    {
			for (p3 = p4; !isdigit2(p3[0]) && (p3 < p2); p3++);
			if (isdigit2(p3[0]) && (p3 < p2))
			{
			    if (aconf_get_curr("korvege_eroforras_tvp_stat") == 1)
			    {
#ifdef DEBUG
				debug(fordulo, "reformat_event_feldolgoz: csatan kivul TVP plusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
				osszesen->tvp_stat_p += atoi(p3);
			    }
			}
		    
		    }
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_event_feldolgoz: csatan kivul TU minusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			osszesen->tu_koltes += atoi(p3);
			continue;
		    }
		}
	    }
	    // TVP_minusz csatan kivul
	    if (get_cache_mode() || (aconf_get_curr("korvege_eroforras_tvp_stat") == 1))
	    {
		if ((p1 == strstr2(p2,"TVP</SPAN>)")) || (p1 == strstr2(p2,"TVP.</SPAN>)")))
		{
		    if (!fordulo->p || !((fordulo->p[0] == 'v') && (fordulo->p[1] == 't') && (fordulo->p[2] == 'n')))
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_event_feldolgoz: csatan kivul TVP_minusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
			if (isdigit2(p3[0]) && (p3 < p1))
			{
			    osszesen->tvp_stat_n += atoi(p3);
			}
		    }
		    else
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_event_feldolgoz: csatan kivul VTN soran TVP_minusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
		    }
		    continue;
		}
	    }
	    // Pszi_minusz csatan kivul
	    if (get_cache_mode() || (aconf_get_curr("korvege_eroforras_pp_stat") == 1))
	    {
		if ((p1 == strstr2_(p2,"pszi pont</SPAN>)", p1 + 1)) || (p1 == strstr2_(p2,"pszi pont.</SPAN>)", p1 + 1)))
		{
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_event_feldolgoz: csatan kivul pszi minusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			osszesen->pszi_stat_n += atoi(p3);
			continue;
		    }
		}
	    }
	    // Papi hit vesztes (avatar idezes, sotet kasza)
	    if (get_cache_mode() || (aconf_get_curr("korvege_permanens_papirang_stat") == 1))
	    {
		if ((p1 == strstr2_(p2,"papi hit</SPAN>)", p1 + 1)) || (p1 == strstr2_(p2,"papi hit.</SPAN>)", p1 + 1)))
		{
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_event_feldolgoz: csatan kivul papi rang minusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			osszesen->papirang_stat_n += atoi(p3);
			continue;
		    }
		}
	    }
#ifdef DEBUG
	    debug(fordulo, "reformat_event_feldolgoz: csatan kivul ?_minusz: %.*s\n", p1-p2, p2);
#endif
	}
	// Sebzodes csatan kivul
	else if ((spec_event[vi].type&event_type_sebzodes) && ((aconf_get_curr("korvege_eroforras_ep_stat") == 1) || get_cache_mode()))
	{
	    char * psebzodes;
	    {
		if (vege == strstr2(eleje,"vesztettl.</SPAN>"))
		{
		    for (psebzodes = eleje; !isdigit2(*psebzodes) && (psebzodes <= vege); psebzodes++);
		    if (isdigit2(*psebzodes) && (psebzodes < vege))
		    {
			fordulo->osszesen.ep_stat_n += atoi(psebzodes);
		    }
		}
		else if ((vege == strstr2(eleje, "leter</SPAN>")) || (vege == strstr2(eleje, "leter.</SPAN>")) || (vege == strstr2(eleje, "letpont.</SPAN>")))
		{
		    for (psebzodes = eleje; !isdigit2(*psebzodes) && (psebzodes <= vege); psebzodes++);
		    if (isdigit2(*psebzodes) && (psebzodes < vege))
		    {
			fordulo->osszesen.ep_stat_n += atoi(psebzodes);
		    }
		}
		if (vege == strstr2_(eleje,"letpont sebzds a hideg miatt.</SPAN>", vege+1))
		{
		    for (psebzodes = eleje; !isdigit2(*psebzodes) && (psebzodes <= vege); psebzodes++);
		    if (isdigit2(*psebzodes) && (psebzodes < vege))
		    {
			fordulo->osszesen.ep_stat_n += atoi(psebzodes);
		    }
		}
		else
		{
#ifdef DEBUG
		    debug(fordulo, "reformat_event_feldolgoz: csatan kivul ?_szenved: %.*s\n", vege - eleje, eleje);
#endif
		}
	    }
	}
	// ep valtozas
	else if ((spec_event[vi].type&event_type_epvalt) && ((aconf_get_curr("korvege_eroforras_ep_stat") == 1) || get_cache_mode()))
	{
	    for (l1 = eleje; (l1 < vege) && !isdigit2(*l1); l1++);
	    
	    if (isdigit2(*l1))
	    {
		if (spec_event[vi].subtype == event_subtype_1)
		{
		    eleje--;
		    elojel = 1;
		}
		else if (spec_event[vi].subtype == event_subtype_2)
		{
		    eleje = strstr2_(eleje, spec_event[vi].eleje, vege);
		    eleje = skip_space(eleje);
		    elojel = 1;
		}
		
		if (elojel > 0)
		{
		    fordulo->osszesen.ep_stat_p += atoi(l1);
		}
		else if (elojel < 0)
		{
		    fordulo->osszesen.ep_stat_n += atoi(l1);
		}
		if (spec_event[vi].subtype == event_subtype_3)
		{
		    fordulo->osszesen.tu_koltes += 2;
		}
		
		output(fordulo, "%.*s<b>%.*s</b>", eleje - l3, l3, vege - eleje, eleje);
		l3 = vege;
	    }
	}
	// vp valtozas
	else if ((spec_event[vi].type&event_type_vpvalt) && ((aconf_get_curr("korvege_eroforras_vp_stat") == 1) || get_cache_mode()))
	{
	    if (spec_event[vi].subtype == event_subtype_1)
	    {
		for (l4 = eleje, ok = 0; (l4 >= l3-1); l4--)
		{
		    if ((*l4 == '.') && isspace2(*(l4+1)))
		    {
			l1 = skip_space(l4+1);
			if (isupper2(*l1))
			{
			    for(l4 = eleje - 1; (l4 > l1) && ((*l4 == ' ') || (*l4 == '\t') || (*l4 == '\r') || (*l4 == '\n')); l4--);
			    l4++;
			    if (buf = malloc(l4 - l1 + 1))
			    {
				output(fordulo, "%.*s", l1 - l3, l3);
				sprintf(buf, "%.*s", l4 - l1, l1);
				reformat_nev_kiemeles(fordulo, buf, buf + strlen(buf), 0);
				free(buf);
				l3 = l4;
			    }
			    elojel = -1;
			    break;
			}
		    }
		}
	    }
	    else if (spec_event[vi].subtype == event_subtype_2)
	    {
		elojel = 1;
	    }
	    
	    for (l1 = eleje; (l1 < vege) && !isdigit2(*l1); l1++);
	    
	    if (isdigit2(*l1))
	    {
		if (elojel > 0)
		{
		    fordulo->osszesen.vp_stat_p += atoi(l1);
		}
		else if (elojel < 0)
		{
		    fordulo->osszesen.vp_stat_n += atoi(l1);
		}
		
		output(fordulo, "%.*s<b>%.*s</b>", eleje - l3, l3, vege - eleje, eleje);
		l3 = vege;
	    }
	}
	// varazslat meguijitas es felt. gyogyitas
	else if ((spec_event[vi].type&event_type_varazsol) && ((aconf_get_curr("korvege_spell_hasznalat_kiiras") == 1) || get_cache_mode()))
	{
	    char * sp1;
	    
	    if ((sp1 = strstr2(eleje,"gygymgy")) && (sp1 < vege))
	    {
	        cache_add_spell_count(fordulo, fordulo->cache, 5);
	    }
	    else if ((sp1 = strstr2_(eleje,"azonnali gygyts",vege)) && (sp1 < vege))
	    {
	        cache_add_spell_count(fordulo, fordulo->cache, 58);
	    }
	    else if ((sp1 = strstr2_(eleje,"si gygyts",vege)) && (sp1 < vege))
	    {
	        cache_add_spell_count(fordulo, fordulo->cache, 267);
	    }
	    else if ((sp1 = strstr2_(eleje,"teljes gygyuls",vege)) && (sp1 < vege))
	    {
	        cache_add_spell_count(fordulo, fordulo->cache, 133);
	    }
	    else if ((sp1 = strstr2_(eleje,"letszvs III",vege)) && (sp1 < vege))
	    {
	        cache_add_spell_count(fordulo, fordulo->cache, 128);
	    }
	    else if ((sp1 = strstr2_(eleje,"letszvs II",vege)) && (sp1 < vege))
	    {
	        cache_add_spell_count(fordulo, fordulo->cache, 80);
	    }
	    else if ((sp1 = strstr2(eleje,"letszvs")) && (sp1 < vege))
	    {
	        cache_add_spell_count(fordulo, fordulo->cache, 10);
	    }
	    else if ((sp1 = strstr2(eleje, "vmpirizci")) && (sp1 < vege))
	    {
		cache_add_spell_count(fordulo, fordulo->cache, 1);
	    }
	    else if ((sp1 = strstr2_(eleje ,"ldoms II", vege)) && (sp1 < vege))
	    {
		cache_add_spell_count(fordulo, fordulo->cache, 169);
	    }
	    else if ((sp1 = strstr2(eleje ,"ldoms")) && (sp1 < vege))
	    {
		cache_add_spell_count(fordulo, fordulo->cache, 6);
	    }
	    else if ((sp1 = strstr2(eleje ,"mregsemlegests")) && (sp1 < vege))
	    {
		cache_add_spell_count(fordulo, fordulo->cache, 14);
	    }
	    else if ((sp1 = strstr2(eleje ,"knyszerport")) && (sp1 < vege))
	    {
		if (parancs_check(fordulo, "lm"))
		{
		    cache_add_spell_count(fordulo, fordulo->cache, 183);
		}
	    }
	    else if ((sp1 = strstr2(eleje ,"kreci")) && (sp1 < vege))
	    {
		if (parancs_check(fordulo, "kre"))
		{
		    cache_add_spell_count(fordulo, fordulo->cache, 148);
		}
	    }
	    else
	    {
#ifdef DEBUG
		debug(fordulo, "reformat_event_feldolgoz: fel nem ismert varazsolas: %.*s\n", vege - eleje, eleje);
#endif
	    }
	}
	// buvoles
	else if (!get_cache_mode() && (spec_event[vi].type&event_type_buvoles) && (aconf_get_curr("kiemeles_buvoles") == 1))
	{
	    for ( l1 = strstr(vege, ".") ;(l4 = strstr(l1, ".")) &&  l4 < end; l1 = l4)
	    {
		l4 = skip_nonspace(l4);
		l4 = skip_space(l4);
		if (isupper2(*l4))
		{
		    break;
		}
	    }
	    faname = figyelmeztetes_store(fordulo, eleje, l1, 0);
	    output(fordulo, "%.*s<a name=\"figyelmeztetes%d\"><b>%.*s</b></a>", eleje - l3, l3, faname, l1 - eleje, eleje);
	    l3 = l1;
	}
	// epulet kiemeles
	else if (!get_cache_mode() && (spec_event[vi].type&event_type_epulet) && ((aconf_get_curr("kiemeles_epulet") == 1) || (aconf_get_curr("kiszamolas_epulet_koordinata") == 1)))
	{
	  for (for1 = for2 = 0; for1 == for2; for2++, l3 = vege)
	  {
	    char * nev1;
	    char * nev2;
	    int xkoord = 0;
	    int ykoord = 0;
	    int found = 0;
	    int i;
	    t_varos * varos;
	    t_epulet_tipus epulet;
	    
	    elojel = 1;
#ifdef DEBUG
	    debug(fordulo, "reformat_epulet_kiemeles: kiemeles check: %.*s\n", vege - eleje, eleje);
	    output(fordulo,"---> kiemeles eleje <---%.*s---> kiemeles vege <---", eleje - l3, l3);
#else
	    output(fordulo,"%.*s", eleje - l3, l3);
#endif
	    // Milyen epulet?
	    epulet = epulet_tipus_unknown;
	    if ((aconf_get_curr("kiemeles_epulet") == 1) && (l4 = strstr(eleje,"labirintus")) && (l4 < vege) && isdigit2(*eleje))
	    {
		epulet = epulet_tipus_labirintus;
	    }
	    else if ((aconf_get_curr("kiemeles_epulet") == 1) && (l4 = strstr(eleje,"plet")) && (l4 < vege) && isdigit2(*eleje))
	    {
		epulet = epulet_tipus_epulet;
	    }
	    
#ifdef DEBUG
	    debug(fordulo, "reformat_epulet_kiemeles: labirintus check: %.*s\n", vege - eleje, eleje);
#endif
	    // kiemeles
	    if ((aconf_get_curr("kiemeles_epulet") == 1) && (epulet != epulet_tipus_unknown))
	    {
		ssz = atoi(eleje);
		if ((aconf_get_curr("hyperlink_epulet") == 1) && (epulet == epulet_tipus_labirintus))
		{
		    output(fordulo, "<a class=n href=\"%slabik.php%sf=labienc&labissz=%i%s\" target=hyper title=\"Encyclopedia (Web Hyper)\">%.*s</a>", bconf_get_webhyper(), (aconf_get_webhyper_offline()?"@":"?"), ssz, (aconf_get_webhyper_offline()?".htm":""), vege - eleje, eleje);
		}
		else if ((aconf_get_curr("hyperlink_epulet") == 1) && (epulet == epulet_tipus_epulet))
		{
		    output(fordulo, "<a class=n href=\"%sepulet.php%sf=ep&ssz=%i%s\" target=hyper title=\"Encyclopedia (Web Hyper)\">%.*s</a>", bconf_get_webhyper(), (aconf_get_webhyper_offline()?"@":"?"), ssz, (aconf_get_webhyper_offline()?".htm":""), vege - eleje, eleje);
		}
		else
		{
		    output(fordulo, "%.*s", vege - eleje, eleje);
		}
		l3 = vege;
		nev1 = eleje;
		nev2 = vege;
		
		// Koordinata
		if ((aconf_get_curr("kiszamolas_epulet_koordinata") == 1) && (epulet != epulet_tipus_unknown))
		{
		    if ((epulet != epulet_tipus_unknown) && (l4 = strstr(l3+1,"<")) && (eleje = strstr2(l3+1, "bejrat")) && (eleje < l4))
		    {
			
			eleje = skip_space(eleje);
			vege = skip_nonspace(eleje);
#ifdef DEBUG
			debug(fordulo, "reformat_epulet_kiemeles: labirintus check: %.*s\n", vege - eleje, eleje);
#endif
			if (strncmp(eleje,"alattad",7) == 0)
			{
#ifdef DEBUG
			    debug(fordulo, "reformat_epulet_kiemeles: labirintus check: !alattad! %.*s\n", vege - eleje, eleje);
#endif
			    output(fordulo, "%.*s <b>[%d,%d]</b>", vege - l3, l3, fordulo->mezo.x, fordulo->mezo.y);
			    if (aconf_get_curr("notes__labikoordinata") == 1)
			    {
				notes(fordulo->karakter->ksz, fordulo->fsz, "%.*s: [%d,%d]\r\n", nev2 - nev1, nev1, fordulo->mezo.x, fordulo->mezo.y);
			    }
			    continue;
			}
			else if ((strncmp(eleje,"innen",5) == 0) || (strncmp(eleje,"innt",5) == 0))
			{
#ifdef DEBUG
			    debug(fordulo, "reformat_epulet_kiemeles: labirintus check: !innen! %.*s\n", vege - eleje, eleje);
#endif
			    xkoord = fordulo->mezo.x;
			    ykoord = fordulo->mezo.y;
			}
			else
			{
#ifdef DEBUG
			    debug(fordulo, "reformat_epulet_kiemeles: labirintus check: !else! %.*s\n", vege - eleje, eleje);
#endif
			    vege = skip_space(vege);
			    if (strncmp(vege,"kzpontjtl", strlen("kzpontjtl")) == 0)
			    {
				for (i = 0; (i < (sizeof(varosok) / sizeof(t_varos))) && varosok[i].nev; i++)
			        {
				    if (strncmp(eleje,varosok[i].nev,strlen(varosok[i].nev)) == 0)
				    {
					xkoord = varosok[i].xkoord;
					ykoord = varosok[i].ykoord;
				    }
				}
			    }
			    vege = skip_nonspace(vege);
			}
			
			if (xkoord && ykoord)
			{
			    eleje = skip_space(vege);
			    vege = skip_nonspace(eleje);
#ifdef DEBUG
			    debug(fordulo, "reformat_epulet_kiemeles: labirintus check: !koordinata! %.*s\n", vege - eleje, eleje);
#endif
			    if (strncmp(eleje,"nyugatra",vege-eleje) == 0)
			    {
				elojel = -1;
			    }
			    eleje = skip_space(vege);
			    if (isdigit2(*eleje))
			    {
				xkoord = atoi(eleje) / 3 * elojel + xkoord;
#ifdef DEBUG
				debug(fordulo, "reformat_epulet_kiemeles: labirintus check: xkoord=%d\n", xkoord);
#endif
			    }
			    elojel = 1;
			    eleje = skip_space(skip_nonspace(eleje));
			    vege = skip_nonspace(eleje);
			    if (strncmp(eleje,"szakra",vege-eleje) == 0)
			    {
				elojel = -1;
			    }
			    eleje = skip_space(vege);
			    if (isdigit2(*eleje))
			    {
				ykoord = atoi(eleje) / 3 * elojel + ykoord;
#ifdef DEBUG
				debug(fordulo, "reformat_epulet_kiemeles: labirintus check: ykoord=%d\n", ykoord);
#endif
			    }
			    vege = strstr(eleje, ".");
#ifdef DEBUG
			    debug(fordulo, "reformat_epulet_kiemeles: labirintus check: !vege! %.*s\n", vege - l3, l3);
#endif
			    output(fordulo, "%.*s <b>[%d,%d]</b>", vege - l3, l3, xkoord, ykoord);
			    if (aconf_get_curr("notes_labikoordinata") == 1)
			    {
				notes(fordulo->karakter->ksz, fordulo->fsz, "%.*s: [%d,%d]\r\n", nev2 - nev1, nev1, xkoord, ykoord);
			    }
			}
			else
			{
			    output(fordulo, "%.*s", vege - l3, l3);
			}
		    }
		}
	    }
	    else
	    {
		output(fordulo,"%.*s", vege - eleje, eleje);
	    }
	  } // for1,for2
	}
	else if ((spec_event[vi].type&event_type_mezo) && ( get_cache_mode() || (aconf_get_curr("korvege_mezo_kiiras") == 1) || (aconf_get_curr("korvege_eroforras_vp_stat") == 1) || (aconf_get_curr("korvege_eroforras_pp_stat") == 1) || (aconf_get_curr("korvege_eroforras_tu_stat") == 1)))
	{
	  for (for1 = for2 = 0; for1 == for2; for2++)
	  {
	    char * p3;
	    char * p4;
	    char * p5;
	    char p_tmp;
	    char * eleje2;
	    char * vege2;
	    
#ifdef DEBUG
	    debug(fordulo, "reformat_mezo_feldolgozas: [...]: %d \"%.*s\"\n", vege - eleje, vege - eleje, eleje);
	    debug(fordulo, "reformat_mezo_feldolgozas: start=%p, fordulo->taborozas=%p\n", start, fordulo->taborozas);
#endif
	    
	    eleje2 = NULL;
	    vege2 = NULL;
	    if (spec_event[vi].subtype == event_subtype_1)
	    {
		eleje2 = eleje;
		vege2 = vege;
		if ((p3 = strstr2(eleje, "[")) && (p4 = strstr(p3, "]")) && (p4 < vege))
		{
		    eleje = p3;
		    vege = p4;
		}
		else
		{
		    continue;
		}
	    }
	    if (!eleje2 || !vege2)
	    {
		eleje2 = eleje - 1;
		vege2 = vege + 1;
	    }
	    
	    //Mozgas feljegyzese
	    if (isdigit2(*eleje) && isdigit2(*(vege-1)) && ((vege - eleje) < 9))
	    {
#ifdef DEBUG
	        debug(fordulo, "reformat_mezo_feldolgozas: koordinata 1: %d \"%.*s\"\n", vege-eleje, vege - eleje, eleje);
#endif
		for (p3 = eleje; (isdigit2(*p3) || *p3 == '-') && (p3 <= vege); p3++);
		if (*p3 == ',')
		{
		    p4 = p3++;
		    for ( ;(isdigit2(*p3) || *p3 == '-') && (p3 <= vege); p3++);
		    if (p3 == vege)
		    {
			char * teleport_vege;
			
			p_tmp = *p4;
			*p4 = '\0';
			fordulo->mezo.x = atoi(eleje);
			fordulo->mezo.y = atoi(p4+1);
			*p4 = p_tmp;
			if ((fordulo->p) && (teleport_vege = strstr_(fordulo->p, "teleport varzslat befejezsekpp most visszarept a kiindul mezre.", eleje)) && (teleport_vege < eleje))
			{
			    fordulo->teleport.x = 0;
			    fordulo->teleport.y = 0;
			}
			if (aconf_get_curr("kiemeles_mozgas") == 1)
			{
#ifdef DEBUG
			    debug(fordulo, "reformat_mezo_feldolgozas: koordinata 2: x=%d y=%d\n", fordulo->mezo.x, fordulo->mezo.y);
			    output(fordulo,"!!! event_subtype=%d !!!---> koordinata elott eleje <---%.*s---> koordinata elott vege<---", spec_event[vi].subtype, eleje2 - l3, l3);
			    if (aconf_get_curr("korvege_mezo_kiiras") == 1)
			    {
				output(fordulo,"---> koordinata eleje <---<a name=\"mezo%d\"><SPAN CLASS=\"koord\">[%.*s]</SPAN></a>---> koordinata vege <---", fordulo->mezo.ssz, vege - eleje, eleje);
			    }
			    else
			    {
				output(fordulo,"---> koordinata eleje <---<SPAN CLASS=\"koord\">[%.*s]</SPAN>---> koordinata vege <---", vege - eleje, eleje);
			    }
#else
			    output(fordulo,"%.*s", eleje2 - l3, l3);
			    if (aconf_get_curr("korvege_mezo_kiiras") == 1)
			    {
				output(fordulo,"<a name=\"mezo%d\"><SPAN CLASS=\"koord\">[%.*s]</SPAN></a>", fordulo->mezo.ssz, vege - eleje, eleje);
			    }
			    else
			    {
				output(fordulo,"<SPAN CLASS=\"koord\">[%.*s]</SPAN>", vege - eleje, eleje);
			    }
#endif
			    l3 = vege2;
			}
			
//			if ((aconf_get_curr("korvege_mezo_kiiras") == 1) || get_cache_mode())
			if (aconf_get_curr("korvege_mezo_kiiras") == 1)
			{
			    fordulo->mezo.ssz++;
			    mezo_store(fordulo, fordulo->mezo.x, fordulo->mezo.y);
			}
			continue;
		    }
		}
	    }
	    if (aconf_get_curr("kiemeles_mozgas") == 1)
	    {
		//Labiban LM kiemeles
		if (isdigit2(*eleje) && ((vege+1 == strstr2(eleje, "PONT]")) || (vege+1 == strstr2(eleje, "PONT.]")) || (vege+1 == strstr2(eleje, "PONT:]")) || (vege+1 == strstr2(eleje, "PONTRA.]")) || (vege+1 == strstr2(eleje, "PONTON.]")) || (vege+1 == strstr2(eleje, "PONTON vagy.]"))))
		{
#ifdef DEBUG
		    output(fordulo,"!!! event_subtype=%d !!!---> LM elott eleje <---%.*s---> LM elott vege<---<SPAN CLASS=\"koord\">[", spec_event[vi].subtype, eleje2 - l3, l3);
		    output(fordulo,"---> LM eleje <---%.*s---> LM vege <---]</SPAN>", vege - eleje, eleje);
#else
		    output(fordulo,"%.*s<SPAN CLASS=\"koord\"><i>[", eleje2 - l3, l3);
		    output(fordulo,"%.*s]</i></SPAN>", vege - eleje, eleje);
#endif
		    l3 = vege2;
		    continue;
		}
	    }
		
	    if ((get_cache_mode() || (aconf_get_curr("korvege_eroforras_tvp_stat") == 1)) && isdigit2(*(vege-2)) && (*(vege-1) == '.'))
	    {
		if (!fordulo->p || !((fordulo->p[0] == 't') && (fordulo->p[1] == 'p') && (fordulo->p[2] == 's')))
		{
		    if (isdigit2(*eleje) || ((*eleje == '-') && isdigit2(*(eleje+1))))
		    {
			fordulo->osszesen.tvp_koltes += atoi(eleje);
//kiir(NULL, "|%d|", atoi(eleje));
			if (fordulo->osszesen.tvp_kapas <= 0)
			{
			    for( ; !isdigit2(*vege) && (eleje < vege); vege--);
			    for( ; isdigit2(*vege) && (eleje < vege); vege--);
			    vege++;
			    if (isdigit2(*vege))
			    {
				fordulo->osszesen.tvp_kapas += fordulo->osszesen.tvp_koltes + atoi(vege) - fordulo->osszesen.tvp_p + fordulo->osszesen.tvp_n;
			    }
			}
			continue;
		    }
		}
	    }
	    if ((get_cache_mode() || (aconf_get_curr("korvege_eroforras_ep_stat") == 1)) && (*eleje == '-') && isdigit2(*(eleje+1)) && (vege == strstr2(eleje, "letpont")))
	    {
		eleje++;
		fordulo->osszesen.ep_stat_n += atoi(eleje);
		continue;
	    }
	    if (get_cache_mode() || (aconf_get_curr("korvege_eroforras_vp_stat") == 1))
	    {
		if ((*eleje == '-') && (vege == strstr2(eleje, "varzspont.")))
		{
		    eleje++;
		    if (isdigit2(*eleje))
		    {
			fordulo->osszesen.vp_koltes += atoi(eleje);
			continue;
		    }
		}
		else if ((isdigit2(*eleje)) && ((vege == strstr2(eleje, "VP-t.")) || (vege == strstr2(eleje, "vp-t."))) && (p3 = strstr2(eleje,"Kapsz")) && p3 < vege)
		{
		    fordulo->osszesen.tvp_koltes += atoi(eleje);
//kiir(NULL, "|%d|", atoi(eleje));
		    if (fordulo->osszesen.tvp_kapas <= 0)
		    {
			p4 = p3;
			for( ; !isdigit2(*p4) && (eleje < p4); p4--);
			for( ; isdigit2(*p4) && (eleje < p4); p4--);
			p4++;
			if (isdigit2(*p4))
			{
			    fordulo->osszesen.tvp_kapas += fordulo->osszesen.tvp_koltes + atoi(p4) - fordulo->osszesen.tvp_p + fordulo->osszesen.tvp_n;
			}
		    }
		    for ( ; !isdigit2(*p3) && (p3 <= vege); p3++);
		    if (isdigit2(*p3))
		    {
		        fordulo->osszesen.vp_fno += atoi(p3);
#ifdef DEBUG
			debug(fordulo, "reformat_mezo_feldolgozas: FNO vpregen: x=%d\n", atoi(p3));
#endif
		    }
		}
	    }
	    if (get_cache_mode() || (aconf_get_curr("korvege_eroforras_pp_stat") == 1))
	    {
		if ((*eleje == '-') && (vege == strstr2(eleje, "pszi pont.")))
	        {
		    eleje++;
		    if ((aconf_get_curr("korvege_eroforras_pp_stat") == 1) && isdigit2(*eleje))
		    {
			fordulo->osszesen.pszi_koltes += atoi(eleje);
		    }
		}
	    }
	    if (get_cache_mode() || (aconf_get_curr("korvege_eroforras_tu_stat") == 1))
	    {
		if ((*eleje == '-') && (vege == strstr2(eleje, "TU.")))
	        {
		    eleje++;
		    if (isdigit2(*eleje))
		    {
			fordulo->osszesen.tu_koltes += atoi(eleje);
		    }
		}
	    }
	  } // for1,for2
	}
	else if (spec_event[vi].type&event_type_megfejtes)
	{
	    if (!get_cache_mode() && (spec_event[vi].subtype&event_subtype_megfejtes_tim) && (aconf_get_curr("megfejtes_tim") == 1))
	    {
		l3 = reformat_tim_megfejtes(fordulo, l3, end);
	    }
	    else if (!get_cache_mode() && (spec_event[vi].subtype&event_subtype_megfejtes_phua) && (aconf_get_curr("megfejtes_phua") == 1))
	    {
		l3 = reformat_phua_megfejtes(fordulo, l3, end);
	    }
	}
	// kov event ag
    }
    if (!fordulo->mezo_utolso && (get_cache_mode() || (aconf_get_curr("korvege_mezo_kiiras") == 1)) && (l3 == fordulo->taborozas) && (fordulo->mezo.x == 0) && (fordulo->mezo.y == 0) && (fordulo->mezo.ssz == 0))
    {
        mezo_store(fordulo, fordulo->mezo.x, fordulo->mezo.y);
	output(fordulo, "<a name=\"mezo%d\">", fordulo->mezo.ssz);
    }

    return l3;
}

extern char * reformat_phua_megfejtes(t_fordulo * fordulo, char * start, char * end)
{
    char * l1;
    char * l2;
    char * l3;
    char * feladat;
    char * megfejtes = NULL;
    int jlk = 0;
    
    l3 = start;
    
    if (aconf_get_curr("megfejtes_phua") == 1)
    {
	if ((aconf_get_curr("megfejtes_phua") == 1) && (l1 = strstr2(l3, "<I>")) && (l2 = strstr(l1, "</I>")) && (l2 <= end))
	{
	    l1 = skip_space(l1);
	    l2 += 4;
#ifdef DEBUG
	    debug(fordulo, "reformat_phua_megfejtes 1: %.*s\n", l2 - l1, l1);
#endif
	    if (feladat = malloc(l2 - l1 + 1))
	    {
		sprintf(feladat, "%.*s", l2 - l1, l1);
		output(fordulo, "%.*s", l2 - l3, l3);
		if (megfejtes = phua_megfejt(feladat, &jlk))
		{
		    if (jlk)
		    {
			output(fordulo, "<ul>megolds: %s (%d)", megfejtes, jlk);
			if (*megfejtes == '?')
			{
			    output(fordulo, " - Ha ez j lgyszi referlj a <a href=\"%s\" class=n target=hyper title=\"Encyclopedia (Web Hyper)\">hyper</a> fel!", bconf_get_webhyper());
			}
			output(fordulo, "</ul>");
			if (aconf_get_curr("notes_phua_jlk") == 1)
			{
			    notes(fordulo->karakter->ksz, fordulo->fsz, "[%d,%d] mezon a phua kup jlk: %d\r\n", fordulo->mezo.x, fordulo->mezo.y, jlk);
			}
		    }
		    else
		    {
			output(fordulo, "<ul>megolds: %s</ul>", megfejtes);
		    }
		}
#ifdef DEBUG
		debug(fordulo, "reformat_phua_megfejtes 2: %s (%d)\n", megfejtes, jlk);
#endif
	        free(feladat);
		l3 = l2;
	    }
	}
    }
    return l3;    
}

extern char * reformat_tim_megfejtes(t_fordulo * fordulo, char * start, char * end)
{
    char * l1;
    char * l2;
    char * l3;
    char * p1;
    char * p2;
    char * megfejtes = NULL;
    int jlk = 0;
    unsigned char c;
    int i;
    int n;
    char szoveg[4096];
    int space = 0;

    l3 = start;
    if (aconf_get_curr("megfejtes_tim") == 1)
    {
	memset(szoveg,0,4096);
	i = 0;
	for (l2 = l3; (l1 = strstr(l2, "cellpadding=0 cellspacing=0 border=0><tr><td width=15 align=center><img src=")) && (l2 = strstr2(l1, "</table>")) && (l2 <= end);)
	{
	    if (space)
	    {
		szoveg[i++] = ' ';
	    }
	    for (p2 = l1; (i < 4090) && (p1 = strstr2(p2,"<td width=15")) && (p1 = strstr2(p1,">")) && (p2 = strstr2(p1,"</td>")) && (p2 < l2);)
	    {
		if (*p1 == '<')
		{
		    if ((p1 = strstr2(p1,"<img src=\"t")) && (p1 < p2))
		    {
			if (!isdigit2(*p1))
			{
			    if ((p1 = strstr2(p1,"fpic/t")) && (p1 < p2))
			    {
				if (!isdigit2(*p1))
				{
				    continue;
				}
			    }
			    else
			    {
				continue;
			    }
			}
			if (c = tit_char_get_szam(atoi(p1) + 1))
			{
			    szoveg[i++] = c;
			}
		    }
		}
		else if (*p1 == ' ')
		{
		    szoveg[i++] = ' ';
		    space = 1;
		}
	    }
	}
    
	if (strlen(szoveg))
	{
	    if ((megfejtes = tim_megfejt(szoveg, &jlk)) && (strlen(megfejtes) == strlen(szoveg)))
	    {
		for (l2 = l3, i = 0; (l1 = strstr(l2, "cellpadding=0 cellspacing=0 border=0><tr><td width=15 align=center><img src=")) && (l2 = strstr2(l1, "</table>")) && (l2 <= end); l3 = l2)
		{
		    output(fordulo, "%.*s", l1 - l3, l3);
		    if (space && (megfejtes[i] == ' '))
		    {
			i++;
		    }
		    for (p1 = l1, p2 = l1; (i < 4090) && (p2 = strstr(p1,"</td>")) && (p2 < l2); i++, p1 = p2)
		    {
			output(fordulo, "%.*s", p2 - p1, p1);
			output(fordulo, "<br>%c", megfejtes[i]);
			output(fordulo, "</td>");
			p2 += 5;
		    }
		    output(fordulo, "%.*s", l2 - p1, p1);
		}
	    	
		if (jlk)
		{
		    output(fordulo, "<br><ul><b>JLK: %d</b></ul>",jlk);
		    if (aconf_get_curr("notes_tim_jlk") == 1)
		    {
			notes(fordulo->karakter->ksz, fordulo->fsz, "[%d,%d] mezon a minoszkup jlk: %d\r\n", fordulo->mezo.x, fordulo->mezo.y, jlk);
		    }
		}
		l3 = l2;
	    }
#ifdef DEBUG
	    debug(fordulo, "reformat_tim_megfejtes: %s (%d)\n", megfejtes, jlk);
#endif
	    if (megfejtes)
	    {
		free(megfejtes);
	    }
	}
    }
    return l3;    
}

extern char * reformat_enemy_aname(t_fordulo * fordulo, int ssz, char * szn)
{
    int i;
    
    if (aconf_get_curr("korvege_mezo_kiiras") == 1)
    {
	if ((strncmp(szn, "Aukcis", 7) != 0) && ((i = enemy_store(fordulo, fordulo->mezo_utolso, ssz, szn)) > 0))
	{
	    output(fordulo,"<a name=\"enemy%d\"></a>", i);
	}
    }
}

extern char * reformat_nev_kiemeles(t_fordulo * fordulo, char * start, char * end, int flag)
{
    char * p4;
    char * p5;
    char * p6;
    int ssz;
    char * szn;
    char * szn_end;
    char * pontosnev = NULL;
    int felkialtojel = 0;
    int i;
    char * pb = NULL;;

    if (strncmp(start - 11, "\r\n<BR>\r\n<b>", 11) == 0)
    {
#ifdef DEBUG
	debug(fordulo, "reformat_nev_kiemeles: skiped \"%.*s\"\n", end - start, start);
#endif
	return start;
    }
    if ((p4 = strstr2(start - 20, "(Auralts:")) && (p4 < start))
    {
#ifdef DEBUG
	debug(fordulo, "reformat_nev_kiemeles: autalatas miatt skiped \"%.*s\"\n", end - start, start);
#endif
	return start;
    }
    // mar reformattalt
    if ((p4 = strstr2(start, "(#")) && (p5 = strstr(p4, ")")) && (p5 < end))
    {
#ifdef DEBUG
	debug(fordulo, "reformat_nev_kiemeles: mar refomatalt \"%.*s\"\n", end - start, start);
#endif
	ssz = atoi(p4);
	p6 = p4 - 3;
	for ( ;(p6 > start) && isspace2(*p6); p6--);
	p6++;
	if (isspace2(*p6))
	{
	    if (szn = malloc(p6-start+1))
	    {
		sprintf(szn, "%.*s", p6-start, start);
		enemy_store(fordulo, fordulo->mezo_utolso, ssz, szn);
		free(szn);
	    }
	}
	return start;
    }
    if ((aconf_get_curr("kiemeles_karakterszam") == 1) || (aconf_get_curr("kiemeles_szornyszam") == 1))
    {
	if (*(end - 1) == '!')
	{
	    felkialtojel = -1;
	}
	else 
	{
	    felkialtojel = 0;
	}

	szn = malloc(end-start+1+felkialtojel);
	sprintf(szn,"%.*s",end-start+felkialtojel, start);
	szn_end = szn + strlen(szn);
	ssz = 0;
	fordulo->csata.neveleje = start;
	fordulo->csata.nevvege = end+felkialtojel;
#ifdef DEBUG
        debug(fordulo, "reformat_nev_kiemeles 1 szn=\"%s\", flag=%d\n", szn, flag);
	debug(fordulo, "reformat_nev_kiemeles 1 szn_end-5=\"%s\"\n", szn_end-5);
#endif
	if ((aconf_get_curr("kiemeles_karakterszam") == 1) && flag && szn && (strstr(szn,"nvel.") || strstr(szn,"frfival.") || ((strcmp(szn_end-2,"n") == 0) && isspace2(*(szn_end-3))) || ((strcmp(szn_end-5,"frfi") == 0) && isspace2(*(szn_end-6)))))
	{
#ifdef DEBUG
	    debug(fordulo, "reformat_nev_kiemeles 2\n");
#endif
	    if (!(p5 = strstr(end, "<b>")))
	    {
		p5 = end + strlen(end) - 1;
	    }
	    pb = skip_space(end);
	    if (strncmp(pb, "</B>", 4) != 0)
	    {
		pb = NULL;
	    }
	    if ((p4 = strstr2(end, "neve")) && (p5 > p4))
	    {
		p4 = skip_space(p4);
		for (end = p4 ;(end = strstr(end, ".")) && (end - p4 < 50); end++)
		{
		    if ((end+1) != skip_space(end+1))
		    {
			free(szn);
			szn = malloc(end-p4+1);
			sprintf(szn,"%.*s",end-p4,p4);
			if (!(ssz = karakter_check_szam(fordulo, szn, &pontosnev)))
			{
			    ssz = karakter_get_szam(szn, &pontosnev);
			}
			break;
		    }
		}
#ifdef DEBUG
		debug(fordulo, "reformat_nev_kiemeles 3: end=\"%.40s\"\n", end);
#endif
	    }
	    else if ((p4 = strstr2(end, "(letapogats:")) && (p5 > p4))
	    {
		p4 = skip_space(p4);
		if ((end = strstr2(p4, "</B>")) && (end - p4 < 50))
		{
		    free(szn);
		    szn = malloc(end-p4-6);
		    sprintf(szn,"%.*s",end-p4-7,p4+3);
		    if (!(ssz = karakter_check_szam(fordulo, szn, &pontosnev)))
		    {
			ssz = karakter_get_szam(szn, &pontosnev);
			if (pontosnev)
			{
			    free(pontosnev);
			}
			pontosnev = NULL;
		    }
		}
#ifdef DEBUG
		debug(fordulo, "reformat_nev_kiemeles 4\n");
#endif
	    }
	    if(szn)
	    {
		reformat_enemy_aname(fordulo, ssz, (pontosnev ? pontosnev : szn));
	    }
	    if (ssz)
	    {
		if (pontosnev)
		{
		    if (strstr_(p4, pontosnev, NULL) == p4)
		    {
			end = strstr2_(p4, pontosnev, NULL);
			free(szn);
			szn = malloc(end-p4+1);
			sprintf(szn,"%.*s",end-p4,p4);
		    }
		}
		output(fordulo,"%s%.*s<b>%s (#%i)</B>", (pb?"<b>":""), p4-start, start, szn, ssz);
#ifdef DEBUG
		debug(fordulo, "reformat_nev_kiemeles 5\n");
#endif
	    }
	    else
	    {
		output(fordulo,"<b>%.*s</B>", end - start, start);
#ifdef DEBUG
		debug(fordulo, "reformat_nev_kiemeles 6\n");
#endif
	    }
	}
	else if ((aconf_get_curr("kiemeles_karakterszam") == 1) && (ssz = karakter_check_szam(fordulo, szn, &pontosnev)))
	{
	    reformat_enemy_aname(fordulo, ssz, (pontosnev ? pontosnev : szn));
	    output(fordulo, "<b>%s (#%i)</B>", szn, ssz);
#ifdef DEBUG
	    debug(fordulo, "reformat_nev_kiemeles 7\n");
#endif
	}
	else if ((aconf_get_curr("kiemeles_szornyszam") == 1) && (ssz = monster_get_szam(szn, &pontosnev)))
	{
	    reformat_enemy_aname(fordulo, ssz, (pontosnev ? pontosnev : szn));
	    if (aconf_get_curr("hyperlink_szorny") == 1)
	    {
		output(fordulo, "<a class=n href=\"%sszorny_enc.php%sf=szenc&ssz=%i%s\" target=hyper title=\"Encyclopedia (Web Hyper)\"><b>%s%.1s (#%i)</B></a>", bconf_get_webhyper(), (aconf_get_webhyper_offline()?"@":"?"), ssz, (aconf_get_webhyper_offline()?".htm":""), (pontosnev ? pontosnev : szn), (felkialtojel?"!":""), ssz);
	    }
	    else
	    {
		output(fordulo, "<b>%s%.1s (#%i)</B>", (pontosnev ? pontosnev : szn), (felkialtojel?"!":""), ssz);
	    }
#ifdef DEBUG
	    debug(fordulo, "reformat_nev_kiemeles 8\n");
#endif
	}
	else if ((aconf_get_curr("kiemeles_karakterszam") == 1) && (ssz = karakter_get_szam(szn, &pontosnev)))
	{
	    if (pontosnev)
	    {
		free(pontosnev);
	    }
	    pontosnev = NULL;
	    reformat_enemy_aname(fordulo, ssz, (pontosnev ? pontosnev : szn));
	    output(fordulo, "<b>%s (#%i)</B>", szn, ssz);
#ifdef DEBUG
	    debug(fordulo, "reformat_nev_kiemeles 9\n");
#endif
	}
	else
	{
	    reformat_enemy_aname(fordulo, ssz, szn);
	    output(fordulo, "<b>%s</B>", szn);
#ifdef DEBUG
	    debug(fordulo, "reformat_nev_kiemeles 10 else\n");
#endif
	}
#ifdef DEBUG
	debug(fordulo, "reformat_nev_kiemeles 11\n");
#endif
	if (flag)
	{
	    for(p5 = start;(p4 = strstr2(p5, "CLASS=\"kapcsos\">{")) && (p5 = strstr(p4,"}<")) && ((p5+1) == strstr(p4,"</SPAN>")); )
	    {
#ifdef DEBUG
		debug(fordulo, "reformat_nev_kiemeles psziernyo1\n");
#endif
	        if (!(p6 = strstr(end+1,"</B>")) || (p5 < p6))
		{
#ifdef DEBUG
		    debug(fordulo, "reformat_nev_kiemeles psziernyo2\n");
#endif
		    psziernyo_store(fordulo, ssz, (pontosnev ? pontosnev : szn), p4, p5);
		}
	    }
	}
#ifdef DEBUG
	debug(fordulo, "reformat_nev_kiemeles 13\n");
#endif
	free(szn);
#ifdef DEBUG
	debug(fordulo, "reformat_nev_kiemeles 14\n");
#endif
	if (pontosnev)
	{
#ifdef DEBUG
	    debug(fordulo, "reformat_nev_kiemeles 15\n");
#endif
	    free(pontosnev);
	    pontosnev = NULL;
	}

#ifdef DEBUG
	debug(fordulo, "reformat_nev_kiemeles 16\n");
#endif
    }
    
    return end;
}

extern char * reformat_tudatkutatas(t_fordulo * fordulo, char * start, char * end)
{
    char * l1;
    char * l2;
    char * l3;
    char * l4;
    char * l5;
    char * buf;
    char * p1;
    char * p2;
    char * p3;
    char * p4;
    int span_skip;
    char * szn;
    int ssz;
    int x;
    int y;

    l3 = start;
    if (aconf_get_curr("tudatkutatas_karszam") == 1)
    {
	// tudatkutatas
	for (l2 = l3 ; (l1 = strstr(l2, "(")) && (l5 = strstr(l1, ",")) && (l2 = strstr2(l1, ")")) && (l2 < end);)
	{
	    span_skip = 0;
	    l4 = l2;
	    l2 = skip_space(l2+1);
	    if (*(l1+1) == '9')
	    {
		continue;
	    }
	    else if (*(l1+1) == '<')
	    {
		if ((p1 = strstr2(l1, ">")) && (p2 = strstr(p1, ",")) && (p3 = strstr(p2, "<")) && (p3 < l2))
		{
		    x = atoi(p1);
		    y = atoi(p2+1);
		    if ((x || (*p1 == '0')) && (y || (*(p2+1) == '0')))
		    {
			span_skip = 2;
		    }
		    else
		    {
			span_skip = 1;
		    }
		}
	    }
	    else
	    {
		x = atoi(l1+1);
		y = atoi(l5+1);
		if ((x || (*(l1+1) == '0')) && (y || (*(l5+1) == '0')))
		{
		    span_skip = 2;
		}
	    }
	    
	    if (span_skip == 2)
	    {
		output(fordulo, "%.*s<b>[%d,%d]</b>%.*s", l1 - l3, l3, x + fordulo->mezo.x, y + fordulo->mezo.y, l2 - l4, l4);
	    }
	    else if (span_skip)
	    {
		output(fordulo, "%.*s<b>[%.*s]</b>%.*s", l1 - l3, l3, p3 - p1, p1, l2 - l4, l4);
	    }
	    else
	    {
		output(fordulo, "%.*s<b>%.*s</b>", l1 - l3, l3, l2 - l1, l1);
	    }
	    
	    for (p1 = l2, p4 = p2; p1 && (((p2 = strstr(p1, "n")) && (p3 = strstr(p1, "frfi"))) || (p2 = strstr(p1, "n")) || (p3 = strstr(p1, "frfi"))); p4 = p3, p1 = p2 + 1)
	    {
		if (p2 && p3)
		{
		    if (p3 < p2)
		    {
			p2 = p3;
			p3 = p2 + 5;
		    }
		    else
		    {
			p3 = p2 + 2;
		    }
		}
		else if (p3)
		{
		    p2 = p3;
		    p3 = p2 + 5;
		}
		else
		{
		    p3 = p2 + 2;
		}
		
		if (p2 > end)
		{
		    break;
		}
		
		if (((*p3 != ',') && (*p3 != ';')) || (!isspace2(*(p2-1))))
		{
		    continue;
		}
		
		for (p1 = p2 - 1; (*p1 != ',') && (p4 < p1); p1--);
		
		if ((p4 < p1) && (l2 < p1))
		{
		    if (szn = malloc(p1 - l2 + 1))
		    {
			sprintf(szn, "%.*s", p1 - l2, l2);
			if (ssz = karakter_get_szam(szn, NULL))
			{
			    output(fordulo, "<b>%s (#%d)</B>", szn, ssz);
			}
			else
			{
			    output(fordulo, "<b>%s</B>", szn);
			}
			free(szn);
		    }
		    else
		    {
			output(fordulo, "%.*s", p1 - l2, l2);
		    }
		    l2 = p1;
		}
		break;
	    }
	    
	    l3 = l2;
	}
    }
    return l3;
}

extern void reformat_csatan_kivul(t_fordulo * fordulo, char * start, char * end, t_csata * pcsata)
{
    unsigned long n;
    char * p1;
    char * p2;
    char * p3;
    char * p4;
    char * p5;
    char * p6;
    char * t1;
    char * t2;
    char tmp;
    t_csata * osszesen;
    int max;
    int ssz;
    char * szn;
    char * pontosnev = NULL;
    int felkialtojel;
    int i;
    int jellemvaltozas;
    int faname;
    char * ptvp;
    
    osszesen = &fordulo->osszesen;

    if ((p2 = strstr2(start, "</TABLE>")) && (p1 = strstr2(start, "CLASS=\"p\" WIDTH=170>")) && (p1 < p2))
    {
	fordulo->p = p1;
    }
    
	// Csatan kivulis statok

#ifdef DEBUG
	debug(fordulo, "reformat_csatan_kivul: csatan kivul start %p %p\n", start, end);
#endif

	// Kulonfele kiirasi valtoztatasok
	fordulo->csata.neveleje = NULL;
	fordulo->csata.nevvege = NULL;
	pontosnev = NULL;

	p3 = start;

	// Parancs kiirasa
	//fordulo->p = NULL;
	if ((p2 = strstr2(p3, "</TABLE>")) && (p1 = strstr2(p3, "CLASS=\"p\" WIDTH=170>")) && (p1 < p2))
	{
	    char * tp;
	    char * tpend;
	    char ttmp;
	    int tssz;

#ifdef DEBUG
	    output(fordulo, "---> parancs start<---\r\n%.*s---> parancs end <---<br>\r\n", p2 - p3, p3);
#else
	    output(fordulo, "%.*s", p2 - p3, p3);
#endif	
	    p3 = p2;
//	    fordulo->p = p1;
	    
	    if (fordulo->p && (fordulo->p[0] == 'v') && (fordulo->p[1] == 'v') && (fordulo->p[2] == ' '))
	    {
	    
		if (tpend = strstr(fordulo->p, "<"))
		{
		    ttmp = *tpend;
		    *tpend = '\0';
		    for (tp = fordulo->p+2; tp < tpend;)
		    {
			tp = skip_space(tp);
			if (isdigit2(*tp))
			{
			    tssz = atoi(tp);
			    cache_add_spell_count(fordulo, fordulo->cache, tssz);
			}
			tp = skip_nonspace(tp);
		    }
		    *tpend = ttmp;
		}
	    }
	    else if (fordulo->p && ((fordulo->p[0] == 'p') || (fordulo->p[0] == 'v')) && (fordulo->p[1] == ' '))
	    {
		if (isdigit2(fordulo->p[2]))
		{
		    tssz = atoi(&fordulo->p[2]);
		    cache_add_spell_count(fordulo, fordulo->cache, tssz);
		    // varosi teleport
		    if ((tssz == 96) || (tssz == 181))
		    {
			fordulo->teleport.x = fordulo->mezo.x;
			fordulo->teleport.y = fordulo->mezo.y;
		    }
		}
	    }
	    else if (fordulo->p && (fordulo->p[0] == '*'))
	    {
	    
		if ((tp = strstr2(fordulo->p, ">")) && (tp = strstr2(tp, ">")) && (tpend = strstr(tp, "<")))
		{
		    ttmp = *tpend;
		    *tpend = '\0';
		    
		    if ((tp = strstr2(tp, "elmormolod")) < tpend)
		    {
			tp = skip_space(tp);
			tp = skip_nonspace(tp);
			tp = skip_space(tp);
			for (tp = skip_space(tp) ; tp && (tp < tpend) && isdigit2(*tp); )
			{
			    tssz = atoi(tp);
			    cache_add_spell_count(fordulo, fordulo->cache, tssz);
			    tp = skip_nonspace(tp);
			    tp = skip_space(tp);
			    tp = skip_nonspace(tp);
			    tp = skip_space(tp);
			    tp = skip_nonspace(tp);
			    tp = skip_space(tp);
			}
		    }
		    *tpend = ttmp;
		}
	    }
	}
	for (p2 = p3, felkialtojel = 0; (p4 = p2) && (((p1 = strstr(p2, "<b>")) && (p2 = strstr2(p1+3, ">")) && (p2 < end)) || (!p1 && (p5 = strstr2(p4, "<P>")) && (p5 <= end))); felkialtojel = 0)
	{
	    char * pt;

	    if (!p1)
	    {
		if (p5)
		{
		    p1 = p5;
		    p2 = p5;
		}
		else
		{
		    break;
		}
	    }
	    if (strncmp(p1 - 8, "\r\n<BR>\r\n<b>", 11) == 0)
	    {
#ifdef DEBUG
		debug(fordulo, "reformat_csatan_kivul: skiped \"%.*s\"\n", p2 - p1, p1);
#endif
		continue;
	    }
	    if ((p5 = strstr2(p4, "<P>")) && (p5 < p1))
	    {
		p1 = p5;
		p2 = p5;
	    }
#ifdef DEBUG
	    debug(fordulo, "reformat_csatan_kivul: nevkiemeles elott \"%.60s\"\n", p3);
	    debug(fordulo, "reformat_csatan_kivul: nevkiemeles eleje \"%.60s\"\n", p1);
	    debug(fordulo, "reformat_csatan_kivul: nevkiemeles vege \"%.60s\"\n", p2);
	    debug(fordulo, "reformat_csatan_kivul: nevkiemeles vege strncmp=\"%d\"\n", strncmp(p1, "<b>enc.</b>", 11));
#endif
	    // ls. enc atugrasa
	    if (strncmp(p1, "<b>enc.</b>", 11) == 0)
	    {
		continue;
	    }
	    // a titkosirasoknal a sorok atugrasa
	    else if (strncmp(p1+7, "cellpadding=0 cellspacing=0 border=0><tr><td width=15 align=center><img src=", 73) == 0)
	    {
		continue;
	    }
	    
	    p3 = reformat_event_feldolgoz(fordulo, p3, p1);
	    
	    if (p3 > p1)
	    {
	        continue;
	    }
	    
	    if (!get_cache_mode())
	    {
#ifdef DEBUG
		output(fordulo, "---> ettol1(%i) <---\r\n", p1 - p3);
#endif
		// Mezon levo trezsor (csatamezo, stb)
		if (aconf_get_curr("kiemeles_trezsor") == 1)
		{
		    for (t1 = p3; ((t2 = trezsor_next(t1, p1, 2)) && (t2 < p1)); t1 = t2)
		    {
			p3 = trezsor(fordulo, t2, p3, p1);
		    }
		}
	    }
	    
	    if (!get_cache_mode())
	    {
#ifdef DEBUG
		output(fordulo, "%.*s---> eddig1 <---\r\n", p1 - p3, p3);
#else
		output(fordulo, "%.*s", p1 - p3, p3);
#endif
	    } // end of get_cache_mode()

	    if (((get_cache_mode()) || (aconf_get_curr("kiemeles_karakterszam") == 1) || (aconf_get_curr("kiemeles_szornyszam") == 1)) && (p2 == strstr2(p1, "</B>")))
	    {
//		output(fordulo, "%.3s", p1);
		p2 = reformat_nev_kiemeles(fordulo, p1+3, p2-4, 1);
#ifdef DEBUG
		debug(fordulo, "reformat_csatan_kivul: nevkiemeles return: bool=%d, \"%.40s\"\n", strncmp(p2, "</B>", 4), p2);
#endif
		if (strncmp(p2, "</B>", 4) == 0)
		{
//		    output(fordulo, "%.4s", p2);
		    p2 += 4;
		}
	    }
	    else if (p1 != p2)
	    {
#ifdef DEBUG
		output(fordulo, "---> ettol2(%i) <---\r\n", p2 - p1);
#endif
#ifdef DEBUG
		output(fordulo, "%.*s---> eddig2 <---\r\n", p2 - p1, p1);
#else
		output(fordulo, "%.*s", p2 - p1, p1);
#endif	
	    }
	    p3 = p2;

	}
	
	if (!get_cache_mode())
	{
	    // Mezon levo trezsor (csatamezo, stb)
	    if (aconf_get_curr("kiemeles_trezsor") == 1)
	    {
	        for (t1 = p3; ((t2 = trezsor_next(t1, p1, 2)) && (t2 < p1)); t1 = t2)
	        {
	    	    p3 = trezsor(fordulo, t2, p3, p1);
	        }
	    }
	    if (!fordulo->p && (p3 == fordulo->korvege))
	    {
		if ((strncmp(p3, "<P>", 3) != 0) && (strncmp(p3, "<p>", 3) != 0) && (strncmp(p3, "<BR>", 4) != 0) && (strncmp(p3, "<br>", 4) != 0))
		{
		    output(fordulo, "\r\n<BR>\r\n");
		}
	    }
	    if ((aconf_get_curr("tudatkutatas_karszam") == 1) && fordulo->p && ((fordulo->p[0] == 'p') || (fordulo->p[0] == 'v')) && (fordulo->p[1] == ' ') && (fordulo->p[2] == '9') && (fordulo->p[3] == '9'))
	    {
		p3 = reformat_tudatkutatas(fordulo, p3, end);
	    }
	    if ((aconf_get_curr("tudatkutatas_karszam") == 1) && fordulo->p && (fordulo->p[0] == 'v') && (fordulo->p[1] == 'v'))
	    {
		char ttmp;
		char * tpend;
	    
		if (tpend = strstr(fordulo->p, "<"))
		{
		    ttmp = *tpend;
		    *tpend = '\0';
		    if (strstr(fordulo->p, "99"))
		    {
			p3 = reformat_tudatkutatas(fordulo, p3, end);
		    }
		    *tpend = ttmp;
		}
	    }
	}

	p3 = reformat_event_feldolgoz(fordulo, p3, end);
	
	if (get_cache_mode())
	{
	    return;
	}
	
#ifdef DEBUG
	output(fordulo, "---> ettol(%i) <---\r\n", end - p3);
#endif

	// Mezon levo trezsor (csatamezo, stb)
	if (aconf_get_curr("kiemeles_trezsor") == 1)
	{
	    for (t1 = p3; ((t2 = trezsor_next(t1, end, 2)) && (t2 < end)); t1 = t2)
	    {
		p3 = trezsor(fordulo, t2, p3, end);
	    }
	}

#ifdef DEBUG
	output(fordulo, "%.*s---> eddig <---\r\n", end - p3, p3);
#else
	output(fordulo, "%.*s", end - p3, p3);
#endif	
}
