/*
 * Copyright (C) 2003  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#include "typedef.h"
#ifndef INCLUDED_F_CSATAN_KIVUL_TYPES
#define INCLUDED_F_CSATAN_KIVUL_TYPES

typedef enum
{
    event_type_none = 0x00000000,
    event_type_spec_monsta = 0x00000001,
    event_type_szaki_csillag = 0x00000002,
    event_type_tutvp = 0x00000004,
    event_type_tolvaj = 0x00000008,
    event_type_szopoko = 0x00000010,
    event_type_zarknod = 0x00000020,
    event_type_jellemvaltozas = 0x00000040,
    event_type_ef = 0x00000080,
    event_type_szornyehes = 0x00000100,
    event_type_buvoles = 0x00000200,
    event_type_epulet = 0x00000400,
    event_type_mezo = 0x00000800,
    event_type_megfejtes = 0x00001000,
    event_type_csak_taborozas = 0x00004000,
    event_type_varazsol = 0x00008000,
    event_type_vpvalt = 0x00010000,
    event_type_epvalt = 0x00020000,
    event_type_trezsor = 0x00040000,
    event_type_eletkorvalt = 0x00080000,
    event_type_tuvalt = 0x00100000,
    event_type_tvpvalt = 0x00200000,
    event_type_sebzodes = 0x00400000,
    event_type_X_plusz = 0x00800000,
    event_type_X_minusz = 0x01000000,
    event_type_maxvalt = 0x02000000,
    event_type_nincskompi = 0x04000000,
    event_type_csak_kiemel = 0x40000000,
    event_type_csak_kozti = 0x80000000
} t_spec_event_type;

typedef enum
{
    event_subtype_none = 0x0000,
    event_subtype_tolvaj_default_kiiras = 0x0001,
    event_subtype_tolvaj_felismeres_ktkepesseg = 0x0002,
    event_subtype_szopoko_jon = 0x0001,
    event_subtype_szopoko_megy = 0x0002,
    event_subtype_megfejtes_tim= 0x0001,
    event_subtype_megfejtes_phua= 0x0002,
    event_subtype_X_normal= 0x0001,
    event_subtype_X_max= 0x0002,
    event_subtype_1= 0x0001,
    event_subtype_2= 0x0002,
    event_subtype_3= 0x0003,
    event_subtype_4= 0x0004,
    event_subtype_valami = 0x0080
} t_spec_event_subtype;

#ifdef F_CSATAN_KIVUL_INTERNAL_ACCESS
typedef struct spec_event
{
    char * eleje;
    char * nev;
    char * vege;
    char * kiemel_s;
    char * kiemel_e;
    t_spec_event_type type;
    int subtype;
    char * hol;
} t_spec_event;

typedef struct nevhiany
{
    int szam;
    char * nev;
    char * jonev;
} t_nevhiany;


#endif /* F_CSATAN_KIVUL_INTERNAL_ACCESS */
#endif

#ifndef JUST_NEED_TYPES
#ifndef INCLUDED_F_CSATAN_KIVUL_PROTOS
#define JUST_NEED_TYPES
#include "fordulo.h"
extern int event_init(t_fordulo * fordulo);
extern char * reformat_nev_kiemeles(t_fordulo * fordulo, char * start, char * end, int flag);
extern char * reformat_tim_megfejtes(t_fordulo * fordulo, char * start, char * end);
extern char * reformat_phua_megfejtes(t_fordulo * fordulo, char * start, char * end);
extern void reformat_csatan_kivul(t_fordulo * fordulo, char * start, char * end, t_csata * pcsata);
#undef JUST_NEED_TYPES
#define INCLUDED_F_CSATAN_KIVUL_PROTOS
#endif
#endif
