/*
 * Copyright (C) 2003-2005  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#define F_FORDULO_INTERNAL_ACCESS
#include "include.h"
#include "f_fordulo.h"
#ifndef JUST_NEED_TYPES
# define JUST_NEED_TYPES
# include "fordulo.h"
# include "karakter.h"
# include "format.h"
# undef JUST_NEED_TYPES
#else
# include "fordulo.h"
# include "karakter.h"
# include "format.h"
#endif
#include "f_csata.h"
#include "f_csatan_kivul.h"
#include "sorszam.h"
#include "output.h"
#include "globals.h"

#include "f_fordulo.data"

static figyelmeztetes_aname = 0;

extern int csataveg_init(t_fordulo * fordulo)
{
    int i;
    char * p1;
    char * p3;
    char tmp;
    char korvegechr;
    char * buf;
    
    if (fordulo == NULL || !fordulo->fordulostr)
    {
	return -1;
    }
    if (fordulo->korvege_tvp)
    {
	korvegechr = *fordulo->korvege_tvp;
	*fordulo->korvege_tvp = '\0';
    }
    else
    {
	korvegechr = '\0';
    }
    for (i = 0; (i < (sizeof(csataendtxt) / sizeof(t_csataend))) && csataendtxt[i].csataend; i++)
    {
	if (!(buf = strdup(csataendtxt[i].csataend)))
	{
	    continue;
	}
	p1 = skip_space(buf);
	p1 = skip_nonspace(p1);
	tmp = *p1;
	*p1 = '\0';

	p3 = strstr2(fordulo->fordulostr, buf);
	csataendtxt[i].hol = p3;
#ifdef DEBUG
	debug(fordulo, "csataveg_init: [%d] \"%s\" (\"%s\") = %p (\"%.40s\")\n", i, csataendtxt[i].csataend, buf, csataendtxt[i].hol, csataendtxt[i].hol);
#endif
	*p1 = tmp;
	free(buf);
    }
    if (korvegechr)
    {
	*fordulo->korvege_tvp = korvegechr;
    }
}

char * csataveg(t_csata * csata)
{
    char * p1;
    char * p2;
    char * buf;
    char * buf_vege;
    char * eleje;
    char * vege;
    int i;
    int ok;

    if (csata == NULL || !csata->eleje)
    {
	return NULL;
    }
    buf = csata->eleje;
    buf_vege =  buf + strlen(buf);
    for (i = 0, ok = 0, p1 = NULL, p2 = buf + strlen(buf); (i < (sizeof(csataendtxt) / sizeof(t_csataend))) && csataendtxt[i].csataend; i++)
    {
	if (!csataendtxt[i].hol || (csataendtxt[i].hol >= p2))
	{
	    continue;
	}
	if ((p1 = strstr3_(buf, csataendtxt[i].csataend, p2, &eleje, &vege)))
	{
	    if (strstr(csataendtxt[i].csataend, "gygytott is rajtad."))
	    {
		char * pn;
		if ((pn = strstr2(p1, ")")))
		{
		    p1 = pn;
		}
	    }
	    else if (strstr(csataendtxt[i].csataend, "Megmentett a hallkapu"))
	    {
		char * pn;
		if ((pn = strstr2(p1, ")")))
		{
		    p1 = pn;
		}
	    }
	    else if (strstr(csataendtxt[i].csataend, "Feltmadsz!"))
	    {
		char * pn;
		if ((pn = strstr2(p1, ")")))
		{
		    p1 = pn;
		}
	    }
	    else if (strstr(csataendtxt[i].csataend, "Megjtod a"))
	    {
		p1 = eleje;
	    }
	    else if (strstr(csataendtxt[i].csataend, "Ez idzett szrny volt, TP sajnos nem jr rte"))
	    {
		char * pn;
		if ((pn = strstr2(p1, ")")) && (pn < p1 + 10))
		{
		    p1 = pn;
		}
	    }
	    csataendtxt[i].hol = p1;
	    if (p1 < p2)
	    {
		ok = 1;
		p2 = p1;
		csata->vege_eleje = eleje;
		csata->csataveg_i = i;
	    }
	}
	else
	{
	    csataendtxt[i].hol = p2;
	}
    }

    if (ok)
    {
	return p2;
    }
    else
    {
	return NULL;
    }
}

extern char * csata_next(char * buf, t_csata * csata)
{
    char * p1 = NULL;
    char * p2 = NULL;
    char * p3 = NULL;
    char * p4 = NULL;
    char * csatastr;
    long * ii;

    csata->block = NULL;
    csata->vege = NULL;
    csata->vege_eleje = NULL;
    csata->eleje = NULL;
    csata->sebzes_utes = 0;
    csata->sebzes_utes_beforr = 0;
    csata->sebzes_egyeb = 0;
    csata->sebzodes_utes = 0;
    csata->sebzodes_egyeb = 0;
    for (ii = &csata->vampiri; ii <= &csata->egyeb_n; ii++)
    {
	*ii = (int) 0;
    }
    
    if (buf == NULL)
	return NULL;
#ifdef DEBUG
    debug(csata->fordulo, "csata_next 0: %p (%u) \n", buf, strlen(buf));
#endif
    
    if (csata->fordulo->tipus == fordulo_tipus_olimpia)
    {
	csatastr = "<p>";
    }
    else
    {
	csatastr = "<P>";
    }
    for (p1 = buf, p2 = NULL; p1 && (p1 = strstr2(p1, csatastr)); )
    {
#ifdef DEBUG
	debug(csata->fordulo, "csata_next 1: %.20s | %.20s\n",p1, p2);
#endif
	if ((*p1 == '<') || (p1 == strstr(p1,"ssze")) || (*p1 == '\n') || (*p1 == '\r') || (*p1 == '(') || (p1 == strstr(p1,"A tborozs")))
	{
#ifdef DEBUG
	    debug(csata->fordulo, "csata_next 1a: %.20s | %.20s\n",p1, p2);
#endif
	    continue;
	}
	
	csata->eleje = p1;
	if (p2 = csataveg(csata))
	{
#ifdef DEBUG
	    debug(csata->fordulo, "csata_next 2: %.20s | %.20s\n",p1, p2);
#endif
	    p3 = strstr2(p1, csatastr);

	    if (p3 && (p2 > p3))
	    {
#ifdef DEBUG
		debug(csata->fordulo, "csata_next new: !!! talaltam egy eddig nem ismert csataveget !!!\n\"%.*s\"\n", (p3 - p1), p1);
#endif
		continue;
	    }
	    else
	    {
		csata->block = buf;
		csata->eleje = p1;
		csata->vege = p2;
#ifdef DEBUG
		if (csata->neveleje && csata->nevvege)
		{
		    debug(csata->fordulo, "csata_next 3: %.*s | %.20s | %.20s | %.20s | %.20s\n", csata->nevvege - csata->neveleje, csata->neveleje, csata->block, csata->eleje, csata->vege_eleje, csata->vege);
		}
		else
		{
		    debug(csata->fordulo, "csata_next 4: %.20s | %.20s | %.20s\n", csata->block, csata->eleje, csata->vege);
		}
#endif
		return csata->vege;
	    }
#ifdef DEBUG
	    debug(csata->fordulo, "csata_next 5: %.20s | %.20s\n",p1, p2);
#endif
	}
    }
#ifdef DEBUG
    debug(csata->fordulo, "csata_next 6: %.20s\n",p2);
#endif
    return NULL;
}

extern int trezsor_init(t_fordulo * fordulo)
{
    int i;
    char * p1;
    char * p3;
    char tmp;
    char korvegechr;
    char * buf;
    
    if (fordulo == NULL || !fordulo->fordulostr)
    {
	return -1;
    }
    if (fordulo->korvege_tvp)
    {
	korvegechr = *fordulo->korvege_tvp;
	*fordulo->korvege_tvp = '\0';
    }
    else
    {
	korvegechr = '\0';
    }
    for (i = 0; (i < (sizeof(monsta_trezsor) / sizeof(t_trezsor))) && monsta_trezsor[i].nev; i++)
    {
	if (!(buf = strdup(monsta_trezsor[i].nev)))
	{
	    continue;
	}
	p1 = skip_space(buf);
	p1 = skip_nonspace(p1);
	tmp = *p1;
	*p1 = '\0';

	p3 = strstr2(fordulo->fordulostr, buf);
	monsta_trezsor[i].hol = p3;
#ifdef DEBUG
	debug(fordulo, "trezsor_init: monsta_trezsor [%d] \"%s\" = %p (\"%.40s\")\n", i, monsta_trezsor[i].nev, monsta_trezsor[i].hol, monsta_trezsor[i].hol);
#endif
	*p1 = tmp;
	free(buf);
    }
    for (i = 0; (i < (sizeof(mezei_trezsor) / sizeof(t_trezsor))) && mezei_trezsor[i].nev; i++)
    {
	if (!(buf = strdup(mezei_trezsor[i].nev)))
	{
	    continue;
	}
	p1 = skip_space(buf);
	p1 = skip_nonspace(p1);
	tmp = *p1;
	*p1 = '\0';

	p3 = strstr2(fordulo->fordulostr, buf);
	mezei_trezsor[i].hol = p3;
#ifdef DEBUG
	debug(fordulo, "trezsor_init: mezei_trezsor [%d] \"%s\" = %p (\"%.40s\")\n", i, mezei_trezsor[i].nev, mezei_trezsor[i].hol, mezei_trezsor[i].hol);
#endif
	*p1 = tmp;
	free(buf);
    }
    if (korvegechr)
    {
	*fordulo->korvege_tvp = korvegechr;
    }
}

extern char * trezsor_next(char * buf, char * end, int tipus)
{
    int i;
    char * p1;
    char * ret;
    int ok;

#ifdef DEBUG
    debug(NULL, "trezsor_next start: buf=%.50s\n", buf);
#endif

    if (tipus == 1)
    {
	for (i = 0, ok = 0, ret = end; (i < (sizeof(monsta_trezsor) / sizeof(t_trezsor))) && monsta_trezsor[i].nev; i++)
	{
	    if (! monsta_trezsor[i].hol || ( monsta_trezsor[i].hol >= ret))
	    {
		continue;
	    }
	    if (p1 = strstr2_(buf, monsta_trezsor[i].nev, end))
	    {
		if (*p1 == ':')
		{
		    p1++;
		}
		monsta_trezsor[i].hol = p1;
		if (p1 && (p1 < ret))
		{
		    ok = 1;
		    ret = p1;
		}
	    }
	    else
	    {
		monsta_trezsor[i].hol = ret;
	    }
	}
    }
    else if (tipus == 2)
    {
	for (i = 0, ok = 0, ret = end; (i < (sizeof(mezei_trezsor) / sizeof(t_trezsor))) && mezei_trezsor[i].nev; i++)
	{
	    if (! mezei_trezsor[i].hol || ( mezei_trezsor[i].hol >= ret))
	    {
		continue;
	    }
	    if (p1 = strstr2_(buf, mezei_trezsor[i].nev, end))
	    {
		if (*p1 == ':')
		{
		    p1++;
		}
		if (strncmp(p1-3, "moa", 3) == 0)
		{
		    p1 -= 3;
		}
		mezei_trezsor[i].hol = p1;
		if (p1 && (p1 < ret))
		{
		    ok = 1;
		    ret = p1;
		}
	    }
	    else
	    {
		mezei_trezsor[i].hol = ret;
	    }
	}
    }

#ifdef DEBUG
    debug(NULL, "trezsor_next end: ret=\"%.50s\"\n",ret);
#endif

    if (ok)
    {
	return ret;
    }
    else
    {
	return NULL;
    }
}

extern char * trezsor(t_fordulo * fordulo, char * trezsor_start, char * start, char * end)
{
    char * p1;
    char * p2;
    char * p3;
    char * p4;
    char * p5;
    char * cs1;
    char * cs2;
    char * cs3;
    char * cs4;
    int faname;
    
#ifdef DEBUG
	debug(fordulo, "trezsor start: %.*s\n", end - trezsor_start, trezsor_start);
#endif
	if (trezsor_start && (trezsor_start < end) && (p2 = strstr(trezsor_start,".")) && (p2 < end) && (trezsor_start = skip_space(trezsor_start)) &&
	    (isdigit2(*trezsor_start) || (((*trezsor_start == 'e') || (*trezsor_start == 'E')) && (*(trezsor_start+1) == 'g') && (*(trezsor_start+2) == 'y')) || ((*trezsor_start == 'm') && (*(trezsor_start+1) == 'o') && (*(trezsor_start+2) == 'a'))))
	{
#ifdef DEBUG
	    debug(fordulo, "trezsor if: %.*s\n", p2 - trezsor_start, trezsor_start);
	    output(fordulo,"%.*s---> trezsor: start <---<SPAN CLASS=\"trezsor\">", trezsor_start - start, start);
#else
	    output(fordulo,"%.*s<SPAN CLASS=\"trezsor\">", trezsor_start - start, start);
#endif
	    start = trezsor_start;
	    for (p2 = trezsor_start, p4 = p2, p1 = p2; (p2 = strstr2(p2, ".")) && (p2 < end); p4 = p2, p1 = p2)
	    {
		// utolso [ladiko] keresese, elofordulul, hogy a [ladiko] az utolso trezsor es nincs a vegen '.' :(
		for ( ; (p3 = strstr2(p1, "]</SPAN>")) && (p3 < p2); p1 = p3);
		
		p3 = skip_space(p2);
#ifdef DEBUG
		debug(fordulo, "trezsor if2: bool=%d, p1=\"%.60s\", p3=\"%.60s\"\n", (p1 && (p1 != p4) && (*p1 != ',') && (*p1 != '.')), p1, p3);
#endif

		if ((p5 = strstr2(p4, "!")) && (p5 < p2) && (p5 > p1))
		{
		    p4 = p5;
#ifdef DEBUG
		    debug(fordulo, "trezsor if3-: %.60s\n", p4);
#endif
		    break;
		}
		else if ((p2 == p3)) // a trezsor neveben van "."
		{
		    p2 = skip_nonspace(p2);
		    p2++;
		    continue;
		}
		else if (strncmp(p2-5, "mrg.", 5) == 0) // merg. valami
		{
		    p2++;
		    continue;
		}
		else if ((*p3 == '<') && ((*(p3+1) == 'a') || (*(p3+1) == 'A'))) // (ld. enc <a href...
		{
		    p2 = strstr2(p3, "</a>");
		    continue;
		}
		else if (p1 && (p1 != p4) && (*p1 != ',') && (*p1 != '.'))
		{
		    p2 = skip_space(p1);
		    p3 = skip_space(p1);
#ifdef DEBUG
		    debug(fordulo, "trezsor if skip: %.60s\n", p4);
#endif
		}
		
		if ((*p3 == '*') && (*(p3+1) == '*') && (cs1 = strstr2_(p3+2, "Helyet csinlsz", p2)) && (cs1 = strstr2(cs1, "**")))
		{
		    p2 = skip_space(cs1);
		    p3 = skip_space(cs1);
		}
		// kovetkezo mondat, vagy "(Nincs ertelme..."
		if (isupper2(*p3) || (*p3 == '('))
		{
		    p4 = p2;
#ifdef DEBUG
		    debug(fordulo, "trezsor if3a: %.60s\n", p4);
#endif
		    break;
		}
		// <BR>... lezaras
		else if ((*p3 == '<') && (*(p3+1) == 'B') && (*(p3+2) == 'R') && (*(p3+3) == '>'))
		{
		    p4 = p2;
#ifdef DEBUG
		    debug(fordulo, "trezsor if3b: %.60s\n", p4);
#endif
		    break;
		}
		// teleport vagy mozgas vegen felteteles keszites (vagy valami mas), azaz a trezsor utan kozvetlen a [tvp] jon
		else if ((p3 == strstr_(p3,"<SPAN CLASS=\"tvp\">[", p3+30)) && (p5 = strstr2(p3, ">[")) && ((*p5 == '-') || isdigit2(*p5)))
		{
		    p4 = p2;
#ifdef DEBUG
		    debug(fordulo, "trezsor if3c: %.60s\n", p4);
#endif
		    break;
		}
		// buvoles utan a talalkozas valami "{..." resze jon (agyletapi, pszi ernyo, stb)
		else if (p3 == strstr_(p3,"<SPAN CLASS=\"kapcsos\">{", p3+30))
		{
		    p4 = p2;
#ifdef DEBUG
		    debug(fordulo, "trezsor if3d: %.60s\n", p4);
#endif
		    break;
		}
	    }
	    p4--;
#ifdef DEBUG
	    debug(fordulo, "trezsor vege: %.*s\n", p4 - trezsor_start, trezsor_start);
#endif
	    //  Ha a "(ld. )" is legyen kiemelt, akkor erre lent kell kommentet betenni.
	    for (p2 = trezsor_start; (p1 = strstr(p2, "(")) && (p2 = strstr2(p1, ")")) && (p2 <= p4); )
	    {
#ifdef DEBUG
		debug(fordulo, "trezsor: ()-resz: \"%.20s\" \"%20s\"\n", p1, p2-5);
#endif
		if ((cs1 = strstr(start, "**")) && (cs2 = strstr2(cs1+2, "**")) && (cs2 < p1))
		{
		    cs3 = cs1 + 2;
		    cs4 = cs2 - 2;
		    faname = figyelmeztetes_store(fordulo, cs3, cs4, 0);
		    output(fordulo,"%.*s<a name=\"figyelmeztetes%d\"><SPAN CLASS=\"p\">%.*s</SPAN></a>", cs1 - start, start, faname, cs2 - cs1, cs1);
		    start = cs2;
		}
		if ((strncmp(p1, "(Nincs", 6) == 0) && (*(p2-2) == '.'))
		{
		    output(fordulo,"%.*s<SPAN CLASS=\"szogletes\">%.*s</SPAN>", p1 - start, start, p2 - p1, p1);
		    start = p2;
		}
		else if ((strncmp(p1, "(ld.", 4) == 0) && (strncmp(p2-5, "</a>)", 5) == 0))
		{
		    output(fordulo,"%.*s<SPAN CLASS=\"szogletes\">%.*s</SPAN>", p1 - start, start, p2 - p1, p1);
		    start = p2;
		}
		else if (isdigit2(*(p1+1)) && (p2 == strstr2(p1, "arany)")))
		{
		    output(fordulo,"%.*s<SPAN CLASS=\"szogletes\">%.*s</SPAN>", p1 - start, start, p2 - p1, p1);
		    start = p2;
		}
	    }
	    if ((cs1 = strstr(start, "**")) && (cs2 = strstr2(cs1+2, "**")) && (cs2 <= p4))
	    {
		cs3 = cs1 + 2;
		cs4 = cs2 - 2;
		faname = figyelmeztetes_store(fordulo, cs3, cs4, 0);
		output(fordulo,"%.*s<a name=\"figyelmeztetes%d\"><SPAN CLASS=\"p\">%.*s</SPAN></a>", cs1 - start, start, faname, cs2 - cs1, cs1);
		start = cs2;
	    }
#ifdef DEBUG
	    output(fordulo,"%.*s</SPAN>---> trezsor: end <---\r\n", p4 - start, start);
#else
	    output(fordulo,"%.*s</SPAN>", p4 - start, start);
#endif
	    start = p4;
	}
    return start;
}

extern int ladiko(t_fordulo * fordulo, char * start, char * end)
{
    char * p1;
    char * p2;
    char * p3;
    char * p4;
    char * p5;
    char tmp;
    long ap;
    
    if (get_cache_mode() || (aconf_get_curr("korvege_eroforras_ep_stat") == 1) || (aconf_get_curr("korvege_eroforras_ladiko_stat")))
    {
	tmp = *end;
	*end = '\0';
    
	for (p2 = start; (p1 = strstr(p2, "[")) && (p2 = strstr2(p1, "]")) && (p2 < end); )
	{
	    ap = 0;

#ifdef DEBUG
	    debug(fordulo, "ladiko: \"%.*s\"\n", p2-p1, p1);
#endif
	    if ((p3 = strstr2(p1, "ldikba-&gt;")) && (p4 = strstr2(p3, "P]")) && (p2 == p4))
	    {
		p5 = p3;
	        p5 = skip_nonspace(p5);
		p5 = skip_space(p5);
		if (*p5 == '(')
		{
		    p5 = skip_nonspace(p5);
		    p5 = skip_space(p5);
		}
		if (isdigit2(*p5))
		{
		    ap += atoi(p5);
		}
		for (p5 = p4 - 4; isspace2(*p5) && (p3 < p5); p5--);
		
		if ((p3 < p5) && (*p5 == '2') && (*(p5-1) == '-'))
		{
		    if (aconf_get_curr("korvege_eroforras_ladiko_stat") == 1)
		    {
#ifdef DEBUG
			debug(fordulo, "ladiko: %d arany\n", ap);
#endif
			fordulo->osszesen.ladiko_ap += ap;
		    }
		    if (aconf_get_curr("korvege_eroforras_ep_stat") == 1)
		    {
#ifdef DEBUG
			debug(fordulo, "ladiko: -2 eletpont\n");
#endif
		        fordulo->osszesen.ladiko_ep += 2;
		    }
		}
	    }
	}
    
	*end = tmp;
    }
}

extern int figyelmeztetes_store(t_fordulo * fordulo, char * start, char * end, int csata)
{
    t_figyelmeztetes * figyelmeztetes;
    t_figyelmeztetes * f;
    char * adat;
    char * temp;
    
    if (aconf_get_curr("korvege_figyelmeztetes_kiiras") != 1)
    {
	return 0;
    }

    if (!start || !end)
    {
#ifdef DEBUG
	debug(fordulo, "figyelmeztetes_store: bejovo adathiba\n");
#endif
	return -1;
    }

    if (!(figyelmeztetes = malloc(sizeof(t_figyelmeztetes))) || !(temp = malloc(end - start + 1)))
    {
#ifdef DEBUG
	debug(fordulo, "figyelmeztetes_store: ERROR nincs memoria eltarolni a figyelmeztetest\n");
#endif
	return -1;
    }
    
    sprintf(temp,"%.*s", end - start, start);
    str_htm2txt(temp);
    if (!(adat = malloc(strlen(temp) + 1)))
    {
#ifdef DEBUG
	debug(fordulo, "figyelmeztetes_store: ERROR nincs memoria eltarolni a figyelmeztetest\n");
#endif
	return -1;
    }
    strcpy(adat, temp);
    free(temp);
    if (islower2(*adat))
    {
	*adat = toupper2(*adat);
    }
/*
    for (f = fordulo->figyelmeztetes_elso; f; f = f->next)
    {
	if (strcmp(adat, f->adat) == 0)
	{
#ifdef DEBUG
	    debug(fordulo, "figyelmeztetes_store: mar el lett tarolva: \"%s\"\n", adat);
#endif
	    free(adat);
	    free(figyelmeztetes);
	    return 0;
	}
    }
*/    
    figyelmeztetes->adat = adat;
    figyelmeztetes->next = NULL;
    figyelmeztetes->aname = ++figyelmeztetes_aname;
    if (csata && fordulo->mezo_utolso && fordulo->mezo_utolso->enemy_utolso)
    {
	figyelmeztetes->enemy = fordulo->mezo_utolso->enemy_utolso;
    }
    else
    {
	figyelmeztetes->enemy = NULL;
    }

    if (fordulo->figyelmeztetes_utolso)
    {
	fordulo->figyelmeztetes_utolso->next = figyelmeztetes;
    }
    fordulo->figyelmeztetes_utolso = figyelmeztetes;
    if (!fordulo->figyelmeztetes_elso)
    {
	fordulo->figyelmeztetes_elso = figyelmeztetes;
    }
    
#ifdef DEBUG
    debug(fordulo, "figyelmeztetes_store: (%d) \"%s\"\n", figyelmeztetes->aname, figyelmeztetes->adat);
#endif
    return figyelmeztetes_aname;
}

extern int figyelmeztetes_store_delete(t_fordulo * fordulo)
{
    t_figyelmeztetes * figyelmeztetes;
    t_figyelmeztetes * next;
    
    for (figyelmeztetes = fordulo->figyelmeztetes_elso; figyelmeztetes; figyelmeztetes = next)
    {
	if (figyelmeztetes->adat)
	{
	    free(figyelmeztetes->adat);
	}
	next = figyelmeztetes->next;
	free(figyelmeztetes);
    }
    figyelmeztetes_aname = 0;
}

extern int figyelmeztetes_kiir(t_fordulo * fordulo)
{
    t_figyelmeztetes * figyelmeztetes;
    int i;
    
    if (aconf_get_curr("korvege_figyelmeztetes_kiiras") != 1)
    {
	return 0;
    }

    if (!fordulo)
    {
	return -1;
    }
    if (!fordulo->figyelmeztetes_elso)
    {
	return 0;
    }
    output(fordulo,"</B><BR><BR>\r\n");
    output(fordulo,"<P><TABLE WIDTH=100%% CELLPADDING=1 CELLSPACING=0 BORDER=0 CLASS=\"t0\"><TR><TD><TABLE WIDTH=100%% CELLPADDING=2 CELLSPACING=0 BORDER=0 CLASS=\"t1\"><TR><TD CLASS=\"c1\" colspan=2>FIGYELMEZTETSEK</td></tr>\r\n");
    for (i = 0, figyelmeztetes = fordulo->figyelmeztetes_elso; figyelmeztetes; figyelmeztetes = figyelmeztetes->next)
    {
	if (i == 0)
	{
//	    output(fordulo, "<tr><td nowrap class=\"c3\" width=100%% colspan=2>Figyelmeztetsek</td></tr>\r\n");
	}
	if (figyelmeztetes->enemy)
	{
	    output(fordulo, "<tr><td nowrap class=\"t1\" width=6%% align=middle> %d.) </td></td><td nowrap class=\"t1\" style=\"FONT-SIZE: 15px;\" width=94%%> <a class=n href=\"#enemy%d\">%s &nbsp;</td></tr>\r\n", figyelmeztetes->aname, figyelmeztetes->enemy->aname, figyelmeztetes->adat);
	}
	else
	{
	    output(fordulo, "<tr><td nowrap class=\"t1\" width=6%% align=middle> %d.) </td></td><td nowrap class=\"t1\" style=\"FONT-SIZE: 15px;\" width=94%%> <a class=n href=\"#figyelmeztetes%d\">%s &nbsp;</td></tr>\r\n", figyelmeztetes->aname, figyelmeztetes->aname, figyelmeztetes->adat);
	}
	if (aconf_get_curr("notes_figyelmeztetes") == 1)
	{
	    notes(fordulo->karakter->ksz, fordulo->fsz, "(%d) %s\r\n", figyelmeztetes->aname, figyelmeztetes->adat);
	}
	i++;
    }
    output(fordulo,"</table></td></tr></table><br><br>\r\n");
}

extern void reformat_fordulo(t_fordulo * fordulo, char * buf)
{
    unsigned long n;
    char * p1;
    char * p2;
    char * p3;
    char * t1;
    char * t2;
    char tmp;
    t_csata * pcsata;
    t_csata * osszesen;
    
    pcsata = &fordulo->csata;
    osszesen = &fordulo->osszesen;
    csata_next(NULL, pcsata);
    pcsata->fordulo = fordulo;
#ifdef DEBUG
    debug(fordulo, "reformat_fordulo 1: buf=%p\n", buf);
#endif
    // Vegigmegy csatankent, a visszaadott ertek a csata vege!
    for ( t1 = buf; t1 && (t2 = csata_next(t1, pcsata)); t1 = t2)
    {
#ifdef DEBUG
	debug(fordulo, "reformat_fordulo 2: t1=%p t2=%p\n", t1, t2);
#endif
	// Aranytermo ladiko feldolgozasa
	tmp = *t2;
	*t2 = '\0';
	ladiko(fordulo, t1, t2);
	*t2 = tmp;

#ifdef DEBUG
	debug(fordulo, "reformat_fordulo 3: t1=%p t2=%p\n", t1, t2);
#endif
	// Csata elotti resz feldolgozasa ES(!!!) kiirasa
	tmp = *pcsata->eleje;
	*pcsata->eleje = '\0';
	reformat_csatan_kivul(fordulo, pcsata->block, pcsata->eleje, pcsata);
	*pcsata->eleje = tmp;
#ifdef DEBUG
	debug(fordulo, "reformat_fordulo 4: t1=%p t2=%p\n", t1, t2);
#endif
	// Csata feldolgozasa ES(!!!) kiirasa
	tmp = *pcsata->vege;
	*pcsata->vege = '\0';
	reformat_csata(fordulo, pcsata);
	*pcsata->vege = tmp;

    } // enf of for(next_csata)
#ifdef DEBUG
    debug(fordulo, "reformat_fordulo utani resz kiiras: %.60s\n", t1);
#endif
    // Aranytermo ladiko feldolgozasa
    ladiko(fordulo, t1, t1 + strlen(t1));
    // Utolso csata utani resz kiirasa ES(!!!) feldolgozasa
    reformat_csatan_kivul(fordulo, t1, t1 + strlen(t1), NULL);
}

