/*
 * Copyright (C) 2003  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#include "typedef.h"
#ifndef INCLUDED_F_FORDULO_TYPES
#define INCLUDED_F_FORDULO_TYPES

#ifdef F_FORDULO_INTERNAL_ACCESS

typedef struct csataend
{
    char * csataend;
    char * hol;
}
t_csataend;


#endif /* F_FORDULO_INTERNAL_ACCESS */

typedef enum
{
    epulet_tipus_unknown = 0x00,
    epulet_tipus_epulet = 0x01,
    epulet_tipus_labirintus = 0x02
} t_epulet_tipus;

typedef struct varos
{
    char * nev;
    int xkoord;
    int ykoord;
} t_varos;

typedef struct trezsor
{
    char * nev;
    char * hol;
} t_trezsor;

#endif

#ifndef JUST_NEED_TYPES
#ifndef INCLUDED_F_FORDULO_PROTOS
#define JUST_NEED_TYPES
#include "fordulo.h"
extern int csataveg_init(t_fordulo * fordulo);
extern int trezsor_init(t_fordulo * fordulo);
extern char * csata_next(char * buf, t_csata * csata);
extern char * trezsor_next(char * buf, char * end, int tipus);
extern char * trezsor(t_fordulo * fordulo, char * p1, char * p3, char * t3);
extern int ladiko(t_fordulo * fordulo, char * start, char * end);
extern int figyelmeztetes_store(t_fordulo * fordulo, char * start, char * end, int csata);
extern int figyelmeztetes_store_delete(t_fordulo * fordulo);
extern int figyelmeztetes_kiir(t_fordulo * fordulo);
extern void reformat_fordulo(t_fordulo * fordulo, char * buf);
#undef JUST_NEED_TYPES
#define INCLUDED_F_FORDULO_PROTOS
#endif
#endif
