/*
 * Copyright (C) 2003-2005  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#define F_KARLAP_INTERNAL_ACCESS
#include "include.h"
#include "f_karlap.h"
#ifndef JUST_NEED_TYPES
# define JUST_NEED_TYPES
# include "format.h"
# undef JUST_NEED_TYPES
#else
# include "format.h"
#endif
#include "fordulo.h"
#include "sebzes.h"
#include "spell.h"
#include "targy.h"
#include "fegyver.h"
#include "karakter.h"
#include "output.h"
#include "input.h"
#include "torony.h"
#include "globals.h"

static t_faj fajok[] =
{
    {1, "ember"},
    {2, "elf"},
    {3, "trpe"},
    {4, "rnyman"},
    {5, "troll"},
    {6, "gnm"},
    {7, "alakvlt"},
    {8, "kobudera"},
    {9, "mutns"},
    {0, NULL}
};

static t_papirang papirangok[] =
{
    { 40, "lnyeknt az univerzum felett uralkod sistensg", 2450, 0xffff },
    { 39, "lnyt magba fogadott isteni entits", 2370, 2449 },
    { 38, "lnyvel eggy olvadt entits", 2290, 2369 },
    { 37, "lnyvel eggy olvad entits", 2210, 2289 },
    { 36, "minden gynek intzje fldi s gi dolgokban", 2130, 2209 },
    { 35, "kpviselje az istenek tancsban", 2050, 2129 },
    { 34, "istenn kikiltott szemlyes bartja", 1970, 2049 },
    { 33, "lnynek egy jelents rsze", 1890, 1969 },
    { 32, "hrvivje az univerzumban", 1810, 1889 },
    { 31, "leghatalmasabb, halhatatlan fpapja", 1730, 1809 },
    { 30, "isteni megnyilvnulsa", 1650, 1729 },
    { 29, "lnynek egy nagyobb rsze", 1570, 1649 },
    { 28, "testi manifesztcija", 1490, 1569 },
    { 27, "lnynek egy apr rsze", 1410, 1489 },
    { 26, "esszencijnak rkse", 1330, 1409 },
    { 25, "fldi s gi helytartja", 1250, 1329 },
    { 24, "halandk felett uralkod helyettese", 1170, 1249 },
    { 23, "teljhatalm megbzottja s jobbkeze", 1090, 1169 },
    { 22, "els szm avatrja", 1010, 1089 },
    { 21, "szemlyes testrknt szolgl avatrja", 930, 1009 },
    { 20, "kisebb avatrja", 850, 929 },
    { 19, "flisten hatalm szemlyes tancsadja", 770, 849 },
    { 18, "flisten hatalm felszentelt fpapja", 690, 769 },
    { 17, "flisten hatalm uralkod papja", 610, 689 },
    { 16, "flisten hatalm szolgja", 530, 609 },
    { 15, "szemlyes tancsadja", 450, 529 },
    { 14, "korltlan hatalm fpapja", 375, 449 },
    { 13, "nagyhatalm fpapja", 315, 374 },
    { 12, "fpapja", 265, 314 },
    { 11, "fpap-jelltje", 220, 264 },
    { 10, "pspke", 180, 219 },
    { 9, "bborosa", 150, 179 },
    { 8, "felszentelt papja", 120, 149 },
    { 7, "kisebb papja", 95, 119 },
    { 6, "eljvend papja", 75, 94 },
    { 5, "hittrtje", 55, 74 },
    { 4, "tantvnya", 40, 54 },
    { 3, "ministrnsa", 30, 39 },
    { 2, "hsges kvetje", 20, 29 },
    { 1, "kvetje", 1, 19 },
    { 0, NULL, 0, 0 }
};

void reformat_karlap_header_format(t_fordulo * fordulo, char * buf)
{
    char * p1;
    char * p2;
    char * p3;
    char width[20];
    int w;
    
    if (strlen(buf))
    {
	for (p3 = buf; p1 = strstr(p3 , "WIDTH="); p3 = p2)
	{
	    p2 = p1 + 6;
	    if (isdigit2(*p2))
	    {
		for ( ; isdigit2(*p2); p2++);
		w = atoi(p1 + 6);
		if (fordulo->tipus & fordulo_tipus_wrapper)
		{
		    if (w == 720)
		    {
			sprintf(width,"%s", WIDTH);
		    }
		    else if (w == 718)
		    {
			sprintf(width,"100%%");
		    }
		    else if (w == 205)
		    {
			sprintf(width,"30%%");
		    }
		    else if (w < 50)
		    {
			sprintf(width,"%d", w);
		    }
		    else 
		    {
			sprintf(width,"");
		    }
		}
		else
		{
		    if (w == 750)
		    {
			sprintf(width,"%s", WIDTH);
		    }
		    else if (w == 740)
		    {
			sprintf(width,"100%%");
		    }
		    else if (w == 205)
		    {
			sprintf(width,"30%%");
		    }
		    else if (w < 50)
		    {
			sprintf(width,"%d", w);
		    }
		    else 
		    {
			sprintf(width,"");
		    }
		}
		output(fordulo, "%.*s", p1 - p3, p3);

		if (strlen(width))
		{
		    output(fordulo, "WIDTH=%s", width);
		}
	    }
	}
	output(fordulo, "%s", p3);
    }
}

void reformat_karlap_else(t_fordulo * fordulo, char * buf)
{    
    if (strlen(buf))
    {
#ifdef DEBUG
	output(fordulo, "---> karlap start <---\r\n");
#endif
    	reformat_karlap_header_format(fordulo, buf);
#ifdef DEBUG
	output(fordulo, "---> karlap end <---\r\n");
#endif
    }
}

extern void reformat_karlap_tulajdonsag_check(t_fordulo * fordulo)
{
    char * p1;
    char * p2;
    char * p3;
    char * p4;
    char * p5;
    char * t1;
    t_karakter * karakter;
    char key[64];
    char value[64];
    long ertek = 0;
    long modositott = 0;
    long aktualis = 0;
    char tmp;
    char * buf;
    
    if (!fordulo || !fordulo->karakter)
    {
	return; 
    }
    
    karakter = fordulo->karakter;
    
    buf = karakter->tulajdonsag;
    tmp = *karakter->fegyverszaki;
    *karakter->fegyverszaki = '\0';
    
    if (!(t1 = strstr2(buf, "</TABLE></TD></TR></TABLE>")))
    {
	t1 = buf + strlen(buf);
    }
#ifdef DEBUG
    debug(fordulo, "reformat_karlap_tulajdonsag_check: 1\n");
#endif
    for (p4 = buf; (p1 = strstr2(p4, ">&nbsp;")) && (p2 = strstr(p1, ":</TD><TD")) && (p3 = strstr2(p2+8, ">")) && (p4 = strstr(p3, "</TD>")) && (p3 < t1); ertek = 0, modositott = 0, aktualis = 0)
    {
	p1 = skip_space(p1);
	p3 = skip_space(p3);
	if ((p2 - p1 > 63) || (p4 - p3 > 63))
	{
	    continue;
	}

	sprintf(key,"%.*s", p2 - p1, p1);
	sprintf(value,"%.*s", p4 - p3, p3);

#ifdef DEBUG
    debug(fordulo, "reformat_karlap_tulajdonsag_check: key=\"%s\", value=\"%s\"\n", key, value);
#endif
	if ((p5 = strstr2(value, "(")) && (isdigit2(*p5) || ((*p5 == '-') && isdigit2(*(p5+1)))))
	{
	    modositott = atoi(p5);
	}
#ifdef DEBUG
    debug(fordulo, "reformat_karlap_tulajdonsag_check: 11 modositott=%ld\n", modositott);
#endif
	if ((p5 = strstr2(value,"/")) && isdigit2(*p5))
	{
	    aktualis = atoi(p5);
	}
#ifdef DEBUG
    debug(fordulo, "reformat_karlap_tulajdonsag_check: 12 aktualis=%ld\n", aktualis);
#endif
	if (!(ertek = atoi(value)))
	{
	    if (strcmp(key,"Jellem") == 0)
	    {
		karakter->jellem = *value;
		
		if (*value == 'j')
		{
		    if (modositott == 777)
		    {
			karakter->jellemero = 8;
		    }
		    else if (modositott >= 120)
		    {
			karakter->jellemero = 6;
		    }
		    else if (modositott >= 90)
		    {
			karakter->jellemero = 5;
		    }
		    else if (modositott >= 60)
		    {
			karakter->jellemero = 4;
		    }
		    else if (modositott >= 45)
		    {
			karakter->jellemero = 3;
		    }
		    else if (modositott >= 30)
		    {
			karakter->jellemero = 2;
		    }
		    else if (modositott >= 15)
		    {
			karakter->jellemero = 1;
		    }
		}
		else if (*value == 'g')
		{
		    if (modositott == 666)
		    {
			karakter->jellemero = 7;
		    }
		    else if (modositott >= 135)
		    {
			karakter->jellemero = 5;
		    }
		    else if (modositott >= 85)
		    {
			karakter->jellemero = 4;
		    }
		    else if (modositott >= 35)
		    {
			karakter->jellemero = 3;
		    }
		    else if (modositott >= 25)
		    {
			karakter->jellemero = 2;
		    }
		    else if (modositott >= 15)
		    {
			karakter->jellemero = 1;
		    }
		}
		karakter->tulajdonsagok.jellempont = modositott;
	    }
	    continue;
	}
	
#ifdef DEBUG
	debug(fordulo, "reformat_karlap_tulajdonsag_check: 13 ertek=%ld\n", ertek);
#endif
	
	if (strcmp(key,"Er") == 0)
	{
	    karakter->tulajdonsagok.ero = ertek;
	    if (modositott)
	    {
		karakter->tulajdonsagok.ero_modositott = modositott;
	    }
	    else
	    {
		karakter->tulajdonsagok.ero_modositott = karakter->tulajdonsagok.ero;
	    }
	}
	else if (strcmp(key,"IQ") == 0)
	{
	    karakter->tulajdonsagok.iq = ertek;
	    if (modositott)
	    {
		karakter->tulajdonsagok.iq_modositott = modositott;
	    }
	    else
	    {
		karakter->tulajdonsagok.iq_modositott = karakter->tulajdonsagok.iq;
	    }
	}
	else if (strcmp(key,"gyessg") == 0)
	{
	    karakter->tulajdonsagok.ugyesseg = ertek;
	    if (modositott)
	    {
		karakter->tulajdonsagok.ugyesseg_modositott = modositott;
	    }
	    else
	    {
		karakter->tulajdonsagok.ugyesseg_modositott = karakter->tulajdonsagok.ugyesseg;
	    }
	}
	else if (strcmp(key,"Egszsg") == 0)
	{
	    karakter->tulajdonsagok.egeszseg = ertek;
	    if (modositott)
	    {
		karakter->tulajdonsagok.egeszseg_modositott = modositott;
	    }
	    else
	    {
		karakter->tulajdonsagok.egeszseg_modositott = karakter->tulajdonsagok.egeszseg;
	    }
	}
	else if (strcmp(key,"Szerencse") == 0)
	{
	    karakter->tulajdonsagok.szerencse = ertek;
	    if (modositott)
	    {
		karakter->tulajdonsagok.szerencse_modositott = modositott;
	    }
	    else
	    {
		karakter->tulajdonsagok.szerencse_modositott = karakter->tulajdonsagok.szerencse;
	    }
	}
	else if (strcmp(key,"Tmads") == 0)
	{
	    karakter->tulajdonsagok.tamadas = ertek;
	    if (modositott)
	    {
		karakter->tulajdonsagok.tamadas_modositott = modositott;
	    }
	}
	else if (strcmp(key,"Vdekezs") == 0)
	{
	    karakter->tulajdonsagok.vedekezes = ertek;
	    if (modositott)
	    {
		karakter->tulajdonsagok.vedekezes_modositott = modositott;
	    }
	}
	else if (strcmp(key,"letpont") == 0)
	{
	    karakter->tulajdonsagok.maxep = ertek;
	    karakter->tulajdonsagok.ep = aktualis;
	}
	else if (strcmp(key,"Varzspont") == 0)
	{
	    karakter->tulajdonsagok.maxvp = ertek;
	    karakter->tulajdonsagok.vp = aktualis;
	}
	else if (strcmp(key,"Pszi pont") == 0)
	{
	    karakter->tulajdonsagok.maxpp = ertek;
	    karakter->tulajdonsagok.pp = aktualis;
	}
	else if (strcmp(key,"Tudatpont") == 0)
	{
	    karakter->tulajdonsagok.maxtu = ertek;
	    karakter->tulajdonsagok.tu = aktualis;
	}
	else if (strcmp(key,"letkor") == 0)
	{
	    karakter->tulajdonsagok.eletkor_alap = ertek;
	    if (aktualis)
	    {
		karakter->tulajdonsagok.eletkor_aktualis = aktualis;
	    }
	}
	else if (strcmp(key,"Tul. pont") == 0)
	{
	    karakter->tulajdonsagok.tno = ertek;
	}
	else if (strcmp(key,"Kp. pont") == 0)
	{
	    if ((ertek >= -128) && (ertek < 50))
	    {
		ertek = 256 - ertek;
	    }
	    karakter->tulajdonsagok.kno = ertek;
	}
	else if (strcmp(key,"Pnz") == 0)
	{
/*
	    t_targy * targy;
	    
	    karakter->arany = ertek;
	    targy = get_targy_from_ssz(50);
            karakter_targylist_add(fordulo->karakter, targy, ertek, targy_flag_none, targy_hol_nalad);
*/
	}
#ifdef DEBUG
	debug(fordulo, "reformat_karlap_tulajdonsag_check: 14\n");
#endif
    }
    *karakter->fegyverszaki = tmp;
}

void reformat_karlap_tulajdonsag(t_fordulo * fordulo, char * buf)
{
#ifdef DEBUG
    debug(fordulo, "reformat_karlap_tulajdonsag: 1\n");
#endif
//    reformat_karlap_tulajdonsag_check(fordulo, buf);
#ifdef DEBUG
    debug(fordulo, "reformat_karlap_tulajdonsag: 2\n");
#endif
    reformat_karlap_else(fordulo, buf);
}

void reformat_karlap_fegyverszaki(t_fordulo * fordulo, char * buf)
{
    char * p1;
    char * p2;
    char * p3;
    char * p4;
    char * p5;
    char * t1;
    t_karakter * karakter;
    char key[64];
    char value[64];
    int ertek = 0;
    
    if (!fordulo || !fordulo->karakter)
    {
	return; 
    }
    
    karakter = fordulo->karakter;
    
    if (!(t1 = strstr2(buf, "</TABLE></TD></TR></TABLE>")))
    {
	t1 = buf + strlen(buf);
    }

#ifdef DEBUG
    debug(fordulo, "reformat_karlap_fegyverszaki: 1\n");
#endif
    for (p4 = buf; (p1 = strstr2(p4, "&nbsp;")) && (p2 = strstr(p1, ":")) && (p3 = strstr2(p2, "<TD")) && (p3 = strstr2(p3, ">")) && (p4 = strstr(p3, "</TD>")) && (p3 < t1); ertek = 0)
    {
#ifdef DEBUG
    debug(fordulo, "reformat_karlap_fegyverszaki: megtalalva: p1=\"%.*s\", p3=\"%.*s\"\n", p2 - p1, p1, p4 - p3, p3);
#endif
	// Fordulokinezet valtozas atmeneti idoszakaban a fegyverszaki is kapott sorszamozast
	if ((p5 = strstr2(p1, "</SMALL>")) && (p5 < p2))
	{
	    p1 = p5;
	    
	}
	// *ozodot fegyverszaki
	if ((p5 = strstr2(p1, "<SPAN CLASS=\"k\">")) && (p5 < p2))
	{
	    p1 = p5;
	    if ((p5 = strstr(p1, "</SPAN>")) && (p5 < p2))
	    {
		p2 = p5;
	    }
	}
	if ((p5 = strstr2(p3, "<SPAN CLASS=\"k\">")) && (p5 < p4))
	{
	    p3 = p5;
	    if ((p5 = strstr(p3, "</SPAN>")) && (p5 < p4))
	    {
		p4 = p5;
	    }
	}

	p1 = skip_space(p1);
	p3 = skip_space(p3);
	if (*p3 == '*')
	{
	    p3++;
	    p3 = skip_space(p3);
	}
	if (!isdigit2(*p3) || (p2 - p1 > 63) || (p4 - p3 > 63))
	{
#ifdef DEBUG
	    debug(fordulo, "reformat_karlap_fegyverszaki: continue: p1=\"%.*s\", p3=\"%.*s\"\n", p2 - p1, p1, p4 - p3, p3);
#endif
	    continue;
	}

	sprintf(key,"%.*s", p2 - p1, p1);
	sprintf(value,"%.*s", p4 - p3, p3);

#ifdef DEBUG
	debug(fordulo, "reformat_karlap_fegyverszaki: key=\"%s\", value=\"%s\"\n", key, value);
#endif
	if (!(ertek = atoi(value)))
	{
	    continue;
	}
	
#ifdef DEBUG
	debug(fordulo, "reformat_karlap_fegyverszaki: 11 ertek=%d\n",ertek);
#endif
	if (strcmp(key,"vziharc") == 0)
	{
	    karakter->fszaki.vizi = ertek;
	}
	else if (strcmp(key,"klvvs") == 0)
	{
	    karakter->fszaki.okol = ertek;
	}
	else if (strcmp(key,"szrfegyverek") == 0)
	{
	    karakter->fszaki.szuro = ertek;
	}
	else if (strcmp(key,"vgfegyverek") == 0)
	{
	    karakter->fszaki.vago = ertek;
	}
	else if (strcmp(key,"tfegyverek") == 0)
	{
	    karakter->fszaki.uto = ertek;
	}
	else if (strcmp(key,"lfegyverek") == 0)
	{
	    karakter->fszaki.lo = ertek;
	}
	else if (strcmp(key,"dobfegyverek") == 0)
	{
	    karakter->fszaki.dobo = ertek;
	}
#ifdef DEBUG
    debug(fordulo, "reformat_karlap_fegyverszaki: 12\n");
#endif
    }
    reformat_karlap_else(fordulo, buf);
#ifdef DEBUG
    debug(fordulo, "reformat_karlap_fegyverszaki: 2\n");
#endif
}

void reformat_karlap_szakertelmek(t_fordulo * fordulo, char * buf)
{
    char * p1;
    char * p2;
    char * p3;
    char * p4;
    char * p5;
    char * t1;
    t_karakter * karakter;
    char key[64];
    char value[64];
    int ertek = 0;
    
    if (!fordulo || !fordulo->karakter)
    {
	return; 
    }
    
    karakter = fordulo->karakter;
    
    if (!(t1 = strstr2(buf, "</TABLE></TD></TR></TABLE>")))
    {
	t1 = buf + strlen(buf);
    }

#ifdef DEBUG
    debug(fordulo, "reformat_karlap_szakertelmek: 1\n");
#endif
    for (p4 = buf; (p1 = strstr2(p4, "</SMALL>")) && (p2 = strstr(p1, ":")) && (p3 = strstr2(p2, "<TD")) && (p3 = strstr2(p3, ">")) && (p4 = strstr(p3, "</TD>")) && (p3 < t1); ertek = 0)
    {
	// *ozodat szakertelem
	if ((p5 = strstr2(p1, "<SPAN CLASS=\"k\">")) && (p5 < p2))
	{
	    p1 = p5;
	    if ((p5 = strstr(p1, "</SPAN>")) && (p5 < p2))
	    {
		p2 = p5;
	    }
	}
	if ((p5 = strstr2(p3, "<SPAN CLASS=\"k\">")) && (p5 < p4))
	{
	    p3 = p5;
	    if ((p5 = strstr(p3, "</SPAN>")) && (p5 < p4))
	    {
		p4 = p5;
	    }
	}

	p1 = skip_space(p1);
	p3 = skip_space(p3);
	if (*p3 == '*')
	{
	    p3++;
	}
	if (!isdigit2(*p3) || (p2 - p1 > 63) || (p4 - p3 > 63))
	{
	    continue;
	}

	sprintf(key,"%.*s", p2 - p1, p1);
	sprintf(value,"%.*s", p4 - p3, p3);

#ifdef DEBUG
	debug(fordulo, "reformat_karlap_szakertelmek: key=\"%s\", value=\"%s\"\n", key, value);
#endif
	if (!(ertek = atoi(value)))
	{
	    continue;
	}
	
#ifdef DEBUG
	debug(fordulo, "reformat_karlap_szakertelmek: 11 ertek=%d\n",ertek);
#endif
	if (strcmp(key,"rejtzkds") == 0)
	{
	    karakter->kepessegek.rejtozkodes = ertek;
	}
	else if (strcmp(key,"nyomkvets") == 0)
	{
	    karakter->kepessegek.nyomkovetes = ertek;
	}
	else if (strcmp(key,"lops") == 0)
	{
	    karakter->kepessegek.lopas = ertek;
	}
	else if (strcmp(key,"mszs") == 0)
	{
	    karakter->kepessegek.maszas = ertek;
	}
	else if (strcmp(key,"csapdakszts") == 0)
	{
	    karakter->kepessegek.csapdakeszites = ertek;
	}
	else if (strcmp(key,"csapdaszlels") == 0)
	{
	    karakter->kepessegek.csapdaeszleles = ertek;
	}
	else if (strcmp(key,"gygyts") == 0)
	{
	    karakter->kepessegek.gyogyitas = ertek;
	}
	else if (strcmp(key,"titkosrs") == 0)
	{
	    karakter->kepessegek.titkosiras = ertek;
	}
	else if (strcmp(key,"felderts") == 0)
	{
	    karakter->kepessegek.felderites = ertek;
	}
	else if (strcmp(key,"szrnyidomts") == 0)
	{
	    karakter->kepessegek.szornyidomitas = ertek;
	}
	else if (strcmp(key,"teolgia") == 0)
	{
	    karakter->kepessegek.teologia = ertek;
	}
	else if (strcmp(key,"taumaturgia") == 0)
	{
	    karakter->kepessegek.taumaturgia = ertek;
	}
	else if (strcmp(key,"steolgia") == 0)
	{
	    karakter->kepessegek.osteologia = ertek;
	}
	else if (strcmp(key,"staumaturgia") == 0)
	{
	    karakter->kepessegek.ostaumaturgia = ertek;
	}
	else if (strcmp(key,"szerencsejtk") == 0)
	{
	    karakter->kepessegek.szerencsejatek = ertek;
	}
	else if (strcmp(key,"versengs") == 0)
	{
	    karakter->kepessegek.versenges = ertek;
	}
	else if (strcmp(key,"harcmvszetek") == 0)
	{
	    karakter->kepessegek.harcmuveszet = ertek;
	}
	else if (strcmp(key,"szkanderozs") == 0)
	{
	    karakter->kepessegek.szkander = ertek;
	}
	else if (strcmp(key,"zene") == 0)
	{
	    karakter->kepessegek.zene = ertek;
	}
	else if (strcmp(key,"szrnyismeret") == 0)
	{
	    karakter->kepessegek.szornyismeret = ertek;
	}
	else if (strcmp(key,"pszi") == 0)
	{
	    karakter->kepessegek.pszi = ertek;
	}
	else if (strcmp(key,"zrnyits") == 0)
	{
	    karakter->kepessegek.zarnyitas = ertek;
	}
	else if (strcmp(key,"vadszat") == 0)
	{
	    karakter->kepessegek.vadaszat = ertek;
	}
	else if (strcmp(key,"vitalits") == 0)
	{
	    karakter->kepessegek.vitalitas = ertek;
	}
	else if (strcmp(key,"bnyszat") == 0)
	{
	    karakter->kepessegek.banyaszat = ertek;
	}
	else if (strcmp(key,"testpts") == 0)
	{
	    karakter->kepessegek.testepites = ertek;
	}
	else if (strcmp(key,"szs") == 0)
	{
	    karakter->kepessegek.uszas = ertek;
	}
	else if (strcmp(key,"ordts") == 0)
	{
	    karakter->kepessegek.orditas = ertek;
	}
	else if (strcmp(key,"fzs") == 0)
	{
	    karakter->kepessegek.fozes = ertek;
	}
	else
	{
#ifdef DEBUG
	    debug(fordulo, "reformat_karlap_szakertelmek: fel nem ismert szakertelem: \"%s\" %d \n", key, value);
#endif
	}
#ifdef DEBUG
	debug(fordulo, "reformat_karlap_szakertelmek: 12\n");
#endif
    }
    reformat_karlap_else(fordulo, buf);
#ifdef DEBUG
    debug(fordulo, "reformat_karlap_szakertelmek: 2\n");
#endif
}

void reformat_karlap_fno(t_fordulo * fordulo, char * buf)
{
    char * p1;
    char * p2;
    char * p3;
    int * pi;
    int i;
    
    if (!fordulo || !fordulo->karakter)
    {
	return; 
    }
    
    if (p1 = strstr2(buf, "Felhasznlatlan fejlesztsi pont:"))
    {
	fordulo->karakter->fnopont = atoi(p1);
#ifdef DEBUG
    debug(fordulo, "reformat_karlap_fno: fno=%d\n", fordulo->karakter->fnopont);
#endif
    }

    pi = (int *)&fordulo->karakter->fno_skillek;
    for (p3 = p1; (p1 = strstr2(p3, "<SMALL>")) && isdigit2(*p1) && (p2 = strstr2(p1, ":")) && (p2 = skip_space(p2)) && isdigit2(*p2) && (p3 = strstr2(p1, "</TD>")) && (p2 < p3); )
    {
	i = atoi(p1);
	if ((i >= 1) & (i <= sizeof(t_fno_skillek)/sizeof(int)))
	{
	    pi[i-1] = atoi(p2);
#ifdef DEBUG
	    debug(fordulo, "reformat_karlap_fno: i=%d, ertek=%d, fno_skill=\"%.*s\"\n", i, pi[i-1], p3 - p1 - 6, p1);
#endif
	}
    }
    
#ifdef DEBUG
    debug(fordulo, "reformat_karlap_fno: varseb=%d\n", fordulo->karakter->fno_skillek.varazslatsebzes);
#endif
    reformat_karlap_else(fordulo, buf);
}

void reformat_karlap_spellek(t_fordulo * fordulo, char * buf)
{
    char * p1;
    char * p2;
    char * p3;
    char * p4;
    char * p5;
    char szn[10];
    char * nev;
    t_spell * spell;
    char tmp;
    int ssz;
    
    if (!fordulo || !fordulo->karakter)
    {
	return; 
    }
#ifdef DEBUG
    debug(fordulo, "reformat_karlap_spellek: 1\n");
#endif
    p3 = buf;
    if (p3 = strstr2(p3, "Butasg ra bellts:"))
    {
	if ((p1 = strstr2(p3, "teolgia:")) && (p2 = strstr2(p1, "vp")))
	{
	    fordulo->karakter->butasagara_plusz_teo = atoi(p1);
	    fordulo->karakter->butasagara_hatar_teo = atoi(p2);
#ifdef DEBUG
	    debug(fordulo, "reformat_karlap_spellek: butasag ara teologia \"%.30s\" plusz=%d, hatar=%d\n", p1, fordulo->karakter->butasagara_plusz_teo, fordulo->karakter->butasagara_hatar_teo);
#endif
	}
	if ((p1 = strstr2(p3, "taumaturgia:")) && (p2 = strstr2(p1, "vp")))
	{
	    fordulo->karakter->butasagara_plusz_tau = atoi(p1);
	    fordulo->karakter->butasagara_hatar_tau = atoi(p2);
#ifdef DEBUG
	    debug(fordulo, "reformat_karlap_spellek: butasag ara taumaturgia \"%.30s\" plusz=%d, hatar=%d\n", p1, fordulo->karakter->butasagara_plusz_tau, fordulo->karakter->butasagara_hatar_tau);
#endif
	}
    }

    p3 = buf;
    
    if (p1 = strstr2(p3, "varzslatok tanulsra elklthet:"))
    {
	fordulo->karakter->plusz10vpregen = atoi(p1);
#ifdef DEBUG
	debug(fordulo, "reformat_karlap_spellek: 10 vpregenek \"%.30s\" vpregen=%d\n", p1, fordulo->karakter->plusz10vpregen);
#endif
    }

    if (!(p1 = strstr(buf, "id</TD></TR>")))
    {
	p1 = buf + strlen(buf);
    }

    p3 = buf;
    tmp = *p1;
    *p1 = '\0';
    reformat_karlap_header_format(fordulo, p3);
    *p1 = tmp;
    p3 = p1;
    
    for (p2 = p3; (p1 = strstr2(p2, "(")) && (p2 = strstr2(p1, ")")) && (p4 = strstr(p1, "<")) && (p2 <= p4); )
    {
	if ((*p1 != '#') || (!isdigit2(*(p1+1))))
	{
	    continue;
	}
	p1++;
	
	if (ssz = atoi(p1))
	{
	    if (ssz == 110)
	    {
		fordulo->karakter->faj = 7;
	    }
	    if (ssz == 250)
	    {
		fordulo->karakter->meditacio_van = 1;
#ifdef DEBUG
		debug(fordulo, "reformat_karlap_spellek: van meditacio \"%.30s\" \n", p1);
#endif
	    }
	    else if (ssz == 28)
	    {
		fordulo->karakter->csupaszizom_van = 1;
#ifdef DEBUG
		debug(fordulo, "reformat_karlap_spellek: van csupaszizom \"%.30s\" \n", p1);
#endif
	    }
	    else if (ssz == 53)
	    {
		fordulo->karakter->oriasero_van = 1;
#ifdef DEBUG
		debug(fordulo, "reformat_karlap_spellek: van oriasero \"%.30s\" \n", p1);
#endif
	    }
	    
	    if (aconf_get_curr("hyperlink_spell") == 1)
	    {
		output(fordulo, "%.*s<a class=n href=\"%svari_enc.php%sf=venc&ssz=%i%s\" target=hyper title=\"Encyclopedia (Web Hyper)\">%d</a>", p1 - p3, p3, bconf_get_webhyper(), (aconf_get_webhyper_offline()?"@":"?"), ssz, (aconf_get_webhyper_offline()?".htm":""), ssz);
	    }
	    else
	    {
		output(fordulo, "%.*s%d", p1 - p3, p3, ssz);
	    }

	    for (p5 = p1; isdigit2(*p5); p5++);
	    output(fordulo, "%.*s", p2 - p5, p5);
	}
	else
	{
	    output(fordulo, "%.*s", p2 - p3, p3);
	}
	p3 = p2;
    }

//    reformat_karlap_else(fordulo, p3);
    output(fordulo, "%s", p3);
#ifdef DEBUG
    debug(fordulo, "reformat_karlap_spellek: 2\n");
#endif
}

void reformat_karlap_tvlista(t_fordulo * fordulo, char * buf)
{
    char * lista_fvh;
    char * lista_tv;
    char * lista_ftv;
    
    char * p1;
    char * p2;
    char * p3;
    char * l1;
    char * l2;
    char * l3;
    int ssz;
    char tmp;
    int i;
    
    if (!fordulo || !fordulo->karakter)
    {
	return; 
    }
    
#ifdef DEBUG
    debug(fordulo, "reformat_karlap_tvlista: 1\n");
#endif
    
    if (!(p1 = strstr(buf, "TMAD S VDEKEZ")))
    {
	p1 = buf + strlen(buf);
    }

    p3 = buf;
    tmp = *p1;
    *p1 = '\0';
    reformat_karlap_header_format(fordulo, p3);
    *p1 = tmp;

    p3 = p1;
    lista_fvh = strstr(p1, "Feltteles varzslat-hasznlat");
    lista_tv = strstr(p1, "Tmad varzslatok");
    if (!lista_tv)
    {
	lista_tv = strstr(p1, "Vdekez varzslatok");
    }
    lista_ftv = strstr(p1, "Feltteles tmad varzslatok");
    if (!lista_ftv)
    {
	lista_ftv = strstr(p1, "Feltteles vdekez varzslatok");
    }
    
    i = 0;
    for (p2 = p3 ; (p1 = strstr2(p3, "(#")) && (p2 = strstr(p1, ")")) && (p2 - p1 < 5); )
    {
	if (ssz = atoi(p1))
	{
	    if (aconf_get_curr("hyperlink_spell") == 1)
	    {
		output(fordulo, "%.*s<a class=n href=\"%svari_enc.php%sf=venc&ssz=%i%s\" target=hyper title=\"Encyclopedia (Web Hyper)\">%d</a>", p1 - p3, p3, bconf_get_webhyper(), (aconf_get_webhyper_offline()?"@":"?"), ssz, (aconf_get_webhyper_offline()?".htm":""), ssz);
	    }
	    else
	    {
	        output(fordulo, "%.*s%d", p1 - p3, p3, ssz);
	    }
	    p3 = p2;
	    
	    if (lista_ftv && (p1 > lista_ftv))
	    {
		if ((l3 = strstr2(p2, "</TD>")) && (l3 = strstr2(l3, "</TD>")) && (l3 = strstr2(l3, "</TD>")))
		{
		    if ((l1 = strstr2(p2, "(#")) && (l2 = strstr(l1, ")")) && (l2 < l3))
		    {
			if (ssz = atoi(l1))
			{
			    if ((ssz >= 10) && (ssz < 980))
			    {
				if (aconf_get_curr("hyperlink_szorny") == 1)
				{
				    output(fordulo, "%.*s<a class=n href=\"%sszorny_enc.php%sf=szenc&ssz=%i%s\" target=hyper title=\"Encyclopedia (Web Hyper)\">%d</a>", l1 - p3, p3, bconf_get_webhyper(), (aconf_get_webhyper_offline()?"@":"?"), ssz, (aconf_get_webhyper_offline()?".htm":""), ssz);
				}
				else
				{
				    output(fordulo, "%.*s%d", l1 - p3, p3, ssz);
				}
				p3 = l2;
			    }
			    else
			    {
			        output(fordulo, "%.*s", l3 - p3, p3);
				p3 = l3;
			    }
			}
		    }
		}
	    }
	}
    }
#ifdef DEBUG
    debug(fordulo, "reformat_karlap_spellekrajtad: 2\n");
#endif
//    reformat_karlap_else(fordulo, p3);
    output(fordulo, "%s", p3);
}
    
void reformat_karlap_spellrajtad(t_fordulo * fordulo, char * buf)
{
    char * p1;
    char * p2;
    char * p3;
    int ssz;
    char tmp;
    
    if (!fordulo || !fordulo->karakter)
    {
	return; 
    }
    
#ifdef DEBUG
    debug(fordulo, "reformat_karlap_spellekrejtad: 1\n");
#endif
    
    if (!(p1 = strstr(buf, "JELENLEG RAJTAD")))
    {
	p1 = buf + strlen(buf);
    }

    p3 = buf;
    tmp = *p1;
    *p1 = '\0';
    reformat_karlap_header_format(fordulo, p3);
    *p1 = tmp;

    p3 = p1;
    
    karakter_spelllist_init_fentvan(fordulo->karakter);
    for (p2 = p3 ; (p1 = strstr2(p2, "(#")) && (p2 = strstr(p1, ")")) && (p2 - p1 < 5); )
    {
	if (ssz = atoi(p1))
	{
	    karakter_spelllist_set_fentvan(fordulo->karakter, ssz);

	    if (aconf_get_curr("hyperlink_spell") == 1)
	    {
		output(fordulo, "%.*s<a class=n href=\"%svari_enc.php%sf=venc&ssz=%i%s\" target=hyper title=\"Encyclopedia (Web Hyper)\">%d</a>", p1 - p3, p3, bconf_get_webhyper(), (aconf_get_webhyper_offline()?"@":"?"), ssz, (aconf_get_webhyper_offline()?".htm":""), ssz);
	    }
	    else
	    {
		output(fordulo, "%.*s%d", p1 - p3, p3, ssz);
	    }
	    p3 = p2;
	}
    }

#ifdef DEBUG
    debug(fordulo, "reformat_karlap_spellekrajtad: 2\n");
#endif
//    reformat_karlap_else(fordulo, p3);
    output(fordulo, "%s", p3);
}

void reformat_karlap_karlapstart(t_fordulo * fordulo, char * buf)
{
    char * p1;
    char * p2;
    int i;
    
#ifdef DEBUG
    debug(fordulo, "reformat_karlap_karlapstart: 1\n");
#endif
    if (p1 = strstr(buf, " vagy."))
    {
	for (p2 = p1; ((*p2 == ' ') || (*p2 == '\t') || (*p2 == '\r') || (*p2 == '\n')) && (p2 > buf); p2--);
	for (p1 = p2++; (*p1 != ' ') && (*p1 != '\t') && (*p1 != '\r') && (*p1 != '\n') && (p1 > buf); p1--);

	fordulo->karakter->nem =  *(p1+1);
#ifdef DEBUG
	debug(fordulo, "reformat_karlap_karlapstart: nem=%c\n", fordulo->karakter->nem);
#endif

	for (p2 = p1; ((*p2 == ' ') || (*p2 == '\t') || (*p2 == '\r') || (*p2 == '\n')) && (p2 > buf); p2--);
	for (p1 = p2++; (*p1 != ' ') && (*p1 != '\t') && (*p1 != '\r') && (*p1 != '\n') && (p1 > buf); p1--);
	p1++;

	for (i = 0; (i < sizeof(fajok)/sizeof(t_faj)) && fajok[i].nev; i++)
	{
	    if (strncmp(p1,fajok[i].nev,p2-p1) == 0)
	    {
		fordulo->karakter->faj = fajok[i].szam;
		break;
	    }
	}
#ifdef DEBUG
	debug(fordulo, "reformat_karlap_karlapstart: faj=%d\n", fordulo->karakter->faj);
#endif
	for (i = 0; (i < sizeof(papirangok)/sizeof(t_papirang)) && papirangok[i].nev; i++)
	{
	    if (strstr(p2,papirangok[i].nev))
	    {
		fordulo->karakter->papirang = papirangok[i].szam;
		break;
	    }
	}
    }
#ifdef DEBUG
    debug(fordulo, "reformat_karlap_karlapstart: papirang=%d\n", fordulo->karakter->papirang);
#endif
    reformat_karlap_else(fordulo, buf);
#ifdef DEBUG
    debug(fordulo, "reformat_karlap_karlapstart: 2\n");
#endif
}

void reformat_karlap_jo_tudni(t_fordulo * fordulo)
{
    int teooszto;
    int tauoszto;
    int pszioszto;
    int vpregen_alap;
    int vpregen_kelet;
    int vpregen_plusz;
    int erobonusz1;
    int erobonusz2;
    int ugyibonusz;
    int tulosszeg;
    int tulosszeg_modositott;
    t_karakter * karakter;
    t_fegyver * fegyver;
    t_spell * spell;
    int spellero;
    float sebzes;
    float fullsebzes;
    float alapsebzes;
    float mentve;
    int spell_magia_sebzes_bonusz;
    int spell_targy_sebzes_bonusz;
    int fszaki;
    int bonusz;
    int balbonusz;
    int fbonusz;
    int tbonusz;
    int utes;
    int bal_utes;
    int i;
    int j;
    int h[30];
    int b;
    int b1;
    int m;
    int bold;
    int dolt;
    int * pi;
    int * pi2;
    int * pi3;
    t_karakter_targylist * karakter_targylist_elem;
    t_karakter_spelllist * karakter_spelllist_elem;
    t_karakter_fegyverlist * karakter_fegyverlist_elem;
    int tleikan_lehet;
    int ok;
    t_varazslatsebzes * varazslatsebzes;
    int vsebzes1;
    int vsebzes1r;
    int vsebzes2;
    int vi;
    float felfullsebzes;
    int rughar_van;
    int pulzans_bonusz = 0;
    float sebzes_pajzsbol;
    t_fegyver_type fegyver_type;
    int teologia;
    int taumaturgia;
    int osteologia;
    int ostaumaturgia;
    int fegyverszakiosszeg;
    float fegyverszakifoatlag;
    float fegyverszakitavatlag;
    float tapfaktor;
    float tapfaktor_uj;
    int csupaszizom;
    
    if (!fordulo || !fordulo->karakter)
    {
	return;
    }
    
    karakter = fordulo->karakter;
    rughar_van = (aconf_get_curr("spell_sebzes_bonusz_csak_meglevo") == 0) || ((aconf_get_curr("spell_sebzes_bonusz_csak_meglevo") == 1) && karakter_targylist_check_targy(karakter, 518)) || ((aconf_get_curr("spell_sebzes_bonusz_csak_meglevo") == 2) && karakter_targylist_check_targy_kf(karakter, 518));

// regi szamitas
//    karakter->teoero = (int)(karakter->kepessegek.teologia / 3) + karakter->papirang + karakter->papikarkoto + karakter->jellemero;
//    karakter->tauero = (int)(karakter->kepessegek.taumaturgia + 1) / 2;
    
    teologia = karakter->kepessegek.teologia;
    taumaturgia = karakter->kepessegek.taumaturgia;
    osteologia = karakter->kepessegek.osteologia;
    ostaumaturgia = karakter->kepessegek.ostaumaturgia;
    if ((fordulo->betap && (fordulo->betap > SPELLERO_VALTOZAS_TIME)) && (karakter->kepessegek.teologia > 250))
    {
	teologia = (int)((karakter->kepessegek.teologia - 250) / 25) + 250;
    }
    if ((fordulo->betap && (fordulo->betap > SPELLERO_VALTOZAS_TIME)) && (karakter->kepessegek.taumaturgia > 250))
    {
	taumaturgia = (int)((karakter->kepessegek.taumaturgia - 250) / 25) + 250;
    }
    karakter->teoero = (int)(teologia / 3) + karakter->papirang + karakter->papikarkoto + karakter->jellemero;
    karakter->tauero = (int)((taumaturgia + 1) / 2);
    karakter->osteoero = (int)osteologia;
    karakter->ostauero = (int)ostaumaturgia;

    if (fordulo->betap && (fordulo->betap < PSZI_VALTOZAS_TIME))
    {
	karakter->psziero = (int)(karakter->kepessegek.pszi + 1) / 2;
    }
    else
    {
	if (karakter->kepessegek.pszi < 20)
	{
	    karakter->psziero = (int)((karakter->kepessegek.pszi + 1) / 2);
	}
	else
	{
	    karakter->psziero = 10 + (int)(karakter->kepessegek.pszi - 19);
	}
    }
    teooszto = (karakter->kepessegek.teologia ? (int)(karakter->kepessegek.teologia / 7) + 3 : 0);
    tauoszto = (karakter->kepessegek.taumaturgia ? (int)(karakter->kepessegek.taumaturgia / 7) + 3 : 0);
    pszioszto = (karakter->kepessegek.pszi ? (int)(karakter->kepessegek.pszi / 7) + 3 : 0);
    vpregen_alap = (karakter->tulajdonsagok.iq_modositott - 12) + (karakter->teoero * 2) + (taumaturgia > 3 ? taumaturgia - 3 : 0);
    vpregen_kelet = vpregen_alap + (int)(karakter->tulajdonsagok.maxvp / 40);
    vpregen_plusz = karakter->plusz10vpregen * (karakter->meditacio_van?2:1);
    if (!fordulo->karakter->csupaszizom && fordulo->karakter->csupaszizom_van)
    {
	fordulo->karakter->csupaszizom = karakter->teoero / 5 + 1;
    }
    if (!fordulo->karakter->oriasero && fordulo->karakter->oriasero_van)
    {
	fordulo->karakter->oriasero = karakter->teoero / 6 + 1;
    }
    if (karakter->tulajdonsagok.ero_modositott > 36)
    {
	erobonusz1 = karakter->tulajdonsagok.ero_modositott / 3 - 1;
    }
    else if (karakter->tulajdonsagok.ero_modositott >= 16)
    {
	erobonusz1 = (karakter->tulajdonsagok.ero_modositott - 14) / 2;
    }
    else
    {
	erobonusz1 = 0;
    }
    csupaszizom = 0;
    if (fordulo->betap < CSUPASZIZOM_VALTOZAS_TIME)
    {
	csupaszizom = karakter->csupaszizom;
    }
    if (karakter->tulajdonsagok.ero_modositott + fordulo->karakter->hatalomvarazs + csupaszizom > 36)
    {
	erobonusz2 = (karakter->tulajdonsagok.ero_modositott + fordulo->karakter->hatalomvarazs + csupaszizom ) / 3 - 1;
    }
    else if ((karakter->tulajdonsagok.ero_modositott + fordulo->karakter->hatalomvarazs + csupaszizom) >= 16)
    {
	erobonusz2 = (karakter->tulajdonsagok.ero_modositott + fordulo->karakter->hatalomvarazs + csupaszizom - 14) / 2;
    }
    else 
    {
	erobonusz2 = 0;
    }
    if (karakter->tulajdonsagok.ugyesseg_modositott + fordulo->karakter->hatalomvarazs >= 26)
    {
	ugyibonusz = (karakter->tulajdonsagok.ugyesseg_modositott + fordulo->karakter->hatalomvarazs) / 2 - 4;
    }
    else if (karakter->tulajdonsagok.ugyesseg_modositott + fordulo->karakter->hatalomvarazs >= 20)
    {
	ugyibonusz = (karakter->tulajdonsagok.ugyesseg_modositott + fordulo->karakter->hatalomvarazs) - 17;
    }
    else if (karakter->tulajdonsagok.ugyesseg_modositott >= 16)
    {
	ugyibonusz = (karakter->tulajdonsagok.ugyesseg_modositott + fordulo->karakter->hatalomvarazs) / 2 - 8;
    }
    else
    {
	ugyibonusz = 0;
    }
    tulosszeg = karakter->tulajdonsagok.ero + karakter->tulajdonsagok.iq + karakter->tulajdonsagok.ugyesseg + karakter->tulajdonsagok.egeszseg + karakter->tulajdonsagok.szerencse + karakter->tulajdonsagok.maxtu;
    tulosszeg_modositott = karakter->tulajdonsagok.ero_modositott + karakter->tulajdonsagok.iq_modositott + karakter->tulajdonsagok.ugyesseg_modositott + karakter->tulajdonsagok.egeszseg_modositott + karakter->tulajdonsagok.szerencse_modositott + karakter->tulajdonsagok.maxtu;
    fegyverszakiosszeg = karakter->fszaki.vizi + karakter->fszaki.okol + karakter->fszaki.szuro + karakter->fszaki.vago + karakter->fszaki.uto + karakter->fszaki.lo + karakter->fszaki.dobo;
    fegyverszakifoatlag = (float)((karakter->fszaki.okol>karakter->fszaki.uto?karakter->fszaki.okol:karakter->fszaki.uto) + karakter->fszaki.szuro + karakter->fszaki.vago) / (float)3;
    fegyverszakitavatlag = (float)(karakter->fszaki.lo + karakter->fszaki.dobo) / (float)2;
    tapfaktor = ((float)(karakter->szint)*(float)3) + ((float)(karakter->tulajdonsagok.maxep + karakter->tulajdonsagok.maxvp + karakter->tulajdonsagok.maxpp) / (float)10) + (float)karakter->tulajdonsagok.tamadas + (float)karakter->tulajdonsagok.vedekezes + (float)tulosszeg + (float)fegyverszakiosszeg;
    for (pi = (int *)&karakter->kepessegek, b = 0; b < (sizeof(t_kepessegek)/sizeof(int)); b++)
    {
	tapfaktor += (float)pi[b];
    }
    tapfaktor += (float)karakter->tulajdonsagok.tno + (float)karakter->tulajdonsagok.kno;
    tapfaktor_uj = tapfaktor + (float)fegyverszakiosszeg + ((float)karakter->papirang + (float)karakter->jellemero)*(float)3 + ((float)karakter->fnopont/(float)10);
    for (pi = (int *)&karakter->fno_skillek, b = 0; b < (sizeof(t_fno_skillek)/sizeof(int)); b++)
    {
	tapfaktor_uj += (float)pi[b]*(float)10;
    }
    
    // Bonuszok targybol part I -> kiszamolas
    if (aconf_get_curr("karlap_targy_bonusz_kiiras") == 1)
    {
	for (b = 0; b < (sizeof(t_bonuszok)/sizeof(int)); b++)
	{
	    m = 0;
	    for (i = 0, karakter_targylist_elem = get_karakter_targylist_head(fordulo->karakter, 1); karakter_targylist_elem; karakter_targylist_elem = karakter_targylist_elem->next)
	    {
		if ((karakter_targylist_elem->flag&targy_flag_kf) || karakter_targylist_elem->targy->nonkf)
		{
		    if (b == 12)
		    {
			if ((karakter_targylist_elem->ssz == 307) || (karakter_targylist_elem->ssz == 308) || (karakter_targylist_elem->ssz == 309))
			{
			    continue;
			}
		    }
		    pi = (int *)karakter_targylist_elem->targy->bonuszok;
		    if (pi[b])
		    {
			if ((b > 9) && ((karakter_targylist_elem->targy->fegyver && (karakter_targylist_elem->targy->tipus != targy_tipus_kesztyu)) || (karakter_targylist_elem->targy->tipus == targy_tipus_lo)))
			{
			    continue;
			}
			if (karakter_targylist_elem->ssz == 229)
			{
			    continue;
			}
			if (b == 11)
			{
			    if (karakter_targylist_elem->targy->tipus == targy_tipus_pajzs)
			    {
				karakter->sebzes_pajzsbol += pi[b];
				continue;
			    }
			    if (targy_ad_bonuszt_vizben(karakter_targylist_elem->targy))
			    {
				karakter->sebzesbonusz_vizben += pi[b];
			    }
			}
			if ((b == 12) && (karakter_targylist_elem->ssz == 542))
			{
			    t_karakter_targylist * zkat;
			    
			    pulzans_bonusz = 5;
			    
			    if (zkat = karakter_targylist_get_targy(karakter, 896))
			    {
				if (zkat->darab >= 14)
				{
				    pulzans_bonusz = 200;
				}
				else if ((zkat->darab > 0) && (zkat->darab < 4))
				{
				    switch (zkat->darab)
				    {
					case 3:
					    pulzans_bonusz = pulzans_bonusz * 2;
				        case 2:
					    pulzans_bonusz = pulzans_bonusz * 2;
					case 1:
					    pulzans_bonusz = pulzans_bonusz * 2;
				    }
				}
				else if ((zkat->darab >= 4) && (zkat->darab <= 8))
				{
				    pulzans_bonusz = pulzans_bonusz * 8 + (zkat->darab - 3) * 20;
				}
				else if (zkat->darab >= 9)
				{
				    pulzans_bonusz = pulzans_bonusz * 8 + 100 + (zkat->darab - 8) * 10;
				}
				else
				{
				    pulzans_bonusz = 0;
				}
			    }
			    if (pulzans_bonusz > 200)
			    {
				pulzans_bonusz = 200;
			    }
			    pulzans_bonusz = pulzans_bonusz * karakter_targylist_elem->darab;
			    m += pulzans_bonusz;
			}
			else
			{
			    m += pi[b];
			}
			i++;
		    }
		}
	    }
	
	    pi3 = (int *)&karakter->bonuszok;
	    pi3[b] = m;
	}
	vsebzes1 = 0;
	vsebzes2 = 0;
	for (vi = 0, varazslatsebzes = karakter->varazslatsebzes; vi < karakter->varazslatsebzes_size; vi++)
	{
	    if (varazslatsebzes[vi].van)
	    {
		if ((!varazslatsebzes[vi].maxteo || (varazslatsebzes[vi].maxteo && (karakter->kepessegek.teologia < varazslatsebzes[vi].maxteo))) && (!varazslatsebzes[vi].maxtau || (varazslatsebzes[vi].maxtau && (karakter->kepessegek.taumaturgia < varazslatsebzes[vi].maxtau))))
		{
		    if ((varazslatsebzes[vi].flag&targy_flag_kf) || varazslatsebzes[vi].targy->nonkf)
		    {
			vsebzes1 += varazslatsebzes[vi].bonusz;
			vsebzes2 += varazslatsebzes[vi].max;
		    }
		}
	    }
	}
    }
    
    // Kepessegek targybol part I -> kiszamolas
    if (aconf_get_curr("karlap_targy_kepesseg_kiiras") == 1)
    {
	for (b = 0; b < (sizeof(t_kepessegek)/sizeof(int)); b++)
	{
	    m = 0;
	    for (i = 0, karakter_targylist_elem = get_karakter_targylist_head(fordulo->karakter, 2); karakter_targylist_elem; karakter_targylist_elem = karakter_targylist_elem->next)
	    {
		if ((karakter_targylist_elem->flag&targy_flag_kf) || karakter_targylist_elem->targy->nonkf)
		{
		    pi = (int *)karakter_targylist_elem->targy->kepessegek;
		    if (pi[b])
		    {
			m += pi[b];
			i++;
		    }
		}
	    }
	
	    pi3 = (int *)&karakter->kepesseg_bonuszok;
	    pi3[b] = m;
	}
    }
    
    if ((aconf_get_curr("karlap_tno_osszeg_kiiras") == 1) || (aconf_get_curr("karlap_bonuszok_kiiras") == 1) || (aconf_get_curr("karlap_spell_erosseg_kiiras") == 1) || (aconf_get_curr("karlap_spell_oszto_kiiras") == 1) || (aconf_get_curr("karlap_vpregen_kiiras") == 1) || (aconf_get_curr("karlap_targy_bonusz_kiiras") == 1) || (aconf_get_curr("karlap_targy_kepesseg_kiiras") == 1) || (aconf_get_curr("karlap_targy_spell_kiiras") == 1))
    {
	output(fordulo,"<TABLE WIDTH=100%% CELLPADDING=1 CELLSPACING=0 BORDER=0 CLASS=\"t0\"><TR><TD> <TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0 CLASS=\"t1\" WIDTH=100%%>\r\n<TR><TD CLASS=\"c2\" COLSPAN=9>J TUDNI</TD></TR>\r\n");
    }
    if (aconf_get_curr("karlap_ismeretek_kiiras") == 1)
    {
	output(fordulo,"<TR><TD CLASS=\"c3\" COLSPAN=9> Ismersz sszesen</TD></TR>\r\n");
	output(fordulo,"<TR><TD CLASS=\"t1\" COLSPAN=3> %d szrnyet</TD><TD CLASS=\"t1\" COLSPAN=3> %d trgyat</TD><TD CLASS=\"t1\" COLSPAN=3>&nbsp;</TD></TR>\r\n", cache_check_monster_ismert(fordulo, fordulo->cache), cache_check_item_ismert(fordulo, fordulo->cache));
    }
    if (aconf_get_curr("karlap_tno_osszeg_kiiras") == 1)
    {
	output(fordulo,"<TR><TD CLASS=\"c3\" COLSPAN=9> Tulajdonsg sszeg</TD></TR>\r\n");
	output(fordulo,"<TR><TD CLASS=\"t1\" COLSPAN=9> %d (%d)</TD></TR>\r\n", tulosszeg, tulosszeg_modositott) ;
	output(fordulo,"<TR><TD CLASS=\"c3\" COLSPAN=9> Fegyverszakrtelmek</TD></TR>\r\n");
	output(fordulo,"<TR><TD CLASS=\"t1\" COLSPAN=3> %d (sszege)</TD><TD CLASS=\"t1\" COLSPAN=3> %.2f (kzelharciak tlaga)</TD><TD CLASS=\"t1\" COLSPAN=3> %.2f (tvolsgiak tlaga)</TD></TR>\r\n", fegyverszakiosszeg, fegyverszakifoatlag, fegyverszakitavatlag) ;
	output(fordulo,"<TR><TD CLASS=\"c3\" COLSPAN=9> Tpfaktor</TD></TR>\r\n");
	output(fordulo,"<TR><TD CLASS=\"t1\" COLSPAN=3> %.2f &nbsp; <a href='%s&point=%d&x=%d&y=%d' target=tapfaktor>grafikon</a></TD><TD CLASS=\"t1\" COLSPAN=3> %.2f (korriglt: eredeti + papirang*3 + fno/10)</i></TD><TD CLASS=\"t1\" COLSPAN=3> &nbsp; </TD></TR>\r\n", tapfaktor, TAPFAKTOR_GRAFIKON_HYPERLINK, karakter->ksz, fordulo->fsz, (int)tapfaktor, tapfaktor_uj);
//	output(fordulo,"<TR><TD CLASS=\"t1\" COLSPAN=9> &nbsp;</TD></TR>\r\n");
    }
    if (aconf_get_curr("karlap_bonuszok_kiiras") == 1)
    {
	output(fordulo,"<TR><TD CLASS=\"c3\" COLSPAN=9> Bnuszok</TD></TR>\r\n");
	i = 0;
	if (fordulo->karakter->hatalomvarazs)
	{
	    output(fordulo,"<TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> +%d tulajdonsag (hatalomvarzsbl, fordul kzben) </TD>\r\n", fordulo->karakter->hatalomvarazs);
	    i++;
	}
	if (fordulo->karakter->hadiszerencse)
	{
	    output(fordulo,"<TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> +%d szerencse (hadiszerencsbl, fordul kzben) </TD>\r\n", fordulo->karakter->hadiszerencse);
	    i++;
	}
	for ( ; i%3 != 0; i++)
	{
	    output(fordulo,"<TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> &nbsp; </TD>%s", (i%3==2?"</TR>\r\n":""));
	}
	if (fordulo->karakter->csupaszizom || fordulo->karakter->oriasero)
	{
	    output(fordulo,"<TR><TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> &nbsp;</TD>");
	    if (fordulo->karakter->csupaszizom)
	    {
		output(fordulo,"<TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> +%d er (csupasz izom) </TD>", fordulo->karakter->csupaszizom);
	    }
	    else
	    {
		output(fordulo,"<TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> &nbsp;</TD>");
	    }
	    if (fordulo->karakter->oriasero)
	    {
		output(fordulo,"<TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> +%d sebzs (ris er) </TD></TR>\r\n", fordulo->karakter->oriasero);
	    }
	    else
	    {
		output(fordulo,"<TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> &nbsp;</TD></TR>\r\n");
	    }
	}
	output(fordulo,"<TR><TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> +%d sebzs (erbl) </TD><TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> +%d sebzs (erbl, ert nvel varzslatokkal) </TD><TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> +%d sebzs (ert s sebzst nvel varzslatokkal) </TD></TR>\r\n",erobonusz1, erobonusz2, erobonusz2 + fordulo->karakter->oriasero );
	output(fordulo,"<TR><TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> +%d vdelem (gyessgbl) </TD><TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> &nbsp; </TD><TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> &nbsp; </TD></TR>\r\n", ugyibonusz);
	output(fordulo,"<TR>");
	
//	output(fordulo,"<TR><TD CLASS=\"t1\" COLSPAN=9> &nbsp;</TD></TR>\r\n");
    }
    if (aconf_get_curr("karlap_spell_erosseg_kiiras") == 1)
    {
	output(fordulo,"<TR><TD CLASS=\"c3\" COLSPAN=9> Varzslat erssgek</TD></TR>\r\n");
	output(fordulo,"<TR><TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> papi er: %d</TD><TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> varzsli er: %d</TD><TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> pszier: %d</TD></TR>\r\n", karakter->teoero, karakter->tauero, karakter->psziero);
//	output(fordulo,"<TR><TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> s papi er: %d</TD><TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> s varzsli er: %d</TD><TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> &nbsp; </TD></TR>\r\n", karakter->osteoero, karakter->ostauero);
//	output(fordulo,"<TR><TD CLASS=\"t1\" COLSPAN=9> &nbsp;</TD></TR>\r\n");
    }
    if (aconf_get_curr("karlap_spell_oszto_kiiras") == 1)
    {
	output(fordulo,"<TR><TD CLASS=\"c3\" COLSPAN=9> Osztk</TD></TR>\r\n");
	output(fordulo,"<TR><TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> teolgia oszt: %d</TD><TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> taumaturgia oszt: %d</TD><TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> pszi oszt: %d</TD></TR>\r\n", teooszto, tauoszto, pszioszto);
//	output(fordulo,"<TR><TD CLASS=\"t1\" COLSPAN=9> &nbsp;</TD></TR>\r\n");
    }
    if (aconf_get_curr("karlap_vpregen_kiiras") == 1)
    {
	output(fordulo,"<TR><TD CLASS=\"c3\" COLSPAN=9> VP regenerci: %+d (nekrofun %+d)</TD></TR>\r\n", (fordulo->mezo.x < 141 ? vpregen_alap : vpregen_kelet) + vpregen_plusz+karakter->bonuszok.vpreg, (fordulo->mezo.x < 141 ? vpregen_alap : vpregen_kelet) * 2 + vpregen_plusz+karakter->bonuszok.vpreg);
	output(fordulo,"<TR><TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> %d (alap vp.reg. nyugat) </TD><TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> %d (alap vp.reg. kelet) </TD><TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> %d (trgyak + 10vp-k) </TD></TR>\r\n", vpregen_alap, vpregen_kelet, vpregen_plusz+karakter->bonuszok.vpreg);
//	output(fordulo,"<TR><TD CLASS=\"t1\" COLSPAN=9> &nbsp;</TD></TR>\r\n");
    }

    if ((aconf_get_curr("karlap_targy_bonusz_kiiras") == 1) || (aconf_get_curr("karlap_targy_kepesseg_kiiras") == 1) || (aconf_get_curr("karlap_targy_spell_kiiras") == 1))
    {
	output(fordulo,"<TR><TD CLASS=\"t1\" COLSPAN=9> &nbsp;</TD></TR>\r\n");
    }
    
    // Bonuszok targybol part II. -> kiiras
    if (aconf_get_curr("karlap_targy_bonusz_kiiras") == 1)
    {
	memset(h, 0 , sizeof(h));
	for (b = 0; b < (sizeof(t_bonuszok)/sizeof(int)); b++)
	{
	    pi2 = (int *)&karakter->tulajdonsagok;
	    pi3 = (int *)&karakter->bonuszok;
	    for (i = 0, karakter_targylist_elem = get_karakter_targylist_head(fordulo->karakter, 1); karakter_targylist_elem; karakter_targylist_elem = karakter_targylist_elem->next)
	    {
		if (b == 12)
		{
		    if ((karakter_targylist_elem->ssz == 307) || (karakter_targylist_elem->ssz == 308) || (karakter_targylist_elem->ssz == 309))
		    {
			continue;
		    }
		}
		
		bold = 0;
		dolt = 0;
		pi = (int *)karakter_targylist_elem->targy->bonuszok;
		if (pi[b])
		{
		    if ((b > 9) && ((karakter_targylist_elem->targy->fegyver && (karakter_targylist_elem->targy->tipus != targy_tipus_kesztyu)) || (karakter_targylist_elem->targy->tipus == targy_tipus_lo)))
		    {
			continue;
		    }
		    if (karakter_targylist_elem->ssz == 229)
		    {
			continue;
		    }
		    if (!h[b])
		    {
/*
			if ((b < 5) && (pi2[b*2+1] - pi2[b*2] != 0))
			{
			    output(fordulo,"<TR><TD CLASS=\"c3\" COLSPAN=9><b> %s trgyakbl: %+d</b></TD></TR>\r\n", get_bonuszok_neve(b), pi2[b*2+1] - pi2[b*2]);
			}
			else if (pi3[b] != 0)
*/
			if (pi3[b] != 0)
			{
			    output(fordulo,"<TR><TD CLASS=\"c3\" COLSPAN=9><b> %s trgyakbl: %+d</b></TD></TR>\r\n", get_bonuszok_neve(b), pi3[b]);
			}
			else
			{
			    output(fordulo,"<TR><TD CLASS=\"c3\" COLSPAN=9><b> %s trgyakbl: - </b></TD></TR>\r\n", get_bonuszok_neve(b));
			}
			h[b] = 1;
		    }
		    if (karakter_targylist_elem->flag&targy_flag_kf)
		    {
			bold = 1;
			dolt = 0;
		    }
		    if (karakter_targylist_elem->targy->nonkf)
		    {
			bold = 0;
			dolt = 1;
		    }
		    if (aconf_get_curr("hyperlink_targy") == 1)
		    {
			output(fordulo,"%s<TD CLASS=\"t1\" WIDTH=5%% NOWRAP> &nbsp; %s%s %s (#<a  class=n href=\"%stargy_enc.php%sf=tenc&ssz=%d%s\" target=hyper title=\"Encyclopedia (Web Hyper)\">%d</a>) %s%s </TD><TD CLASS=\"t1\" ALIGN=\"RIGHT\" WIDTH=1%%> %s%s %+d %s%s </TD><TD CLASS=\"t1\" WIDTH=10%%> &nbsp; </TD>%s", (i%3==0?"<TR>":""), (bold?"<b>":""), (dolt?"<i>":""), karakter_targylist_elem->targy->nev, bconf_get_webhyper(), (aconf_get_webhyper_offline()?"@":"?"), karakter_targylist_elem->targy->ssz, (aconf_get_webhyper_offline()?".htm":""), karakter_targylist_elem->targy->ssz, (dolt?"</i>":""), (bold?"</b>":""), (bold?"<b>":""), (dolt?"<i>":""), (((b == 12) && (karakter_targylist_elem->ssz == 542))?pulzans_bonusz:pi[b]), (bold?"</b>":""), (dolt?"</i>":""), (i%3==2?"</TR>\r\n":""));
		    }
		    else
		    {
			output(fordulo,"%s<TD CLASS=\"t1\" WIDTH=5%% NOWRAP> &nbsp; %s%s %s (#%d) %s%s </TD><TD CLASS=\"t1\" ALIGN=\"RIGHT\" WIDTH=1%%> %s%s %+d %s%s </TD><TD CLASS=\"t1\" WIDTH=10%%> &nbsp; </TD>%s", (i%3==0?"<TR>":""), (bold?"<b>":""), (dolt?"<i>":""), karakter_targylist_elem->targy->nev, karakter_targylist_elem->targy->ssz, (dolt?"</i>":""), (bold?"</b>":""), (bold?"<b>":""), (dolt?"<i>":""), (((b == 12) && (karakter_targylist_elem->ssz == 542))?pulzans_bonusz:pi[b]), (bold?"</b>":""), (dolt?"</i>":""), (i%3==2?"</TR>\r\n":""));
		    }
		    i++;
		}
	    }
	    for ( ; i%3 != 0; i++)
	    {
		output(fordulo,"<TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> &nbsp; </TD>%s", (i%3==2?"</TR>\r\n":""));
	    }
	    if (h[b])
	    {
		output(fordulo,"<TR><TD CLASS=\"t1\" COLSPAN=9> &nbsp;</TD></TR>\r\n");
	    }
	}

	// varazslatsebzes targybol
	i = 0;
	h[0] = 0;
	for (vi = 0, varazslatsebzes = karakter->varazslatsebzes; vi < karakter->varazslatsebzes_size; vi++)
	{
	    if (varazslatsebzes[vi].van)
	    {
		if ((!varazslatsebzes[vi].maxteo || (varazslatsebzes[vi].maxteo && (karakter->kepessegek.teologia < varazslatsebzes[vi].maxteo))) && (!varazslatsebzes[vi].maxtau || (varazslatsebzes[vi].maxtau && (karakter->kepessegek.taumaturgia < varazslatsebzes[vi].maxtau))))
		{
		    if (!h[0])
		    {
			if (vsebzes1 && vsebzes2)
			{
			    output(fordulo,"<TR><TD CLASS=\"c3\" COLSPAN=9><b> varzslatsebzs trgyakbl: %+d%% (max %d) </b></TD></TR>\r\n", vsebzes1, vsebzes2);
			}
			else
			{
			    output(fordulo,"<TR><TD CLASS=\"c3\" COLSPAN=9><b> varzslatsebzs trgyakbl: - </b></TD></TR>\r\n");
			}
			h[0] = 1;
		    }
		    bold = 0;
		    dolt = 0;
		    if (varazslatsebzes[vi].flag&targy_flag_kf)
		    {
			bold = 1;
			dolt = 0;
		    }
		    if (varazslatsebzes[vi].targy->nonkf)
		    {
			bold = 0;
			dolt = 1;
		    }
		    if (aconf_get_curr("hyperlink_targy") == 1)
		    {
			output(fordulo,"%s<TD CLASS=\"t1\" WIDTH=5%% NOWRAP> &nbsp; %s%s %s (#<a  class=n href=\"%stargy_enc.php%sf=tenc&ssz=%d%s\" target=hyper title=\"Encyclopedia (Web Hyper)\">%d</a>) %s%s </TD><TD CLASS=\"t1\" ALIGN=\"RIGHT\" WIDTH=1%% NOWRAP> %s%s %+d%% (max %d)  %s%s </TD><TD CLASS=\"t1\" WIDTH=10%%> &nbsp; </TD>%s", (i%3==0?"<TR>":""), (bold?"<b>":""), (dolt?"<i>":""), varazslatsebzes[vi].targy->nev, bconf_get_webhyper(), (aconf_get_webhyper_offline()?"@":"?"), varazslatsebzes[vi].targy->ssz, (aconf_get_webhyper_offline()?".htm":""), varazslatsebzes[vi].targy->ssz, (dolt?"</i>":""), (bold?"</b>":""), (bold?"<b>":""), (dolt?"<i>":""), varazslatsebzes[vi].bonusz, varazslatsebzes[vi].max, (bold?"</b>":""), (dolt?"</i>":""), (i%3==2?"</TR>\r\n":""));
		    }
		    else
		    {
			output(fordulo,"%s<TD CLASS=\"t1\" WIDTH=5%% NOWRAP> &nbsp; %s%s %s (#%d) %s%s </TD><TD CLASS=\"t1\" ALIGN=\"RIGHT\" WIDTH=1%% NOWRAP> %s%s %+d%% (max %d) %s%s </TD><TD CLASS=\"t1\" WIDTH=10%%> &nbsp; </TD>%s", (i%3==0?"<TR>":""), (bold?"<b>":""), (dolt?"<i>":""), varazslatsebzes[vi].targy->nev, varazslatsebzes[vi].targy->ssz, (dolt?"</i>":""), (bold?"</b>":""), (bold?"<b>":""), (dolt?"<i>":""), varazslatsebzes[vi].bonusz, varazslatsebzes[vi].max, (bold?"</b>":""), (dolt?"</i>":""), (i%3==2?"</TR>\r\n":""));
		    }
		    i++;
		}
	    }
	}
	for ( ; i%3 != 0; i++)
	{
	    output(fordulo,"<TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> &nbsp; </TD>%s", (i%3==2?"</TR>\r\n":""));
	}
	if (h[0])
	{
	    output(fordulo,"<TR><TD CLASS=\"t1\" COLSPAN=9> &nbsp;</TD></TR>\r\n");
	}
    }
    
    // Kepessegek targybol part II. -> kiiras
    if (aconf_get_curr("karlap_targy_kepesseg_kiiras") == 1)
    {
	memset(h, 0 , sizeof(h));
	for (b = 0; b < (sizeof(t_kepessegek)/sizeof(int)); b++)
	{
	    pi2 = (int *)&karakter->kepessegek;
	    pi3 = (int *)&karakter->kepesseg_bonuszok;

	    for (i = 0, karakter_targylist_elem = get_karakter_targylist_head(fordulo->karakter, 2); karakter_targylist_elem; karakter_targylist_elem = karakter_targylist_elem->next)
	    {
		bold = 0;
		dolt = 0;
		pi = (int *)karakter_targylist_elem->targy->kepessegek;
		if (pi[b])
		{
		    if (!h[b])
		    {
			if (pi3[b] != 0)
			{
			    output(fordulo,"<TR><TD CLASS=\"c3\" COLSPAN=9><b> %s trgyakbl: %+d</b></TD></TR>\r\n", get_kepessegek_neve(b), pi3[b]);
			}
			else
			{
			    output(fordulo,"<TR><TD CLASS=\"c3\" COLSPAN=9><b> %s trgyakbl: - </b></TD></TR>\r\n", get_kepessegek_neve(b));
			}
			h[b] = 1;
		    }
		    if (karakter_targylist_elem->flag&targy_flag_kf)
		    {
			bold = 1;
			dolt = 0;
		    }
		    if (karakter_targylist_elem->targy->nonkf)
		    {
			bold = 0;
			dolt = 1;
		    }
		    if (aconf_get_curr("hyperlink_targy") == 1)
		    {
			output(fordulo,"%s<TD CLASS=\"t1\" WIDTH=5%% NOWRAP> &nbsp; %s%s %s (#<a  class=n href=\"%stargy_enc.php%sf=tenc&ssz=%d%s\" target=hyper title=\"Encyclopedia (Web Hyper)\">%d</a>) %s%s </TD><TD CLASS=\"t1\" ALIGN=\"RIGHT\" WIDTH=1%%> %s%s %+d %s%s </TD><TD CLASS=\"t1\" WIDTH=10%%> &nbsp; </TD>%s", (i%3==0?"<TR>":""), (bold?"<b>":""), (dolt?"<i>":""), karakter_targylist_elem->targy->nev, bconf_get_webhyper(), (aconf_get_webhyper_offline()?"@":"?"), karakter_targylist_elem->targy->ssz, (aconf_get_webhyper_offline()?".htm":""), karakter_targylist_elem->targy->ssz, (dolt?"</i>":""), (bold?"</b>":""), (bold?"<b>":""), (dolt?"<i>":""), pi[b], (dolt?"</i>":""), (bold?"</b>":""), (i%3==2?"</TR>\r\n":""));
		    }
		    else
		    {
			output(fordulo,"%s<TD CLASS=\"t1\" WIDTH=5%% NOWRAP> &nbsp; %s%s %s (#%d) %s%s </TD><TD CLASS=\"t1\" ALIGN=\"RIGHT\" WIDTH=1%%> %s%s %+d %s%s </TD><TD CLASS=\"t1\" WIDTH=10%%> &nbsp; </TD>%s", (i%3==0?"<TR>":""), (bold?"<b>":""), (dolt?"<i>":""), karakter_targylist_elem->targy->nev, karakter_targylist_elem->targy->ssz, (dolt?"</i>":""), (bold?"</b>":""), (bold?"<b>":""), (dolt?"<i>":""), pi[b], (dolt?"</i>":""), (bold?"</b>":""), (i%3==2?"</TR>\r\n":""));
		    }
		    i++;
		}
	    }
	    for ( ; i%3 != 0; i++)
	    {
		output(fordulo,"<TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> &nbsp; </TD>%s", (i%3==2?"</TR>\r\n":""));
	    }
	    if (h[b])
	    {
		output(fordulo,"<TR><TD CLASS=\"t1\" COLSPAN=9> &nbsp;</TD></TR>\r\n");
	    }
	}
    }

    // Spellek targybol
    if (aconf_get_curr("karlap_targy_spell_kiiras") == 1)
    {
	for (h[0] = 0, i = 0, karakter_targylist_elem = get_karakter_targylist_head(fordulo->karakter, 3); karakter_targylist_elem; karakter_targylist_elem = karakter_targylist_elem->next)
	{
	    if (karakter_targylist_elem->targy->spell)
	    {
		if (!h[0])
		{
		    output(fordulo,"<TR><TD CLASS=\"c3\" COLSPAN=9><b> varzslatok trgyakbl: (H paranccsal hasznlva a trgyat)</b></TD></TR>\r\n");
		    h[0] = 1;
		}

		output(fordulo,"%s<TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> %s ", (i%3==0?"<TR>":""), karakter_targylist_elem->targy->nev);
		if (aconf_get_curr("hyperlink_targy") == 1)
		{
		    output(fordulo,"(#<a  class=n href=\"%stargy_enc.php%sf=tenc&ssz=%d%s\" target=hyper title=\"Encyclopedia (Web Hyper)\">%d</a>)", bconf_get_webhyper(), (aconf_get_webhyper_offline()?"@":"?"), karakter_targylist_elem->targy->ssz, (aconf_get_webhyper_offline()?".htm":""), karakter_targylist_elem->targy->ssz);
		}
		else
		{
		    output(fordulo,"(#%d)", karakter_targylist_elem->targy->ssz);
		}
		output(fordulo,":<br>&nbsp;&nbsp;&nbsp;&nbsp;%s ", karakter_targylist_elem->targy->spell->nev);
		if (aconf_get_curr("hyperlink_spell") == 1)
		{
		    output(fordulo,"(#<a class=n href=\"%svari_enc.php%sf=venc&ssz=%d%s\" target=hyper title=\"Encyclopedia (Web Hyper)\">%d</a>) ", bconf_get_webhyper(), (aconf_get_webhyper_offline()?"@":"?"), karakter_targylist_elem->targy->spell->ssz, (aconf_get_webhyper_offline()?".htm":""), karakter_targylist_elem->targy->spell->ssz);
		}
		else
		{
		    output(fordulo,"(#%d)", karakter_targylist_elem->targy->spell->ssz);
		}
		output(fordulo,"</TD>%s", (i%3==2?"</TR>\r\n":""));
		i++;
	    }
	}
	for ( ; i%3 != 0; i++)
	{
	output(fordulo,"<TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> &nbsp; </TD>%s", (i%3==2?"</TR>\r\n":""));
	}
	if (h[0])
	{
//	    output(fordulo,"<TR><TD CLASS=\"t1\" COLSPAN=9> &nbsp;</TD></TR>\r\n");
        }
    }

    if ((aconf_get_curr("karlap_tno_osszeg_kiiras") == 1) || (aconf_get_curr("karlap_bonuszok_kiiras") == 1) || (aconf_get_curr("karlap_spell_erosseg_kiiras") == 1) || (aconf_get_curr("karlap_spell_oszto_kiiras") == 1) || (aconf_get_curr("karlap_vpregen_kiiras") == 1) || (aconf_get_curr("karlap_targy_bonusz_kiiras") == 1) || (aconf_get_curr("karlap_targy_kepesseg_kiiras") == 1) || (aconf_get_curr("karlap_targy_spell_kiiras") == 1))
    {
	output(fordulo,"</TABLE></TD></TR></TABLE>\r\n<P>\r\n");
    }
    
    // Figyelt dolgok (spellek, targyak)
    if ((aconf_get_curr("targy_figyelt") == 1) || (aconf_get_curr("spell_figyelt") == 1))
    {
	char hs[1];
	char * szin = NULL;
	int szink;

	output(fordulo,"<TABLE WIDTH=100%% CELLPADDING=1 CELLSPACING=0 BORDER=0 CLASS=\"t0\"><TR><TD> <TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0 CLASS=\"t1\" WIDTH=100%%>\r\n<TR><TD CLASS=\"c2\" COLSPAN=9>FIGYELEMMEL KISRT TRGYAK, VARZSLATOK</TD></TR>\r\n");

	memset(hs, 0 , sizeof(hs));
	if (aconf_get_curr("targy_figyelt") == 1)
	{
	    t_targy_figyelt * targy_figyelt;
	    int darab;
	    int kf;
	    
	    h[0] = 0;
	    for (i = 0, targy_figyelt = karakter->karakter_targy_figyelt_list_head; targy_figyelt; targy_figyelt = targy_figyelt->next)
	    {

		karakter_targylist_elem = NULL;
		if (targy_figyelt->targylist)
		{
		    karakter_targylist_elem = targy_figyelt->targylist;
		}


		if (!targy_figyelt->targy)
		{
		    continue;
		}

		if (!hs[0])
		{
		    output(fordulo,"<TR><TD CLASS=\"c3\" COLSPAN=9><b> Figyelt trgyak </b><span class=kapcsos>(karakterlapon a megadott limitnek megfelel van-e [nlad kzben, bank nincs beleszmolva])</span></TD></TR>\r\n");
		    hs[0] = 1;
		}

		darab = 0;
		bold = 0;
		kf = 0;
		if (karakter_targylist_elem)
		{
//		    darab = karakter_targylist_elem->darab;
		    darab = 0;
		    if (karakter_targylist_elem->nalad)
		    {
			darab = karakter_targylist_elem->nalad;
		    }
/*
		    if (karakter_targylist_elem->flag&targy_flag_kf)
		    {
			kf = 1;
		        bold = 1;
		    }
*/
		}
		
		szink = 0;
		if (szin)
		{
		    free(szin);
		    szin = NULL;
		}
		
		if (targy_figyelt->min && (darab < targy_figyelt->min))
		{
		    szink = 1;
		}
		else if (targy_figyelt->max && (darab >= targy_figyelt->max))
		{
		    szink = 2;
		}
		else if ((targy_figyelt->min == 0) && (targy_figyelt->max == 0) && (darab == 0))
		{
		    szink = 1;
		}
		
		if (szink == 1)
		{
		    if (szin = malloc(strlen("<font color=>") + strlen(bconf_get_color_figyelt_keves()) + 1))
		    {
			sprintf(szin, "<font color=%s>", bconf_get_color_figyelt_keves());
		    }
		}
		else if (szink == 2)
		{
		    if (szin = malloc(strlen("<font color=>") + strlen(bconf_get_color_figyelt_sok()) + 1))
		    {
			sprintf(szin, "<font color=%s>", bconf_get_color_figyelt_sok());
		    }
		}
		
		if (aconf_get_curr("hyperlink_targy") == 1)
		{
		    output(fordulo,"%s<TD ALIGN=RIGHT CLASS=\"t1\" WIDTH=30> %s%d%s </TD><TD CLASS=\"t1\" WIDTH=8> %s </TD><TD CLASS=\"t1\" WIDTH=30%% NOWRAP> %s%s%s%s (#<a  class=n href=\"%stargy_enc.php%sf=tenc&ssz=%d%s\" target=hyper title=\"Encyclopedia (Web Hyper)\">%d</a>) %s </TD>%s", (i%3==0?"<TR>":""), (szin?szin:""), darab, (szin?"</font>":""), (kf?"*":"&nbsp;"), (bold?"<SPAN CLASS=\"k\">":""), (szin?szin:""), targy_figyelt->targy->nev, (szin?"</font>":""), bconf_get_webhyper(), (aconf_get_webhyper_offline()?"@":"?"), targy_figyelt->targy->ssz, (aconf_get_webhyper_offline()?".htm":""), targy_figyelt->targy->ssz, (bold?"</b>":""), (i%3==2?"</TR>\r\n":""));
		}
		else
		{
		    output(fordulo,"%s<TD ALIGN=RIGHT CLASS=\"t1\" WIDTH=30> %s%d%s </TD><TD CLASS=\"t1\" WIDTH=8> %s </TD><TD CLASS=\"t1\" WIDTH=30%% NOWRAP> %s%s%s%s (#%d) %s </TD>%s", (i%3==0?"<TR>":""), (szin?szin:""), darab, (szin?"</font>":""), (kf?"*":"&nbsp;"), (bold?"<SPAN CLASS=\"k\">":""), (szin?szin:""), targy_figyelt->targy->nev, (szin?"</font>":""), targy_figyelt->targy->ssz, (bold?"</b>":""), (i%3==2?"</TR>\r\n":""));
		}
		if (szin)
		{
		    free(szin);
		    szin = NULL;
		}
		i++;
	    }
	    for ( ; i%3 != 0; i++)
	    {
		output(fordulo,"<TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> &nbsp; </TD>%s", (i%3==2?"</TR>\r\n":""));
	    }
	}

	memset(hs, 0 , sizeof(hs));
	if (aconf_get_curr("spell_figyelt") == 1)
	{
	    t_spell_figyelt * spell_figyelt;
	    char * prefix;
	    	    
	    for (i = 0, spell_figyelt = get_spell_figyelt_head(); spell_figyelt; spell_figyelt = spell_figyelt->next)
	    {
		if (!spell_figyelt->spell)
		{
		    continue;
		}
		karakter_spelllist_elem = NULL;
		if (spell_figyelt->spelllist)
		{
		    karakter_spelllist_elem = spell_figyelt->spelllist;
		}

		if (!hs[0])
		{
		    output(fordulo,"<TR><TD CLASS=\"c3\" COLSPAN=9><b> Figyelt varzslatok </b><span class=kapcsos>(tborozs kzben rajtad van-e)</span></TD></TR>\r\n");
		    hs[0] = 1;
		}

		szink = 0;
		if (szin)
		{
		    free(szin);
		    szin = NULL;
		}
		
		if (spell_figyelt->irany == 1)
		{
		    if (!karakter_spelllist_elem)
		    {
			continue;
		    }
		    else if (!spell_figyelt->fentvan)
		    {
			szink = 1;
		    }
		}
		else if (spell_figyelt->irany == 2)
		{
		    if (spell_figyelt->fentvan)
		    {
			szink = 2;
		    }
		    else if (!spell_figyelt->fentvan)
		    {
			continue;
		    }
		}
		
		prefix = "";
		if (szink == 1)
		{
		    if (szin = malloc(strlen("<font color=>") + strlen(bconf_get_color_figyelt_keves()) + 1))
		    {
			sprintf(szin, "<font color=%s>", bconf_get_color_figyelt_keves());
		    }
		    prefix = "-";
		}
		else if (szink == 2)
		{
		    if (szin = malloc(strlen("<font color=>") + strlen(bconf_get_color_figyelt_sok()) + 1))
		    {
			sprintf(szin, "<font color=%s>", bconf_get_color_figyelt_sok());
		    }
		    prefix = "+";
		}

		if (aconf_get_curr("hyperlink_spell") == 1)
		{
		    output(fordulo,"%s<TD ALIGN=RIGHT CLASS=\"t1\" WIDTH=38 COLSPAN=2> %s%s%s </TD><TD CLASS=\"t1\" WIDTH=30%% NOWRAP> %s%s%s (#<a  class=n href=\"%svari_enc.php%sf=venc&ssz=%d%s\" target=hyper title=\"Encyclopedia (Web Hyper)\">%d</a>) </TD>%s", (i%3==0?"<TR>":""), (szin?szin:""), prefix, (szin?"</font>":""), (szin?szin:""), spell_figyelt->spell->nev, (szin?"</font>":""), bconf_get_webhyper(), (aconf_get_webhyper_offline()?"@":"?"), spell_figyelt->spell->ssz, (aconf_get_webhyper_offline()?".htm":""), spell_figyelt->spell->ssz, (i%3==2?"</TR>\r\n":""));
		}
		else
		{
		    output(fordulo,"%s<TD ALIGN=RIGHT CLASS=\"t1\" WIDTH=38 COLSPAN=2> %s%s%s </TD><TD CLASS=\"t1\" WIDTH=30%% NOWRAP> %s%s%s (#%d) </TD>%s", (i%3==0?"<TR>":""), (szin?szin:""), prefix, (szin?"</font>":""), (szin?szin:""), spell_figyelt->spell->nev, (szin?"</font>":""), spell_figyelt->spell->ssz, (i%3==2?"</TR>\r\n":""));
		}
		if (szin)
		{
		    free(szin);
		    szin = NULL;
		}
		i++;
	    }
	    for ( ; i%3 != 0; i++)
	    {
		output(fordulo,"<TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> &nbsp; </TD>%s", (i%3==2?"</TR>\r\n":""));
	    }
	}
	output(fordulo,"</TABLE>");
	output(fordulo,"</TD></TR></TABLE>\r\n<P>\r\n");
    }
    
    // Targyak tipusonkenti bontasban
    if ((aconf_get_curr("karlap_targy_tipusonkent_ekszer") == 1) || (aconf_get_curr("karlap_targy_tipusonkent_zarknod") == 1) || 
        (aconf_get_curr("karlap_targy_tipusonkent_pancel") == 1) || (aconf_get_curr("karlap_targy_tipusonkent_kulcsok") == 1) || 
	(aconf_get_curr("karlap_targy_tipusonkent_cirkusz") == 1) || (aconf_get_curr("karlap_targy_tipusonkent_ejfatty") == 1) ||
	(aconf_get_curr("karlap_targy_tipusonkent_moa") == 1) || (aconf_get_curr("karlap_targy_tipusonkent_ryuku") == 1))
    {
	t_targy_tipus slotok_pancel[] = {targy_tipus_pancel, targy_tipus_pajzs, targy_tipus_sisak, targy_tipus_kesztyu, targy_tipus_csizma, targy_tipus_kopeny, targy_tipus_nadrag, targy_tipus_vallvedo, targy_tipus_ov, targy_tipus_uszogatya};
	t_targy_tipus slotok_ekszer[] = {targy_tipus_gyuru, targy_tipus_karkoto, targy_tipus_fulbevalo, targy_tipus_nyaklanc, targy_tipus_orokkevalosag_ekszer};
	t_targy_tipus slotok_kulcs[] = {targy_tipus_kulcs};
	t_targy_tipus slotok_cirkusz[] = {targy_tipus_cirkusz};
	t_targy_tipus slotok_moa[] = {targy_tipus_moa};
	t_targy_tipus slotok_ryuku[] = {targy_tipus_ryuku};
	t_targy_tipus slotok_zarknod[] = {targy_tipus_esthar, targy_tipus_boadhun, targy_tipus_kyorg, targy_tipus_arnytunde};
	t_targy_tipus slotok_ejfatty[] = {targy_tipus_ejfatty_szarmazek, targy_tipus_ejfatty_esszencia};
	int sl = (sizeof(slotok_pancel) + sizeof(slotok_ekszer) + sizeof(slotok_kulcs) + sizeof(slotok_cirkusz) + sizeof(slotok_zarknod) + sizeof(slotok_ejfatty) + sizeof(slotok_moa) + sizeof(slotok_ryuku))/ sizeof(t_targy_tipus);
	t_targy_tipus slotok[sl];
	char hs[sl];
	int sn = 0;
	int kf;
	t_targy_tipus targy_tipus_osszerakhato;
	t_targy * targy_osszerakhato;
	int targy_osszerakhato_darab;
	
	if (aconf_get_curr("karlap_targy_tipusonkent_pancel") == 1)
	{
	    for (i = 0; i < (sizeof(slotok_pancel) / sizeof(t_targy_tipus)); slotok[sn++] = slotok_pancel[i++]);
	}
	if (aconf_get_curr("karlap_targy_tipusonkent_ekszer") == 1)
	{
	    for (i = 0; i < (sizeof(slotok_ekszer) / sizeof(t_targy_tipus)); slotok[sn++] = slotok_ekszer[i++]);
	}
	if (aconf_get_curr("karlap_targy_tipusonkent_kulcsok") == 1)
	{
	    for (i = 0; i < (sizeof(slotok_kulcs) / sizeof(t_targy_tipus)); slotok[sn++] = slotok_kulcs[i++]);
	}
	if (aconf_get_curr("karlap_targy_tipusonkent_cirkusz") == 1)
	{
	    for (i = 0; i < (sizeof(slotok_cirkusz) / sizeof(t_targy_tipus)); slotok[sn++] = slotok_cirkusz[i++]);
	}
	if (aconf_get_curr("karlap_targy_tipusonkent_moa") == 1)
	{
	    for (i = 0; i < (sizeof(slotok_moa) / sizeof(t_targy_tipus)); slotok[sn++] = slotok_moa[i++]);
	}
	if (aconf_get_curr("karlap_targy_tipusonkent_ryuku") == 1)
	{
	    for (i = 0; i < (sizeof(slotok_ryuku) / sizeof(t_targy_tipus)); slotok[sn++] = slotok_ryuku[i++]);
	}
	if (aconf_get_curr("karlap_targy_tipusonkent_zarknod") == 1)
	{
	    for (i = 0; i < (sizeof(slotok_zarknod) / sizeof(t_targy_tipus)); slotok[sn++] = slotok_zarknod[i++]);
	}
	if (aconf_get_curr("karlap_targy_tipusonkent_ejfatty") == 1)
	{
	    for (i = 0; i < (sizeof(slotok_ejfatty) / sizeof(t_targy_tipus)); slotok[sn++] = slotok_ejfatty[i++]);
	}
	
	output(fordulo,"<TABLE WIDTH=100%% CELLPADDING=1 CELLSPACING=0 BORDER=0 CLASS=\"t0\"><TR><TD> <TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0 CLASS=\"t1\" WIDTH=100%%>\r\n<TR><TD CLASS=\"c2\" COLSPAN=9>TRGYAID TIPUSONKNTI BONTSBAN</TD></TR>\r\n");

	memset(hs, 0 , sizeof(hs));
	memset(h, 0 , sizeof(h));

	for (b = 0; b < sn; b++)
	{
	    for (i = 0, karakter_targylist_elem = get_karakter_targylist_head(fordulo->karakter, 0); karakter_targylist_elem; karakter_targylist_elem = karakter_targylist_elem->next)
	    {
		if ((karakter_targylist_elem->targy->tipus != slotok[b]) && (karakter_targylist_elem->targy->tipus2 != slotok[b]))
		{
		    continue;
		}
		
		bold = 0;
		kf = 0;
		if (!hs[b])
		{
		    output(fordulo,"<TR><TD CLASS=\"c3\" COLSPAN=9><b> %s </b></TD></TR>\r\n", get_tipusok_neve(slotok[b]));
		    hs[b] = 1;
		}
		if (karakter_targylist_elem->flag&targy_flag_kf)
		{
		    kf = 1;
		    bold = 1;
		}
		if (aconf_get_curr("hyperlink_targy") == 1)
		{
		    output(fordulo,"%s<TD ALIGN=RIGHT CLASS=\"t1\" WIDTH=30> %d </TD><TD CLASS=\"t1\" WIDTH=8> %s </TD><TD CLASS=\"t1\" WIDTH=30%% NOWRAP> %s%s (#<a  class=n href=\"%stargy_enc.php%sf=tenc&ssz=%d%s\" target=hyper title=\"Encyclopedia (Web Hyper)\">%d</a>) %s </TD>%s", (i%3==0?"<TR>":""), karakter_targylist_elem->darab, (kf?"*":"&nbsp;"), (bold?"<SPAN CLASS=\"k\">":""), karakter_targylist_elem->targy->nev, bconf_get_webhyper(), (aconf_get_webhyper_offline()?"@":"?"), karakter_targylist_elem->targy->ssz, (aconf_get_webhyper_offline()?".htm":""), karakter_targylist_elem->targy->ssz, (bold?"</b>":""), (i%3==2?"</TR>\r\n":""));
		}
		else
		{
		    output(fordulo,"%s<TD ALIGN=RIGHT CLASS=\"t1\" WIDTH=30> %d </TD><TD CLASS=\"t1\" WIDTH=8> %s </TD><TD CLASS=\"t1\" WIDTH=30%% NOWRAP> %s%s (#%d) %s </TD>%s", (i%3==0?"<TR>":""), karakter_targylist_elem->darab, (kf?"*":"&nbsp;"), (bold?"<SPAN CLASS=\"k\">":""), karakter_targylist_elem->targy->nev, karakter_targylist_elem->targy->ssz, (bold?"</SPAN>":""), (i%3==2?"</TR>\r\n":""));
		}
		i++;
	    }
	    for ( ; i%3 != 0; i++)
	    {
		output(fordulo,"<TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> &nbsp; </TD>%s", (i%3==2?"</TR>\r\n":""));
	    }
	    
	    // osszerakhato targyak
	    if (((slotok[b] == targy_tipus_arnytunde) || (slotok[b] == targy_tipus_ejfatty_esszencia)) && (hs[b] || hs[b-1]))
	    {
		if (slotok[b] == targy_tipus_arnytunde)
		{
		    b1 = 0;
		    targy_tipus_osszerakhato = targy_tipus_faji_targy;
		}
		else
		{
		    b1 = 1;
		    targy_tipus_osszerakhato = targy_tipus_ejfatty_targy;
		}
		
		for (i = 0, targy_osszerakhato = get_targy_head(); targy_osszerakhato; targy_osszerakhato = targy_osszerakhato->next)
		{
		    if ((targy_osszerakhato->tipus != targy_tipus_osszerakhato) && (targy_osszerakhato->tipus2 != targy_tipus_osszerakhato))
		    {
			continue;
		    }
		    if (!targy_check_faj(fordulo->karakter, targy_osszerakhato->ssz))
		    {
			continue;
		    }
		    targy_osszerakhato_darab = karakter_targylist_check_targy_osszerakas(fordulo->karakter, targy_osszerakhato->ssz);
		    if (!targy_osszerakhato_darab)
		    {
			continue;
		    }
		    if (!h[b1])
		    {
			output(fordulo,"<TR><TD CLASS=\"t1\" COLSPAN=9><i><b> sszerakhat %s </b></i></TD></TR>\r\n", get_tipusok_neve(targy_tipus_osszerakhato));
			h[b1] = 1;
		    }
		    if (aconf_get_curr("hyperlink_targy") == 1)
		    {
			output(fordulo,"%s<TD ALIGN=RIGHT CLASS=\"t1\" WIDTH=30> %d </TD><TD CLASS=\"t1\" WIDTH=8> &nbsp; </TD><TD CLASS=\"t1\" WIDTH=30%% NOWRAP> <i>%s (#<a  class=n href=\"%stargy_enc.php%sf=tenc&ssz=%d%s\" target=hyper title=\"Encyclopedia (Web Hyper)\">%d</a>) </i> </TD>%s", (i%3==0?"<TR>":""), targy_osszerakhato_darab, targy_osszerakhato->nev, bconf_get_webhyper(), (aconf_get_webhyper_offline()?"@":"?"), targy_osszerakhato->ssz, (aconf_get_webhyper_offline()?".htm":""), targy_osszerakhato->ssz, (i%3==2?"</TR>\r\n":""));
		    }
		    else
		    {
			output(fordulo,"%s<TD ALIGN=RIGHT CLASS=\"t1\" WIDTH=30> %d </TD><TD CLASS=\"t1\" WIDTH=8> &nbsp; </TD><TD CLASS=\"t1\" WIDTH=30%% NOWRAP> <i>%s (#%d) </i> </TD>%s", (i%3==0?"<TR>":""), targy_osszerakhato_darab, targy_osszerakhato->nev, targy_osszerakhato->ssz, (i%3==2?"</TR>\r\n":""));
		    }
		    i++;
		}
		for ( ; i%3 != 0; i++)
		{
		    output(fordulo,"<TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> &nbsp; </TD>%s", (i%3==2?"</TR>\r\n":""));
		}
	    }
	}
	output(fordulo,"</TABLE>");
	output(fordulo,"</TD></TR></TABLE>\r\n<P>\r\n");
    }

    // Varazslatok sebzese
    if (aconf_get_curr("karlap_spell_sebzes_kiiras") == 1)
    {
	memset(h, 0 , sizeof(h));
	output(fordulo,"<TABLE WIDTH=100%% CELLPADDING=1 CELLSPACING=0 BORDER=0 CLASS=\"t0\"><TR><TD> <TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0 CLASS=\"t1\" WIDTH=100%%>\r\n<TR><TD CLASS=\"c2\" COLSPAN=15>VARZSLATAID SEBZSE</TD></TR>\r\n");
	output(fordulo,"<TR><TD CLASS=\"t1\">&nbsp;</TD><TD CLASS=\"t1\" COLSPAN=2 ALIGN=middle>alap</TD><TD CLASS=\"t1\" COLSPAN=2 ALIGN=right>rughar</TD><TD CLASS=\"t1\" COLSPAN=2 ALIGN=middle>&nbsp;FNObl&nbsp;</TD><TD CLASS=\"t1\" COLSPAN=2 ALIGN=middle>trgybl</TD><TD CLASS=\"t1\" COLSPAN=2 ALIGN=middle>tipusbnusz</TD><TD CLASS=\"t1\">&nbsp;</TD><TD CLASS=\"t1\" COLSPAN=2 ALIGN=middle>elrhet</TD><TD CLASS=\"t1\">&nbsp;</TD></TR>\r\n");
	for (karakter_spelllist_elem = get_karakter_spelllist_head(fordulo->karakter, 1); karakter_spelllist_elem;  karakter_spelllist_elem = karakter_spelllist_elem->next)
	{
	    t_spell * magia_bonusz;
	    t_targy * spellero_bonusz;
	    int magia_megvan;
	    int spellero_megvan;
	    int spellero_targy_fentvan;
	    
	    if (!(spell = karakter_spelllist_elem->spell))
	    {
		continue;
	    }
	    
	    {
		if (spell->type & spell_type_teo)
		{
		    spellero = karakter->teoero;
		    b = 0;
#ifdef DEBUG
		    debug(fordulo, "reformat_karlap_jo_tudni: spell %s (#%d) teo, spellero=%d\n", spell->nev, spell->ssz, spellero);
#endif
		}
		else if (spell->type & spell_type_tau)
		{
		    spellero = karakter->tauero;
		    b = 1;
#ifdef DEBUG
		    debug(fordulo, "reformat_karlap_jo_tudni: spell %s (#%d) tau, spellero=%d\n", spell->nev, spell->ssz, spellero);
#endif
		}
		else if (spell->type & spell_type_osteo)
		{
		    spellero = karakter->osteoero;
		    b = 2;
#ifdef DEBUG
		    debug(fordulo, "reformat_karlap_jo_tudni: spell %s (#%d) osteo, spellero=%d\n", spell->nev, spell->ssz, spellero);
#endif
		}
		else if (spell->type & spell_type_ostau)
		{
		    spellero = karakter->ostauero;
		    b = 3;
#ifdef DEBUG
		    debug(fordulo, "reformat_karlap_jo_tudni: spell %s (#%d) ostau, spellero=%d\n", spell->nev, spell->ssz, spellero);
#endif
		}
		else if (spell->type & spell_type_pszi)
		{
		    spellero = karakter->psziero;
		    b = 4;
#ifdef DEBUG
		    debug(fordulo, "reformat_karlap_jo_tudni: spell %s (#%d) pszi, spellero=%d\n", spell->nev, spell->ssz, spellero);
#endif
		}
		else if (spell->type & spell_type_avk)
		{
		    spellero = 1;
		    b = 5;
#ifdef DEBUG
		    debug(fordulo, "reformat_karlap_jo_tudni: spell %s (#%d) avk, spellero=%d\n", spell->nev, spell->ssz, spellero);
#endif
		}
		else
		{
#ifdef DEBUG
		    debug(fordulo, "reformat_karlap_jo_tudni: spell %s (#%d) ismeretlen tipus\n", spell->nev, spell->ssz);
#endif
		    continue;
		}
		
		if (!spell->maxero || (spell->maxero == 1) || (spellero < spell->maxero))
		{
		    spell_magia_sebzes_bonusz = spellero;
		    spell_targy_sebzes_bonusz = spellero;
		}
		else
		{
		    spell_magia_sebzes_bonusz = spell->maxero;
		    spell_targy_sebzes_bonusz = spell->maxero;
		}
		
		if (spell->maxero && (spellero > spell->maxero))
		{
		    spellero = spell->maxero;
		}
		
		sebzes = sebzes_calculate(spell->sebzes) * (float)spellero;
		felfullsebzes = sebzes;

		if (spell->mento & spell_mento_felezo)
		{
		    mentve = sebzes / 2;
		}
		else if (spell->mento & spell_mento_nullazo)
		{
		    mentve = 0;
		}
		else
		{
		    mentve = -1;
		}

#ifdef DEBUG
		debug(fordulo, "reformat_karlap_jo_tudni: spell sebzes=%.1f, mentve=%.1f\n", sebzes, mentve);
#endif
		if (!h[b])
		{
		    output(fordulo,"<TR><TD CLASS=\"c3\" COLSPAN=15><b> %s </b></TD></TR>\r\n", get_spelltipus_neve(b));
		    h[b] = 1;
		}

		// neve + sorszam
		if (aconf_get_curr("hyperlink_spell") == 1)
		{
		    output(fordulo,"<TR><TD CLASS=\"t1\" WIDTH=25%% NOWRAP> %s (#<a  class=n href=\"%svari_enc.php%sf=venc&ssz=%d%s\" target=hyper title=\"Encyclopedia (Web Hyper)\">%d</a>)</TD>", spell->nev, bconf_get_webhyper(), (aconf_get_webhyper_offline()?"@":"?"), spell->ssz, (aconf_get_webhyper_offline()?".htm":""), spell->ssz);
		}
		else
		{
		    output(fordulo,"<TR><TD CLASS=\"t1\" WIDTH=25%% NOWRAP> %s (#%d)</TD>", spell->nev, spell->ssz);
		}
		
		// sebzes + mentve
		if (mentve > -1)
		{
		    output(fordulo,"<TD CLASS=\"t1\" ALIGN=\"RIGHT\" WIDTH=1%% NOWRAP> %.1f / </TD><TD CLASS=\"t1\" ALIGN=\"RIGHT\" WIDTH=1%% > %.1f</TD>", sebzes, mentve);
		}
		else
		{
		    output(fordulo,"<TD CLASS=\"t1\" ALIGN=\"RIGHT\" WIDTH=1%% NOWRAP> %.1f &nbsp; </TD><TD CLASS=\"t1\"> &nbsp;</TD>", sebzes);
		}
		output(fordulo,"<TD CLASS=\"t1\" WIDTH=10%%> &nbsp; </TD>");

		// rughar
		if (rughar_van)
		{
		    if (spell->sebzes.darab * spellero)
		    {
			output(fordulo,"<TD CLASS=\"t1\" NOWRAP>+%.1d</TD>", spell->sebzes.darab * spellero);
			felfullsebzes += spell->sebzes.darab * spellero;
		    }
		    else 
		    {
			output(fordulo,"<TD CLASS=\"t1\"> &nbsp;</TD>");
		    }
		}
		else 
		{
		    output(fordulo,"<TD CLASS=\"t1\"> &nbsp;</TD>");
		}
		output(fordulo,"<TD CLASS=\"t1\"> &nbsp;</TD>");
		
		vsebzes1 = 0;
		vsebzes2 = 0;
		// varazslatsebzes FNO
		if (karakter->fno_skillek.varazslatsebzes)
		{
		    vsebzes1 += (((felfullsebzes / 10) < 15 ? (felfullsebzes / 10) : 15) * karakter->fno_skillek.varazslatsebzes);
		}
		if (vsebzes1)
		{
		    output(fordulo,"<TD CLASS=\"t1\" NOWRAP>+%.1d</TD>", vsebzes1);
		}
		else 
		{
		    output(fordulo,"<TD CLASS=\"t1\"> &nbsp;</TD>");
		}
		output(fordulo,"<TD CLASS=\"t1\"> &nbsp;</TD>");

		// varazslatsebzes targybol
		for (vi = 0, varazslatsebzes = karakter->varazslatsebzes; vi < karakter->varazslatsebzes_size; vi++)
		{
		    if (varazslatsebzes[vi].van)
		    {
			if ((!varazslatsebzes[vi].maxteo || (varazslatsebzes[vi].maxteo && (karakter->kepessegek.teologia < varazslatsebzes[vi].maxteo))) && (!varazslatsebzes[vi].maxtau || (varazslatsebzes[vi].maxtau && (karakter->kepessegek.taumaturgia < varazslatsebzes[vi].maxtau))))
			{
			    vsebzes2 += (((felfullsebzes * varazslatsebzes[vi].bonusz / 100) < varazslatsebzes[vi].max) ? (felfullsebzes * varazslatsebzes[vi].bonusz / 100) : varazslatsebzes[vi].max);
			}
		    }
		}
		if ((spell->ssz == 260) && karakter->gharitonfokusz)
		{
		    vsebzes2 += 150;
		}
		if (vsebzes2)
		{
		    output(fordulo,"<TD CLASS=\"t1\" NOWRAP>+%.1d</TD>", vsebzes2);
		}
		else 
		{
		    output(fordulo,"<TD CLASS=\"t1\"> &nbsp;</TD>");
		}
		output(fordulo,"<TD CLASS=\"t1\"> &nbsp;</TD>");

		fullsebzes = felfullsebzes + vsebzes1 + vsebzes2;
		
		// fullsebzes += [tuzmagia/jegmagia/villammagia] + [tuzur/parducborpenztarca/fairlightov]
		if (spell->type & spell_type_tuz)
		{
		    magia_bonusz = get_spell_from_ssz(157);
		    spellero_bonusz = get_targy_from_ssz(533);
		    magia_megvan = karakter_spelllist_check_spell(karakter, 157);
		    spellero_megvan = karakter_targylist_check_targy(karakter, 533);
		    spellero_targy_fentvan = karakter_targylist_check_targy_kf(karakter, 533);
		}
		else if (spell->type & spell_type_villam)
		{
		    magia_bonusz = get_spell_from_ssz(227);
		    spellero_bonusz = get_targy_from_ssz(559);
		    magia_megvan = karakter_spelllist_check_spell(karakter, 227);
		    spellero_megvan = karakter_targylist_check_targy(karakter, 559);
		    spellero_targy_fentvan = karakter_targylist_check_targy_kf(karakter, 559);
		}
		else if (spell->type & spell_type_jeg)
		{
		    magia_bonusz = get_spell_from_ssz(279);
		    spellero_bonusz = get_targy_from_ssz(1117);
		    magia_megvan = karakter_spelllist_check_spell(karakter, 279);
		    spellero_megvan = karakter_targylist_check_targy(karakter, 1117);
		    spellero_targy_fentvan = karakter_targylist_check_targy_kf(karakter, 1117);
		}
		else
		{
		    magia_bonusz = NULL;
		    spellero_bonusz = NULL;
		    magia_megvan = 0;
		    spellero_megvan = 0;
		    spellero_targy_fentvan = 0;
		}

		ok = 0;
		output(fordulo,"<TD CLASS=\"t1\" NOWRAP>");
		if (magia_bonusz && (aconf_get_curr("spell_sebzes_magia_bonusz") == 1))
		{
		    if ((aconf_get_curr("spell_sebzes_bonusz_csak_meglevo") == 0) || (((aconf_get_curr("spell_sebzes_bonusz_csak_meglevo") == 1) || (aconf_get_curr("spell_sebzes_bonusz_csak_meglevo") == 2)) && magia_megvan))
		    {
			output(fordulo,"+%.1d (%s)", spell_magia_sebzes_bonusz, magia_bonusz->nev);
			fullsebzes += spell_magia_sebzes_bonusz;
			ok = 1;
		    }
		}
		if (spellero_bonusz && (aconf_get_curr("spell_sebzes_spellero_bonusz") == 1))
		{
		    if ((aconf_get_curr("spell_sebzes_bonusz_csak_meglevo") == 0) || ((aconf_get_curr("spell_sebzes_bonusz_csak_meglevo") == 1) && spellero_megvan) || ((aconf_get_curr("spell_sebzes_bonusz_csak_meglevo") == 2) && spellero_targy_fentvan))
		    {
			output(fordulo,"%s+%.1d (%s)", (ok?", ":""), spell_targy_sebzes_bonusz, spellero_bonusz->nev);
			fullsebzes += spell_targy_sebzes_bonusz;
			ok = 1;
		    }
		}
		output(fordulo,"%s</TD>", (ok?"":" &nbsp; "));

		spell->sebzes.sebzes = sebzes;
		spell->sebzes.fullsebzes = fullsebzes;
		if (spell->mento & spell_mento_felezo)
		{
		    mentve = fullsebzes / 2;
		}
		else if (spell->mento & spell_mento_nullazo)
		{
		    mentve = 0;
		}
		else
		{
		    mentve = -1;
		}
		// fullsebzes + mentve
		if (mentve > -1)
		{
		    output(fordulo,"<TD CLASS=\"t1\" WIDTH=8%% ALIGN=middle NOWRAP> =>&nbsp;&nbsp;</TD><TD CLASS=\"t1\" ALIGN=\"RIGHT\" NOWRAP> %.1f / </TD><TD CLASS=\"t1\" ALIGN=\"RIGHT\" WIDTH=1%% > %.1f</TD>", fullsebzes, mentve);
		}
		else
		{
		    output(fordulo,"<TD CLASS=\"t1\" WIDTH=8%% ALIGN=middle NOWRAP> =>&nbsp;&nbsp;</TD><TD CLASS=\"t1\" ALIGN=\"RIGHT\" NOWRAP> %.1f &nbsp; </TD><TD CLASS=\"t1\" ALIGN=\"RIGHT\" WIDTH=1%% > &nbsp;</TD>", fullsebzes);
		}
//		output(fordulo,"<TD CLASS=\"t1\" ALIGN=\"RIGHT\" NOWRAP> =>&nbsp;&nbsp;</TD><TD CLASS=\"t1\" ALIGN=\"RIGHT\" NOWRAP> %.1f </TD>", fullsebzes);
		output(fordulo,"<TD CLASS=\"t1\" WIDTH=9%%> &nbsp;</TD></TR>\r\n");
	    }
	}
	output(fordulo,"<TR><TD CLASS=\"t1\" COLSPAN=15><br><i>Mgiarzkenysg nincs figyelve, ha valakinek van rla adata hol mdositja a sebzst <br>(gyk: milyen sorrendben szmoldnak a dolgok) azt lgyszi kldje el nekem. [KWS]</i> </TD></TR>\r\n");
	output(fordulo,"</TABLE>");
	output(fordulo,"</TD></TR></TABLE>\r\n<P>\r\n");
    }
    
    // Fegyverek sebzese
    if (aconf_get_curr("karlap_fegyver_sebzes_kiiras") == 1)
    {
	memset(h, 0 , sizeof(h));
	output(fordulo,"<TABLE WIDTH=100%% CELLPADDING=1 CELLSPACING=0 BORDER=0 CLASS=\"t0\"><TR><TD> <TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0 CLASS=\"t1\" WIDTH=100%%>\r\n<TR><TD CLASS=\"c2\" COLSPAN=13>FEGYVEREID SEBZSE</TD></TR>\r\n");
	output(fordulo,"<TR><TD CLASS=\"t1\">&nbsp;</TD><TD CLASS=\"t1\" COLSPAN=2 ALIGN=middle>jobbkz</TD><TD CLASS=\"t1\" ALIGN=middle>pajzs</TD><TD CLASS=\"t1\" COLSPAN=2 ALIGN=middle>balkz</TD><TD CLASS=\"t1\" COLSPAN=3 ALIGN=middle>fegyver varzslata</TD><TD CLASS=\"t1\" ALIGN=middle><i>s1</i></TD><TD CLASS=\"t1\" ALIGN=middle><i>&nbsp;&nbsp;s2&nbsp;&nbsp;</i></TD><TD CLASS=\"t1\" ALIGN=middle><i>s3</i></TD><TD CLASS=\"t1\">&nbsp;</TD></TR>\r\n");
	for (i = 0; i < 7; i++)
	{
	    for (karakter_fegyverlist_elem = get_karakter_fegyverlist_head(karakter, i); karakter_fegyverlist_elem;  karakter_fegyverlist_elem = karakter_fegyverlist_elem->next)
	    {
		if (fegyver = karakter_fegyverlist_elem->fegyver)
		{
		    tleikan_lehet = 0;
		    bonusz = 0;
		    balbonusz = 0;
		    fszaki = 0;
		    if ((fegyver->type & fegyver_type_vizi) || (i == 6))
		    {
			b = 0;
			bonusz = erobonusz2 + fordulo->karakter->oriasero;
			balbonusz = erobonusz2 / 2 + fordulo->karakter->oriasero;
			fszaki = karakter->fszaki.vizi;
			fegyver_type = fegyver_type_vizi;
		    }
		    else if (fegyver->type & fegyver_type_okol)
		    {
			b = 1;
			tleikan_lehet = 1;
			bonusz = erobonusz2 + fordulo->karakter->oriasero;
			balbonusz = erobonusz2 / 2 + fordulo->karakter->oriasero;
			fszaki = karakter->fszaki.okol;
			fegyver_type = fegyver_type_okol;
		    }
		    else if (fegyver->type & fegyver_type_szuro)
		    {
			b = 2;
			tleikan_lehet = 1;
			bonusz = erobonusz2 + fordulo->karakter->oriasero;
			balbonusz = erobonusz2 / 2 + fordulo->karakter->oriasero;
			fszaki = karakter->fszaki.szuro;
			fegyver_type = fegyver_type_szuro;
		    }
		    else if (fegyver->type & fegyver_type_vago)
		    {
			b = 3;
			tleikan_lehet = 1;
			bonusz = erobonusz2 + fordulo->karakter->oriasero;
			balbonusz = erobonusz2 / 2 + fordulo->karakter->oriasero;
			fszaki = karakter->fszaki.vago;
			fegyver_type = fegyver_type_vago;
		    }
		    else if (fegyver->type & fegyver_type_uto)
		    {
			b = 4;
			tleikan_lehet = 1;
			bonusz = erobonusz2 + fordulo->karakter->oriasero;
			balbonusz = erobonusz2 / 2 + fordulo->karakter->oriasero;
			fszaki = karakter->fszaki.uto;
			fegyver_type = fegyver_type_uto;
		    }
		    else if (fegyver->type & fegyver_type_lo)
		    {
			b = 5;
			bonusz = fordulo->karakter->oriasero;
			fszaki = karakter->fszaki.lo;
		    }
		    else if (fegyver->type & fegyver_type_dobo)
		    {
			b = 6;
			bonusz = fordulo->karakter->oriasero;
			fszaki = karakter->fszaki.dobo;
			fegyver_type = fegyver_type_dobo;
		    }
		    else 
		    {
			bonusz = 0;
			fszaki = 0;
			fegyver_type = fegyver_type_none;
			continue;
		    }
		    
		    if (karakter->tleikan_targy_darab && (fszaki <= 44) && tleikan_lehet)
		    {
			if (fszaki <= 35)
			{
			    tbonusz = 8;
			}
			else
			{
			    int egeszb;
			    
			    egeszb = fszaki / 3;
			    tbonusz = 30 - 2 * egeszb;
			}
		    }
		    else
		    {
			tbonusz = 0;
		    }
		    
		    bonusz += tbonusz * karakter->tleikan_targy_darab;
		    balbonusz += tbonusz * karakter->tleikan_targy_darab / 2;
		    sebzes_pajzsbol = 0;
		    
		    if (fegyver_type & fegyver_type_vizi)
		    {
			bonusz += karakter->sebzesbonusz_vizben;
			balbonusz += karakter->sebzesbonusz_vizben;
		    }
		    else
		    {
			bonusz += karakter->bonuszok.sebzes;
			balbonusz += karakter->bonuszok.sebzes;
			sebzes_pajzsbol = karakter->sebzes_pajzsbol;
		    }
		    
		    fbonusz = fszaki / 3;
#ifdef DEBUG
		    debug(fordulo, "reformat_karlap_jo_tudni: fegyver %s (#%d) fszaki: %d, bonusz=%d, balbonusz=%d, fbonusz=%d, tleikan=%d*%d\n", fegyver->targy->nev, fegyver->targy->ssz,  fszaki, bonusz, balbonusz, fbonusz, karakter->tleikan_targy_darab, tbonusz);
#endif
		    utes = (fszaki + 4) / 8 + 1;
		    if (fszaki < 6)
		    {
			bal_utes = 0;
		    }
		    else if (fszaki < 20)
		    {
			bal_utes = 1;
		    }
		    else
		    {
			bal_utes = utes - 2;
		    }
		    if (fegyver_type & fegyver_type_okol)
		    {
			if (i == 6)
			{
			    sebzes = 2;
			}
			else
			{
			    sebzes = get_okol_sebzes(karakter, fegyver);
			}
		    }
		    else
		    {
			sebzes = sebzes_calculate(fegyver->sebzes);
			if (fegyver_type & fegyver_type_vizi)
			{
			    if (fegyver->type & fegyver_type_szuro)
			    {
				sebzes = sebzes * 2 / 3;
			    }
			    else if (fegyver->type & fegyver_type_vago)
			    {
				sebzes = sebzes / 2;
			    }
			    else if ((fegyver->type & fegyver_type_uto) || (fegyver->type & fegyver_type_okol))
			    {
				sebzes = sebzes / 4;
			    }
			}
		    }
		    if (karakter->faji_kopeny && ((fegyver_type & fegyver_type_okol) || (fegyver_type & fegyver_type_szuro) || (fegyver_type & fegyver_type_vago) || (fegyver_type & fegyver_type_uto)))
		    {
			utes++;
		    }
		    if (karakter->ovsal)
		    {
			utes++;
			bal_utes++;
		    }
		    
		    // nehezekbol csak 1 
		    if (fegyver->targy->ssz == 258)
		    {
			utes = 1;
			bal_utes = 0;
		    }
		    if (fegyver_type & fegyver_type_vizi)
		    {
			bal_utes = 0;
		    }
		    
		    if (!h[b])
		    {
			output(fordulo,"<TR><TD CLASS=\"c3\" COLSPAN=13><b> %s </b></TD></TR>\r\n", get_fegyvertipus_neve(b));
			h[b] = 1;
		    }
		    if (aconf_get_curr("hyperlink_targy") == 1)
		    {
			output(fordulo,"<TR><TD CLASS=\"t1\" WIDTH=22%% NOWRAP> %s (#<a  class=n href=\"%stargy_enc.php%sf=tenc&ssz=%d%s\" target=hyper title=\"Encyclopedia (Web Hyper)\">%d</a>)</TD>", fegyver->targy->nev, bconf_get_webhyper(), (aconf_get_webhyper_offline()?"@":"?"), fegyver->targy->ssz, (aconf_get_webhyper_offline()?".htm":""), fegyver->targy->ssz);
		    }
		    else
		    {
			output(fordulo,"<TR><TD CLASS=\"t1\" WIDTH=22%% NOWRAP> %s (#%d)</TD>", fegyver->targy->nev, fegyver->targy->ssz);
		    }
		    output(fordulo,"<TD CLASS=\"t1\" ALIGN=\"RIGHT\" WIDTH=1%% NOWRAP>%d tm. &nbsp; </TD><TD CLASS=\"t1\" ALIGN=\"RIGHT\" WIDTH=1%% NOWRAP> %.1f</TD>", utes, utes * (sebzes + bonusz + fbonusz));
//		    output(fordulo,"<TD CLASS=\"t1\" WIDTH=5%%>&nbsp;</TD>");
		    if (sebzes_pajzsbol && !(fegyver_type & fegyver_type_vizi))
		    {
			output(fordulo,"<TD CLASS=\"t1\" ALIGN=\"MIDDLE\" WIDTH=1%% NOWRAP> <i>+%.1f</i> &nbsp;&nbsp;&nbsp; </TD>", utes * sebzes_pajzsbol);
		    }
		    else
		    {
		        output(fordulo,"<TD CLASS=\"t1\" ALIGN=\"MIDDLE\" WIDTH=1%% NOWRAP> &nbsp; </TD>");
		    }
		    if ((bal_utes >= 1) && ((fegyver->type & fegyver_type_balkez) || ((fegyver->type & fegyver_type_okol) && (karakter->kepessegek.harcmuveszet >= 38) && (fegyver->targy->ssz == 28))))
		    {
			output(fordulo,"<TD CLASS=\"t1\" ALIGN=\"RIGHT\" WIDTH=1%% NOWRAP>%d tm. &nbsp; </TD><TD CLASS=\"t1\" ALIGN=\"RIGHT\" WIDTH=1%% NOWRAP> %.1f &nbsp; </TD>", bal_utes, bal_utes * (sebzes + balbonusz + fbonusz/2));
		    }
		    else
		    {
		        output(fordulo,"<TD CLASS=\"t1\" ALIGN=\"MIDDLE\" WIDTH=1%% NOWRAP COLSPAN=2> - &nbsp; </TD>");
		    }
		    output(fordulo,"<TD CLASS=\"t1\" WIDTH=%d%%> &nbsp; </TD>", (sebzes_pajzsbol?4:15));
		    
		    if (fegyver->spell)
		    {
			spellero = (fegyver->spell->maxero == 1 ? 1 : fegyver->spellero);
			alapsebzes = sebzes_calculate(fegyver->spell->sebzes);
			sebzes = alapsebzes * (float)spellero;
			felfullsebzes = sebzes;
			
			// felfullsebzes += rughar
			if (rughar_van)
			{
			    if (spellero * fegyver->spell->sebzes.darab)
			    {
			        felfullsebzes += spellero * fegyver->spell->sebzes.darab;
			    }
			}
			
			vsebzes1 = 0;
			vsebzes1r = 0;
			vsebzes2 = 0;
			// varazslatsebzes FNObol
			if (karakter->fno_skillek.varazslatsebzes)
			{
			    vsebzes1 += ((sebzes / 10) < 15 ? (sebzes / 10) : 15) * karakter->fno_skillek.varazslatsebzes;
			    vsebzes1r += ((felfullsebzes / 10) < 15 ? (felfullsebzes / 10) : 15) * karakter->fno_skillek.varazslatsebzes;
			}
			// varazslatsebzes targybol
			for (vi = 0, varazslatsebzes = karakter->varazslatsebzes; vi < karakter->varazslatsebzes_size; vi++)
			{
			    if (varazslatsebzes[vi].van)
			    {
				if ((varazslatsebzes[vi].maxteo && (karakter->kepessegek.teologia < varazslatsebzes[vi].maxteo)) || (varazslatsebzes[vi].maxtau && (karakter->kepessegek.taumaturgia < varazslatsebzes[vi].maxtau)))
				{
				    vsebzes2 += ((felfullsebzes * varazslatsebzes[vi].bonusz / 100) < varazslatsebzes[vi].max) ? (felfullsebzes * varazslatsebzes[vi].bonusz / 100) : varazslatsebzes[vi].max;
				}
			    }
			}
			sebzes += vsebzes1;
			felfullsebzes += vsebzes1r + vsebzes2;
			fullsebzes = felfullsebzes;

			// fullsebzes += [tuzmagia/jegmagia/villammagia] + [tuzur/parducborpenztarca/fairlightov]
			if (fegyver->spell->type & spell_type_tuz)
			{
			    fullsebzes += fegyver->spellero + fegyver->spellero;
			}
			else if (fegyver->spell->type & spell_type_jeg)
			{
			    fullsebzes += fegyver->spellero + fegyver->spellero;
			}
			else if (fegyver->spell->type & spell_type_villam)
			{
			    fullsebzes += fegyver->spellero + fegyver->spellero;
			}
			
			if ((fegyver->spell->ssz == 1))
			{
			    output(fordulo,"<TD CLASS=\"t1\" NOWRAP WIDTH=20%%> %s ", fegyver->spell->nev);
			}
			else if ((fegyver->spell->ssz == 271))
			{
			    output(fordulo,"<TD CLASS=\"t1\" NOWRAP WIDTH=20%%> 1* : %s ", fegyver->spell->nev);
			}
			else if ((fegyver->spellesely >= 0) && (fegyver->spellesely <= 100))
			{
			    output(fordulo,"<TD CLASS=\"t1\" NOWRAP WIDTH=20%%> %3d%% : %s ", fegyver->spellesely, fegyver->spell->nev);
			}
			else
			{
			    output(fordulo,"<TD CLASS=\"t1\" NOWRAP WIDTH=20%%> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; %s ", fegyver->spell->nev);
			}
			if (aconf_get_curr("hyperlink_spell") == 1)
			{
			    output(fordulo,"(#<a  class=n href=\"%svari_enc.php%sf=venc&ssz=%d%s\" target=hyper title=\"Encyclopedia (Web Hyper)\">%d</a>) ", bconf_get_webhyper(), (aconf_get_webhyper_offline()?"@":"?"), fegyver->spell->ssz, (aconf_get_webhyper_offline()?".htm":""), fegyver->spell->ssz);
			}
			else
			{
			    output(fordulo,"(#%d) ", fegyver->spell->ssz);
			}
			output(fordulo,"</TD><TD CLASS=\"t1\" >&nbsp;</TD>");
			if (sebzes)
			{
			    output(fordulo,"<TD CLASS=\"t1\" ALIGN=\"RIGHT\" WIDTH=3%% NOWRAP> %.1f </TD>", (sebzes != alapsebzes ? sebzes : (fegyver->spell->maxero == 1 ? alapsebzes : 0)));
			    if (felfullsebzes && (felfullsebzes != (sebzes ? sebzes : alapsebzes)))
			    {
				output(fordulo,"<TD CLASS=\"t1\" ALIGN=\"RIGHT\" WIDTH=3%% NOWRAP> &nbsp; %.1f </TD>", felfullsebzes);
			    }
			    else
			    {
				output(fordulo,"<TD CLASS=\"t1\" ALIGN=\"RIGHT\" WIDTH=3%% NOWRAP> &nbsp; </TD>");
			    }
			    if (fullsebzes && (fullsebzes != felfullsebzes))
			    {
				output(fordulo,"<TD CLASS=\"t1\" ALIGN=\"RIGHT\" WIDTH=3%% NOWRAP> &nbsp; %.1f </TD>", fullsebzes);
			    }
			    else
			    {
				output(fordulo,"<TD CLASS=\"t1\" ALIGN=\"RIGHT\" WIDTH=3%% NOWRAP> &nbsp; </TD>");
			    }
			}
			else
			{
			    output(fordulo,"<TD CLASS=\"t1\" ALIGN=\"RIGHT\" WIDTH=1%% COLSPAN=3> &nbsp; </TD>");
			}
		    }
		    else
		    {
			output(fordulo,"<TD CLASS=\"t1\" COLSPAN=5 WIDTH=30%%> &nbsp;</TD>");
		    }
		    output(fordulo,"<TD CLASS=\"t1\" WIDTH=15%%> &nbsp;</TD></TR>\r\n");
		}
	    }
	}
	output(fordulo,"<TR><TD CLASS=\"t1\" COLSPAN=13><br><i>s1: alapsebzs plusz varzslatsebzs FNObl &nbsp;&nbsp;&nbsp; s2: s1 plusz %svarzslatsebzs trgybl &nbsp;&nbsp;&nbsp; s3: s2 plusz tipusbnuszok</i> </TD></TR>\r\n", (rughar_van?"rughar s ":""));
	output(fordulo,"<TR><TD CLASS=\"t1\" COLSPAN=13><i>A sebzst ad KT-kpessgek nincsenek figyelve, mgiarzkenysg szintn.</i> </TD></TR>\r\n");
	output(fordulo,"<TR><TD CLASS=\"c3\" COLSPAN=13>");
	output(fordulo,"<li>A varzslatot lv fegyvereknl nem igazn van adat rla milyen esllyel s milyen ervel lvi el a spellt. Ha nem stimmel, lgyszi szlj (ne azt, hogy nem j, hanem azt mond meg, hogy mi a j adat)! Ez a te rdeked is, mert ez a felirat akkor fog innen eltnni, amint az adatok nagyrsze j lesz :)</li>");
	output(fordulo,"<br>[KWS]<br>email: <b><u>reformat(kukuc)vizipok.hu</u></b>");
	output(fordulo,"</TD></TR>\r\n");
	output(fordulo,"</TABLE>");
	output(fordulo,"</TD></TR></TABLE>\r\n<P>\r\n");
    }
    
    if (aconf_get_curr("karlap_kihivas_torony_kiiras") == 1)
    {
	int torony_szint;
	float esely;
	int proba_id;
	char * proba_nevek[] = {"szakrtelem", "ismeret", "szrny ls", "trgy kszits"};
	t_proba_tipus proba_tipusok[] = {proba_szakertelem, proba_info, proba_oles, proba_keszites};
	t_torony_kiir_store * kiir_store_curr = NULL;
	t_torony_kiir_store * kiir_store_next = NULL;
	int store_n;
	t_proba_info_tipus proba_info_tipus;
	char * p1;
	char * p2;
	char p_szam[10];
	t_targy * targy;
	int prev_ssz;
				    
	
	output(fordulo,"<TABLE WIDTH=100%% CELLPADDING=1 CELLSPACING=0 BORDER=0 CLASS=\"t0\"><TR><TD> <TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0 CLASS=\"t1\" WIDTH=100%%>\r\n<TR><TD CLASS=\"c2\" COLSPAN=3>KIHVS TORONY ESLYEK</TD></TR>\r\n");
	for (torony_szint = 1; torony_szint <= 8; torony_szint++)
	{
	    esely = torony(fordulo, torony_szint);
	    output(fordulo,"<TR><TD CLASS=\"t1\" COLSPAN=3>%d. szint teljestsre %s%s" TORONY_SZAM_FORMAT " eslyed van</TD></TR>\r\n", torony_szint, (esely<100?"&nbsp;":""), (esely<10?"&nbsp;":""), esely);
	    
	}
	for (proba_id = 0; (aconf_get_curr("karlap_kihivas_torony_reszletes") == 1) && (proba_id < 4); proba_id++)
	{
	    for (i = 1; i <= 3; i++)
	    {
		esely = torony_get_proba_szint_esely(i, proba_tipusok[proba_id]);
		output(fordulo,"<TR><TD CLASS=\"t1\" COLSPAN=3>&nbsp;</TD></TR>\r\n");
		output(fordulo,"<TR><TD CLASS=\"c3\" COLSPAN=3>%d. szint %s prba: " TORONY_SZAM_FORMAT " ", i, proba_nevek[proba_id], esely);
		output(fordulo, " - <i>[torony <b>%s2, 3, 4, %s%s%s8</b> szintjn krik]</i>", (i==1||i==2?"1, ":""), (i==2||i==3?"5, ":""), (proba_tipusok[proba_id]==proba_oles?"6, ":""), (proba_tipusok[proba_id]==proba_szakertelem?"7, ":""));
		output(fordulo, "</TD></TR>\r\n");
		h[0] = 0;
		for (kiir_store_curr = torony_kiir_store_get_head(), store_n = 0, prev_ssz = -1; kiir_store_curr; kiir_store_curr = kiir_store_next)
		{
		    kiir_store_next = kiir_store_curr->next;
		    
		    if ((kiir_store_curr->tipus != proba_tipusok[proba_id]) || (kiir_store_curr->szint != i))
		    {
			continue;
		    }
		    
		    switch (kiir_store_curr->tipus)
		    {
			case proba_szakertelem:
			    if ((kiir_store_curr->ssz2) || (torony_get_szakertelem_ertek(fordulo, kiir_store_curr->ssz) >= 0))
			    {
				if (!h[0])
				{
				    output(fordulo,"<TR><TD CLASS=\"t1\" COLSPAN=3>Nem megfelel szakrtelmek:</TD></TR>\r\n");
				    h[0] = 1;
				}
				if (prev_ssz != kiir_store_curr->ssz)
				{
				    if (prev_ssz != -1)
				    {
					output(fordulo, "</TD>%s", (store_n%3==2?"</TR>\r\n":""));
					store_n++;
				    }
				    output(fordulo, "%s<TD CLASS=\"t1\">%s", (store_n%3==0?"<TR VALIGN=top>":""), torony_get_szakertelem_nev(kiir_store_curr->ssz));
				    prev_ssz = kiir_store_curr->ssz;
				}
				if ((kiir_store_curr->ssz2 == 0) && torony_get_szakertelem_ertek(fordulo, kiir_store_curr->ssz) >= 0)
				{
				    output(fordulo, ": %d<br>&nbsp;&nbsp;<i>min. szakrtelem: %d</i>", torony_get_szakertelem_ertek(fordulo, kiir_store_curr->ssz), torony_get_szakertelem_kellene(i, kiir_store_curr->ssz));
				}
				else if (kiir_store_curr->ssz2)
				{
				    if ((kiir_store_curr->ssz == 11) || (kiir_store_curr->ssz == 4) || (kiir_store_curr->ssz == 9) || (kiir_store_curr->ssz == 14))
				    {
					t_spell * spell;
					
					if (spell = get_spell_from_ssz(kiir_store_curr->ssz2))
					{
					    output(fordulo, "<br>&nbsp;&nbsp;<i>%s (#%d)</i>", spell->nev, kiir_store_curr->ssz2);
					}
				    }
				    else if ((kiir_store_curr->ssz == 6) || (kiir_store_curr->ssz == 5) || (kiir_store_curr->ssz == 15))
				    {
					if (targy = get_targy_from_ssz(kiir_store_curr->ssz2))
					{
					    output(fordulo, "<br>&nbsp;&nbsp;<i>%s (#%d)</i>", targy->nev, kiir_store_curr->ssz2);
					}
				    }
				}
			    }
			    break;
			
			case proba_info:
			    if (!h[0])
			    {
			        output(fordulo,"<TR><TD CLASS=\"t1\" COLSPAN=3>Hinyz informcik:</TD></TR>\r\n");
			        h[0] = 1;
			    }
			    if ((t_proba_info_tipus)kiir_store_curr->ssz2 == proba_info_targy)
			    {
				if (targy = get_targy_from_ssz(kiir_store_curr->ssz))
				{
				    output(fordulo, "%s<TD CLASS=\"t1\">%s (#%d)</TD>%s", (store_n%3==0?"<TR VALIGN=top>":""), targy->nev, kiir_store_curr->ssz, (store_n%3==2?"</TR>\r\n":""));
				    store_n++;
				}
			    }
			    else if ((t_proba_info_tipus)kiir_store_curr->ssz2 == proba_info_szorny)
			    {
				sprintf(p_szam, "\n%5d ", kiir_store_curr->ssz);
				if ((p1 = monsters_str_get()) && (p1 = strstr2(p1, p_szam)))
				{
				    p1 = skip_space(p1);
				    for (p2 = p1; (p2 < p1 + strlen(p1)) && (!isdigit2(*p2)); p2++);
				    if (isdigit2(*p2) || (p2 == p1 + strlen(p1)))
				    {
					output(fordulo, "%s<TD CLASS=\"t1\">%.*s (#%d)</TD>%s", (store_n%3==0?"<TR VALIGN=top>":""), p2 - p1, p1, kiir_store_curr->ssz, (store_n%3==2?"</TR>\r\n":""));
					store_n++;
				    }
				}
			    }
			    break;
			
			case proba_oles:
			    if (!h[0])
			    {
			        output(fordulo,"<TR><TD CLASS=\"t1\" COLSPAN=3>Problms a szrny meglse:</TD></TR>\r\n");
			        h[0] = 1;
			    }
			    sprintf(p_szam, "\n%5d ", kiir_store_curr->ssz);

			    if ((p1 = monsters_str_get()) && (p1 = strstr2(p1, p_szam)))
			    {
			        p1 = skip_space(p1);
			        for (p2 = p1; (p2 < p1 + strlen(p1)) && (!isdigit2(*p2)); p2++);
			        if (isdigit2(*p2) || (p2 == p1 + strlen(p1)))
			        {
				    if ((t_proba_oles_tipus)kiir_store_curr->ssz2 == proba_oles_noinfo)
				    {
					output(fordulo, "%s<TD CLASS=\"t1\">%.*s (#%d)<br>&nbsp;&nbsp;<i>nem ismered</i></TD>%s", (store_n%3==0?"<TR VALIGN=top>":""), p2 - p1, p1, kiir_store_curr->ssz, (store_n%3==2?"</TR>\r\n":""));
					store_n++;
				    }
				    else
				    {
					int oles_i;
					int oles_array[CACHE_MONSTER_MEGOLES_LEN*2 + 1];
					int oles_percent;
					
					memset(oles_array, 0, sizeof(oles_array));
					cache_check_monster(fordulo, fordulo->cache, kiir_store_curr->ssz, &oles_percent, CACHE_MONSTER_MEGOLES_LEN, oles_array);
					oles_percent = kiir_store_curr->alkoto_darab;
					
					output(fordulo, "%s<TD CLASS=\"t1\">%.*s (#%d)<br>&nbsp;&nbsp;<i>oles: %d %% ", (store_n%3==0?"<TR VALIGN=top>":""), p2 - p1, p1, kiir_store_curr->ssz, oles_percent);
					for (oles_i = 0, h[1] = 0; oles_i < CACHE_MONSTER_MEGOLES_LEN; oles_i++)
					{
					    if (oles_array[oles_i*2])
					    {
						output(fordulo, "%s%d%s", (!h[1]?"(":" "), oles_array[oles_i*2], (oles_array[oles_i*2+1]==(int)cache_monster_megoli_flag_megoli?"+":(oles_array[oles_i*2+1]==(int)cache_monster_megoli_flag_nemoli?"-":"")));
						h[1] = 1;
					    }
					}
					output(fordulo, "%s</i></TD>%s", (h[1]?")":(oles_percent?"":"(nincs csata adat)")), (store_n%3==2?"</TR>\r\n":""));
					store_n++;
				    }
				}
			    }
			    break;
			
			case proba_keszites:
			    if (!h[0])
			    {
			        output(fordulo,"<TR><TD CLASS=\"t1\" COLSPAN=3>Trgykszitshez hinyz alkotrszek:</TD></TR>\r\n");
			        h[0] = 1;
			    }
			    if (targy = get_targy_from_ssz(kiir_store_curr->ssz))
			    {
				if (prev_ssz != kiir_store_curr->ssz)
				{
				    if (prev_ssz != -1)
				    {
					output(fordulo, "</TD>%s", (store_n%3==2?"</TR>\r\n":""));
					store_n++;
				    }
				    output(fordulo, "%s<TD CLASS=\"t1\">%s (#%d):", (store_n%3==0?"<TR VALIGN=top>":""), targy->nev, kiir_store_curr->ssz);
				    prev_ssz = kiir_store_curr->ssz;
				}
				if (kiir_store_curr->ssz2 == 0)
				{
				    // nem ismert
				    output(fordulo, "<br>&nbsp;&nbsp;<i>nem ismered</i>");
				}
				else if (kiir_store_curr->ssz2 == -1)
				{
				    // banyaszat
				    output(fordulo, "<br>&nbsp;&nbsp;<i>4-es bnyszat</i>");
				}
				else if (kiir_store_curr->ssz2 == -2)
				{
				    // varazsital fozes
				    output(fordulo, "<br>&nbsp;&nbsp;<i>varzsitalfzs</i>");
				}
				else
				{
				    // nincs alkoto
				    t_targy * targy2;
				    
				    if (targy2 = get_targy_from_ssz(kiir_store_curr->ssz2))
				    {
					output(fordulo, "<br>&nbsp;&nbsp;<i>%d %s (#%d)</i>", kiir_store_curr->alkoto_darab, targy2->nev, kiir_store_curr->ssz2);
				    }
				}
			    }
			    break;
			
			default:
			    break;
		    }
		}
	    }
	}
	output(fordulo,"</TABLE>");
	output(fordulo,"</TD></TR></TABLE>\r\n<P>\r\n");
    }
}

void reformat_karlap_megterheltseg(t_fordulo * fordulo, char * buf)
{
    char * p1;
    char * p2;
    char * p3;
    char tmp;
    
    p3 = buf;
    if (aconf_get_curr("karlap_targy_suly_kiiras") == 1)
    {
	if ((p2 = strstr2(p3, "Megterheltsg")) && (p1 = strstr(p2, "<TR>")))
	{
	    tmp = *p1;
	    *p1 = '\0';
	    reformat_karlap_header_format(fordulo, p3);
	    *p1 = tmp;
	    output(fordulo, "<TR><TD CLASS=\"t1\" COLSPAN=2>Trgyaid sszrtke: %d arany (a bankban lv trgyak nlkl)</TD></TR>\r\n", fordulo->karakter->targyak_erteke);
	    output(fordulo, "<TR><TD CLASS=\"t1\" COLSPAN=2>HU-ban lv trgyaid sszrtke: %d arany</TD></TR>\r\n", fordulo->karakter->targyak_erteke_huban);
	    p3 = p1;
	}
    }
    
    reformat_karlap_else(fordulo, p3);
}

void reformat_karlap_targylista(t_fordulo * fordulo, char * buf)
{
    char * p1;
    char * p2;
    char * p3;
    char * p4;
    char * p5;
    char * p6;
    char tmp;
    int ssz;
    int darab;
    int huban;
    t_targy * targy;
    char puffer[63];
    char * buf_vege;

    if (!(p1 = strstr(buf, "ALIGN=RIGHT")))
    {
	p1 = buf + strlen(buf);
    }
    
    if (fordulo->karakter->targyment)
    {
#ifdef DEBUG
	debug(fordulo, "reformat_karlap_targylista: buf_vege targyment\n");
#endif
        buf_vege = fordulo->karakter->targyment;
    }
    else if (fordulo->karakter->targyjott)
    {
#ifdef DEBUG
	debug(fordulo, "reformat_karlap_targylista: buf_vege targyjott\n");
#endif
	buf_vege = fordulo->karakter->targyjott;
    }
    else
    {
#ifdef DEBUG
	debug(fordulo, "reformat_karlap_targylista: buf_vege karlapend\n");
#endif
	buf_vege = fordulo->karakter->karlapend;
    }
    if (!buf_vege || (buf_vege > (buf + strlen(buf))))
    {
	buf_vege = buf + strlen(buf);
    }
    
    p3 = buf;
    tmp = *p1;
    *p1 = '\0';
    reformat_karlap_header_format(fordulo, p3);
    *p1 = tmp;

    for (p3 = p1; (p1 = strstr2(p3, "(")) && (p2 = strstr2(p1, ")")) && (p2 - p1 < 7); p3 = p2)
    {
	darab = 0;
	huban = 0;
	if ((p4 = strstr2(p3, "ALIGN=RIGHT")) && (p5 = strstr2(p4, ">")) && (p6 = strstr(p5, "<")) && (p6 == strstr(p5, "</TD>")) && (p6 < p1))
	{
	    p5 = skip_space(p5);
	    if (*p5 == '$')
	    {
		p5++;
		huban = 1;
	    }
	    if (isdigit2(*p5))
	    {
		darab = atoi(p5);
	    }
	}
	else if ((p5 = strstr2(p3, "COLSPAN=6>[")) && (p6 = strstr(p5, "<")) && (p6 == strstr(p2, "</TD>")))
	{
	    p5 = skip_nonspace(p5);
	    p5 = skip_space(p5);
	    if (*p5 == '$')
	    {
		p5++;
		huban = 1;;
	    }
	    if (isdigit2(*p5))
	    {
		darab = atoi(p5);
	    }
	}
	p1++;
	tmp = *p1;
	*p1 = '\0';
	reformat_karlap_header_format(fordulo, p3);
	*p1 = tmp;

	if (ssz = atoi(p1))
	{
	    if (aconf_get_curr("hyperlink_targy") == 1)
	    {
		output(fordulo, "<a class=n href=\"%stargy_enc.php%sf=tenc&ssz=%i%s\" target=hyper title=\"Encyclopedia (Web Hyper)\">%d</a>)", bconf_get_webhyper(), (aconf_get_webhyper_offline()?"@":"?"), ssz, (aconf_get_webhyper_offline()?".htm":""), ssz);
	    }
	    else
	    {
		output(fordulo, "%d)", ssz);
	    }
	    if ((p1 < buf_vege) && (targy = get_targy_from_ssz(ssz)))
	    {
		sprintf(puffer,"");
		if (aconf_get_curr("karlap_targy_ertek_kiiras") == 1)
		{
		    if (targy->ea * darab)
		    {
			fordulo->karakter->targyak_erteke += targy->ea * darab;
			if (huban)
			{
			    fordulo->karakter->targyak_erteke_huban += targy->ea * darab;
			}
			sprintf(puffer," {%d}", targy->ea * darab);
		    }
		}
		if (aconf_get_curr("karlap_targy_suly_kiiras") == 1)
		{
		    if (targy->suly * darab)
		    {
		    	fordulo->karakter->targyak_sulya += targy->suly * darab;
			sprintf(puffer,"%s [%.2f]", puffer, (float)targy->suly * (float)darab / (float)100);
		    }
		}
		if (strlen(puffer))
		{
		    output(fordulo, "%s", puffer);
		}
	    }
	}
	else
	{
	    output(fordulo, "%.*s", p2 - p1, p1);
	}
	p3 = p2;
    }
    
    reformat_karlap_header_format(fordulo, p3);
}

void reformat_karlap_targylista_valtozas(t_fordulo * fordulo, char * buf)
{
    t_karakter_targylist * karakter_targylist_elem;
    int i;
    char hs[2];

    memset(hs, 0 , sizeof(hs));
    
    if (aconf_get_curr("karlap_targy_valtozas_kiiras") == 1)
    {
	for (i = 0, karakter_targylist_elem = get_karakter_targylist_head(fordulo->karakter, 4); karakter_targylist_elem; karakter_targylist_elem = karakter_targylist_elem->next)
	{
	    if (karakter_targylist_elem->darab < 0)
	    {
		if (!hs[0])
		{
		    output(fordulo,"<TABLE WIDTH=100%% CELLPADDING=1 CELLSPACING=0 BORDER=0 CLASS=\"t0\"><TR><TD> <TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0 CLASS=\"t1\" WIDTH=100%%>\r\n<TR><TD CLASS=\"c2\" COLSPAN=9>ELZ FORDULD VGN MG MEGVOLT... (*)</TD></TR>\r\n");
		    hs[0] = 1;
		}
		if (aconf_get_curr("hyperlink_targy") == 1)
		{
		    output(fordulo,"%s<TD ALIGN=RIGHT CLASS=\"t1\" WIDTH=30> %d </TD><TD CLASS=\"t1\" WIDTH=8> &nbsp; </TD><TD CLASS=\"t1\" WIDTH=30%% NOWRAP> %s (#<a  class=n href=\"%stargy_enc.php%sf=tenc&ssz=%d%s\" target=hyper title=\"Encyclopedia (Web Hyper)\">%d</a>) </TD>%s", (i%3==0?"<TR>":""), (0 - karakter_targylist_elem->darab), karakter_targylist_elem->targy->nev, bconf_get_webhyper(), (aconf_get_webhyper_offline()?"@":"?"), karakter_targylist_elem->targy->ssz, (aconf_get_webhyper_offline()?".htm":""), karakter_targylist_elem->targy->ssz, (i%3==2?"</TR>\r\n":""));
		}
		else
		{
		    output(fordulo,"%s<TD ALIGN=RIGHT CLASS=\"t1\" WIDTH=30> %d </TD><TD CLASS=\"t1\" WIDTH=8> &nbsp; </TD><TD CLASS=\"t1\" WIDTH=30%% NOWRAP> %s (#%d) </TD>%s", (i%3==0?"<TR>":""), (0 - karakter_targylist_elem->darab), karakter_targylist_elem->targy->nev, karakter_targylist_elem->targy->ssz, (i%3==2?"</TR>\r\n":""));
		}
		i++;
	    }
	}
	
	if (hs[0])
	{
	    for ( ; i%3 != 0; i++)
    	    {
		output(fordulo,"<TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> &nbsp; </TD>%s", (i%3==2?"</TR>\r\n":""));
	    }
	    output(fordulo,"<TR><TD CLASS=\"t1\" COLSPAN=9><br><i> * Reformat: tborozs kzbeni vltozs benne van, illetve bankba bepakols nem jelenik meg</i> </TD></TR>\r\n");
	    output(fordulo,"</TABLE>");
	    output(fordulo,"</TD></TR></TABLE>\r\n<P>\r\n");
	}
	for (i = 0, karakter_targylist_elem = get_karakter_targylist_head(fordulo->karakter, 4); karakter_targylist_elem; karakter_targylist_elem = karakter_targylist_elem->next)
	{
	    if (karakter_targylist_elem->darab >= 0)
	    {
		if (!hs[1])
		{
		    output(fordulo,"<TABLE WIDTH=100%% CELLPADDING=1 CELLSPACING=0 BORDER=0 CLASS=\"t0\"><TR><TD> <TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0 CLASS=\"t1\" WIDTH=100%%>\r\n<TR><TD CLASS=\"c2\" COLSPAN=9>ELZ FORDULD TA KERLT HOZZD... (*)</TD></TR>\r\n");
		    hs[1] = 1;
		}
		if (aconf_get_curr("hyperlink_targy") == 1)
		{
		    output(fordulo,"%s<TD ALIGN=RIGHT CLASS=\"t1\" WIDTH=30> %d </TD><TD CLASS=\"t1\" WIDTH=8> &nbsp; </TD><TD CLASS=\"t1\" WIDTH=30%% NOWRAP> %s (#<a  class=n href=\"%stargy_enc.php%sf=tenc&ssz=%d%s\" target=hyper title=\"Encyclopedia (Web Hyper)\">%d</a>) </TD>%s", (i%3==0?"<TR>":""), (karakter_targylist_elem->darab), karakter_targylist_elem->targy->nev, bconf_get_webhyper(), (aconf_get_webhyper_offline()?"@":"?"), karakter_targylist_elem->targy->ssz, (aconf_get_webhyper_offline()?".htm":""), karakter_targylist_elem->targy->ssz, (i%3==2?"</TR>\r\n":""));
		}
		else
		{
		    output(fordulo,"%s<TD ALIGN=RIGHT CLASS=\"t1\" WIDTH=30> %d </TD><TD CLASS=\"t1\" WIDTH=8> &nbsp; </TD><TD CLASS=\"t1\" WIDTH=30%% NOWRAP> %s (#%d) </TD>%s", (i%3==0?"<TR>":""), (karakter_targylist_elem->darab), karakter_targylist_elem->targy->nev, karakter_targylist_elem->targy->ssz, (i%3==2?"</TR>\r\n":""));
		}
		i++;
	    }
	}
	if (hs[1])
	{
	    for ( ; i%3 != 0; i++)
    	    {
		output(fordulo,"<TD CLASS=\"t1\" WIDTH=33%% COLSPAN=3> &nbsp; </TD>%s", (i%3==2?"</TR>\r\n":""));
	    }
	    output(fordulo,"<TR><TD CLASS=\"t1\" COLSPAN=9><br><i> * Reformat: tborozs kzbeni vltozs benne van, illetve bankbl kivtel nem jelenik meg</i> </TD></TR>\r\n");
	    output(fordulo,"</TABLE>");
	    output(fordulo,"</TD></TR></TABLE>\r\n<P>\r\n");
	}
	output(fordulo,"</TD></TR></TABLE></CENTER>\r\n");
    }
}

extern void reformat_karlap(t_fordulo * fordulo)
{
    char ** p1;
    char ** p2;
    char * t1;
    char * t2;
    char * buf;
    char tmp;
    unsigned long n;
    int i;
    int size;
    int valtozast_kiirni;

    if (get_cache_mode())
    {
	return;
    }
    valtozast_kiirni = 1;
    for (i = 1, size = 0, p1 = &fordulo->karakter->karlapstart; p1 < &fordulo->karakter->karlapend; p1 = p2, i++)
    {
	p2 = p1 + 1;
#ifdef DEBUG
	debug(fordulo, "fordulo reformat karlap 1: p1=%p p2=%p\n", *p1, *p2);
#endif
	if (*p1 == NULL)
	{
	    continue;
	}
#ifdef DEBUG
	debug(fordulo, "fordulo reformat karlap 2: p1=%p p2=%p\n", *p1, *p2);
#endif
	while ((*p2 == NULL) &&  (p2 < &fordulo->karakter->karlapend))
	{
	    p2++;
	}
	tmp = **p2;
	**p2 = '\0';
#ifdef DEBUG
	debug(fordulo, "fordulo reformat karlap 3: p1=%p p2=%p\n", *p1, *p2);
#endif

	kiir(fordulo, ".");
	if ((p1 == &fordulo->karakter->karlapstart))
	{
	    reformat_karlap_karlapstart(fordulo, *p1);
	}
	else if ((p1 == &fordulo->karakter->tulajdonsag))
	{
	    reformat_karlap_tulajdonsag(fordulo, *p1);
	}
	else if ((p1 == &fordulo->karakter->fegyverszaki))
	{
	    reformat_karlap_fegyverszaki(fordulo, *p1);
	}
	else if ((p1 == &fordulo->karakter->szakertelmek))
	{
	    reformat_karlap_szakertelmek(fordulo, *p1);
	}
	else if ((p1 == &fordulo->karakter->fno))
	{
	    reformat_karlap_fno(fordulo, *p1);
	}
	else if ((p1 == &fordulo->karakter->spellek))
	{
	    reformat_karlap_spellek(fordulo, *p1);
	}
	else if ((p1 == &fordulo->karakter->spellrajtad))
	{
	    reformat_karlap_spellrajtad(fordulo, *p1);
	}
	else if ((p1 == &fordulo->karakter->tvlista))
	{
	    reformat_karlap_tvlista(fordulo, *p1);
	}
	else if ((p1 == &fordulo->karakter->targylista))
	{
	    reformat_karlap_jo_tudni(fordulo);
	    reformat_karlap_targylista(fordulo, *p1);
	}
	else if ((p1 == &fordulo->karakter->megterheltseg))
	{
	    reformat_karlap_megterheltseg(fordulo, *p1);
	}
	else if ((p1 == &fordulo->karakter->bank))
	{
	    reformat_karlap_targylista(fordulo, *p1);
	}
	else if ((p1 >= &fordulo->karakter->targyment) && (p1 <= &fordulo->karakter->targyjott))
	{
	    if ((fordulo->tipus == fordulo_tipus_olimpia) || (aconf_get_curr("karlap_targy_valtozas_kiiras") == 0) || !get_karakter_targylist_head(fordulo->karakter, 4))
	    {
		reformat_karlap_else(fordulo, *p1);
	    }
	}
	else if ((p1 >= &fordulo->karakter->karlapstart) && (p1 < &fordulo->karakter->karlapend))
	{
	    reformat_karlap_else(fordulo, *p1);
	}

	if ((aconf_get_curr("karlap_targy_valtozas_kiiras") == 1) && get_karakter_targylist_head(fordulo->karakter, 4) && (p1 >= &fordulo->karakter->bank) && valtozast_kiirni)
	{
	    reformat_karlap_targylista_valtozas(fordulo, *p1);
	    valtozast_kiirni = 0;
	}

	**p2 = tmp;
#ifdef DEBUG
	debug(fordulo, "fordulo reformat karlap 4: p1=%p p2=%p\n", *p1, *p2);
#endif
    }
}
