/*
 * Copyright (C) 2003  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#define F_KORVEGE_INTERNAL_ACCESS
#include "include.h"
#include "f_korvege.h"
#ifndef JUST_NEED_TYPES
# define JUST_NEED_TYPES
# include "format.h"
# undef JUST_NEED_TYPES
#else
# include "format.h"
#endif
#include "output.h"
#include "cache.h"
#include "karakter.h"
#include "format.h"
#include "spell.h"
#include "targy.h"
#include "input.h"
#include "fordulo.h"
#include "psziernyo.h"

static char * cimsor_stat[] =
{
    "EBBEN A FORDULBAN...",
    "Reformattlt fordulidban..."
};

static char * cimsor_spell[] =
{
    "HASZNLT VARZSLATOK",
    "Reformattlt fordulidban hasznlt, mr ebben a fordulban ismert varzslatok"
};

extern int stats_kiir(t_fordulo * fordulo, int mode)
{
    long int csata_gyogyulas = 0;
    long int csata_vp = 0;
    long int csata_pp = 0;
    int kiir = 0;
    int csata_kiir = 0;
    int eroforras_kiir = 0;
    int permanens_kiir = 0;
    t_csata * stats;
    t_csata csata;
    long * ll;
    int i;
    long value;
    
    if (mode == 1)
    {
	memset(&csata, 0 , sizeof(t_csata));
	ll = (long *)&csata.sebzes_utes;
	for (i = 0; &ll[i] <= &csata.egyeb_n; i++)
	{
	    if (cache_check_stat(fordulo, fordulo->cache, i+1, &value) == 1)
	    {
		ll[i] = value;
	    }
	}
	stats = &csata;
    }
    else
    {
	stats = &fordulo->osszesen;
    }
    
    csata_kiir = ((aconf_get_curr("korvege_sebzes_stat") == 1) || (aconf_get_curr("korvege_sebzodes_stat") == 1) || (aconf_get_curr("korvege_csata_gyogyulas_stat") == 1) || (aconf_get_curr("korvege_csata_vp_stat") == 1) || (aconf_get_curr("korvege_csata_pp_stat") == 1) || (aconf_get_curr("korvege_csata_tu_stat") == 1) || (aconf_get_curr("korvege_csata_tvp_stat") == 1) || (aconf_get_curr("korvege_csata_oregedes_stat") == 1) || (aconf_get_curr("korvege_csata_papirang_stat") == 1));
    eroforras_kiir = ((aconf_get_curr("korvege_eroforras_ep_stat") == 1) || (aconf_get_curr("korvege_eroforras_vp_stat") == 1) || (aconf_get_curr("korvege_eroforras_pp_stat") == 1) || (aconf_get_curr("korvege_eroforras_tu_stat") == 1) || (aconf_get_curr("korvege_eroforras_tvp_stat") == 1));
    permanens_kiir = ((aconf_get_curr("korvege_permanens_instabil_stat") == 1) || (aconf_get_curr("korvege_permanens_max_stat") == 1) || (aconf_get_curr("korvege_permanens_oregedes_stat") == 1) || (aconf_get_curr("korvege_permanens_jellem_stat") == 1) || (aconf_get_curr("korvege_permanens_papirang_stat") == 1));

    // Osszezes kiirasa
    if (csata_kiir || eroforras_kiir || permanens_kiir)
    {
	output(fordulo,"<P><TABLE WIDTH=100%% CELLPADDING=1 CELLSPACING=0 BORDER=0 CLASS=\"t0\"><TR><TD><TABLE WIDTH=100%% CELLPADDING=2 CELLSPACING=0 BORDER=0 CLASS=\"t1\"><TR><TD CLASS=\"c1\" colspan=2>%s</TD></TR>\r\n", (mode==1?cimsor_stat[1]:cimsor_stat[0]));
	if (mode == 1)
	{
	    output(fordulo, "<TR><TD CLASS=\"c1\" colspan=2><font class=klap style=\"FONT-WEIGHT: normal;\">");
	    cache_header_fordulok_kiir(fordulo, fordulo->cache, cache_type_stat);
	    output(fordulo,"<font></TD></TR>\r\n");
	}
	if (csata_kiir)
	{
	    output(fordulo,"<tr><td nowrap class=\"c3\" colspan=2>Csatkban trtnt</td></tr>\r\n");

	    //Sebzes + sebzodes
	    if (aconf_get_curr("korvege_sebzes_stat") == 1)
	    {
		output(fordulo,"<tr><td nowrap class=\"t1\" align=right><SPAN CLASS=\"sebez\">%ld</SPAN></td><td nowrap class=\"t1\"> letpontot tttl, ", stats->sebzes_utes);
		output(fordulo,"<SPAN CLASS=\"sebez\">%ld</SPAN> letpontot egyb mdon sebeztl a szrnyekbe (kalandozkba). ", stats->sebzes_egyeb);
		output(fordulo,"sszesen <SPAN CLASS=\"sebez\">%ld</SPAN> letpont sebezs.</td></tr>\r\n", stats->sebzes_utes + stats->sebzes_egyeb);
	    }
	    if (aconf_get_curr("korvege_sebzodes_stat") == 1)
	    {
		output(fordulo,"<tr><td nowrap class=\"t1\" align=right><SPAN CLASS=\"szenved\">%ld</SPAN></td><td nowrap class=\"t1\"> letpontot tseiktl, ", stats->sebzodes_utes);
		output(fordulo,"<SPAN CLASS=\"szenved\">%ld</SPAN> letpontot egyb mdon sebzdtl. ", stats->sebzodes_egyeb);
		output(fordulo,"sszesen <SPAN CLASS=\"szenved\">%ld</SPAN> letpont sebzds.</td></tr>\r\n", stats->sebzodes_utes + stats->sebzodes_egyeb);
	    }
	    if ((aconf_get_curr("korvege_sebzes_stat") == 1) || (aconf_get_curr("korvege_sebzodes_stat") == 1))
	    {
		if (stats->sebzes_utes_beforr)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> letpontot tttl volna mgikusan/ezsttel sebezhet szrnyekbe, de mivel ezt nem mgikus/ezst fegyverrel tetted, nem sok hatsa volt :)</td></tr>\r\n", stats->sebzes_utes_beforr);
		}
		output(fordulo,"<tr><td nowrap class=\"t1\" colspan=2> &nbsp;</td></tr>\r\n");
	    }

	    // Gyogyulas
	    if (aconf_get_curr("korvege_csata_gyogyulas_stat") == 1)
	    {
		if(stats->vampiri != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> letpontot vmpirizcival gygyultl.</td></tr>\r\n", stats->vampiri);
		}
		if(stats->nekrocsok != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> letpontot nekromanta cskjval gygyultl.</td></tr>\r\n", stats->nekrocsok);
		}
		if(stats->kreitonfozet != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> letpontot kreiton fzettel gygyultl.</td></tr>\r\n", stats->kreitonfozet);
		}
		if(stats->trafo_ep != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> letpontot trafval szereztl.</td></tr>\r\n", stats->trafo_ep);
		}
		if(stats->torpregen != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> letpontot trpregenercival regenerltl.</td></tr>\r\n", stats->torpregen);
		}
		if(stats->morgan_csata != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> letpontot Morgan szilnk gygyitott.</td></tr>\r\n", stats->morgan_csata); 
		}
		if(stats->mihlanil != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> letpontot mihlanil pncllal adott.</td></tr>\r\n", stats->mihlanil);
		}
		if(stats->ep_p != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> letpontot egyb mdon gygyultl.</td></tr>\r\n", stats->ep_p);
		}
		if(stats->kobor != 0)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> letpontnyi sebzdst a kbr fogott fel.</td></tr>\r\n", stats->kobor);
		}
		if(stats->vampirkt != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> letpontnyi sebzdst a brd fogott fel.</td></tr>\r\n", stats->vampirkt);
		}
		if(stats->vampiri != 0 || stats->nekrocsok != 0 || stats->kreitonfozet != 0 || stats->trafo_ep != 0 || stats->torpregen != 0 || stats->morgan_csata != 0 || stats->mihlanil != 0 || stats->ep_p != 0 || stats->kobor != 0 || stats->vampirkt != 0) 
		{ 
		    csata_gyogyulas = stats->vampiri + stats->nekrocsok + stats->kreitonfozet + stats->trafo_ep + stats->torpregen + stats->morgan_csata + stats->mihlanil + stats->ep_p + stats->kobor + stats->vampirkt;
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%+ld</SPAN></td><td nowrap class=\"t1\"> letpont gygyuls sszesen.</td></tr>\r\n", csata_gyogyulas);
		    output(fordulo,"<tr><td nowrap class=\"t1\" colspan=2> &nbsp;</td></tr>\r\n");
		}
	    }

	    // VP valtozas
	    if (aconf_get_curr("korvege_csata_vp_stat") == 1)
	    {
		if(stats->trafo_vp != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> varzspontot trafval nyertl ki</td></tr>\r\n", stats->trafo_vp);
		}
		if(stats->kontakt_vp != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> varzspontot direkt kontaktus II-vel kaptl.</td></tr>\r\n", stats->kontakt_vp);
		}
		if(stats->vp_p != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> varzspontot egyb mdon kaptl. (pl manaelementl, varzstltds, stb.)</td></tr>\r\n", stats->vp_p);
		}
		if(stats->vp_n != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> varzspontot szvtak el.</td></tr>\r\n", stats->vp_n);
		}
		if(stats->trafo_vp != 0 || stats->kontakt_vp != 0 || stats->vp_p != 0 || stats->vp_n != 0) 
		{
		    csata_vp = stats->trafo_vp + stats->kontakt_vp + stats->vp_p - stats->vp_n;
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%+ld</SPAN></td><td nowrap class=\"t1\"> varzspont sszesen.</td></tr>\r\n", csata_vp);
		    output(fordulo,"<tr><td nowrap class=\"t1\" colspan=2> &nbsp;</td></tr>\r\n");
		}
	    }

	    // PP valtozas
	    if (aconf_get_curr("korvege_csata_pp_stat") == 1)
	    {
		if(stats->pszi_p != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> pszi pontot szereztl.</td></tr>\r\n", stats->pszi_p);
		}
		if(stats->kontakt_pp != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> pszi pontot direkt kontaktus I-gyel kaptl.</td></tr>\r\n", stats->kontakt_pp);
		}
		if(stats->pszi_n != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> pszi pontot szvtak el tled.</td></tr>\r\n", stats->pszi_n);
		}
		if(stats->pszi_p != 0 || stats->pszi_n != 0 || stats->kontakt_pp != 0)
		{
		    csata_pp = stats->pszi_p + stats->kontakt_pp - stats->pszi_n;
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%+ld</SPAN></td><td nowrap class=\"t1\"> pszi pont sszesen.</td></tr>\r\n", csata_pp);
		    output(fordulo,"<tr><td nowrap class=\"t1\" colspan=2> &nbsp;</td></tr>\r\n");
		}
	    }

	    // Tu valtozas
	    if (aconf_get_curr("korvege_csata_tu_stat") == 1)
	    {
		if(stats->tu_n != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> TU-t szvtak el tled.</td></tr>\r\n", stats->tu_n);
		    output(fordulo,"<tr><td nowrap class=\"t1\" colspan=2> &nbsp;</td></tr>\r\n");
		}
	    }
    
	    // TVP valtozas
	    if (aconf_get_curr("korvege_csata_tvp_stat") == 1)
	    {
		if(stats->tvp_n != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> TVP-t szvtak el tled.</td></tr>\r\n", stats->tvp_n);
		    output(fordulo,"<tr><td nowrap class=\"t1\" colspan=2> &nbsp;</td></tr>\r\n");
		}
	    }
    
	    // Oregedes
	    if (aconf_get_curr("korvege_csata_oregedes_stat") == 1)
	    {
		if(stats->oregedes_csata != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> vet regedtl.</td></tr>\r\n", stats->oregedes_csata);
		    output(fordulo,"<tr><td nowrap class=\"t1\" colspan=2> &nbsp;</td></tr>\r\n");
		}
	    }
	    // Papi rang
	    if (aconf_get_curr("korvege_csata_papirang_stat") == 1)
	    {
		if(stats->papirang_csata != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> hitet vesztettl.</td></tr>\r\n", stats->papirang_csata);
		    output(fordulo,"<tr><td nowrap class=\"t1\" colspan=2> &nbsp;</td></tr>\r\n");
		}
	    }
	}

	kiir = (stats->ep_stat_p) != 0 || (stats->feltamadas) || (stats->dem) || (csata_gyogyulas != 0) || (stats->morgan_stat != 0) || (stats->sebzodes_utes != 0) || (stats->sebzodes_egyeb != 0) || (stats->kurt_stat_ep != 0) || (stats->ladiko_ep != 0) || (stats->ep_stat_n != 0);
	kiir = kiir || stats->vp_stat_p || stats->vp_stat_n || stats->kurt_stat_vp || stats->vp_fno || stats->vp_manakristaly || stats->vp_varazsko || csata_vp || stats->vp_koltes;
	kiir = kiir || stats->pszi_stat_p || stats->pszi_stat_n || csata_pp || stats->pszi_koltes || stats->tu_koltes || stats->tu_stat_p || stats->tu_stat_n || stats->tu_n || stats->tvp_stat_p || stats->tvp_stat_n || stats->tvp_koltes || stats->tvp_kapas || (stats->tvp_n != 0) || (stats->ladiko_ap != 0);
	if (eroforras_kiir && kiir)
	{
	    // Eroforras valtozasok
	    output(fordulo,"<tr><td nowrap class=\"c3\" colspan=2>Erforrs vltozsok a fordulban</td></tr>\r\n");

	    // Eletpont valtozas
	    if (aconf_get_curr("korvege_eroforras_ep_stat") == 1)
	    {
		if (csata_gyogyulas != 0)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> letpontot a csatkban gygyultl.</td></tr>\r\n", csata_gyogyulas);
		}
		if (stats->morgan_stat != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> letpontot Morgan szilnkkal kaptl (a csatkon kivl elltt varzslatokra).</td></tr>\r\n", stats->morgan_stat);
		}
		if (stats->ep_stat_p != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> letpontot valamilyen egyb mdon szereztl. (kr elejei regen, gygyts, spell, targy, stb.)</td></tr>\r\n", stats->ep_stat_p);
		}
		if (stats->dem != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> letpontot demezskor kaptl.</td></tr>\r\n", stats->dem);
		}
		if (stats->feltamadas != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> letpontot feltmadsbl/hallkapubl kaptl.</td></tr>\r\n", stats->feltamadas);
		}
		if ((stats->sebzodes_utes != 0) || (stats->sebzodes_egyeb != 0))
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> letpontot a csatkban sebzdtl.</td></tr>\r\n", stats->sebzodes_utes + stats->sebzodes_egyeb);
		}
		if (stats->kurt_stat_ep != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> letpontot Ezstmgus krttel vesztettl.</td></tr>\r\n", stats->kurt_stat_ep);
		}
		if (stats->ladiko_ep != 0)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> letpontot az aranyterm ldiktl sebzdtl.</td></tr>\r\n", stats->ladiko_ep);
		}
		if (stats->ep_stat_n != 0)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> letpontot sebzdtl egyb mdon. (csapdk, hezs, stb.)</td></tr>\r\n", stats->ep_stat_n);
		}
		if ((stats->ep_stat_p) != 0 || (stats->feltamadas) || (stats->dem) || (csata_gyogyulas != 0) || (stats->morgan_stat != 0) || (stats->sebzodes_utes != 0) || (stats->sebzodes_egyeb != 0) || (stats->kurt_stat_ep != 0) || (stats->ladiko_ep != 0) || (stats->ep_stat_n != 0))
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%+ld</SPAN></td><td nowrap class=\"t1\"> letpontot sszesen.</td></tr>\r\n", stats->ep_stat_p + stats->dem + stats->feltamadas + csata_gyogyulas + stats->morgan_stat - stats->sebzodes_utes - stats->sebzodes_egyeb - stats->kurt_stat_ep - stats->ladiko_ep - stats->ep_stat_n);
		    output(fordulo,"<tr><td nowrap class=\"t1\" colspan=2> &nbsp;</td></tr>\r\n");
		}
	    }
        
	    // VP valtozas
	    if (aconf_get_curr("korvege_eroforras_vp_stat") == 1)
	    {
		// Manakristaly
		if(stats->vp_manakristaly != 0)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> varzspontot nyertl ki manakristlybl.</td></tr>\r\n", stats->vp_manakristaly);
		}
		// Varazsko
		if(stats->vp_varazsko != 0)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> varzspontot kaptl varzskbl.</td></tr>\r\n", stats->vp_varazsko);
		}
		// Kurt
		if(stats->kurt_stat_ep && stats->kurt_stat_vp) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> varzspontot Ezstmgus krttel krtltl.</td></tr>\r\n", stats->kurt_stat_vp);
		}
		// VP regen kepesseg
		if(stats->vp_fno) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> varzspontot kaptl FNO pontbl szerezhet VP regenercival.</td></tr>\r\n", stats->vp_fno);
		}
		if(stats->vp_stat_p != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> varzspontot regenerltl, vagy szereztl egyb mdon. (kr elejei regenbl, IMbl, TU-bl, stb.)</td></tr>\r\n", stats->vp_stat_p);
		}
		// Csatabol
		if(csata_vp != 0)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%+ld</SPAN></td><td nowrap class=\"t1\"> varzspontot csatkban szereztl/vesztettl.</td></tr>\r\n", csata_vp);
		}
		if(stats->vp_koltes != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> varzspontot kltttl. (V, VV paranccsal)</td></tr>\r\n", stats->vp_koltes);
		}
		if(stats->vp_stat_n != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> varzspontot vesztettl. (idcsere, vp sziv csapda, mgiafal stb.)</td></tr>\r\n", stats->vp_stat_n);
		}
		if(stats->vp_stat_p || stats->vp_stat_n || stats->kurt_stat_vp || stats->vp_fno || stats->vp_manakristaly || stats->vp_varazsko || csata_vp || stats->vp_koltes)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%+ld</SPAN></td><td nowrap class=\"t1\"> varzspont sszesen. (Ebbl klthetsz harci tmad/vdekez varzslatokra)</td></tr>\r\n", stats->vp_stat_p - stats->vp_stat_n +  stats->kurt_stat_vp + stats->vp_fno + stats->vp_manakristaly + stats->vp_varazsko + csata_vp - stats->vp_koltes);
		    output(fordulo,"<tr><td nowrap class=\"t1\" colspan=2> &nbsp;</td></tr>\r\n");
		}
	    }
    
	    // Pszi pont valtozas
	    if (aconf_get_curr("korvege_eroforras_pp_stat") == 1)
	    {
		if(stats->pszi_stat_p != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> pszi pontot kaptl. (kr elejei regen, stb.)</td></tr>\r\n", stats->pszi_stat_p);
		}
		if(stats->pszi_koltes != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> pszi pontot kltttl. (P, VV paranccsal)</td></tr>\r\n", stats->pszi_koltes);
		}
		if(csata_pp  != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%+ld</SPAN></td><td nowrap class=\"t1\"> pszi pontot csatkban szereztl/vesztettl.</td></tr>\r\n", csata_pp);
		}
		if(stats->pszi_stat_n != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> pszi pontot vesztettl. (pl. poszog msze, stb.)</td></tr>\r\n", stats->pszi_stat_n);
		}
		if(stats->pszi_stat_p || stats->pszi_stat_n || csata_pp || stats->pszi_koltes) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%+ld</SPAN></td><td nowrap class=\"t1\"> pszi pont sszesen.</td></tr>\r\n", stats->pszi_stat_p - stats->pszi_stat_n + csata_pp - stats->pszi_koltes);
		    output(fordulo,"<tr><td nowrap class=\"t1\" colspan=2> &nbsp;</td></tr>\r\n");
		}
	    } 
   
	    // TU valtozas
	    if (aconf_get_curr("korvege_eroforras_tu_stat") == 1)
	    {
		if(stats->tu_stat_p != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> TU-t kaptl/llitottl el.</td></tr>\r\n", stats->tu_stat_p);
		}
		if(stats->tu_koltes != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> TU-t hasznltl fel.</td></tr>\r\n", stats->tu_koltes);
		}
		if(stats->tu_stat_n != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> TU-t vesztettl.</td></tr>\r\n", stats->tu_stat_n);
		}
		if(stats->tu_n != 0 || stats->tu_p != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%+ld</SPAN></td><td nowrap class=\"t1\"> TU-t csatkban szereztl/vesztettl.</td></tr>\r\n", stats->tu_p - stats->tu_n);
		}
		if(stats->tu_stat_p || stats->tu_stat_n || stats->tu_n || stats->tu_koltes)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%+ld</SPAN></td><td nowrap class=\"t1\"> TU sszesen.</td></tr>\r\n", stats->tu_stat_p - stats->tu_stat_n + stats->tu_p - stats->tu_n - stats->tu_koltes);
		    output(fordulo,"<tr><td nowrap class=\"t1\" colspan=2> &nbsp;</td></tr>\r\n");
		}
	    }

	    // TVP valtozas
	    if (aconf_get_curr("korvege_eroforras_tvp_stat") == 1)
	    {
		if(stats->tvp_kapas != 0)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> TVP-t kaptal.</td></tr>", stats->tvp_kapas);
		}
		if(stats->tvp_stat_p != 0)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> TVP-t egyb forrsbl szereztl. (sfrnyporbl, TU-bl, idcserbl stb.)</td></tr>", stats->tvp_stat_p);
		}
		if(stats->tvp_p != 0)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> TVP-t nyertl a csatakban.</td></tr>", stats->tvp_p);
		}
		if(stats->tvp_koltes != 0)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> TVP-t kltttl.</td></tr>", stats->tvp_koltes);
		}
		if(stats->tvp_stat_n != 0)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> TVP-t vesztettl a csatkon kivl.</td></tr>", stats->tvp_stat_n);
		}
		if(stats->tvp_n != 0)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> TVP-t vesztettl a csatakban.</td></tr>", stats->tvp_n);
		}
		if(stats->tvp_kapas - stats->tvp_koltes + stats->tvp_stat_p - stats->tvp_stat_n + stats->tvp_p - stats->tvp_n)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%+ld</SPAN></td><td nowrap class=\"t1\"> TVP sszesen.</td></tr>\r\n", stats->tvp_kapas - stats->tvp_koltes + stats->tvp_stat_p - stats->tvp_stat_n + stats->tvp_p - stats->tvp_n);
		}
		if(stats->tvp_koltes || stats->tvp_kapas || stats->tvp_stat_p || stats->tvp_stat_n || stats->tvp_p || stats->tvp_n)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" colspan=2> &nbsp;</td></tr>\r\n");
		}
	    }
	    
	    // Arany valtozas, ladiko
	    if (aconf_get_curr("korvege_eroforras_ladiko_stat") == 1)
	    {
		if (stats->ladiko_ap != 0)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> aranyat kaptl az aranyterm ldikba doblt trgyakrt</tr>", stats->ladiko_ap);
		    output(fordulo,"<tr><td nowrap class=\"t1\" colspan=2> &nbsp;</td></tr>\r\n");
		}
	    }
	}

	kiir = stats->ero || stats->iq || stats->ugyesseg || stats->egeszseg || stats->szerencse;
	kiir = kiir || stats->ep_max_p || stats->vp_max_p || stats->pszi_max_p || stats->tu_max_p || stats->ep_max_n || stats->vp_max_n || stats->pszi_max_n || stats->tu_max_n;
	kiir = kiir || stats->papirang_stat_p || stats->papirang_stat_n || stats->oregedes_stat || stats->fiatalodas_stat || stats->oregedes_csata || stats->jellem_stat_p || stats->jellem_csata_p || stats->jellem_stat_n || stats->jellem_csata_n;
	if (permanens_kiir && kiir)
	{
	    // Permanens valtozasok
	    output(fordulo,"<tr><td nowrap class=\"c3\" colspan=2>Permanens vltozsok a fordulban</td></tr>\r\n");

	    // Instabil
	    if ((aconf_get_curr("korvege_permanens_instabil_stat") == 1) || (aconf_get_curr("korvege_permanens_tulajdonsag_stat") == 1))
	    {
		if (stats->ero != 0)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%+ld</SPAN></td><td nowrap class=\"t1\"> er</td></tr>\r\n", stats->ero);
		}
		if (stats->iq != 0)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%+ld</SPAN></td><td nowrap class=\"t1\"> IQ</td></tr>\r\n", stats->iq);
		}
		if (stats->ugyesseg != 0)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%+ld</SPAN></td><td nowrap class=\"t1\"> gyessg</td></tr>\r\n", stats->ugyesseg);
		}
		if (stats->egeszseg != 0)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%+ld</SPAN></td><td nowrap class=\"t1\"> egszsg</td></tr>\r\n", stats->egeszseg);
		}
		if (stats->szerencse != 0)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%+ld</SPAN></td><td nowrap class=\"t1\"> szerencse</td></tr>\r\n", stats->szerencse);
		}
		if (stats->ero || stats->iq || stats->ugyesseg || stats->egeszseg || stats->szerencse)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" colspan=2> &nbsp;</td></tr>\r\n");
		}
	    }
    
	    // Max. valtozasok
	    if (aconf_get_curr("korvege_permanens_max_stat") == 1)
	    {
		if(stats->ep_max_p != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> max.p-t kaptl.</td></tr>\r\n", stats->ep_max_p);
		}
		if(stats->ep_max_n != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"szenved\">%ld</SPAN></td><td nowrap class=\"t1\"> max.p-t vesztettl.</td></tr>\r\n", stats->ep_max_n);
		}
		if(stats->vp_max_p != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> max.vp-t kaptl.</td></tr>\r\n", stats->vp_max_p);
		}
		if(stats->vp_max_n != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"szenved\">%ld</SPAN></td><td nowrap class=\"t1\"> max.vp-t vesztettl.</td></tr>\r\n", stats->vp_max_n);
		}
		if(stats->pszi_max_p != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> max.pszi-t kaptl.</td></tr>\r\n", stats->pszi_max_p);
		}
		if(stats->pszi_max_n != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"szenved\">%ld</SPAN></td><td nowrap class=\"t1\"> max.pszi-t vesztettl.</td></tr>\r\n", stats->pszi_max_n);
		}
		if(stats->tu_max_p != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> max.tu-t kaptl.</td></tr>\r\n", stats->tu_max_p);
		}
		if(stats->tu_max_n != 0)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"szenved\">%ld</SPAN></td><td nowrap class=\"t1\"> max.tu-t vesztettl.</td></tr>\r\n", stats->tu_max_n);
		}
		if (stats->ep_max_p || stats->vp_max_p || stats->pszi_max_p || stats->tu_max_p || stats->ep_max_n || stats->vp_max_n || stats->pszi_max_n || stats->tu_max_n)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" colspan=2> &nbsp;</td></tr>\r\n");
		}
	    }
    
	    // Oregedes csatan kivul
	    if (aconf_get_curr("korvege_permanens_oregedes_stat") == 1)
	    {
		if(stats->oregedes_stat != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> vet regedtl. (VV, valamilyen varazslat pl. kisebb kivnsg, stb.)</td></tr>\r\n", stats->oregedes_stat);
		}
		if(stats->oregedes_csata != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> vet regedtl a csatkban. (frgls, szrny regit, stb.)</td></tr>\r\n", stats->oregedes_csata);
		}
		if(stats->oregedes_stat || stats->oregedes_csata)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%+ld</SPAN></td><td nowrap class=\"t1\"> v regeds sszesen.</td></tr>\r\n", stats->oregedes_stat + stats->oregedes_csata);
		    output(fordulo,"<tr><td nowrap class=\"t1\" colspan=2> &nbsp;</td></tr>\r\n");
		}
		if(stats->fiatalodas_stat != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> vet fiatalodtl. (varzslat, ital)</td></tr>\r\n", stats->fiatalodas_stat);
		    output(fordulo,"<tr><td nowrap class=\"t1\" colspan=2> &nbsp;</td></tr>\r\n");
		}
	    }
    
	    // Papi rang csatan kivul
	    if (aconf_get_curr("korvege_permanens_papirang_stat") == 1)
	    {
		if(stats->papirang_stat_p != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> hitet szereztl a csatkon kvl.</td></tr>\r\n", stats->papirang_stat_p);
		}
		if(stats->papirang_stat_n != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> hitet vesztetettl a csatkon kvl. (stt kasza, valamilyen varazslat pl. avatar idzs, stb.)</td></tr>\r\n", stats->papirang_stat_n);
		}
		if(stats->papirang_csata != 0) 
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> hitet vesztettl a csatkban.</td></tr>\r\n", stats->papirang_csata);
		}
		if(stats->papirang_stat_p || stats->papirang_stat_n || stats->papirang_csata)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%+ld</SPAN></td><td nowrap class=\"t1\"> hitpont sszesen.</td></tr>\r\n", stats->papirang_stat_p - (stats->papirang_stat_n + stats->papirang_csata));
		    output(fordulo,"<tr><td nowrap class=\"t1\" colspan=2> &nbsp;</td></tr>\r\n");
		}
	    }
    
	    // Jellem
	    if (aconf_get_curr("korvege_permanens_jellem_stat") == 1)
	    {
		if(stats->jellem_stat_p != 0)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> jsgot kaptl a csatkon kivl. (jellemproba, aranypikkely, kufr meglse, stb.)</td></tr>\r\n", stats->jellem_stat_p);
		}
		if(stats->jellem_csata_p != 0)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> jsgot kaptl a csatkban. (gyntats, purifikls, stb.)</td></tr>\r\n", stats->jellem_csata_p);
		}
		if(stats->jellem_stat_n != 0)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> gonoszsgot kaptl. (jellemprba, stt tekercs, trikornis meglse, stb.)</td></tr>\r\n", stats->jellem_stat_n);
		}
		if(stats->jellem_csata_n != 0)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" width=5%% align=right><SPAN CLASS=\"plusminus\">%ld</SPAN></td><td nowrap class=\"t1\"> gonoszsgot kaptl a csatkban. (purifikls, stb.)</td></tr>\r\n", stats->jellem_csata_n);
		}
		if (stats->jellem_stat_p || stats->jellem_csata_p || stats->jellem_stat_n || stats->jellem_csata_n)
		{
		    output(fordulo,"<tr><td nowrap class=\"t1\" colspan=2> &nbsp;</td></tr>\r\n");
		}
	    }
	}
    
	output(fordulo,"</table>\r\n</td></tr>\r\n</table><br><br>\r\n");
    }
}

extern int varazslathasznalat_kiir(t_fordulo * fordulo, int mode)
{
        int h[10];
	int b;
	int i;
	int oszlopok_szama = 3;
	t_karakter_spelllist * karakter_spelllist_elem;
    	t_spell * spell;
	long count;
	long curr;
	long value;
	
        memset(h, 0 , sizeof(h));
	i = 0;
	
	output(fordulo,"<P><TABLE WIDTH=100%% CELLPADDING=1 CELLSPACING=0 BORDER=0 CLASS=\"t0\"><TR><TD><TABLE WIDTH=100%% CELLPADDING=2 CELLSPACING=0 BORDER=0 CLASS=\"t1\"><TR><TD CLASS=\"c1\" colspan=%d>%s</TD></TR>\r\n", oszlopok_szama*3+1, (mode==1?cimsor_spell[1]:cimsor_spell[0]));
	if (mode == 1)
	{
	    output(fordulo, "<TR><TD CLASS=\"c1\" colspan=%d><font class=klap style=\"FONT-WEIGHT: normal;\">", oszlopok_szama*3+1);
	    cache_header_fordulok_kiir(fordulo, fordulo->cache, cache_type_spell);
	    output(fordulo,"<font></TD></TR>\r\n");
	}

	for (karakter_spelllist_elem = get_karakter_spelllist_head(fordulo->karakter, 0); karakter_spelllist_elem;  karakter_spelllist_elem = karakter_spelllist_elem->next)
	{
	    if (!(spell = karakter_spelllist_elem->spell))
	    {
		continue;
	    }
	    
		if (spell->type & spell_type_teo)
		{
		    b = 0;
		}
		else if (spell->type & spell_type_tau)
		{
		    b = 1;
		}
		else if (spell->type & spell_type_osteo)
		{
		    b = 2;
		}
		else if (spell->type & spell_type_ostau)
		{
		    b = 3;
		}
		else if (spell->type & spell_type_pszi)
		{
		    b = 4;
		}
		else if (spell->type & spell_type_avk)
		{
		    b = 5;
		}
		else
		{
		    continue;
		}
		
	    cache_check_spell(fordulo, fordulo->cache, spell->ssz, &count, &curr);
	    if (mode == 1)
	    {
		value = count;
	    }
	    else
	    {
		value = curr;
	    }
	    
	    if (value == 0)
	    {
		continue;
	    }
	    
	    if (!h[b])	
	    {
        	output(fordulo,"<tr><td nowrap class=\"c3\" colspan=%d> %s </td></tr>\r\n", oszlopok_szama*3+1, get_spelltipus_neve(b));
		h[b] = 1;
		i = 0;
	    }
	    else
	    {
		i++;
	    }
	    
	    if (i%oszlopok_szama == 0)
	    {
		output(fordulo,"<TR><TD CLASS=\"t1\" WIDTH=5%%>&nbsp;</TD>");
	    }
	    
	    // neve + sorszam
	    if (aconf_get_curr("hyperlink_spell") == 1)
	    {
	        output(fordulo,"<TD CLASS=\"t1\" NOWRAP> %s (#<a  class=n href=\"%svari_enc.php%sf=venc&ssz=%d%s\" target=hyper title=\"Encyclopedia (Web Hyper)\">%d</a>):</TD>", spell->nev, bconf_get_webhyper(), (aconf_get_webhyper_offline()?"@":"?"), spell->ssz, (aconf_get_webhyper_offline()?".htm":""), spell->ssz);
	    }
	    else
	    {
	        output(fordulo,"<TD CLASS=\"t1\" NOWRAP> %s (#%d):</TD>",  spell->nev, spell->ssz);
	    }
	    
	    output(fordulo, "<TD CLASS=\"t1\" WIDTH=1%% ALIGN=right> %ld </TD><TD WIDTH=%d%%>&nbsp;</TD>", value, (95/oszlopok_szama-10));
	    
	    if (i%oszlopok_szama == oszlopok_szama-1)
	    {
		output(fordulo,"</TR>\r\n");
	    }
	}
	output(fordulo,"</table>\r\n</td></tr>\r\n</table><br><br>\r\n");
}
void reformat_korvege(t_fordulo * fordulo, char * buf)
{
    int i;
    int n;
    long * ll;
    char * p1;
    char * p2;
    t_fordulo * fordulo_elozo = NULL;
    
    referencia_check(fordulo);
    spellek_spelllista_check(fordulo);
    reformat_karlap_tulajdonsag_check(fordulo);
    targyak_targylista_check(fordulo);
    
    if ((p1 = strstr2(buf, "kvetkez krre")) && (p2 = strstr2(p1, "pontot vihetsz t.")))
    {
	p1 = skip_space(p1);
	fordulo->osszesen.tvp_kapas -= atoi(p1);
	if (0 != (fordulo->osszesen.tvp_kapas - fordulo->osszesen.tvp_koltes + fordulo->osszesen.tvp_stat_p - fordulo->osszesen.tvp_stat_n - fordulo->osszesen.tvp_n))
	{
#ifdef DEBUG
	    debug(fordulo, "reformat_korvege: nem stimmel a tvp egyenleg!\n");
#endif
/*
	    i = get_cache_mode();
	    set_cache_mode(0);
	    kiir(NULL, "|TVP:%d|", fordulo->fsz);
	    set_cache_mode(i);
*/
	}
    }
    
    if (fordulo->tipus != fordulo_tipus_olimpia)
    {
	t_forras * forras = NULL;
	char * filename;
	char * file = NULL;
	char * dir = NULL;
	int type;
	
	for (type = 1; filename = elozofordulo_neve(fordulo, type); type++)
	{
	    if (!(fordulo->forras->name && strstr(fordulo->forras->name, filename)))
	    {
		dir = elozofordulo_dir(fordulo, type);
		if (file = get_filename(dir, filename))
		{
		    if (forras = forras_create(file, forras_type_file))
		    {
			if (fordulo_elozo = fordulo_load_elozo(forras))
			{
			    free(file);
			    free(filename);
			    if (dir)
			    {
				free(dir);
			    }
			    break;
			}
			forras_destroy(forras);
			forras = NULL;
		    }
		    free(file);
		}
	    }
	    if (filename)
	    {
		free(filename);
		filename = NULL;
	    }
	    if (dir)
	    {
		free(dir);
		dir = NULL;
	    }
	}
		
	if (fordulo_elozo && fordulo_elozo->karakter)
	{
	    reformat_karlap_tulajdonsag_check(fordulo_elozo);
	    if ((aconf_get_curr("karlap_targy_valtozas_kiiras") == 1))
	    {
		targyak_targylista_check(fordulo_elozo);
		karakter_targylista_valtozas_check(fordulo->karakter, fordulo_elozo->karakter);
	    }
	    
	    n = fordulo_elozo->karakter->tulajdonsagok.tu - fordulo->karakter->tulajdonsagok.tu + fordulo->osszesen.tu_stat_p - fordulo->osszesen.tu_stat_n + fordulo->osszesen.tu_p - fordulo->osszesen.tu_n - fordulo->osszesen.tu_koltes;
	    if (0 != n)
	    {
#ifdef DEBUG
		debug(fordulo, "reformat_korvege: nem stimmel a tu egyenleg! n=%d\n", n);
#endif
/*
		i = get_cache_mode();
		set_cache_mode(0);
		kiir(NULL, "|TU:%d{%d}|", fordulo->fsz, n);
		set_cache_mode(i);
*/
	    }
	    
	    fordulo_unload(fordulo_elozo);
	    fordulo_elozo = NULL;
	}
	if (forras)
	{
	    forras_destroy(forras);
	    forras = NULL;
	}
    }
    
    ll = (long *)&fordulo->osszesen.sebzes_utes;
    for (i = 0; &ll[i] <= &fordulo->osszesen.egyeb_n; i++)
    {
	if (ll[i])
	{
	    cache_add_stat_value(fordulo->cache, i+1, ll[i]);
	}
    }

    if (fordulo_elozo)
    {
	fordulo_unload(fordulo_elozo);
	fordulo_elozo = NULL;
    }
    
    if (get_cache_mode())
    {
	return;
    }
    
    if (strlen(buf))
    {
#ifdef DEBUG
	output(fordulo, "---> korvege start<---\r\n%s---> korvege end<---\r\n", buf);
#else
	output(fordulo, "%s", buf);
#endif
    }

    output(fordulo,"</B><BR><BR>\r\n");
    
    if (aconf_get_curr("korvege_figyelmeztetes_kiiras") == 1)
    {
	figyelmeztetes_kiir(fordulo);
    }
    
    stats_kiir(fordulo, 0);
    
    if (aconf_get_curr("korvege_spell_hasznalat_kiiras") == 1)
    {
	varazslathasznalat_kiir(fordulo, 0);
    }
    
    if (aconf_get_curr("korvege_kalandozocsata_kiiras") == 1)
    {
	kalandozocsata_kiir(fordulo);
    }
    if (aconf_get_curr("korvege_psziernyo_kiiras") == 1)
    {
	psziernyo_kiir(fordulo);
    }
    if (aconf_get_curr("korvege_mezo_kiiras") == 1)
    {
	mezo_kiir(fordulo);
    }
}

void reformat_terkep(t_fordulo * fordulo, char * buf)
{
    int i;
    long * ll;
    
    if (get_cache_mode())
    {
	return;
    }
    
    if (strlen(buf))
    {
#ifdef DEBUG
	output(fordulo, "---> terkep start<---\r\n%s---> terkep end<---\r\n", buf);
#else
	output(fordulo, "%s", buf);
#endif
    }
    if (aconf_get_curr("fullstats_kiiras_stat") == 1)
    {
	stats_kiir(fordulo, 1);
    }
    if (aconf_get_curr("fullstats_kiiras_varazslat") == 1)
    {
	varazslathasznalat_kiir(fordulo, 1);;
    }
}
