/*
 * Copyright (C) 2003  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#define FORDULO_INTERNAL_ACCESS
#include "include.h"
#include "fordulo.h"
#include "karakter.h"
#include "input.h"
#include "conf.h"
#include "psziernyo.h"

static t_fordulo * p_fordulo = NULL;

int fordulo_set_pointers(t_fordulo * fordulo)
{
    char * p1 = NULL;
    char * p2 = NULL;
    char * p3 = NULL;
    char * p4 = NULL;
    char ** px;
    int pszakasz;
    int parancs;
    char * parancs_l = NULL;
    char * parancs_str;
    char * karlap_str;
    t_maradektvp_parancs * maradektvp_parancs = NULL;
    t_maradektvp_parancs * maradektvp_parancs_elozo = NULL;
    
	    if (fordulo->tipus == fordulo_tipus_olimpia && (p1 = strstr(fordulo->fejlec, "</h2></center>\r\n<br>\r\n")))
	    {
		fordulo->taborozas = p1 + strlen("</h2></center>\r\n<br>\r\n");
#ifdef DEBUG
		debug(fordulo, "fordulo_set_pointers olimpia %p\n",fordulo->taborozas);
#endif
	    }
	    else if (p1 = strstr(fordulo->fejlec, "</h2></center>\r\n<BR>\r\n"))
	    {
		fordulo->taborozas = p1 + strlen("</h2></center>\r\n<BR>\r\n");
#ifdef DEBUG
		debug(fordulo, "fordulo_set_pointers taborozas %p\n",fordulo->taborozas);
#endif
	    }
	    else
	    {
		p1 = fordulo->fejlec;
	    }
#ifdef DEBUG
	    debug(fordulo, "fordulo_set_pointers 1\n");
#endif
	    p3 = p1;
	    if (p2 = strstr_(p1, "Tbb pontod maradt, mint amennyit a kvetkez krre t tudsz vinni. Ebbl automatikusan gygytasz / gyakorolsz / lelmet szerzel.", NULL))
	    {
		fordulo->maradektvp = p2;
		p3 = p2;
	    }
	    
	    if (p2 = strstr_(p3,"<BR><B>Ebben a krben", NULL))
	    {
		fordulo->korvege_tvp = p2;
		p3 = fordulo->korvege_tvp;
	    }
	    else if (p2 = strstr_(p3,"<b>\r\nEbben a krben", NULL))
	    {
		fordulo->korvege_tvp = p2;
		p3 = fordulo->korvege_tvp;
	    }
	    
#ifdef DEBUG
	    debug(fordulo, "fordulo_set_pointers korvege_tvp %p\n",fordulo->korvege_tvp);
	    debug(fordulo, "fordulo_set_pointers 2\n");
#endif
	    for ( pszakasz = 1, parancs = 1; (fordulo->tipus == fordulo_tipus_olimpia) && p1 && (p2 = strstr(p1,"<p><center><h2>")); parancs++)
	    {
		if ((p3 = strstr(p2,"SVJCI RENDSZER")) && (p3 < strstr(p2,"</h2></center>")))
		{
		    fordulo->maradektvp = p2;
#ifdef DEBUG
		    debug(fordulo, "fordulo_set_pointers svajci rendszer: %p\n", p2);
#endif
		    p1 = p2 + 1;
		    continue;
		}
		if ((p3 = strstr(p2,"EREDMNYHIRDETS")) && (p3 < strstr(p2,"</h2></center>")))
		{
		    fordulo->korvege_tvp = p2;
#ifdef DEBUG
		    debug(fordulo, "fordulo_set_pointers eredmenyhirdetes: %p\n", p2);
#endif
		    break;
		}
#ifdef DEBUG
		debug(fordulo, "fordulo_set_pointers versenyszamok [%d/%d]: %p\n", pszakasz, parancs, p2);
#endif
		fordulo->parancs[parancs - 1] = p2;
		p1 = p2 + 1;
	    }
	    
	    parancs_str = NULL;
	    if (strstr(p1, "<BR><TABLE CELLPADDING=0 CELLSPACING=0><TR><TD CLASS=\"p\" WIDTH=170>"))
	    {
		parancs_str = "<BR><TABLE CELLPADDING=0 CELLSPACING=0><TR><TD CLASS=\"p\" WIDTH=170>";
	    }
	    else if (strstr(p1, "<BR><TABLE WIDTH=100% CELLPADDING=0 CELLSPACING=0><TR><TD CLASS=\"p\" WIDTH=170>"))
	    {
		parancs_str = "<BR><TABLE WIDTH=100% CELLPADDING=0 CELLSPACING=0><TR><TD CLASS=\"p\" WIDTH=170>";
	    }
	    
	    for ( pszakasz = 0, parancs = 1; parancs_str && (fordulo->tipus & (fordulo_tipus_kft_uj|fordulo_tipus_reformat_kws)) && p1 && (p2 = strstr(p1, parancs_str)) && (p2 < fordulo->korvege_tvp); parancs++)
	    {
		p3 = p2 + strlen(parancs_str);
#ifdef DEBUG
		debug(fordulo, "fordulo_set_pointers parancsok [%d/%d]: %p -> \"%.100s\"\n", pszakasz, parancs, p2, p3);
#endif
		if (p3[0] == '*')
		{
		    if (pszakasz == 0)
		    {
			if (parancs > 10)
			{
			    kiir(fordulo, "ERROR: parancs beolvasasi hiba, 10nel tobb kezdeti parancs\r\n");
			    return -1;
			}
			fordulo->kezdeti[parancs - 1] = p2;
		    }
		    if (pszakasz == 1)
		    {
			pszakasz++;
			parancs = 1;
		    }
		    if (pszakasz == 2)
		    {
			if (parancs > 10)
			{
			    kiir(fordulo, "ERROR: parancs beolvasasi hiba, 10nel tobb befejezo parancs\r\n");
			    return -1;
			}
			fordulo->befejezo[parancs - 1] = p2;
		    }
		}
		else
		{
		    if (pszakasz == 0)
		    {
			pszakasz++;
			parancs = 1;
		    }
		    if (pszakasz == 1)
		    {
			if (parancs > 40)
			{
			    pszakasz = 2;
			}
			else
			{
			    fordulo->parancs[parancs - 1] = p2;
			}
		    }
		    if (pszakasz == 2)
		    {
			if (!fordulo->maradektvp)
			{
			    fordulo->maradektvp = p2;
			}
			if (fordulo->maradektvp && (p2 >= fordulo->maradektvp))
			{
			    if (maradektvp_parancs = malloc(sizeof(t_maradektvp_parancs)))
			    {
				maradektvp_parancs->parancs = p2;
				maradektvp_parancs->next = NULL;
				if (!fordulo->maradektvp_parancs)
				{
				    fordulo->maradektvp_parancs = maradektvp_parancs;
				}
				if (maradektvp_parancs_elozo)
				{
				    maradektvp_parancs_elozo->next = maradektvp_parancs;
				}
				maradektvp_parancs_elozo = maradektvp_parancs;
			    }
			}
		    }
		}
		p1 = p3 + 1;
	    }
#ifdef DEBUG
	    debug(fordulo, "fordulo_set_pointers 3 p1=%p, \"%.1000s\"\n", p1, p1);
#endif
	    if (!p1)
	    {
		p1 = fordulo->fejlec;
	    }
	    for (p3 = p1; (p2 = strstr2_(p3, "pontot hasznltl fel, van mg", NULL)) && (p3 = strstr2(p2, "]</SPAN>")) && (p3 < fordulo->korvege_tvp); )
	    {
		fordulo->korvege = p3;
	    }
	    if (!fordulo->korvege && (p1 != fordulo->fejlec) && (p3 = strstr(p1, "visszadtumozs krelem")) && (p3 = strstr2(p3, "</TD></TR></TABLE>")) && (p3 < fordulo->korvege_tvp))
	    {
		fordulo->korvege = p3;
	    }
#ifdef DEBUG
	    debug(fordulo, "fordulo_set_pointers korvege %p \"%.100s\"\n", fordulo->korvege, fordulo->korvege);
#endif
	    p2 = p1;
	    for (p3 = p1; (p2 = strstr(p3,"<P><TABLE WIDTH=100% CELLPADDING=1 CELLSPACING=0 BORDER=0 CLASS=\"t0\">")) && (p3 = strstr(p2, "</"));)
	    {
		if ((p4 = strstr(p2,"NEKIK RHATSZ")) && (p4 < p3))
		{
		    fordulo->nekikirhatsz = p2;
#ifdef DEBUG
		    debug(fordulo, "fordulo_set_pointers nekikirhatsz %p\n",fordulo->nekikirhatsz);
#endif
		}
		else if ((p4 = strstr(p2,"ENCYCLOPEDIA FANTASIA")) && (p4 < p3))
		{
		    fordulo->encek = p2;
#ifdef DEBUG
		    debug(fordulo, "fordulo_set_pointers encek %p\n",fordulo->encek);
#endif
		}
		else if ((p4 = strstr(p2,"E krben tett lpseid trkpe")) && (p4 < p3))
		{
		    fordulo->terkep = p2;
#ifdef DEBUG
		    debug(fordulo, "fordulo_set_pointers terkep %p\n",fordulo->terkep);
#endif
		}
		else if ((p4 = strstr(p2,". Kt)")) && (p4 < p3))
		{
		    fordulo->ktjelentes = p2;
#ifdef DEBUG
		    debug(fordulo, "fordulo_set_pointers kt jelentes %p\n",fordulo->ktjelentes);
#endif
		}
		else if ((p4 = strstr_(p2,"VLTOZSOK A TLLK FLDJN A LEGUTBBI FORDULD TA",p3)) && (p4 < p3))
		{
		    fordulo->valtozasok = p2;
#ifdef DEBUG
		    debug(fordulo, "fordulo_set_pointers valtozasok %p\n",fordulo->valtozasok);
#endif
		}
		else if ((p4 = strstr_(p2,"TLLK FLDJE REFERENCIA",p3)) && (p4 < p3))
		{
		    if (!fordulo->ref_start)
		    {
			fordulo->ref_start = p2;
		    }
#ifdef DEBUG
		    debug(fordulo, "fordulo_set_pointers referencia start %p\n", p2);
#endif
		}
		else if ((p4 = strstr(p2,"SZRNYEK<")) && (p4 < p3))
		{
		    if (!fordulo->ref_szorny)
		    {
			fordulo->ref_szorny = p2;
		    }
#ifdef DEBUG
		    debug(fordulo, "fordulo_set_pointers referencia szornyek %p\n", p2);
#endif
		}
		else if ((p4 = strstr(p2,"TRGYAK<")) && (p4 < p3))
		{
		    if (!fordulo->ref_targy)
		    {
			fordulo->ref_targy = p2;
		    }
#ifdef DEBUG
		    debug(fordulo, "fordulo_set_pointers referencia targyak %p\n",p2);
#endif
		}
		else if ((p4 = strstr(p2,"PARANCSOK<")) && (p4 < p3))
		{
		    fordulo->ref_parancs = p2;
#ifdef DEBUG
		    debug(fordulo, "fordulo_set_pointers referencia parancsok %p\n",fordulo->ref_parancs);
#endif
		}
	    }
#ifdef DEBUG
	    debug(fordulo, "fordulo_set_pointers 4\n");
#endif
	    if (p2 = strstr(p1,"<CENTER><TABLE CELLPADDING=5 CELLSPACING=0 CLASS=\"klap\" WIDTH="))
	    {
		fordulo->karlap = p2;
		fordulo->karakter->karlapstart = p2;
		if ((p1 = strstr2(p2, "Szint:</TD><TD CLASS=\"t1\">")) && (isdigit2(*p1)))
		{
		    fordulo->karakter->szint = atoi(p1);
		}
		p1 = p2 + 1;
		if (fordulo->tipus & fordulo_tipus_wrapper)
		{
		    karlap_str = "<TABLE WIDTH=718 CELLPADDING=1 CELLSPACING=0 BORDER=0 CLASS=\"t0\">";
		}
		else if (fordulo->tipus & fordulo_tipus_reformat_kws)
		{
		    karlap_str = "<TABLE WIDTH=100% CELLPADDING=1 CELLSPACING=0 BORDER=0 CLASS=\"t0\">";
		}
		else
		{
		    karlap_str = "<TABLE WIDTH=740 CELLPADDING=1 CELLSPACING=0 BORDER=0 CLASS=\"t0\">";
		}
#ifdef DEBUG
		debug(fordulo, "fordulo_set_pointers karlap %p, karlap_str=\"%s\"\n",fordulo->karlap, karlap_str);
#endif
		for (p3 = p1; (p2 = strstr(p3, karlap_str)) && (p3 = strstr2(p2, "</TABLE></TD></TR></TABLE>")); )
		{
		    if ((p4 = strstr(p2,"E krben tett lpseid trkpe")) && (p4 < p3))
		    {
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers karlap vege break\n");
#endif
			break;
		    }
		    else if ((p4 = strstr(p2,"&nbsp;letkor:")) && (p4 < p3))
		    {
			fordulo->karakter->tulajdonsag = p2;
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers tulajdonsagok %p\n",fordulo->karakter->tulajdonsag);
#endif
		    }
		    else if ((p4 = strstr(p2,"HARCI ISMERETEK")) && (p4 < p3))
		    {
			fordulo->karakter->fegyverszaki = p2;
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers fegyverszaki %p\n",fordulo->karakter->fegyverszaki);
#endif
		    }
		    else if ((p4 = strstr(p2,"Feltteles fegyvervlts:")) && (p4 < p3))
		    {
			fordulo->karakter->ff = p2;
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers fegyvervaltas %p\n",fordulo->karakter->ff);
#endif
		    }
		    else if ((p4 = strstr(p2,"EGYB ISMERETEK")) && (p4 < p3))
		    {
			fordulo->karakter->szakertelmek = p2;
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers szakertlemek %p\n",fordulo->karakter->szakertelmek);
#endif
		    }
		    else if ((p4 = strstr(p2,"FEJLESZTSI PONTOK")) && (p4 < p3))
		    {
			fordulo->karakter->fno = p2;
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers fno %p\n",fordulo->karakter->fno);
#endif
		    }
		    else if ((p4 = strstr(p2,"FELTTELES PARANCSOK")) && (p4 < p3))
		    {
			fordulo->karakter->fparancs = p2;
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers felteteles parancsok %p\n",fordulo->karakter->fparancs);
#endif
		    }
		    else if ((p4 = strstr(p2,"VARZSLATAID")) && (p4 < p3))
		    {
			if (p4 != strstr(p2,"VARZSLATAID SEBZSE"))
			{
			    fordulo->karakter->spellek = p2;
#ifdef DEBUG
			    debug(fordulo, "fordulo_set_pointers spellek %p\n",fordulo->karakter->spellek);
#endif
			}
		    }
		    else if ((p4 = strstr(p2,"JELENLEG RAJTAD LEV")) && (p4 < p3))
		    {
			fordulo->karakter->spellrajtad = p2;
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers spellrajtad %p\n",fordulo->karakter->spellrajtad);
#endif
		    }
		    else if ((p4 = strstr(p2,"TMAD S VDEKEZ VARZSLATOK LISTJA")) && (p4 < p3))
		    {
			fordulo->karakter->tvlista = p2;
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers tvlista %p\n",fordulo->karakter->tvlista);
#endif
		    }
		    else if ((p4 = strstr(p2,"ELFOGOTT SZRNYEID")) && (p4 < p3))
		    {
			fordulo->karakter->elfogottszornyek = p2;
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers elfogott szornyek %p\n",fordulo->karakter->elfogottszornyek);
#endif
		    }
		    else if ((p4 = strstr(p2,"ISTENI KLDETSEID")) && (p4 < p3))
		    {
			fordulo->karakter->istenikuldi = p2;
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers istenikuldi %p\n",fordulo->karakter->istenikuldi);
#endif
		    }
		    else if ((p4 = strstr(p2,"HSTETTEID")) && (p4 < p3))
		    {
			fordulo->karakter->hostett = p2;
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers hostett %p\n",fordulo->karakter->hostett);
#endif
		    }
		    else if ((p4 = strstr(p2,"J TUDNI")) && (p4 < p3))
		    {
			fordulo->karakter->reformat_jo_tudni = p2;
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers reformat jo tudni %p\n",fordulo->karakter->reformat_jo_tudni);
#endif
		    }
		    else if ((p4 = strstr(p2,"FIGYELEMMEL KISRT TRGYAK, VARZSLATOK")) && (p4 < p3))
		    {
			fordulo->karakter->reformat_figyelemmel_kisert = p2;
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers reformat figyelemmel kisert %p\n",fordulo->karakter->reformat_figyelemmel_kisert);
#endif
		    }
		    else if ((p4 = strstr(p2,"TRGYAID TIPUSONKNTI BONTSBAN")) && (p4 < p3))
		    {
			fordulo->karakter->reformat_tipusonkenti_bontas = p2;
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers reformat tipusonkenti bontas %p\n",fordulo->karakter->reformat_tipusonkenti_bontas);
#endif
		    }
		    else if ((p4 = strstr(p2,"VARZSLATAID SEBZSE")) && (p4 < p3))
		    {
			fordulo->karakter->reformat_varazslataid_sebzese = p2;
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers reformat varazslataid sebzese %p\n",fordulo->karakter->reformat_varazslataid_sebzese);
#endif
		    }
		    else if ((p4 = strstr(p2,"FEGYVEREID SEBZSE")) && (p4 < p3))
		    {
			fordulo->karakter->reformat_fegyvereid_sebzese = p2;
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers reformat fegyvereid sebzese %p\n",fordulo->karakter->reformat_fegyvereid_sebzese);
#endif
		    }
		    else if ((p4 = strstr(p2,"KIHVS TORONY ESLYEK")) && (p4 < p3))
		    {
			fordulo->karakter->reformat_kihivas_torony = p2;
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers reformat kihivas torony %p\n",fordulo->karakter->reformat_kihivas_torony);
#endif
		    }
		    else if ((p4 = strstr(p2,"NLAD LV TRGYAK")) && (p4 < p3))
		    {
			fordulo->karakter->targylista = p2;
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers targylista %p\n",fordulo->karakter->targylista);
#endif
		    }
		    else if ((p4 = strstr(p2,"sszsly:")) && (p4 < p3))
		    {
			fordulo->karakter->megterheltseg = p2;
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers megterheltseg %p\n",fordulo->karakter->megterheltseg);
#endif
		    }
		    else if ((p4 = strstr(p2,"TRGYAID A BANK SZFJBEN")) && (p4 < p3))
		    {
			fordulo->karakter->bank = p2;
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers bank %p\n",fordulo->karakter->bank);
#endif
		    }
		    else if ((p4 = strstr(p2,"A FORDUL ELEJN MG MEGVOLT")) && (p4 < p3))
		    {
			fordulo->karakter->targyment = p2;
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers targyment1 %p\n",fordulo->karakter->targyment);
#endif
		    }
		    // alternativa a targyment-re...
		    else if ((p4 = strstr(p2,"AZ ELZ FORDULBAN MG MEGVOLT...")) && (p4 < p3))
		    {
			fordulo->karakter->targyment = p2;
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers targyment2 %p\n",fordulo->karakter->targyment);
#endif
		    }
		    // ha reformazott a fordulo, akkor a targyment:
		    else if ((p4 = strstr(p2,"ELZ FORDULD VGN MG MEGVOLT...")) && (p4 < p3))
		    {
			fordulo->karakter->targyment = p2;
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers targyment3 %p\n",fordulo->karakter->targyment);
#endif
		    }
		    else if ((p4 = strstr(p2,"EBBEN A FORDULBAN KERLT HOZZD")) && (p4 < p3))
		    {
			fordulo->karakter->targyjott = p2;
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers targyjott1 %p\n",fordulo->karakter->targyjott);
#endif
		    }
		    // ha reformazott a fordulo, akkor a targyjott:
		    else if ((p4 = strstr(p2,"ELZ FORDULD TA KERLT HOZZD...")) && (p4 < p3))
		    {
			fordulo->karakter->targyjott = p2;
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers targyjott2 %p\n",fordulo->karakter->targyjott);
#endif
		    }
		    else
		    {
#ifdef DEBUG
			debug(fordulo, "fordulo_set_pointers karakterlapon eddig nem ismert rublika!!! \"%.*s\"\n",p3 - p2, p2);
#endif				    
		    }
		}
		if (fordulo->karakter->fegyverszaki && (p4 = strstr2_(fordulo->karakter->fegyverszaki, "dh vrvrs kde:", fordulo->karakter->szakertelmek)))
		{
		    p4 = skip_space(p4);
		    fordulo->karakter->dvk = atoi(p4);
		}
	    }

#ifdef DEBUG
	    debug(fordulo, "fordulo_set_pointers 5\n");
#endif
	    if ((p3 = strstr(p1, "<hr>\r\n&copy <a href=http://www.beholder.hu>")) && (p2 = strstr2(p3, "<br>\r\n")))
	    {
		fordulo->end_eleje = p3;
		fordulo->end = p2;
	    }
	    else if ((p3 = strstr(p1, "&copy <a href=http://www.beholder.hu>")) && (p2 = strstr2(p3, "<br>\r\n")))
	    {
		fordulo->end_eleje = p3;
		fordulo->end = p2;
	    }
	    else if ((p3 = strstr(p1, "&copy <A CLASS=fordulolink HREF=http://www.beholder.hu>")) && (p2 = strstr2(p3, "<br>\r\n")))
	    {
		fordulo->end_eleje = p3;
		fordulo->end = p2;
	    }
	    else
	    {
		fordulo->end = fordulo->fordulostr + strlen(fordulo->fordulostr) - 1;
	    }
#ifdef DEBUG
	    debug(fordulo, "fordulo_set_pointers end_eleje %p\n",fordulo->end_eleje);
	    debug(fordulo, "fordulo_set_pointers end %p\n",fordulo->end);
	    debug(fordulo, "fordulo_set_pointers 6\n");
#endif
	    for (px = &fordulo->karlap + 1; (*px == NULL) && (px < &fordulo->end); px++)
	    {
#ifdef DEBUG
	        debug(fordulo, "fordulo_set_pointers karlapend skip %p\n",*px);
#endif
	    }
	    fordulo->karakter->karlapend = *px;
#ifdef DEBUG
	    debug(fordulo, "fordulo_set_pointers karlapend %p\n", fordulo->karakter->karlapend);
#endif
	    return 1;
}

extern t_fordulo * fordulo_load(t_forras * forras)
{
    t_fordulo * fordulo = NULL;
    t_karakter * karakter = NULL;
    FILE * fp = NULL;
    FILE * out = NULL;
    unsigned long size;
    char * fordulostr = NULL;
    char * p1 = NULL;
    char * p2 = NULL;
    char * p3 = NULL;
    char * p4 = NULL;
    char ** px;
    int ksz = 0;
    int fsz = 0;
    int pszakasz;
    int parancs;
    char * parancs_l = NULL;
    char * parancs_str;
    char ** pp;
    char * karlap_str;
    char * end_str;
    int or;
    
#ifdef DEBUG
    debug(fordulo, "fordulo_load 0\n");
#endif
    if (fordulo = malloc(sizeof(t_fordulo)))
    {
        memset(fordulo,0,sizeof(t_fordulo));
	if (!karakter_init(fordulo))
	{
	    fordulo_unload(fordulo);
	    return NULL;
	}

        fordulo->dataflow = dataflow_get();
#ifdef DEBUG
        debug(fordulo, "fordulo_load 2\n");
#endif
        if(fordulostr = input(forras))
        {
#ifdef DEBUG
	    debug(fordulo, "fordulo_load 3\n");
#endif
	    p1 = fordulostr;
	    fordulo->forras = forras;
	    fordulo->fordulostr = fordulostr;
	    fordulo->fejlec = fordulo->fordulostr;

	    for (pp = &fordulo->taborozas; pp <= &fordulo->end; pp++)
	    {
		*pp = NULL;
	    }
#ifdef DEBUG
	    debug(fordulo, "fordulo_load 6\n");
#endif
	    if (strstr(fordulo->fejlec, "<!-- clformat"))
	    {
#ifdef DEBUG
		debug(fordulo, "tipus = clformat\n");
#endif
		fordulo->tipus = fordulo_tipus_reformat_cl;
	    }
	    else if (strstr(fordulo->fordulostr,"HREF=#reformat>ReFormat") || strstr(fordulo->fordulostr,"<BR>ReFormat by KWS<BR>"))
	    {
#ifdef DEBUG
		debug(fordulo, "tipus = reformat kws\n");
#endif
		fordulo->tipus = fordulo_tipus_reformat_kws;
	    }
	    else if (strstr(fordulo->fejlec, "RSZVTELE AZ OLIMPIN"))
	    {
#ifdef DEBUG
	        debug(fordulo, "tipus = olimpia\n");
#endif
	        fordulo->tipus = fordulo_tipus_olimpia;
	    }
	    else if (strstr(fordulo->fejlec, "<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"profile.css\">"))
	    {
#ifdef DEBUG
		debug(fordulo, "tipus = kft uj\n");
#endif
		fordulo->tipus = fordulo_tipus_kft_uj;
	    }
	    else if (strstr(fordulo->fejlec, "<LINK REL=StyleSheet HREF=\"profile.css\" TYPE=\"text/css\">"))
	    {
#ifdef DEBUG
		debug(fordulo, "tipus = kft uj\n");
#endif
		fordulo->tipus = fordulo_tipus_kft_uj_wrapper;
	    }
	    else
	    {
#ifdef DEBUG
		debug(fordulo, "tipus = unknown\n");
#endif
		fordulo->tipus = fordulo_tipus_unknown;
	    }

	    if ((fordulo->tipus !=  fordulo_tipus_unknown) && (p1 = strstr(fordulo->fejlec,"Betpllva: ")) && (p2 = strstr(fordulo->fejlec,"KALANDOZ: #")))
	    {
		struct tm tmbetap;
		
		memset(&tmbetap, 0, sizeof(tmbetap));
#ifdef DEBUG
		debug(fordulo, "fordulo_load set karszam, taplalasi ido\n");
#endif
		p1 += 12;
		p2 += 12;
		if (isdigit2(p1[0]))
		{
		    fordulo->ev = atoi(p1);
		    tmbetap.tm_year = fordulo->ev - 1900;
		    
		    p1 = strstr(p1, " ") + 1;
		    fordulo->honap[0] = p1[0];
		    fordulo->honap[1] = p1[1];
		    fordulo->honap[2] = p1[2];
		    fordulo->honap[3] = '\0';
		    if (strncmp(p1, "jan", 3) == 0)
		    {
			tmbetap.tm_mon = 0;
		    }
		    else if (strncmp(p1, "febr", 4) == 0)
		    {
			tmbetap.tm_mon = 1;
		    }
		    else if (strncmp(p1, "mrc", 4) == 0)
		    {
			tmbetap.tm_mon = 2;
		    }
		    else if (strncmp(p1, "pr", 3) == 0)
		    {
			tmbetap.tm_mon = 3;
		    }
		    else if (strncmp(p1, "mj", 3) == 0)
		    {
			tmbetap.tm_mon = 4;
		    }
		    else if (strncmp(p1, "jn", 3) == 0)
		    {
			tmbetap.tm_mon = 5;
		    }
		    else if (strncmp(p1, "jl", 3) == 0)
		    {
			tmbetap.tm_mon = 6;
		    }
		    else if (strncmp(p1, "aug", 3) == 0)
		    {
			tmbetap.tm_mon = 7;
		    }
		    else if (strncmp(p1, "szept", 4) == 0)
		    {
			tmbetap.tm_mon = 8;
		    }
		    else if (strncmp(p1, "okt", 3) == 0)
		    {
			tmbetap.tm_mon = 9;
		    }
		    else if (strncmp(p1, "nov", 3) == 0)
		    {
			tmbetap.tm_mon = 10;
		    }
		    else if (strncmp(p1, "dec", 3) == 0)
		    {
			tmbetap.tm_mon = 11;
		    }
		    else
		    {
			tmbetap.tm_mon = -1;
		    }
		    
		    p1 = strstr(p1, " ") + 1;
		    tmbetap.tm_mday = atoi(p1);
		    
		    p1 = strstr(p1, " ") + 1;
		    tmbetap.tm_hour = atoi(p1);
		    
		    p1 = strstr(p1, ":") + 1;
		    tmbetap.tm_min = atoi(p1);
		    
		    if (tmbetap.tm_mon != -1)
		    {
			fordulo->betap = mktime(&tmbetap);
		    }
		}
		if (isdigit2(p2[0]))
		{
		    fordulo->karakter->ksz = atoi(p2);
		}
	    }
	    if ((fordulo->tipus !=  fordulo_tipus_unknown) && (p1 = strstr(fordulo->fejlec,"JTKHETED, ")))
	    {
#ifdef DEBUG
	        debug(fordulo, "fordulo_load set forduloszam\n");
#endif
		p1 += 12;
		if (isdigit2(p1[0]))
		{
		    fordulo->fsz = atoi(p1);
		}
	    }
	    
	    // debughoz a fordulo ponter elmentese
	    if (!p_fordulo)
	    {
		p_fordulo = fordulo;
	    }
	    
	    if (!fordulo->karakter->ksz)
	    {
		fordulo->tipus = fordulo_tipus_unknown;
	    }
	    
	    if (fordulo->tipus == fordulo_tipus_reformat_cl)
	    {
//		conf_set_cl();

		kiir(fordulo, "%d. file: %s, %d karakter %d fordulo: clformattal mar konvertalva!\r\n", forras->n, forras->name, fordulo->karakter->ksz, fordulo->fsz);
		fordulo_unload(fordulo);
		return NULL;

	    }
	    else if (fordulo->tipus == fordulo_tipus_reformat_kws)
	    {
		kiir(fordulo, "%d. file: %s, %d karakter %d fordulo: Ez mar reformattalt!\r\n", forras->n, forras->name, fordulo->karakter->ksz, fordulo->fsz);
		fordulo_unload(fordulo);
		return NULL;
	    }
	    else if (fordulo->tipus == fordulo_tipus_unknown)
	    {
		kiir(fordulo, "%d. file: %s, %d karakter %d fordulo: Ismeretlen tipus!\r\n", forras->n, forras->name, fordulo->karakter->ksz, fordulo->fsz);
		fordulo_unload(fordulo);
		return NULL;
	    }
#ifdef DEBUG
	    debug(fordulo, "fordulo_load 7\n");
#endif
	    conf_load_karakter(fordulo->karakter);
	    
	    if ((or = output_open(fordulo)) > 0)
	    {
	        if (fordulo->tipus == fordulo_tipus_olimpia)
		{
		    kiir(fordulo, "%d. file: %s -> %s, %d karakter olimpiai fordulo %d.%s: Loading... ", forras->n, forras->name, (fordulo->output.name ? fordulo->output.name : "STDOUT"), fordulo->karakter->ksz, fordulo->ev, fordulo->honap);
		}
		else
		{
		    kiir(fordulo, "%d. file: %s -> %s, %d karakter %d fordulo: Loading... ", forras->n, forras->name, (fordulo->output.name ? fordulo->output.name : "STDOUT"), fordulo->karakter->ksz, fordulo->fsz);
		}
	    }
	    else
	    {
		if (or == -2)
		{
		    kiir(fordulo, "%d. file: %s -> %s, %d karakter %d fordulo: Sajat magat nem irhatja felul!\r\n", forras->n, forras->name, (fordulo->output.name ? fordulo->output.name : " - "), fordulo->karakter->ksz, fordulo->fsz);
		}
		else
		{
		    kiir(fordulo, "%d. file: %s -> %s, %d karakter %d fordulo: Problema a kimenettel!\r\n", forras->n, forras->name, (fordulo->output.name ? fordulo->output.name : " - "), fordulo->karakter->ksz, fordulo->fsz);
		}
		fordulo_unload(fordulo);
		return NULL;
	    }
#ifdef DEBUG
	    debug(fordulo, "fordulo_load 8\n");
#endif
	    if (fordulo_set_pointers(fordulo) < 0)
	    {
		fordulo_unload(fordulo);
		return NULL;
	    }
	    
	    if (fordulo->tipus == fordulo_tipus_olimpia && (!fordulo->end || !fordulo->fejlec))
	    {
		kiir(fordulo, "ERROR: A feolvasott file \"%s\" nem jo szerkezetu olimpiai fordulonak!\r\n", forras->name);
		fordulo_unload(fordulo);
		return NULL;
	    }
	    else if (fordulo->tipus == fordulo_tipus_olimpia)
	    {
#ifdef DEBUG
		debug(fordulo, "fordulo_load olimpiai fordulo...\n");
#endif
	    }
	    else if (!fordulo->end || !fordulo->fejlec || !fordulo->taborozas || !fordulo->karlap || !fordulo->korvege_tvp)
	    {
#ifdef DEBUG
		debug(fordulo, "fordulo_load error if: fordulo->end=%p, fordulo->fejlec=%p, fordulo->taborozas=%p, fordulo->karlap=%p, fordulo->korvege_tvp=%p\n", fordulo->end, fordulo->fejlec, fordulo->taborozas, fordulo->karlap, fordulo->korvege_tvp);
#endif
		kiir(fordulo, "ERROR: A feolvasott file \"%s\" nem jo szerkezetu normal fordulonak!\r\n", forras->name);
		fordulo_unload(fordulo);
		return NULL;
	    }
#ifdef DEBUG
	    debug(fordulo, "fordulo_load 14\n");
#endif
	    return fordulo;
	}
	else // if (fordulostr = input())...
	{
	    kiir(fordulo, "%d. file: %s nem sikerult megnyitni!\r\n", forras->n, forras->name);
	    fordulo_unload(fordulo);    
	}
    }
    return NULL;
}

extern int karakter_unload(t_fordulo * fordulo)
{
    if (fordulo->karakter)
    {
	karakter_deinit(fordulo);
	free(fordulo->karakter);
	fordulo->karakter = NULL;
    }
}

extern int fordulo_unload(t_fordulo * fordulo)
{
    char ** p1;
    char ** p2;
    unsigned long n;
    int i;
    t_maradektvp_parancs * maradektvp_parancs;
    t_maradektvp_parancs * maradektvp_parancs_next;
    
    output_close(fordulo);
    karakter_unload(fordulo);
    psziernyo_store_delete(fordulo);
    figyelmeztetes_store_delete(fordulo);
    mezo_store_delete(fordulo);
    for (maradektvp_parancs = fordulo->maradektvp_parancs; maradektvp_parancs; maradektvp_parancs = maradektvp_parancs_next)
    {
	maradektvp_parancs_next = maradektvp_parancs->next;
	free(maradektvp_parancs);
    }
    if (fordulo->fordulostr)
    {
	free((char *)fordulo->fordulostr);
    }
    if (p_fordulo == fordulo)
    {
	p_fordulo = NULL;
    }
    free(fordulo);
    fordulo = NULL;
}

extern t_fordulo * get_fordulo(void)
{
    return p_fordulo;
}

extern t_fordulo * fordulo_load_elozo(t_forras * forras)
{
    t_fordulo * fordulo = NULL;
    FILE * fp = NULL;
    FILE * out = NULL;
    unsigned long size;
    char * fordulostr = NULL;
    char * p1 = NULL;
    char * p2 = NULL;
    char * p3 = NULL;
    char * p4 = NULL;
    char ** px;
    int ksz = 0;
    int fsz = 0;
    int pszakasz;
    int parancs;
    char * parancs_l = NULL;
    char * parancs_str;
    char ** pp;
    char * karlap_str;
    char * end_str;
    int or;
    
#ifdef DEBUG
    debug(fordulo, "fordulo_load_elozo 0\n");
#endif
    if (fordulo = malloc(sizeof(t_fordulo)))
    {
        memset(fordulo,0,sizeof(t_fordulo));
	if (!karakter_init(fordulo))
	{
	    fordulo_unload(fordulo);
	}
        fordulo->dataflow = dataflow_get();
#ifdef DEBUG
        debug(fordulo, "fordulo_load_elozo 2\n");
#endif
        if(fordulostr = input(forras))
        {
#ifdef DEBUG
	    debug(fordulo, "fordulo_load_elozo 3\n");
#endif
	    p1 = fordulostr;
	    fordulo->forras = forras;
	    fordulo->fordulostr = fordulostr;
	    fordulo->fejlec = fordulo->fordulostr;

	    for (pp = &fordulo->taborozas; pp <= &fordulo->end; pp++)
	    {
		*pp = NULL;
	    }
#ifdef DEBUG
	    debug(fordulo, "fordulo_load_elozo 6\n");
#endif
	    if (strstr(fordulo->fejlec, "<!-- clformat"))
	    {
#ifdef DEBUG
		debug(fordulo, "tipus = clformat\n");
#endif
		fordulo->tipus = fordulo_tipus_reformat_cl;
	    }
	    else if (strstr(fordulo->fordulostr,"HREF=#reformat>ReFormat") || strstr(fordulo->fordulostr,"<BR>ReFormat by KWS<BR>"))
	    {
#ifdef DEBUG
		debug(fordulo, "tipus = reformat kws\n");
#endif
		fordulo->tipus = fordulo_tipus_reformat_kws;
	    }
	    else if (strstr(fordulo->fejlec, "RSZVTELE AZ OLIMPIN"))
	    {
#ifdef DEBUG
	        debug(fordulo, "tipus = olimpia\n");
#endif
	        fordulo->tipus = fordulo_tipus_olimpia;
		fordulo_unload(fordulo);
		return NULL;
	    }
	    else if (strstr(fordulo->fejlec, "<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"profile.css\">"))
	    {
#ifdef DEBUG
		debug(fordulo, "tipus = kft uj\n");
#endif
		fordulo->tipus = fordulo_tipus_kft_uj;
	    }
	    else if (strstr(fordulo->fejlec, "<LINK REL=StyleSheet HREF=\"profile.css\" TYPE=\"text/css\">"))
	    {
#ifdef DEBUG
		debug(fordulo, "tipus = kft uj\n");
#endif
		fordulo->tipus = fordulo_tipus_kft_uj_wrapper;
	    }
	    else
	    {
#ifdef DEBUG
		debug(fordulo, "tipus = unknown\n");
#endif
		fordulo->tipus = fordulo_tipus_unknown;
	    }

	    if ((fordulo->tipus !=  fordulo_tipus_unknown) && (p1 = strstr(fordulo->fejlec,"Betpllva: ")) && (p2 = strstr(fordulo->fejlec,"KALANDOZ: #")))
	    {
#ifdef DEBUG
		debug(fordulo, "fordulo_load_elozo set karszam, taplalasi ido\n");
#endif
		p1 += 12;
		p2 += 12;
		if (isdigit2(p1[0]))
		{
		    fordulo->ev = atoi(p1);
		    p1 = strstr(p1, " ") + 1;
		    fordulo->honap[0] = p1[0];
		    fordulo->honap[1] = p1[1];
		    fordulo->honap[2] = p1[2];
		    fordulo->honap[3] = '\0';
		}
		if (isdigit2(p2[0]))
		{
		    fordulo->karakter->ksz = atoi(p2);
		}
	    }
	    if ((fordulo->tipus !=  fordulo_tipus_unknown) && (p1 = strstr(fordulo->fejlec,"JTKHETED, ")))
	    {
#ifdef DEBUG
	        debug(fordulo, "fordulo_load_elozo set forduloszam\n");
#endif
		p1 += 12;
		if (isdigit2(p1[0]))
		{
		    fordulo->fsz = atoi(p1);
		}
	    }
	    
	    if (!fordulo->karakter->ksz)
	    {
		fordulo->tipus = fordulo_tipus_unknown;
	    }
	    
	    if (fordulo->tipus == fordulo_tipus_reformat_cl)
	    {
//		conf_set_cl();

		fordulo_unload(fordulo);
		return NULL;

	    }
	    else if (fordulo->tipus == fordulo_tipus_unknown)
	    {
		fordulo_unload(fordulo);
		return NULL;
	    }
#ifdef DEBUG
	    debug(fordulo, "fordulo_load_elozo 7\n");
#endif
	    if (fordulo_set_pointers(fordulo) < 0)
	    {
		fordulo_unload(fordulo);
		return NULL;
	    }
	    
	    if (fordulo->tipus == fordulo_tipus_olimpia && (!fordulo->end || !fordulo->fejlec))
	    {
//		kiir(fordulo, "ERROR: A feolvasott file \"%s\" nem jo szerkezetu olimpiai fordulonak!\r\n", forras->name);
		fordulo_unload(fordulo);
		return NULL;
	    }
	    else if (fordulo->tipus == fordulo_tipus_olimpia)
	    {
#ifdef DEBUG
		debug(fordulo, "fordulo_load_elozo olimpiai fordulo...\n");
#endif
	    }
	    else if (!fordulo->end || !fordulo->fejlec || !fordulo->taborozas || !fordulo->karlap || !fordulo->korvege_tvp)
	    {
#ifdef DEBUG
		debug(fordulo, "fordulo_load_elozo error if: fordulo->end=%p, fordulo->fejlec=%p, fordulo->taborozas=%p, fordulo->karlap=%p, fordulo->korvege_tvp=%p\n", fordulo->end, fordulo->fejlec, fordulo->taborozas, fordulo->karlap, fordulo->korvege_tvp);
#endif
//		kiir(fordulo, "ERROR: A feolvasott file \"%s\" nem jo szerkezetu normal fordulonak!\r\n", forras->name);
		fordulo_unload(fordulo);
		return NULL;
	    }
#ifdef DEBUG
	    debug(fordulo, "fordulo_load_elozo 14\n");
#endif
	    return fordulo;
	}
	else // if (fordulostr = input())...
	{
	    fordulo_unload(fordulo);    
	}
    }
    return NULL;
}

extern char * elozofordulo_neve(t_fordulo * fordulo, int i)
{
    char * ret = NULL;
    char * ctype1[] = { "w" , "_", "_" };
    char * ctype2[] = { "HTM" , "HTM", "htm" };
    
    i--;
    if ((i >= 0) && (i < sizeof(ctype1)/sizeof(char *)))
    {
	if (ret = malloc(20))
	{
	    sprintf(ret, "%d%s%d.%s", fordulo->karakter->ksz, ctype1[i], fordulo->fsz - 1, ctype2[i]);
	}
    }
    return ret;
}

extern char * elozofordulo_dir(t_fordulo * fordulo, int i)
{
    char * ret = NULL;
    char * s = NULL;
    
    if (i == 1)
    {
	if (s = bconf_get_outdir())
	{
	    ret = strdup(s);
	}
    }
    if ((i == 2) || (i == 3))
    {
	ret = forras_indir(fordulo->forras);
    }
    return ret;
}

