/*
 * Copyright (C) 2003  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#include "typedef.h"
#ifndef INCLUDED_FORDULO_TYPES
#define INCLUDED_FORDULO_TYPES

#ifndef JUST_NEED_TYPES
# define JUST_NEED_TYPES
# include "dataflow.h"
# include "format.h"
# include "spell.h"
# include "fegyver.h"
# include "targy.h"
# include "input.h"
# include "output.h"
# include "cache.h"
# undef JUST_NEED_TYPES
#else
# include "dataflow.h"
# include "format.h"
# include "spell.h"
# include "fegyver.h"
# include "targy.h"
# include "input.h"
# include "output.h"
# include "cache.h"
#endif

typedef enum
{
    fordulo_tipus_unknown 	= 0x00,
    fordulo_tipus_kft_regi 	= 0x01,
    fordulo_tipus_kft_uj 	= 0x02,
    fordulo_tipus_wrapper 	= 0x04,
    fordulo_tipus_kft_uj_wrapper 	= fordulo_tipus_kft_uj | fordulo_tipus_wrapper,
    fordulo_tipus_olimpia 	= 0x08,
    fordulo_tipus_reformat_cl 	= 0x10,
    fordulo_tipus_reformat_kws 	= 0x20
} t_fordulo_tipus;

typedef struct psziernyo t_psziernyo;
struct psziernyo
{
    int ssz;
    char * szn;
    char * adat;
    t_psziernyo * next;
};

typedef struct enemy
{
    int aname;
    int ssz;
    char * nev;
    char * megj;
    t_csata * csata;
    struct enemy * next;
} t_enemy;

typedef struct figyelmeztetes t_figyelmeztetes;
struct figyelmeztetes
{
    int ssz;
    char * szn;
    char * adat;
    int aname;
    t_enemy * enemy;
    t_figyelmeztetes * next;
};

typedef struct refpont
{
    char * leiras;
    struct refpont * next;
} t_refpont;

typedef struct mezo t_mezo;
struct mezo
{
    int ssz;
    int x;
    int y;
    t_enemy * enemy_elso;
    t_enemy * enemy_utolso;
    t_mezo * next;
};

typedef enum
{
    mezo_type_mozgas = 1,
    mezo_type_oli_ellen = 2,
    mezo_type_oli_hely = 3
} t_mezo_type;

typedef struct labi
{
    int mezo_ssz;
    t_refpont * refpont_elso;
    t_refpont * refpont_utolso;
    struct labi * next;
} t_labi;

typedef struct maradektvp_parancs
{
    char * parancs;
    struct maradektvp_parancs * next;
} t_maradektvp_parancs;

struct fordulo
{
    t_forras * forras;
    t_output output;
    t_cache * cache;
    t_fordulo_dataflow dataflow;
    t_output kiir;
    t_fordulo_tipus tipus;
    t_karakter * karakter;
    int fsz;
    unsigned long betap;
    int ev;
    char honap[4];
    char * fordulostr;
    char * fejlec;
    char * taborozas;
    char * kezdeti[10];
    char * parancs[40];
    char * befejezo[10];
    char * maradektvp;
    char * korvege;
    char * korvege_tvp;
    char * nekikirhatsz;
    char * encek;
    char * karlap;
    char * ktjelentes;
    char * terkep;
    char * valtozasok;
    char * ref_start;
    char * ref_szorny;
    char * ref_targy;
    char * ref_parancs;
    char * end_eleje;
    char * end;
    char * p;
    t_maradektvp_parancs * maradektvp_parancs;
    t_csata csata;
    t_csata osszesen;
    t_psziernyo * psziernyo_elso;
    t_psziernyo * psziernyo_utolso;
    t_figyelmeztetes * figyelmeztetes_elso;
    t_figyelmeztetes * figyelmeztetes_utolso;
    t_mezo_type mezo_type;
    t_mezo mezo;
    t_mezo teleport;
    t_mezo * mezo_elso;
    t_mezo * mezo_utolso;
};

#endif

#ifndef JUST_NEED_TYPES
#ifndef INCLUDED_FORDULO_PROTOS
#define INCLUDED_FORDULO_PROTOS
extern t_fordulo * fordulo_load(t_forras * forras);
extern int fordulo_unload(t_fordulo * fordulo);
extern int karakter_unload(t_fordulo * fordulo);
extern t_fordulo * get_fordulo(void);
extern t_fordulo * fordulo_load_elozo(t_forras * forras);
extern char * elozofordulo_neve(t_fordulo * fordulo, int i);
extern char * elozofordulo_dir(t_fordulo * fordulo, int i);
#endif
#endif
