/*
 * Copyright (C) 2003  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#define GLOBALS_INTERNAL_ACCESS
#include "include.h"
#include "globals.h"
#include "dataflow.h"

// Konstatnsok start
static char * karakters_str = NULL;
static char * monsters_str = NULL;
static int monsters_max_ssz = 0;
static t_fordulo_dataflow dataflow =  fordulo_input_normal | fordulo_output_normal;
static int quiet = 0;
static int pdirconf = 0;
static char * pdir = NULL;
#ifdef WIN32
static int nopause = 0;
#endif
static cache_mode = 0;
static pszi_mode = 0;
// Konstansok end

extern int deinit_globals(void)
{
    if (pdir)
    {
	free(pdir);
	pdir = NULL;
    }
}

extern t_fordulo_dataflow dataflow_get(void)
{
    return dataflow;
}

extern t_fordulo_dataflow dataflow_set(t_fordulo_dataflow new)
{
    dataflow |= new;
    return dataflow;
}

extern t_fordulo_dataflow dataflow_unset(t_fordulo_dataflow del)
{
    dataflow &= ~del;
    return dataflow;
}

extern char * karakters_str_get(void)
{
    if (karakters_str)
    {
	return karakters_str;
    }
    else
    {
	return "";
    }
}

extern char * karakters_str_set(char * karakters)
{
    if (!karakters)
    {
	return NULL;
    }
    
    if (karakters_str = strdup(karakters))
    {
	return karakters_str;
    }
    
    return NULL;
}

extern char * karakters_str_unset(void)
{
    if (karakters_str)
    {
	free(karakters_str);
    }

    return NULL;
}

extern char * monsters_str_get(void)
{
    if (monsters_str)
    {
	return monsters_str;
    }
    else
    {
	return "";
    }
}

extern char * monsters_str_set(char * monsters)
{
    char * p;
    char * p1;

    if (!monsters)
    {
	return NULL;
    }
    
    if (monsters_str = strdup(monsters))
    {
	for (p = monsters_str + strlen(monsters_str) - 1; p > monsters_str; p--, monsters_max_ssz = 0)
	{
	    if (*p == '\n')
	    {
		p1 = skip_space(p);
		if (isdigit2(*p1))
		{
		    monsters_max_ssz = atoi(p1);
		    if  (monsters_max_ssz && (monsters_max_ssz < 980))
		    {
			break;
		    }
		}
	    }
	}
	
	return monsters_str;
    }
    
    return NULL;
}

extern char * monsters_str_unset(void)
{
    if (monsters_str)
    {
	free(monsters_str);
    }

    return NULL;
}

extern int monsters_get_max(void)
{
    return monsters_max_ssz;
}

extern int set_quiet(int i)
{
    quiet = i;
    return quiet;
}

extern int get_quiet(void)
{
    return quiet;
}

extern int set_pdirconf(int i)
{
    pdirconf = i;
    return pdirconf;
}

extern int get_pdirconf(void)
{
    return pdirconf;
}

extern char * set_pdir(char * s)
{
    pdir = s;
    return pdir;
}

extern char * get_pdir(void)
{
    return pdir;
}

#ifdef WIN32
extern int set_nopause(int i)
{
    nopause = i;
    return nopause;
}

extern int get_nopause(void)
{
    return nopause;
}
#endif

extern int set_cache_mode(int i)
{
    cache_mode = i;
    return cache_mode;
}

extern int get_cache_mode(void)
{
    return cache_mode;
}

extern int set_pszi_mode(int i)
{
    pszi_mode = i;
    return pszi_mode;
}

extern int get_pszi_mode(void)
{
    return pszi_mode;
}
