/*
 * Copyright (C) 2005  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#define FORMAT_INTERNAL_ACCESS
#include "include.h"
#include "fordulo.h"
#include "karakter.h"
#include "output.h"
#include "globals.h"
#include "init.h"
#include "input.h"
#include "conf.h"
#include "commandline.h"
#include "f_fordulo.h"
#include "f_csatan_kivul.h"

extern int psziernyo_store(t_fordulo * fordulo, int ssz, char * szn, char * start, char * end)
{
    t_psziernyo * psziernyo;
    char * szn2;
    char * adat;
    char * s1;
    char * s2;
    
    if (aconf_get_curr("korvege_psziernyo_kiiras") != 1)
    {
	return 0;
    }

    if (!szn || !start || !end)
    {
#ifdef DEBUG
	debug(fordulo, "psziernyo_store: bejovo adathiba");
#endif
	return -1;
    }
    
    szn = skip_space(szn);
    if (!(psziernyo = malloc(sizeof(t_psziernyo))) || !(szn2 = strdup(szn)) || !(adat = malloc(end - start + 1)))
    {
#ifdef DEBUG
	debug(fordulo, "psziernyo_store: ERROR nincs memoria eltarolni a psziernyot");
#endif
	return -1;
    }
    
    sprintf(adat,"%.*s", end - start, start);

    if (strstr(adat,"Agyletapogats:") || strstr(adat, "KCC:") ||  strstr(adat, "FM:") ||  strstr(adat, "D:"))
    {
	free(adat);
	free(szn2);
	free(psziernyo);
	return 0;
    }
    psziernyo->ssz = ssz;
    psziernyo->szn = szn2;
    psziernyo->adat = adat;
    psziernyo->next = NULL;
	for (s1 = psziernyo->adat, s2 = s1; s1 < (psziernyo->adat + strlen(psziernyo->adat)) ; s1++, s2++)
	{
	    while ((*s1 == '\n') || (*s1 == '\r'))
	    {
		s1++;
	    }
	    *s2 = *s1;
	}
	*s2 = '\0';
	for (s1 = psziernyo->szn, s2 = s1; s1 < (psziernyo->szn + strlen(psziernyo->szn)) ; s1++, s2++)
	{
	    while ((*s1 == '\n') || (*s1 == '\r'))
	    {
		s1++;
	    }
	    *s2 = *s1;
	}
	*s2 = '\0';
    if (fordulo->psziernyo_utolso)
    {
	fordulo->psziernyo_utolso->next = psziernyo;
    }
    fordulo->psziernyo_utolso = psziernyo;
    if (!fordulo->psziernyo_elso)
    {
	fordulo->psziernyo_elso = psziernyo;
    }
    
#ifdef DEBUG
	debug(fordulo, "psziernyo_store: %s (#%d): %s\n", psziernyo->szn, psziernyo->ssz, psziernyo->adat);
#endif
    return 1;
}

extern int psziernyo_store_delete(t_fordulo * fordulo)
{
    t_psziernyo * psziernyo;
    t_psziernyo * next;
    
    for (psziernyo = fordulo->psziernyo_elso; psziernyo; psziernyo = next)
    {
	if (psziernyo->szn)
	{
	    free(psziernyo->szn);
	}
	if (psziernyo->adat)
	{
	    free(psziernyo->adat);
	}
	next = psziernyo->next;
	free(psziernyo);
    }
}

extern int psziernyo_kiir(t_fordulo * fordulo)
{
    t_psziernyo * psziernyo;
    int i;
    
    if (aconf_get_curr("korvege_psziernyo_kiiras") != 1)
    {
	return 0;
    }

    if (!fordulo)
    {
	return -1;
    }
    if (!fordulo->psziernyo_elso)
    {
	return 0;
    }
    
    output(fordulo,"</B><BR><BR>\r\n");
    output(fordulo,"<P><TABLE WIDTH=100%% CELLPADDING=1 CELLSPACING=0 BORDER=0 CLASS=\"t0\"><TR><TD><TABLE WIDTH=100%% CELLPADDING=2 CELLSPACING=0 BORDER=0 CLASS=\"t1\"><TR><TD CLASS=\"c1\" colspan=3>PSZI ERNYVEL SZERZETT INFORMCIK</td></tr>\r\n");
    for (i = 0, psziernyo = fordulo->psziernyo_elso; psziernyo; psziernyo = psziernyo->next)
    {
	if (psziernyo->ssz >= 10 && psziernyo->ssz < 1000)
	{
	    if (i == 0)
	    {
		output(fordulo, "<tr><td nowrap class=\"c3\" width=100%% colspan=3>Szrnyek</td></tr>\r\n");
	    }
	    output(fordulo, "<tr><td nowrap class=\"t1\">%s <a class=n href=\"%sszorny_enc.php%sf=szenc&ssz=%i%s\" target=hyper title=\"Encyclopedia (Web Hyper)\">(#%d) : <a></td><td nowrap class=\"t1\"> %s <i>(%d. szinten, dvk=%d%%)</i></td><td nowrap class=\"t1\" width=100%%>&nbsp;</td></tr>\r\n", psziernyo->szn, bconf_get_webhyper(), (aconf_get_webhyper_offline()?"@":"?"), psziernyo->ssz, (aconf_get_webhyper_offline()?".htm":""), psziernyo->ssz, psziernyo->adat, fordulo->karakter->szint, fordulo->karakter->dvk);
	    i++;
	}
    }
    for (i = 0, psziernyo = fordulo->psziernyo_elso; psziernyo; psziernyo = psziernyo->next)
    {
	if (psziernyo->ssz >= 1000)
	{
	    if (i == 0)
	    {
		output(fordulo, "<tr><td nowrap class=\"c3\" width=100%% colspan=3>Karakterek</td></tr>\r\n");
	    }
	    output(fordulo, "<tr><td nowrap class=\"t1\">%s (#%d) : </td><td nowrap class=\"t1\"> %s</td><td nowrap class=\"t1\" width=100%%>&nbsp;</td></tr>\r\n", psziernyo->szn, psziernyo->ssz, psziernyo->adat);
	    i++;
	}
    }
    for (i = 0, psziernyo = fordulo->psziernyo_elso; psziernyo; psziernyo = psziernyo->next)
    {
	if (psziernyo->ssz < 10)
	{
	    if (i == 0)
	    {
		output(fordulo, "<tr><td nowrap class=\"c3\" width=100%% colspan=3>Sorszm nlkliek</td></tr>\r\n");
	    }
	    output(fordulo, "<tr><td nowrap class=\"t1\">%s : </td><td nowrap class=\"t1\"> %s</td><td nowrap class=\"t1\" width=100%%>&nbsp;</td></tr>\r\n", psziernyo->szn, psziernyo->adat);
	    i++;
	}
    }
    output(fordulo,"</table></td></tr></table><br><br>\r\n");
}

extern int psziernyo_lista(t_fordulo * fordulo)
{
    t_psziernyo * psziernyo;
    int i;
    char * s1;
    char * s2;
    
    if (!fordulo)
    {
	return -1;
    }
    if (!fordulo->psziernyo_elso)
    {
	return 0;
    }
    
    for (i = 0, psziernyo = fordulo->psziernyo_elso; psziernyo; psziernyo = psziernyo->next)
    {
#ifdef DEBUG
	debug(fordulo, "psziernyo_lista: [%4d_%3d]: %s | (#%d) | %s | %d. szinten | dvk=%d%% | %lu\n", fordulo->karakter->ksz, fordulo->fsz, psziernyo->szn, psziernyo->ssz, psziernyo->adat, fordulo->karakter->szint, fordulo->karakter->dvk, fordulo->betap);
#endif
	if (psziernyo->ssz >= 10 && psziernyo->ssz < 1000)
	{
	    output(fordulo, "[%4d_%3d]: [M] | %s | (#%d) | %s | %d. szinten | dvk=%d%% | %lu\r\n", fordulo->karakter->ksz, fordulo->fsz, psziernyo->szn, psziernyo->ssz, psziernyo->adat, fordulo->karakter->szint, fordulo->karakter->dvk, fordulo->betap);
	}
	if (psziernyo->ssz >= 1000)
	{
	    output(fordulo, "[%4d_%3d]: [K] | %s | (#%d) | %s | %lu\r\n", fordulo->karakter->ksz, fordulo->fsz, psziernyo->szn, psziernyo->ssz, psziernyo->adat, fordulo->betap);
	}
	if (psziernyo->ssz < 10)
	{
	    output(fordulo, "[%4d_%3d]: [X] | %s | %s | %lu\r\n", fordulo->karakter->ksz, fordulo->fsz, psziernyo->szn, psziernyo->adat, fordulo->betap);
	}
    }
}

void psziernyo_search(t_fordulo * fordulo, char * start)
{
    char * p1;
    char * p2;
    char * p3;
    char * p4;
    char * p5;
    int ssz;
    char * szn;
    char * szn_end;
    char * pontosnev = NULL;
    
    for (p1 = start; ((p1 = strstr2(p1, "<b>")) && (p2 = strstr(p1, "<"))); )
    {
	if (p2 != strstr(p1, "</B>"))
	{
	    continue;
	}
	
	ssz = 0;
	
	// mar reformattalt
	if ((p3 = strstr2(p1, "(#")) && (p4 = strstr(p3, ")")) && (p4 < p2))
	{
#ifdef DEBUG
	    debug(fordulo, "psziernyo_search: refomatalt \"%.*s\"\n", p2 - p1, p1);
#endif
	    ssz = atoi(p3);
	    p5 = p3 - 3;
	    for ( ;(p5 > p1) && isspace2(*p5); p5--);
	    p5++;
	    if (isspace2(*p5))
	    {
		szn = p1;
		szn_end = p5;
	    }
	}
	else
	{
	    szn = p1;
	    szn_end = p2;
	}
	if (szn)
	{
	    set_cache_mode(1);
	    reformat_nev_kiemeles(fordulo, szn, szn_end, 1);
	    set_cache_mode(0);
	}
    }
}

extern int psziernyo_main(t_fordulo * fordulo)
{
    char ** p1;
    char ** p2;
    char * px;
    char * t1;
    char * t2;
    char * buf;
    char tmp;
    unsigned long n;
    int i;
    int size;
    
    kiir(fordulo, "Psziernyok keresese");
    for (i = 1, size = 0, p1 = &fordulo->fejlec; p1 < &fordulo->end; p1 = p2, i++)
    {
#ifdef DEBUG
# ifdef USE_CHECK_ALLOC
//    check_report_usage();
# endif
#endif
	p2 = p1 + 1;
#ifdef DEBUG
	debug(fordulo, "psziernyo_main 1: p1=%p p2=%p\n", *p1, *p2);
#endif
	if (*p1 == NULL)
	{
	    continue;
	}
#ifdef DEBUG
	debug(fordulo, "psziernyo_main 2: p1=%p p2=%p\n", *p1, *p2);
#endif
	while (((*p2 == NULL) || (*p2 < *p1)) &&  (p2 < &fordulo->end))
	{
	    p2++;
	}
	tmp = **p2;
	**p2 = '\0';
#ifdef DEBUG
	debug(fordulo, "psziernyo_main 3: p1=%p p2=%p\n", *p1, *p2);
#endif
	kiir(fordulo, ".");
	fordulo->p = NULL;
	if ((p1 > &fordulo->fejlec) && (p1 < &fordulo->korvege_tvp) && (p2 <= &fordulo->korvege_tvp))
	{
	    if (fordulo->tipus == fordulo_tipus_olimpia)
	    {
#ifdef DEBUG
		debug(fordulo, "psziernyo_main olimpia: %.100s\n", *p1);
#endif
		continue;
	    }
	    else
	    {
#ifdef DEBUG
		debug(fordulo, "psziernyo_main parancs: %.100s\n", *p1);
#endif
		if ((p1 == &fordulo->maradektvp) && fordulo->maradektvp_parancs && fordulo->maradektvp_parancs->parancs)
		{
		    char ttmp;
		    t_maradektvp_parancs * maradektvp_parancs = fordulo->maradektvp_parancs;
		    t_maradektvp_parancs * maradektvp_parancs_next;
#ifdef DEBUG
		    debug(fordulo, "psziernyo_main  maradektvp\n");
#endif
		    ttmp = *maradektvp_parancs->parancs;
		    *maradektvp_parancs->parancs = '\0';
		    psziernyo_search(fordulo, *p1);
		    *maradektvp_parancs->parancs = ttmp;
		    
		    for (maradektvp_parancs = fordulo->maradektvp_parancs; maradektvp_parancs; maradektvp_parancs = maradektvp_parancs_next)
		    {
			maradektvp_parancs_next = maradektvp_parancs->next;
			if (maradektvp_parancs_next)
			{
			    ttmp = *maradektvp_parancs_next->parancs;
			    *maradektvp_parancs_next->parancs = '\0';
			}
			psziernyo_search(fordulo, maradektvp_parancs->parancs);
			if (maradektvp_parancs_next)
			{
			    *maradektvp_parancs_next->parancs = ttmp;
			}
		    }
		}
		else
		{
		    psziernyo_search(fordulo, *p1);
		}
	    }
	}
	
	**p2 = tmp;
    }
    
    psziernyo_lista(fordulo);
    
    kiir(fordulo, " Done.\r\n");
    return 1;
}

