/*
 * Copyright (C) 2003  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#include "typedef.h"
#ifndef INCLUDED_TIT_TYPES
#define INCLUDED_TIT_TYPES

typedef enum 
{
    tim_type_unknown = 0x00,
    tim_type_nyugat = 0x01,
    tim_type_kelet = 0x02
} t_tim_type;

typedef struct tim
{
    int ssz;
    t_tim_type type;
    char * szoveg;
    int jelszo_helye;
    int ct[5];
    struct tim * next;
} t_tim;


#endif

#ifndef JUST_NEED_TYPES
#ifndef INCLUDED_TIT_PROTOS
#define INCLUDED_TIT_PROTOS
extern char tit_char_get_szam(int i);
extern int tit_szam_get_char(char c);
extern int tit_get_jlk(char * s);
extern t_tim * get_tim_head(void);
extern t_tim * tim_create(char * szoveg);
extern int tim_list_add_tim(char * szoveg);
extern int tim_list_destroy(void);
extern int init_tim(char * filename);
extern char * tim_megfejt(char * szoveg, int * jlk);
#endif
#endif
