/*
 * Copyright (C) 2003  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#include "typedef.h"

#ifndef INCLUDED_TORONY_TYPES
#define INCLUDED_TORONY_TYPES
#ifndef JUST_NEED_TYPE
# define JUST_NEED_TYPE
# include "conf.h"
# undef JUST_NEED_TYPE
#else
# include "conf.h"
#endif

#define TORONY_SZAM_FORMAT "%6.2f %%"
#define PROBA_MAX_SZINT 3
#define PROBA_SZINT_HOSSZ 9
#define TARGY_KESZITES_MAX_ALKOTO 4

typedef enum
{
    proba_none = 0,
    proba_szakertelem = 1,
    proba_info = 2,
    proba_oles = 3,
    proba_keszites = 4
} t_proba_tipus;

typedef enum
{
    proba_info_szorny = 1,
    proba_info_targy = 2
} t_proba_info_tipus;

typedef enum
{
    proba_oles_noinfo = 0,
    proba_oles_nemoli = -1
} t_proba_oles_tipus;

typedef struct proba
{
    char * nev;
    t_proba_tipus tipus;
    float esely;
    int (* esely_calculate)();
} t_proba;

typedef struct probak
{
    t_proba elem[4];
} t_probak;

typedef struct proba_szint
{
    int proba[PROBA_SZINT_HOSSZ];
} t_proba_szint;

typedef struct lefutas
{
    t_proba ** line[PROBA_SZINT_HOSSZ];
} t_lefutas;

typedef struct targy_keszites
{
    int ssz;
//    t_targy_alkoto targy_alkoto[TARGY_KESZITES_MAX_ALKOTO];
} t_targy_keszites;

typedef struct szorny_oles
{
    int ssz;
    int percent;
    t_confset confset;
    struct szorny_oles * next;
} t_szorny_oles;

typedef struct torony_kiir_store
{
    t_proba_tipus tipus;
    int szint;
    int ssz;
    int ssz2;
    int alkoto_darab;
    struct torony_kiir_store * next;
} t_torony_kiir_store;

#endif

#ifndef JUST_NEED_TYPES
#ifndef INCLUDED_TORONY_PROTOS
#define INCLUDED_TORONY_PROTOS
extern int torony_kiir_store_destroy(void);
extern int destroy_szint_esely(void);
extern float torony(t_fordulo * fordulo, int szint);
extern int esely_calculate_szakertelem(t_fordulo * fordulo, t_proba * proba, int szint);
extern int esely_calculate_info(t_fordulo * fordulo, t_proba * proba, int szint);
extern int esely_calculate_oles(t_fordulo * fordulo, t_proba * proba, int szint);
extern int esely_calculate_keszites(t_fordulo * fordulo, t_proba * proba, int szint);
extern int torony_szorny_oles_set_percent(int ssz, int percent, t_confset confset);
extern int torony_szorny_oles_get_percent(int ssz);
extern int torony_szorny_oles_lista_destroy(int flag);
extern t_torony_kiir_store * torony_kiir_store_get_head(void);
extern char * torony_get_szakertelem_nev(int i);
extern int torony_get_szakertelem_ertek(t_fordulo * fordulo, int i);
extern float torony_get_proba_szint_esely(int szint, t_proba_tipus tipus);
extern int torony_get_szakertelem_kellene(int szint, int i);
extern int torony_unload(void);
#endif
#endif
