/*
 * Copyright (C) 2003  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#define UL_INTERNAL_ACCESS
#include "include.h"
#include "ul.h"
#include "fordulo.h"
#include "karakter.h"
#include "conf.h"


extern int ultemp(t_fordulo * fordulo)
{
    char * dir = NULL;
    char filename[16];
    char filename_out[16];
    char * file = NULL;
    char * file_out = NULL;
    FILE * fp = NULL;
    FILE * fp_out = NULL;
    char line[LINE_MAXLEN];
    int currline;
    char * p1;
    int n;
    
    if (!fordulo || !fordulo->karakter)
    {
	return -1;
    }
    if (dir = bconf_get_winul40dir())
    {
	sprintf(filename_out, "%d-%03d.UL", fordulo->karakter->ksz, fordulo->fsz+1);
	if (file_out = get_filename(dir, filename_out))
	{
	    if (fp = fopen(file_out,"rb"))
	    {
		fclose(fp);
		free(file_out);
		return 0;
	    }
	    sprintf(filename, "%d-000.UL", fordulo->karakter->ksz);
	    if (file = get_filename(dir, filename))
	    {
		if (fp = fopen(file,"rb"))
		{
		    if (fp_out = fopen(file_out,"wb"))
		    {
			for (currline = 1; fgets(line, LINE_MAXLEN - 1, fp); currline++)
			{
			    if (strlen(line) > LINE_MAXLEN/2)
			    {
				fclose(fp);
				fclose(fp_out);
				unlink(file_out);
				free(file);
				free(file_out);
				return -1;
			    }
			    if (currline == 3)
			    {
				if (p1 = strstr2(line, "ind.koord:"))
				{
				    p1++;
				}
				else if (p1 = strstr2(line+2, "|"))
				{
				    p1++;
				    sprintf(p1, "ind.koord: ");
				    p1 += strlen("ind.koord: ");
				}
				else
				{
				    p1 = NULL;
				}
				if (p1)
				{
				    n = sprintf(p1, "%d;%d\r\n", fordulo->mezo.x, fordulo->mezo.y);
				    p1 += n;
				}
			    }
			    else if (currline == 4)
			    {
				if (p1 = strstr2(line, "______ F: "))
				{
				    sprintf(p1, "%3d", fordulo->fsz+1);
				    p1[3] = ' ';
				}
				if (fordulo->teleport.x && fordulo->teleport.y)
				{
				    if (p1 = strstr2(line, "teleport :"))
				    {
					p1++;
				    }
				    else if (p1 = strstr2(line+2, "|"))
				    {
					p1++;
					sprintf(p1, "teleport : ");
					p1 += strlen("teleport : ");
				    }
				    else
				    {
					p1 = NULL;
				    }
				    if (p1)
				    {
					n = sprintf(p1, "%d;%d\r\n", fordulo->teleport.x, fordulo->teleport.y);
					p1 += n;
				    }
				}
			    }
		    
			    fputs(line, fp_out);
			}
			fclose(fp_out);
		    }
		    fclose(fp);
		}
		free(file);
	    }	    
	    free(file_out);
	}
    }
    return 0;
}
